<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cFluxoCaixa
 *
 * @author GRAFICA BILL
 */
class cFluxoCaixa extends CI_Controller {

    public function registarEntradaValores() {

        $idtipopagamento = $this->input->post('idtipopagamento');
        $idusuario = $this->input->post('idusuario');
        $valor = $this->input->post('valor');
        $idBanco = $this->input->post('idBanco');
        $referencia = $this->input->post('referencia');
        $this->load->model('mfluxoCaixa');
        $tipomovimento = 'Entrada';

        if ($idtipopagamento == 2) {// se a venda for a com o TPA
            $idTipovenda = 1;  //O dinheiro cai  Banco 
        } else {// senao 
            $idTipovenda = 3;   //senao no caixa
        }
        $this->mfluxoCaixa->registarEntradasCaixa($referencia, $valor, $tipomovimento, $idtipopagamento, $idusuario, $idTipovenda, 8); // chama modelo que contem a função para registar a entrada 
        $this->registarSaldoContaEntrada($idtipopagamento, $valor, $idBanco); // chama a função para registar o saldo na respectiva conta
        $this->json->success('Entrada registada');
    }

    public function registarSaldoContaEntrada($idtipopagamento, $preco, $idBanco) {// Atualizar saldo vindo da tela registar entradas
        $this->load->model('mfluxoCaixa');
        $this->load->model('Mbanco');
        if ($idtipopagamento == 1) { // e o pagamento for feito em dinheiro
            $this->mfluxoCaixa->atualizarSadoNasContas(2, $preco); // chama modelo que contem a função para o saldo na conta corrente
            $this->mfluxoCaixa->atualizarSadoNasContas(3, $preco); // chama modelo que contem a função para o saldo na conta caixa
        } else { // se o pagamento não for em dineiro o saldo caira na conta banco
            $this->mfluxoCaixa->atualizarSadoNasContas(1, $preco); // chama modelo que contem a função para o saldo na conta banco
            $this->mfluxoCaixa->atualizarSadoNasContas(2, $preco); // chama modelo que contem a função para o saldo na conta corrente
            $this->mfluxoCaixa->atualizarDebitoBanco($idBanco, $preco); // chama modelo que contem a função para o saldo nas contas 
        }
    }

    public function registarDividas() {
        $idfornecedor = $this->input->post('idfornecedor');

        $datapagamento = $this->input->post('datapagamento');
        $iduser = $this->input->post('idusuario');
        $preco = $this->input->post('valor');
        $referencia = $this->input->post('referencia');
        $this->load->model('mfluxoCaixa');
        $statu = 'ACTIVA';
        $data = @date('Y-m-d');
        $this->mfluxoCaixa->registarContasPagar($idfornecedor, $data, $datapagamento, $iduser, $preco, $referencia, $statu); // verifica se a quantidade disponivel é menor que a solicitada

        $this->json->success('Conta registada');
    }

    public function registarSaldoInicialdiario() {
        if (!$this->mfluxoCaixa->verificar_caixa_aberto()) {
            $valor = $this->mfluxoCaixa->pegarSaldoContaFundoCaixa();
            $this->mfluxoCaixa->registarEntradasCaixaDiario($valor);
        }
    }

    public function verificaCaixaAberto($idUsuario) {
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        foreach ($lista as $linha) {
            return $tatus = $linha->status;
        }
    }

    public function verificaCaixaAberto2() {// verifica se o caixa esta aberto para poder desablitar o botao
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        foreach ($lista as $linha) {
            if ($linha->status == 'Aberto') {
                echo $linha->status;
            } else {
                echo 'Fechado';
            }
        }
    }

    public function abrirCaixa3() {// abre o caixa apartir da tela de bootstrap
        $idUsuario = $this->input->post('idUsuarioAbrCaixa');
        $hora = $data = @date('H:m:s');
        $valorCaixa = $this->input->post('valorCaixa');
        $descricao = 'Abertura de caixa';
        $idtipopagamento = 1;
        $this->load->model('mfluxoCaixa');
        $this->load->model('mUsuario');
        $idcaixa = $this->mUsuario->mlistaridCaixa($idUsuario);
        $tipo = 'Suprimento';
        $tatus = $this->verificaCaixaAberto($idUsuario);
        if ($tatus == 'Aberto') {
            echo json_encode('Aberto');
        } elseif ($tatus == 'Fechado') {
            $this->mfluxoCaixa->reaberturaDeCaixa($idUsuario);
            $this->registarSaldoInicialdiario();
            // Atualizar o valor de 'estadoCaixa' na sessão
            $this->session->set_userdata('estadoCaixa', "A");
            echo json_encode('OK');
        } else {
            $this->mfluxoCaixa->abrirCaixam($idcaixa, $idUsuario, $hora);
            $this->mfluxoCaixa->suprimentoSangria($idUsuario, $valorCaixa, $idtipopagamento, $descricao, $tipo, $hora);
            $this->registarSaldoInicialdiario();
            $this->session->set_userdata('estadoCaixa', "A");
            echo json_encode('OK');
        }
    }

    public function abrirCaixa2() {

        $idUsuario = $this->input->post('idUsuario');
        $hora = $data = @date('H:m:s');
        $valorCaixa = $this->input->post('valorCaixa');
        $descricao = $this->input->post('descricao');
        $idtipopagamento = $this->input->post('idtipopagamento');
        $this->load->model('mfluxoCaixa');
        $this->load->model('Musuarios');
        $idcaixa = $this->Musuarios->mlistaridCaixa($idUsuario);
        $tipo = 'Suprimento';
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        if ($lista) {
            foreach ($lista as $linha) {
                $tatus = $linha->status;
            }
            if ($tatus == 'Aberto') {
                $this->json->GerarMessagemJSONText('O caixa selecionado ja esta aberto');
            } elseif ($tatus == 'Fechado') {
                $this->mfluxoCaixa->reaberturaDeCaixa($idUsuario);
                $this->registarSaldoInicialdiario();
                $this->json->success('Caixa reaberto');
            } else {
                $this->mfluxoCaixa->abrirCaixam($idcaixa, $idUsuario, $hora);
                $this->mfluxoCaixa->suprimentoSangria($idUsuario, $valorCaixa, $idtipopagamento, $descricao, $tipo, $hora);
                $this->registarSaldoInicialdiario();
                $this->json->success('Caixa Aberto');
            }
        } else {
            $this->mfluxoCaixa->abrirCaixam($idcaixa, $idUsuario, $hora);
            $this->mfluxoCaixa->suprimentoSangria($idUsuario, $valorCaixa, $idtipopagamento, $descricao, $tipo, $hora);
            $this->registarSaldoInicialdiario();
            $this->json->success('Caixa Aberto');
        }
    }

    public function abrirCaixa() {
        $idcaixa = $this->input->post('idcaixa');
        $idUsuario = $this->input->post('idUsuario');
        $hora = $data = @date('H:m:s');
        $valorCaixa = $this->input->post('valorCaixa');
        $descricao = $this->input->post('descricao');
        $idtipopagamento = $this->input->post('idtipopagamento');
        $this->load->model('mfluxoCaixa');
        $tipo = 'Suprimento';
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        if ($lista) {
            foreach ($lista as $linha) {
                $tatus = $linha->status;
            }
            if ($tatus == 'Aberto') {
                $this->json->GerarMessagemJSONText('O caixa selecionado ja esta aberto');
            } elseif ($tatus == 'Fechado') {
                $this->mfluxoCaixa->reaberturaDeCaixa($idUsuario);
                $this->registarSaldoInicialdiario();
                $this->json->success('Caixa reaberto');
            } else {
                $this->mfluxoCaixa->abrirCaixam($idcaixa, $idUsuario, $hora);
                $this->mfluxoCaixa->suprimentoSangria($idUsuario, $valorCaixa, $idtipopagamento, $descricao, $tipo, $hora);
                $this->registarSaldoInicialdiario();
                $this->json->success('Caixa Aberto');
            }
        } else {
            $this->mfluxoCaixa->abrirCaixam($idcaixa, $idUsuario, $hora);
            $this->mfluxoCaixa->suprimentoSangria($idUsuario, $valorCaixa, $idtipopagamento, $descricao, $tipo, $hora);
            $this->registarSaldoInicialdiario();
            $this->json->success('Caixa Aberto');
        }
    }

    public function fecharCaixa() {
        $idUsuario = $this->input->post('idUsuario');
        $hora = $data = @date('H:m:s');
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        if ($lista) {
            foreach ($lista as $linha) {
                $tatus = $linha->status;
            }
            if ($tatus == 'Aberto') {
                $this->mfluxoCaixa->fechamentDeCaixa($idUsuario, $hora);
                $this->json->success('Caixa Fechado');
            } else {
                $this->json->GerarMessagemJSONText('O caixa selecionado ja se encontra encerrado');
            }
        } else {
            $this->json->GerarMessagemJSONText('O caixa selecionado não foi aberto no dia de hoje');
        }
    }

    public function suprimentoCaixa() {
        $idUsuario = $this->input->post('idUsuario');
        $idtipopagamento = 1;
        $hora = $data = date('H:m:s');
        $valor = $this->input->post('valoSuprimento');
        $descricao = $this->input->post('motivoSuprimento');
        $this->load->model('mfluxoCaixa');
        $tipo = 'Suprimento';
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        if ($lista) {
            foreach ($lista as $linha) {
                $tatus = $linha->status;
            }
            if ($tatus == 'Aberto') {
                $this->mfluxoCaixa->suprimentoSangria($idUsuario, $valor, $idtipopagamento, $descricao, $tipo, $hora); //
                echo json_encode('OK');
            } else {
                echo json_encode('Não se pode efetuar suprimento em um caixa feixado');
            }
        } else {
            echo json_encode('Não se pode efetuar suprimento em um caixa feixado');
        }
    }

    public function sangriaCaixa() {
        $idUsuario = $this->input->post('idUsuario');
        $idtipopagamento = 1;
        $hora = $data = @date('H:m:s');
        $valor = $this->input->post('valorSagria');
        $descricao = $this->input->post('motivoSangria');
        $idBanco = $this->input->post('idBanco');
        $this->load->model('mfluxoCaixa');
        $tipo = 'Sangria';
        $movimento = 'Saida';
        $fpagamento = 2;
        if ($fpagamento == 2) {// se a venda for a pronto pagamento
            $idTipovenda = 1; //o tipo de pagamento em cash 
        } else {// senao 
            $idTipovenda = 3;  //com TPA 
        }
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        if ($lista) {
            foreach ($lista as $linha) {
                $tatus = $linha->status;
            }
            if ($tatus == 'Aberto') {
                $this->mfluxoCaixa->suprimentoSangria($idUsuario, $valor, $idtipopagamento, $descricao, $tipo, $hora); //
                $this->mfluxoCaixa->mregistarSaidas($descricao, $valor, $movimento, $fpagamento, $idUsuario, $idTipovenda, 5); // 
                $this->subtrairSaldoConta($fpagamento, $idTipovenda, $valor, $idBanco);
                echo json_encode('OK');
            } else {
                echo json_encode('Não se pode efetuar sangria em um caixa feixado');
            }
        } else {
            echo json_encode('Não se pode efetuar sangria em um caixa feixado');
        }
    }

    public function registarSaida() {
        $fpagamento = $this->input->post('idtipopagamento');
        $iduser = $this->input->post('idusuario');
        $referencia = $this->input->post('referencia');
        $valor = $this->input->post('valor');
        $idBanco = $this->input->post('idBanco');
        $idTipoMovimentoCaixa = $this->input->post('idTipoMovimentoCaixa');
        $this->load->model('mfluxoCaixa');
        $movimento = 'Saida';
        if ($fpagamento == 2) {// se a venda for a pronto pagamento
            $idTipovenda = 1; //o tipo de pagamento em cash 
        } else {// senao 
            $idTipovenda = 3;  //com TPA 
        }

        $this->load->model('mfluxoCaixa');
        $this->mfluxoCaixa->mregistarSaidas($referencia, $valor, $movimento, $fpagamento, $iduser, $idTipovenda, $idTipoMovimentoCaixa); // 
        $this->subtrairSaldoConta($fpagamento, $idTipovenda, $valor, $idBanco);

        $this->json->success('Saida registada');
    }

    public function subtrairSaldoConta($fpagamento, $idTipovenda, $preco, $idBanco) {
        $this->load->model('mfluxoCaixa');
        $this->mfluxoCaixa->atualizarSadoNasContasDebito($idTipovenda, $preco); // chama modelo que contem a função para o saldo nas contas
        if ($fpagamento == 2) {
            $this->mfluxoCaixa->atualizarSadoNasContasBanco($idBanco, $preco); // chama modelo que contem a função para o saldo nas contas 
        }
    }

    public function listarEntradasSaidas() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $dataminima = $this->input->get('dataminima');
        if (empty($dataminima)) {
            $dataminima = date('Y-m-d');
        }
        $this->load->model('mfluxoCaixa');
        $tipo = '--';
        if ($this->mfluxoCaixa->listarvMovimentosEntradasSaidas($start, $limit, $dataminima)) {
            foreach ($this->mfluxoCaixa->listarvMovimentosEntradasSaidas($start, $limit, $dataminima)as $row) {

                $imprimir[] = array(
                    'idmovimento' => $row->idmovimento,
                    'data' => $row->datamovimento,
                    'tipomovimento' => $row->tipomovimento,
                    'referencia' => $row->referencia,
                    'idtipoPagamentoSaida' => $row->idtipoPagamentoSaida,
                    'nomeconta' => $row->nomeconta,
                    'tipo' => $row->tipo,
                    'designacao' => $row->designacao,
                    'valor' => $this->fucoes->formatarDinheiro($row->valor, true),
                );
                $total = $this->mfluxoCaixa->contarMovimentos();
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarCaixas() {
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->listarcaixa();
        foreach ($lista as $linha) {
            $dados = array(
                'idcaixa' => $linha->idcaixa,
                'nomecaixa' => $linha->nomecaixa,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listarSuprimento($idTipo) {
        $this->load->model('mfluxoCaixa');
        $sumprimento = 0;
        $sumpr = $this->mfluxoCaixa->listarSuprimento($idTipo);

        if ($sumpr) {
            foreach ($sumpr as $linha) {
                $sumprimento = $linha->valor;
            }
        } else {
            $sumprimento = 0;
        }
        return $sumprimento;
    }

    public function listarSangria($idTipo) {
        $this->load->model('mfluxoCaixa');
        $sangria = 0;
        $sangr = $this->mfluxoCaixa->listarSangria($idTipo);

        if ($sangr) {
            foreach ($sangr as $linha) {
                $sangria = $linha->valor;
            }
        } else {
            $sangria = 0;
        }
        return $sangria;
    }

    public function listarCaixaResumo() {
        $idcaixa = $this->input->get('idcaixa');
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->listarResumoCaixa($idcaixa, $idUsuario);
        $venda = 0;
        $resultado = 0;
        $resposta = '';
        foreach ($lista as $linha) {
            $venda = $linha->total_venda;
            $idTipo = $linha->idTipopagamento;
            $sumprimento = $this->listarSuprimento($idTipo);
            $sangria = $this->listarSangria($idTipo);
            $resultado = $venda + $sumprimento - $sangria;
            if ($sumprimento == 0)
                $sumprimento = '--';
            if ($sangria == 0)
                $sangria = '--';
            $dados = array(
                'forma' => $linha->tipo,
                'vendas' => $venda,
                'suprimento' => $sumprimento,
                'sangria' => $sangria,
                'resultado' => $resultado,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listarAberturacaixa() {
        $idcaixa = $this->input->get('idcaixa');
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->listarResumoCaixa($idcaixa, $idUsuario);
        $venda = 0;
        $resultado = 0;
        $resposta = '';
        //$resposta['resultado']='';
        foreach ($lista as $linha) {
            $venda = $linha->total_venda;
            $idTipo = $linha->idTipopagamento;
            $sumprimento = $this->listarSuprimento($idTipo);
            $sangria = $this->listarSangria($idTipo);
            $resultado = $venda + $sumprimento - $sangria;
            if ($sumprimento == 0)
                $sumprimento = '--';
            if ($sangria == 0)
                $sangria = '--';
            $dados = array(
                'forma' => $linha->tipo,
                'vendas' => $venda,
                'suprimento' => $sumprimento,
                'sangria' => $sangria,
                'resultado' => $resultado,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listarCaixaSangriaSuprimento() {
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->listarSangriaSuprimentos(4);
        $data = array();
        foreach ($lista as $linha) {

            $data = array(
                'dataCaixa' => $linha->data . ' ' . $linha->hora,
                'tipo' => $linha->tipomovimento,
                'descricao' => $linha->descricao,
                'usuario' => $linha->usuario,
                'forma' => $linha->tipo,
                'valor' => $linha->valor

                    //                
            );
        }
        $saida = array(
            "draw" => 1,
            "recordsTotal" => 1,
            "recordsFiltered" => 1,
            "data" => $data,
        );
        echo json_encode($saida);
    }

    public function listarCaixaDados() {
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->dadosDoCaixa($idUsuario);
        foreach ($lista as $linha) {
            $tatus = $linha->status;
            $horafeixo = $linha->horafeixo;
            if ($tatus == 'Aberto')
                $horafeixo = 'EM ABERTO';
            else {
                $horafeixo = $linha->horafeixo;
            }

            $dados = array(
                'usuario' => $linha->unome,
                'horaabertura' => $linha->horaabertura,
                'horafeixo' => $horafeixo,
                'caixa' => $linha->nomecaixa,
                'status' => $tatus,
                    //                
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function estadoCaixa() {
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('mfluxoCaixa');
        $tatus = 'Fechado';
        $lista = $this->mfluxoCaixa->dadosDoCaixa($idUsuario);
        if ($lista) {
            foreach ($lista as $linha) {
                $tatus = $linha->status;
                $imprimir[] = array(
                    'status' => $tatus,
                        //                
                );
                $total = 1;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function verificaStatusCaixa() {
        //  $idUsuario= 8;
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->verificaCaixa($idUsuario);
        $caixa = 'NAO';
        if ($lista) {
            foreach ($lista as $linha) {
                $tatus = $linha->status;
            }
            if ($tatus == 'Aberto') {
                $caixa = 'SIM';
            }
        }
        $this->json->success($caixa);
    }

    public function listarUsuariosDoCaixa() {
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('musuarios');
        $lista = $this->musuarios->listarUsuariosCaixa($idUsuario);
        foreach ($lista as $row) {
            $posto = $row->nomecaixa;
            $dados = array(
                'idUsuario' => $row->id_usiario,
                'nome' => $row->usuario,
                'utilizador' => $row->utilizador,
                'unome' => $row->unome,
                'caixa' => $posto,
                'idcaixa' => $row->idcaixa,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listarUsuariosDoCaixa2() {
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('musuarios');
        $lista = $this->musuarios->listarUsuariosCaixa2($idUsuario);
        foreach ($lista as $row) {
            $posto = $row->nomecaixa;
            $dados = array(
                'idUsuario' => $row->id_usiario,
                'nome' => $row->usuario,
                'utilizador' => $row->utilizador,
                'unome' => $row->unome,
                'caixa' => $posto,
                'idcaixa' => $row->idcaixa,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listarContas() {
        $this->load->model('mtipoveda');
        $lista = $this->mtipoveda->listcontas();
        foreach ($lista as $row) {
            $dados = array(
                'idtipoconta' => $row->idtipoconta,
                'nomeconta' => $row->nomeconta,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

// public function registarSaldoConta($idtipoConta,$preco){
//       $this->load->model('mfluxoCaixa');
//       $this->mfluxoCaixa->atualizarSadoNasContas($idtipoConta,$preco);// chama modelo que contem a função para o saldo na conta  
//}
    public function calculaPercentagemProdutosRecebido($qtdRecebido, $totalQtdComprado) {

        return ($qtdRecebido * 100) / $totalQtdComprado;
    }

    public function listarContasPagar() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $fornecedor = $this->input->get('fornecedor');
        $this->load->model('mfluxoCaixa');
        $debito = 0;
        if ($this->mfluxoCaixa->contasPagarLista($start, $limit, $fornecedor)) {
            foreach ($this->mfluxoCaixa->contasPagarLista($start, $limit, $fornecedor)as $row) {
                //  $qtdRecebido=$row->recebido; 

                $idCompra = $row->idCompra;
                $qtdRecebido = $this->mfluxoCaixa->totalProdutosComprados($idCompra);
                $idcontaPagar = $row->idcontaPagar;
                $totalQtdComprado = $this->mfluxoCaixa->totalProdutosComprados($idCompra);
                //    $totalRecebido= $this->calculaPercentagemProdutosRecebido($qtdRecebido,$totalQtdComprado);
                $debito = $this->mfluxoCaixa->totalDividaPgagoFornecedores($idcontaPagar);
                $imprimir[] = array(
                    'idCompra' => $idCompra,
                    'idpagamento' => $idcontaPagar,
                    'data' => $row->data,
                    'fornecedor' => $row->fornecedor,
                    'datapagamento' => $row->datapagamento,
                    'dataCompra' => $row->dataCompra,
                    'dataVencimento' => $row->dataVencimento,
                    'statu' => $row->statu,
                    'valorNConvertido' => $row->valor,
                    'dataVencimento' => $row->dataVencimento,
                    'debito' => $this->fucoes->formatarDinheiro($debito, true),
                    'valor' => $this->fucoes->formatarDinheiro($row->valor, true),
                    'nfatura' => $row->nfatura,
                    'valorFatura' => $row->valorFatura,
                );
                $total = $this->mfluxoCaixa->contarDividas();
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function acharTotal($desconto, $qtd, $valor) {
        if ($desconto > 0) {
            $desconto1 = ($valor * $desconto) / 100;
            $preco = $valor - $desconto1;
            $total = $preco * $qtd;
            return number_format($total, 2, '.', '');
        } else {
            $total = $valor * $qtd;
            return number_format($total, 2, '.', '');
        }
    }

    public function calcuralDesconto($desconto, $qtd, $valor) {
        $desconto1 = ($valor * $desconto) / 100;
        return $desconto1 * $qtd;
    }

    public function registarTransferencia() {
        $idtipocontaorigem = $this->input->post('idtipocontaorigem');
        $idtipocontadestino = $this->input->post('idtipocontadestino');
        $iduser = $this->input->post('idusuario');
        $preco = $this->input->post('valor');
        $data = @date('Y-m-d');
        if ($idtipocontaorigem == $idtipocontadestino) {
            $this->json->GerarMessagemJSONText('A conta de destino não pode ser igual a conta de origem');
        } else {
            $this->load->model('mfluxoCaixa');
            $this->mfluxoCaixa->regTrasferncia($idtipocontaorigem, $idtipocontadestino, $preco, $iduser, $data); // verifica se a quantidade disponivel é menor que a solicitada
            $this->mfluxoCaixa->atualizarSadoNasContas($idtipocontadestino, $preco);
            $this->mfluxoCaixa->atualizarSadoNasContasSub($idtipocontaorigem, $preco);
            $this->json->success('Trasnferência realizada');
        }
    }

    public function listarTrasnferencias() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $this->load->model('mfluxoCaixa');
        if ($this->mfluxoCaixa->listTraferencias($start, $limit)) {
            foreach ($this->mfluxoCaixa->listTraferencias($start, $limit)as $row) {
                $idcontaorigem = $row->idcontaorigem;
                $idcontadestino = $row->idcontadestino;
                foreach ($this->mfluxoCaixa->listConta($idcontaorigem) as $linha) {
                    $nomecontaorigem = $linha->nomeconta;
                }
                foreach ($this->mfluxoCaixa->listConta($idcontadestino) as $linha) {
                    $nomecontadestino = $linha->nomeconta;
                }

                $imprimir[] = array(
                    'idtrasferencia' => $row->idtrasferencia,
                    'ContaOrigem' => $nomecontaorigem,
                    'contaDestino' => $nomecontadestino,
                    'datatrasferencia' => $row->datatrasferencia,
                    'valor' => $this->fucoes->formatarDinheiro($row->valor, true),
                    'unome' => $row->unome,
                );
                $total = $this->mfluxoCaixa->contarTrasnferencias();
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function totalSaldo() {// funão que pega o total de saldo disponivel
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->somaSaldoconta();
        foreach ($lista as $row) {
            $dados = array(
                'valordebito' => $this->fucoes->formatarDinheiro($row->valordebito, true)
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function saldoBanco() {// funão que pega o saldo na conta banco
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->pegarSaldoBanco();
        foreach ($lista as $row) {
            $dados = array(
                'valorBanco' => $this->fucoes->formatarDinheiro($row->valordebito, true)
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function saldoContaCorrente() {// funão que pega o saldo na conta corrente
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->pegarSaldoContaCorrente();
        foreach ($lista as $row) {
            $dados = array(
                'valorContaCorrente' => $this->fucoes->formatarDinheiro($row->valordebito, true)
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function saldoContaFundoCaixa() {// funão que pega o saldo disponivel no caixa
        $this->load->model('mfluxoCaixa');
        $dados = array(
            'valorFundoCaixa' => $this->fucoes->formatarDinheiro($this->mfluxoCaixa->pegarSaldoContaFundoCaixa(), true)
        );
        $resposta['resultado'][] = $dados;
        echo json_encode($resposta);
    }

    public function valoresReceberVsPagar() {// funão que pega os valores  a receber e a pagar
        $this->load->model('mfluxoCaixa');
        $tipo = '';
        $consulta = $this->mfluxoCaixa->contasApagrSoma();
        $consultaReceber = $this->mfluxoCaixa->contasReceberSoma();
        $totalPago = $this->mfluxoCaixa->totalGeralDividaPgago(); // pega o total pago de uma divida
        foreach ($consulta as $lista) {
            $tipo = 'A pagar';
            $valor = $lista->valor;
            $this->mfluxoCaixa->receberVSpagarAtualizar($tipo, $valor);
        }
        foreach ($consultaReceber as $list) {
            $tipo = 'A Receber';
            $valor = $list->valor;
            $this->mfluxoCaixa->receberVSpagarAtualizar($tipo, $valor);
        }
        $cons = $this->mfluxoCaixa->receberVSpagarListar();
        foreach ($cons as $row) {
            $valor = (int) $row->valor;
            $dados = array(
                'tipo' => $row->tipo,
                'valor' => $valor
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listarEntradasVsSaidasGraficos() {// funão que pega o saldo na conta corrente
        $this->load->model('mfluxoCaixa');
        $lista = $this->mfluxoCaixa->entradaSaidas();
        foreach ($lista as $row) {
            $dados = array(
                'tipomovimento' => $row->tipomovimento . 's',
                'valor' => $row->valor,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    /**
     * Avalia o estado de pagamento da fatura para um determinado recebimento.
     *
     * O método calcula o total da dívida e o total pago para o recebimento informado,
     * utilizando os métodos `totalDivida` (do modelo mContaCliente) e `totalDividaPgago`
     * (do modelo mfluxoCaixa). Em seguida, compara esses valores:
     *
     * - Se o total pago for menor que o total da dívida, significa que a fatura foi paga parcialmente.
     *   Nesse caso, retorna o código 2.
     *
     * - Caso contrário, retorna o código 3, indicando que a fatura está totalmente paga.
     *
     * @param int $idrecebimento O identificador do recebimento.
     * @return int Código de estado da fatura: 2 para dívida paga parcialmente e 3 para fatura totalmente paga.
     */
    public function estadoPagFatura($idrecebimento) {
        // Obtém o total da dívida associada ao recebimento.
        $totalDivida = $this->mContaCliente->totalDivida($idrecebimento);

        // Obtém o total pago para esse mesmo recebimento.
        $totalPago = $this->mfluxoCaixa->totalDividaPgago($idrecebimento);
        // Se o total pago for menor que o total da dívida,
        // significa que a dívida foi paga parcialmente.
        if ($totalPago < $totalDivida) {
            return 2; // Dívida paga parcialmente.
        } else {
            // Caso contrário, a fatura está totalmente paga.
            return 3; // Fatura paga integralmente.
        }
    }

    public function pagamentoDeCredito() {// funão que 
        $idrecebimento = $this->input->post('idReccebimento');
        $idtipopagamento = $this->input->post('idFormaPagamento');
        $retidoIva = $this->input->post('retido');
        $idusuario = $this->input->post('idUsuario');
        $idcliente = $this->input->post('idCliente');
        $fatura = $this->input->post('fatura');
        $valor = $this->input->post('valorPago');
        $dataComputador = date('Y-m-d H:i:s');
        $tipo = 1; // tipo de valor a atualizar na tabela receberVSpagar
        $this->load->model('mfluxoCaixa');
        $this->load->model('mFatura');
        $this->load->model('mContaCliente');

        $ultimaDta = $this->mFatura->retornaUltimaDataHoraPorFatura($this->mfluxoCaixa->pegaIdFaturaCredito($idrecebimento));
        if (strtotime($dataComputador) >= strtotime($ultimaDta)) {
            $this->mContaCliente->pagamentoPeriodo($idcliente, $valor);
            $idPagamento = $this->mfluxoCaixa->registarPagamentosDividas($idrecebimento, $idtipopagamento, $idusuario, $valor);
//            $this->mfluxoCaixa->valor_retido_recibo($idPagamento, $retidoIva);
            $this->mfluxoCaixa->subtrair_total_divida($valor, $tipo);
            $idEstadoPagFatura = $this->estadoPagFatura($idrecebimento);
            $this->mfluxoCaixa->liquidarVendaCredito($idrecebimento, $idEstadoPagFatura);
//            $this->registarEntrada($idtipopagamento, $valor, $idusuario, $fatura); // chama a função para registar o movimento de entrada
//            $this->registarSaldoConta($idtipopagamento, $valor); // chama a função para registar o saldo na respectiva conta
            $saida = array(
                "idPagamento" => $idPagamento,
                "msg" => 'OK',
            );
            echo json_encode($saida);
        } else {
            $saida = array(
                "idPagamento" => 0,
                "msg" => 'INV',
            );
            echo json_encode($saida);
        }
    }

    public function registarSaldoConta($idtipopagamento, $preco) {
        $this->load->model('mfluxoCaixa');
        $this->load->model('Mbanco');
        if ($idtipopagamento == 1) { // e o pagamento for feito em dinheiro
            $this->mfluxoCaixa->atualizarSadoNasContas(2, $preco); // chama modelo que contem a função para o saldo na conta corrente
            $this->mfluxoCaixa->atualizarSadoNasContas(3, $preco); // chama modelo que contem a função para o saldo na conta caixa
        } else { // se o pagamento não for em dineiro o saldo caira na conta banco
            $this->mfluxoCaixa->atualizarSadoNasContas(1, $preco); // chama modelo que contem a função para o saldo na conta banco
            $this->mfluxoCaixa->atualizarSadoNasContas(2, $preco); // chama modelo que contem a função para o saldo na conta corrente
            $this->mfluxoCaixa->atualizarDebitoBanco($this->Mbanco->idContaActiva(), $preco); // chama modelo que contem a função para o saldo nas contas 
        }
    }

    public function registarEntrada($idtipopagamento, $valor, $idusuario, $fatura) {
        if ($idtipopagamento == 2) {// se a venda for a com o TPA
            $idTipovenda = 1;  //O dinheiro cai  Banco 
        } else {// senao 
            $idTipovenda = 3;   //senao no caixa
        }
        $tipomovimento = 'Entrada';
        $idTipoMovimentoCaixa = 8;
        $referencia = 'Valores recebidos do cliente referente ao pagamento da dívida da fatura número ' . $fatura;
        $this->mfluxoCaixa->registarEntradasCaixa($referencia, $valor, $tipomovimento, $idtipopagamento, $idusuario, $idTipovenda, $idTipoMovimentoCaixa); // chama modelo que contem a função para registar a entrada 
    }

    public function liquidarDividaFornecedor() {// funão que  
        $idCompra = $this->input->post('idCompra');
        $fpagamento = $this->input->post('fpagamento');
        $idusuario = $this->input->post('idusuario');
        $dataPagamento = $this->input->post('dataPagamento');
        $valor = $this->input->post('valor');
        $tipo = 3;
        $this->load->model('mfluxoCaixa');
        $this->load->model('Mbanco');
        $idContaPagar = $this->mfluxoCaixa->idContaPagar($idCompra);
        $movimento = 'Saida';
        if ($fpagamento == 2) {// se a venda for a pronto pagamento
            $idTipovenda = 1; //o tipo de pagamento em cash 
        } else {// senao 
            $idTipovenda = 3;  //com TPA 
        }
        $idTipoMovimentoCaixa = 2;
        $referencia = 'Pagamento da dvida com fornecedores';
        $this->load->model('mfluxoCaixa');
        $this->mfluxoCaixa->registarPagamentosDividasFornecedores($idContaPagar, $fpagamento, $idusuario, $valor, $dataPagamento);
        $this->mfluxoCaixa->mregistarSaidas($referencia, $valor, $movimento, $fpagamento, $idusuario, $idTipovenda, $idTipoMovimentoCaixa); //
        $this->mfluxoCaixa->liquidarVendaCreditoFornecedores($idContaPagar, $valor);
        $this->subtrairSaldoConta($fpagamento, $idTipovenda, $valor, $this->Mbanco->idContaActiva());
        $this->mfluxoCaixa->subtrair_total_divida($valor, $tipo);
        $this->json->success('OK');
    }

    public function dividasPagas() {// metodo que pega as dividas pagas
        $idrecebimento = $this->input->get('idRecebimento');
        $this->load->model('mfluxoCaixa');
        $dados = array();
        foreach ($this->mfluxoCaixa->mdividasPagas($idrecebimento)as $row) {
            $dados[] = array(
                'idPagamento' => $row->idPagamento,
                'data' => $row->data,
                'valor' => $row->valor,
            );
        }
        echo json_encode($dados);
    }

   

    public function imprimirRelatorioFinancas() { //lista em PDF as vendas na view vendas modulo finanças
        $dataminima = $this->input->post('dataminima');
        $this->load->model('mRelatorioFinancas');
        $this->mRelatorioFinancas->relatorioPDF($dataminima);
        $this->json->success('Ipmrimir');
    }

    public function control_caixa() { // pega os dados de caixa para a tela em botstrap
//            $idUsuario = $this->input->get('idUsuario');
        $idUsuario = 5;
        $this->load->model('mfluxoCaixa');
        $data = array();

        foreach ($this->mfluxoCaixa->listar_abertura_por_usuario($idUsuario) as $linha) {
            $linha->id;
            $dataCaixa = $linha->data;
            $vendaCash = $this->mfluxoCaixa->listar_vendas_cash($dataCaixa, $idUsuario);
            $vendaTpa = $this->mfluxoCaixa->listar_vendas_tpa($dataCaixa, $idUsuario);
            $saldoInicial = $this->mfluxoCaixa->listarSaldo_caixa_abertuta($dataCaixa, $idUsuario);
            $total = $vendaCash + $vendaTpa + $saldoInicial;
            $sub_array = array();
            $sub_array[] = '<div  class="update" data-id="' . $linha->id . '"
                data-colum_name="saldoInicial">' . $dataCaixa . '</div>';
            $sub_array[] = '<div  class="update" data-id="' . $linha->id . '"
                data-colum_name="saldoInicial">' . $saldoInicial . '</div>';
            $sub_array[] = '<div  class="update" data-id="' . $linha->id . '"
                data-colum_name="vendaCash">' . $vendaCash . '</div>';
            $sub_array[] = '<div  class="update" data-id="' . $linha->id . '"
                data-colum_name="vendaTpa">' . $vendaTpa . '</div>';
            $sub_array[] = '<div  class="update" data-id="' . $linha->id . '"
                data-colum_name="total">' . $total . '</div>';
            $sub_array[] = '<a href="#" class="btn btn-sm btn-info encerrar" id="' . $linha->id . '"><i class="fa fa-pencil "></i>Encerrar</a>';

            $data[] = $sub_array;
        }
        $saida = array(
            // "draw" =>inval($_POST["draw"]),
            "recordsTotal" => 1,
            "recordsFiltered" => 1,
            "data" => $data,
        );
        echo json_encode($saida);
    }

    public function dados_caixa() { // pega os dados de caixa para a tela em botstrap
        $idUsuario = $this->input->get('idUsuario');
        $idCaixaAberto = $this->input->get('idCaixaAberto');
        $this->load->model('mfluxoCaixa');
        $dataCaixa = $this->mfluxoCaixa->data_caixa($idUsuario, $idCaixaAberto);
        $vendaCash = $this->mfluxoCaixa->listar_vendas_cash($dataCaixa, $idUsuario);
        $vendaCashParcelado = $this->mfluxoCaixa->listaCashParcelado($dataCaixa, $idUsuario);
        $vendaTpa = $this->mfluxoCaixa->listar_vendas_tpa($dataCaixa, $idUsuario);
        $vendaTpaParcelado = $this->mfluxoCaixa->listaTpaParcelado($dataCaixa, $idUsuario);
        $saldoInicial = $this->mfluxoCaixa->listarSaldo_caixa_abertuta($dataCaixa, $idUsuario);
        $sangria = $this->mfluxoCaixa->listarSaldo_caixa_sagria($dataCaixa, $idUsuario);
        $entradas = $vendaCash + $vendaTpa + $saldoInicial + $vendaCashParcelado + $vendaTpaParcelado;
        $total = $entradas - $sangria;

        $data[] = array(
            'saldoInicial' => $saldoInicial,
            'sangrias' => $sangria,
            'vendaCash' => $vendaCash + $vendaCashParcelado,
            'vendaTpa' => $vendaTpa + $vendaTpaParcelado,
            'total' => $total,
        );
        echo json_encode($data);
    }

    public function encerrarCaixa() {//modelo q  encerra o [
        $idUsuario = $this->input->post('idUsuario');
        $idCaixaAberto = $this->input->post('idCaixaAberto');
        $this->load->model('mfluxoCaixa');
        $dataCaixa = $this->mfluxoCaixa->data_caixa($idUsuario, $idCaixaAberto);
        $this->mfluxoCaixa->feicho_caixa($idUsuario, $dataCaixa); // chama modelo que contem a função para registar a entrada 
        echo json_encode("OK");
    }

    public function control_caixa_gerente() { // pega os dados de caixa para 
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mfluxoCaixa');

        $lista = $this->mfluxoCaixa->listar_abertura_por_usuario_gerente($idUsuario);
        $data = array();
        foreach ($lista as $linha) {
            $linha->id;
            $dataCaixa = $linha->data;
            $vendaCash = $this->mfluxoCaixa->listar_vendas_cash($dataCaixa, $idUsuario);
            $vendaCashParcelado = $this->mfluxoCaixa->listaCashParcelado($dataCaixa, $idUsuario);
            $vendaTpa = $this->mfluxoCaixa->listar_vendas_tpa($dataCaixa, $idUsuario);
            $vendaTpaParcelado = $this->mfluxoCaixa->listaTpaParcelado($dataCaixa, $idUsuario);
            $saldoInicial = $this->mfluxoCaixa->listarSaldo_caixa_abertuta($dataCaixa, $idUsuario);
            $sangria = $this->mfluxoCaixa->listarSaldo_caixa_sagria($dataCaixa, $idUsuario);
            $entreque = $this->mfluxoCaixa->listar_valor_entregue($dataCaixa, $idUsuario);
            $entradas = $vendaCash + $vendaTpa + $saldoInicial + $vendaCashParcelado + $vendaTpaParcelado;
            $total = $entradas - $sangria;
            $dif = $total - $entreque;
            if ($dif < 0) {
                $dif = 0;
            }
            $data[] = array(
                'idUsuario' => $idUsuario,
                'dataCaixa' => $dataCaixa,
                'saldoInicial' => $saldoInicial,
                'sangrias' => $sangria,
                'vendaCash' => $vendaCash + $vendaCashParcelado,
                'vendaTpa' => $vendaTpa + $vendaTpaParcelado,
                'total' => $total,
                'entregue' => $entreque,
                'diferenca' => $dif,
                'idCaixaAberto' => $linha->id,
            );
        }
        $saida = array(
            "draw" => 1,
            "recordsTotal" => 1,
            "recordsFiltered" => 1,
            "data" => $data,
        );
        echo json_encode($saida);
    }

    public function fecharCaixaGerente() {
        $idUsuario = $this->input->post('idUsuario');
        $idCaixaAberto = $this->input->post('idCaixaAberto');
        $entregue = $this->input->post('valor');
        $total = $this->input->post('total');
        $this->load->model('mfluxoCaixa');
        $dataCaixa = $this->mfluxoCaixa->data_caixa($idUsuario, $idCaixaAberto);
        $hora = $data = date('H:m:s');
        $this->load->model('mfluxoCaixa');

        $this->mfluxoCaixa->fechamentDeCaixaGerente($idUsuario, $hora, $entregue, $dataCaixa);
        $dif = $total - $entregue;
//        if ($dif > 0) {
//            $this->dividaFuncionario($idUsuario, $dif);
//        }

        echo json_encode("OK");
    }

    public function dividaFuncionario($idUsuario, $dif) {
        $this->load->model('Musuarios');
        $this->load->model('mfuncionario');
        if ($this->Musuarios->consultar_tilizador_linkado($idUsuario)) {
            $idFuncionario = $this->Musuarios->mlistaridIdFuncionario($idUsuario);
            $this->mfuncionario->registaDividasFuncionario($idFuncionario, $dif);
        }
    }

    public function lista_historico_caixa() { // pega os dados de caixa para 
        $this->load->model('mfluxoCaixa');
        $this->load->model('Musuarios');
        $lista = $this->mfluxoCaixa->listar_abertura_por_Historico();
        if ($lista) {
            foreach ($lista as $linha) {
                $linha->id;
                $dataCaixa = $linha->data;
                $dataEncerramento = $linha->dataEncerramento;
                $idUsuario = $linha->idusuario;
                $vendaCash = $this->mfluxoCaixa->listar_vendas_cash($dataCaixa, $idUsuario);
                $vendaTpa = $this->mfluxoCaixa->listar_vendas_tpa($dataCaixa, $idUsuario);
                $vendaCashParcelado = $this->mfluxoCaixa->listaCashParcelado($dataCaixa, $idUsuario);
                $vendaTpaParcelado = $this->mfluxoCaixa->listaTpaParcelado($dataCaixa, $idUsuario);
                $saldoInicial = $this->mfluxoCaixa->listarSaldo_caixa_abertuta($dataCaixa, $idUsuario);
                $sangria = $this->mfluxoCaixa->listarSaldo_caixa_sagria($dataCaixa, $idUsuario);
                $entreque = $this->mfluxoCaixa->listar_valor_entregue($dataCaixa, $idUsuario);
                $estado = $this->mfluxoCaixa->pega_estado_caixa($dataCaixa, $idUsuario);
                $nome = $this->Musuarios->mlistaridNome($idUsuario);
                $entradas = $vendaCash + $vendaTpa + $saldoInicial + $vendaCashParcelado + $vendaTpaParcelado;
                $total = $entradas - $sangria;
                $dif = $total - $entreque;
                if ($dif < 0) {
                    $dif = 0;
                }
                $imprimir[] = array(
                    'nome' => $nome,
                    'idUsuario' => $idUsuario,
                    'dataCaixa' => $dataCaixa,
                    'saldoInicial' => $saldoInicial,
                    'sangrias' => $sangria,
                    'vendaCash' => $vendaCash + $vendaCashParcelado,
                    'vendaTpa' => $vendaTpa + $vendaTpaParcelado,
                    'total' => $total,
                    'entregue' => $entreque,
                    'diferenca' => $dif,
                    'estado' => $estado,
                    'dataEncerramento' => $dataEncerramento,
                );
                $totalRgistos = count($this->mfluxoCaixa->listar_abertura_por_Historico());
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $totalRgistos . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function imprimeResumoCaixa() {
        $idUsuario = $this->input->post('idUsuario');
        $dataCaixa = $this->input->post('dataCaixa');
        $this->load->model('mresumoCaixa');
        $this->mresumoCaixa->imprimePDFResumo($idUsuario, $dataCaixa);
        $this->json->success('Ipmrimir');
    }

    public function imprimeResumoA5() {
        $idUsuario = $this->input->post('idUsuario');
        $dataCaixa = $this->input->post('dataCaixa');
        $this->load->model('mresumoCaixaA5');
        $this->mresumoCaixaA5->imprimePDFResumoA5($idUsuario, $dataCaixa);
        $this->json->success('Ipmrimir');
    }

    public function imprimePDFResumo() {
        echo $idUsuario = '4' . '<br>';
        $dataCaixa = '2020-07-27' . '<br>';
        $this->load->model('ClientesM');
        $this->load->model('mMoeda');
        $this->load->model('mfluxoCaixa');
        $this->load->model('mfaturaM2');
        $this->load->model('Musuarios');
        $this->load->model('mIva');
        $tabela = '';

        setlocale(LC_ALL, "pt_BR", "pt_BR.iso-8859-1", "pt_BR.utf-8", "portuguese");
        foreach ($this->mfluxoCaixa->listar_abertura_por_usuario_resumo($idUsuario, $dataCaixa) as $linha) {
            // echo   $dataCaixa=$linha->data;
            echo $vendaCash = $this->mfluxoCaixa->listar_vendas_cash($dataCaixa, $idUsuario);
            $vendaTpa = $this->mfluxoCaixa->listar_vendas_tpa($dataCaixa, $idUsuario);
            $saldoInicial = $this->mfluxoCaixa->listarSaldo_caixa_abertuta($dataCaixa, $idUsuario);
            $entreque = $this->mfluxoCaixa->listar_valor_entregue($dataCaixa, $idUsuario);
            $estado = $this->mfluxoCaixa->pega_estado_caixa($dataCaixa, $idUsuario);
            $nome = $this->Musuarios->mlistaridNome($idUsuario);
            $horaAbertura = $this->mfluxoCaixa->pega_hora_abertura($dataCaixa, $idUsuario);
            echo $dataEnceramento = $this->mfluxoCaixa->pega_data_encerramemto($dataCaixa, $idUsuario);
            echo $horaEnceramento = $this->mfluxoCaixa->pega_hora_encerramemto($dataCaixa, $idUsuario);
            $total = $vendaCash + $vendaTpa + $saldoInicial;
            $dif = $total - $entreque;
            if ($dif < 0) {
                $dif = 0;
            }
        }
        foreach ($this->mfaturaM2->pegaProdutosResumo($dataCaixa, $idUsuario) as $linha) {
            $idProduto = $linha->idpr;

            $linha->qtd;
            $linha->custo;
            $linha->total;
            //     $ivaInt=$this->mIva->calculo_iva_int($total,$idProduto);
            $tabela = $tabela . '<tr>
                            <td class="agt" width="120">' . $linha->produto . '</td>
                            <td class="agt"  width="50">' . $linha->custo . '</td>
                            <td class="agt"  width="50">TOTAL</td>
                        </tr>  ';
        }
    }

    public function lista_historico_notas() { // pega os dados de caixa para 
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('mfluxoCaixa');
        $this->load->model('Musuarios');

        $lista = $this->mfluxoCaixa->listar_historico_notas();
        if ($lista) {
            foreach ($lista as $linha) {

                $pu = $linha->pu;
                $idNota = $linha->idNota;
                $idCaixaAbF = $this->mfluxoCaixa->pega_id_caixa($idUsuario);
                $qtd = $this->mfluxoCaixa->pega_qtd_Notas($idCaixaAbF, $idNota);
                $totalNotas = $pu * $qtd;

                $imprimir[] = array(
                    'idNota' => $linha->idNota,
                    'denominacao' => $linha->denominacao,
                    'pu' => $pu,
                    'total' => $totalNotas,
                    'qtd' => $qtd == null ? 0 : $qtd,
                );
                $totalRgistos = 13;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $totalRgistos . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function registaQtdNotas() { //lista em PDF as vendas na view vendas modulo finanças
        $idUsuario = $this->input->post('idUsuario');
        $idNota = $this->input->post('idNota');
        $qtd = $this->input->post('qtd');
        $this->load->model('mfluxoCaixa');
        $idCaixaAbF = $this->mfluxoCaixa->pega_id_caixa($idUsuario);
        if ($this->mfluxoCaixa->consultarNota($idCaixaAbF, $idNota)) {
            $this->mfluxoCaixa->atualizaTotalNotas($idCaixaAbF, $idNota, $qtd);
            $this->json->success('OK');
        } else {
            $this->mfluxoCaixa->registaNotas($idCaixaAbF, $idNota, $qtd);
            $this->json->success('OK');
        }
    }

    public function listaContaPagarPorFaturaFornevedor() {
        $idCompra = $this->input->get('idCompra');
        $this->load->model('mfluxoCaixa');
        if ($this->mfluxoCaixa->mlistaContaPagarPorFacturaFornevedor($idCompra)) {
            foreach ($this->mfluxoCaixa->mlistaContaPagarPorFacturaFornevedor($idCompra)as $row) {
                $idContaPagar = $row->idcontaPagar;

                $idCompra = $row->idCompra;
                $qtdRecebido = $this->mfluxoCaixa->totalProdutosComprados($idCompra);
                $qtdPagamento = $this->mfluxoCaixa->contarPagamentosFatura($idContaPagar);
                $totalPago = $this->mfluxoCaixa->mpegaTotalPaga($idContaPagar);
                $totalCompra = $this->mfluxoCaixa->mpegaTotalCompra($idCompra);
                $divida = $totalCompra - $totalPago;
                $totalQtdComprado = $this->mfluxoCaixa->totalProdutosComprados($idCompra);
                $totalRecebido = $this->calculaPercentagemProdutosRecebido($qtdRecebido, $totalQtdComprado);
                $imprimir[] = array(
                    'totalRecebido' => 'Produtos ' . '(' . $totalRecebido . '% Recebido)',
                    'qtdPagamento' => 'Pagamentos ' . '(' . $qtdPagamento . ')',
                    'totalPago' => $this->fucoes->formatarDinheiro($totalPago, true),
                    'totalCompra' => $this->fucoes->formatarDinheiro($totalCompra, true),
                    'valorFatura' => $row->valorFatura,
                    'datapagamento' => $row->datapagamento,
                    'dataCompra' => $row->dataCompra,
                    'dataVencimento' => $row->dataVencimento,
                    'nfatura' => $row->nfatura,
                    'divida' => number_format($divida, 2, '.', ''),
                );
                $total = 1;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function valoresReceberVsPagarHojeGrafico() {// funão que pega os valores  a receber e a pagar
        $this->load->model('mfluxoCaixa');
        $resposta = '';
        $pagoHoje = $this->mfluxoCaixa->pagoHoje();
        $recebidoHoje = $this->mfluxoCaixa->RecebidoHoje();
        $resultado = $recebidoHoje - $pagoHoje;
        for ($i = 1; $i <= 3; $i++) {
            if ($i == 1) {
                $valor = $pagoHoje;
                $tipo = 'Recebido';
            } elseif ($i == 2) {
                $valor = $recebidoHoje;
                $tipo = 'Pago';
            } else {
                $valor = $resultado;
                $tipo = 'Resultado';
            }
            $dados = array(
                'valor' => $valor,
                'tipo' => $tipo,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function valoresRecebidosVsPagoMes() {// funão que pega os valores  a receber e a pagar
        $this->load->model('mfluxoCaixa');
        $resposta = '';
        $pagoMes = $this->mfluxoCaixa->pagoMes();
        $recebidoMes = $this->mfluxoCaixa->RecebidoMes();
        $resultadoMes = $recebidoMes - $pagoMes;

        $dados = array(
            'pagoMes' => $pagoMes,
            'recebidoMes' => $recebidoMes,
            'resultadoMes' => $resultadoMes,
        );
        $resposta['resultado'][] = $dados;

        echo json_encode($resposta);
    }

    public function valoresRecebidosVsPagoMesGrafico() {// funão que pega os valores  a receber e a pagar
        $this->load->model('mfluxoCaixa');
        $resposta = '';
        $pagoMes = $this->mfluxoCaixa->pagoMes();
        $recebidoMes = $this->mfluxoCaixa->RecebidoMes();
        $resultadoMes = $recebidoMes - $pagoMes;
        for ($i = 1; $i <= 3; $i++) {
            if ($i == 1) {
                $valor = $pagoMes;
                $tipo = 'Recebido';
            } elseif ($i == 2) {
                $valor = $recebidoMes;
                $tipo = 'Pago';
            } else {
                $valor = $resultadoMes;
                $tipo = 'Resultado';
            }
            $dados = array(
                'valor' => $valor,
                'tipo' => $tipo,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function valoresRecebidosVsPagoAno() {// funão que pega os valores  a receber e a pagar
        $this->load->model('mfluxoCaixa');
        $resposta = '';
        $pagoAno = $this->mfluxoCaixa->pagoAno();
        $recebidoAno = $this->mfluxoCaixa->recebidoAno();
        $resultadoAno = $recebidoAno - $pagoAno;

        $dados = array(
            'pagoAno' => $pagoAno,
            'recebidoAno' => $recebidoAno,
            'resultadoAno' => $resultadoAno,
        );
        $resposta['resultado'][] = $dados;

        echo json_encode($resposta);
    }

    public function pega_tipo_movimento_caixa() {
        $this->load->model('mfluxoCaixa');

        foreach ($this->mfluxoCaixa->mpega_tipo_movimento_caixa() as $value) {
            $dados = array(
                'idTipoMovimentoCaixa' => $value->idTipoMovimentoCaixa,
                'designacao' => $value->designacao,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    //METODO AUXILIAR Q PARA ATUALIZAR idTipoMovimentoCaixa

    public function pega_movimentacoes() {
        $this->load->model('mfluxoCaixa');

        foreach ($this->mfluxoCaixa->mpega_movimentacoes() as $value) {
            $idmovimento = $value->idmovimento;
            $tipomovimento = $value->tipomovimento;
            if ($tipomovimento == 'Entrada') {
                $idTipoMovimentoCaixa = 8;
            } else {
                $idTipoMovimentoCaixa = 2;
            }
            $this->mfluxoCaixa->mpega_atualiza_movimentacoes($idmovimento, $idTipoMovimentoCaixa);
        }
        echo json_encode('ok');
    }

    public function abrirGaveta() {
        $this->load->model('mAbrirGaveta');
        $this->mAbrirGaveta->imprimirCodeGavPDF();
        $this->json->success('OK');
    }

}
