<?php

class CUtilizador extends CI_Controller {

    var $usuario = '';

    public function gravaLojaUtilizador($idUsuario) {
        $this->load->model('mLojas');
        foreach ($this->mLojas->mlistaLojas() as $lin) {
            if (!$this->MUsuario->verificaLojaUsuario($idUsuario, $lin->id)) {
                $this->MUsuario->registaLojaUsuario($idUsuario, $lin->id, 'n');
            }
        }
    }

    public function regitarUtilizadores() {
        $unome = $this->input->post('unome');
        $usuario = $this->input->post('usuario');
        $enha = md5($this->input->post('password'));
        $email = $this->input->post('email');
        $nivel = $this->input->post('idNivel');
        $idcaixa = $this->input->post('idCaixaLoja');
        $idPonto = 2;
        $vender = '';
        $checkboxes = $this->input->post('checkboxes');
        if (!empty($checkboxes)) {
            $vender = 's';
        }
        $permitirDesconto = $this->input->post('desconto');
        $desconto = 'n';
        if (!empty($permitirDesconto)) {
            $desconto = 's';
        }
        $reimprimir = 's';
        $idTipoFatura = 2;
        $idInterface = 1;
        if ($idcaixa == 'Caixa Nº') {
            $idcaixa = 3;
        } else {
            $idcaixa = 1;
        }
//
        $this->load->model('MUsuario');
        $idUsuario = $this->MUsuario->mregistarUtilizador($unome, $usuario, $enha, $email, $nivel, $idcaixa, $vender);
        $this->MUsuario->usuarioscaixaloja($idUsuario);
        if ($vender == 's') {
            $this->MUsuario->usuarioPontoVenda($idUsuario, $idPonto, $reimprimir, $idTipoFatura, $idInterface, $desconto);
            $this->gravaLojaUtilizador($idUsuario);
            foreach ($checkboxes as $idLoja) {
                $this->MUsuario->atualizarLojaUsuario($idUsuario, $idLoja, 's');
            }
//                
        }

        echo json_encode('OK');
    }

    public function atualizaraUsuarioPontoVenda($idUsuario, $idPonto, $reimprimir, $idTipoFatura, $idInterface, $desconto) {
        if ($this->MUsuario->cansulta_posto_venda($idUsuario)) {
            $this->MUsuario->atualizaPontoVenda($idUsuario, $idPonto, $reimprimir, $idTipoFatura, $idInterface, $desconto);
        } else {
            $this->MUsuario->usuarioPontoVenda($idUsuario, $idPonto, $reimprimir, $idTipoFatura, $idInterface, $desconto);
        }
    }

    public function resetEstadoLoja($idUsuario) {
        // Carrega o modelo mLojas para acessar a função mlistaLojas
        $this->load->model('mLojas');

        // Percorre todas as lojas retornadas pela função mlistaLojas
        foreach ($this->mLojas->mlistaLojas() as $lin) {
            // Atualiza o estado da loja para o usuário especificado
            // Aqui, a função atualizarLojaUsuario define o estado da loja como 'n' (inativo)
            // $lin->idArmanze é o identificador da loja atual
            $this->musuario->atualizarLojaUsuario($idUsuario, $lin->id, 'n');
        }
    }

    public function atualizar_usuario() {
        $idUsuario = $this->input->post('idUsuario');
        $unome = $this->input->post('unome');
        $usuario = $this->input->post('usuario');
        $email = $this->input->post('email');
        $nivel = $this->input->post('idNivel');
        $idPonto = 2;
        $vender = '';
        $checkboxes = $this->input->post('checkboxes');
        if (!empty($checkboxes)) {
            $vender = 's';
        }
        $permitirDesconto = $this->input->post('desconto');
        $desconto = 'n';
        if (!empty($permitirDesconto)) {
            $desconto = 's';
        }
        $reimprimir = 's';
        $idTipoFatura = 2;
        $idInterface = 1;
        $this->load->model('musuario');
        $this->musuario->matualizarUsuario($idUsuario, $unome, $usuario, $email, $nivel, $vender);
        if ($vender == 's') {
            $this->gravaLojaUtilizador($idUsuario);
            $this->resetEstadoLoja($idUsuario);
            $this->atualizaraUsuarioPontoVenda($idUsuario, $idPonto, $reimprimir, $idTipoFatura, $idInterface, $desconto);
            foreach ($checkboxes as $idLoja) {
                $this->musuario->atualizarLojaUsuario($idUsuario, $idLoja, 's');
            }
        }

        echo json_encode('OK');
    }

    public function eliminarUtilizador() {

        $idUsuario = $this->input->post('idUtilizador');
        $this->load->model('MUsuario');
        if ($this->MUsuario->verificaFatura($idUsuario)) {
            echo json_encode('N');
        } else if ($this->MUsuario->m_eliminar_utilizador($idUsuario)) {
            echo json_encode('OK');
        } else {
            echo json_encode('N');
        }
    }

    public function atualizar_senha() {// a tualiza a senha atraves do id de cadastro
        $id = $this->input->post('idUsuario');
        $enha = md5($this->input->post('password'));
        $this->load->model('MUsuario');
        $this->MUsuario->atuaizarSenhan($id, $enha);
        if ($this->MUsuario->consultaUsuarioCaixa($id)) {
            $this->MUsuario->mApagaUsuarioCaica($id);
        }
         echo json_encode('OK');
    }

    public function validar() {
        $this->usuario = $this->input->POST("usuario"); // pega via post o email que vem do formulario
        $pass = $this->input->POST("senha");
        $senha = md5($this->input->POST("senha"));
        $this->load->model('mUsuario');

        $data_session = '';
        $result = $this->mUsuario->validatede($this->usuario, $senha);
        if ($result) {
            $usuario = $this->mUsuario->usuario($this->usuario);
            $id = $this->mUsuario->usuarioId($this->usuario);
            $nivel = $this->tipoUsuario($usuario);

            $password = $pass;
            $data_session = array(
                'nivel' => $nivel,
                'usuario' => $usuario,
                'id' => $id,
                'password' => $password,
                'logado' => TRUE
            );
            $this->session->set_userdata($data_session);
            echo json_encode('OK');
        } else {
            echo json_encode('Usuário ou password incorreta');
        }
    }

    public function tipoUsuario($usuario) {
        $this->load->model('mUsuario');

        foreach ($this->mUsuario->idNivel($usuario) as $value) {
            $idnivel = $value->nivel;
        }
        return $idnivel;
    }

    public function tipoUsuario1($usuario) {
        $this->load->model('mUsuario');
        foreach ($this->mUsuario->Mlistarnivel($usuario) as $value) {
            $usuario = $value->usuario;
        }
        return $usuario;
    }

    public function logoempresa() {
        $this->load->model('mUsuario');
        foreach ($this->mUsuario->pegarlogo() as $value) {
            $logo = $value->img;
        }
        return $logo;
    }

    public function tipoUsuario2($usuario) {
        $this->load->model('mUsuario');
        foreach ($this->mUsuario->idUsuario($usuario) as $value) {
            $id = $value->id;
        }
        return $id;
    }

    public function tipoCaixa($usuario) {
        $this->load->model('mUsuario');
        foreach ($this->mUsuario->mlistarcaixa($usuario) as $value) {
            $idcaixa = $value->idcaixa;
        }
        return $idcaixa;
    }

    public function clistar_niveis_acesso() {
        $this->load->model('mUsuario');
        $array = $this->mUsuario->mpega_niveis_acesso();
        $dados = array();
        foreach ($array as $row) {
            $dados[] = array(
                'idNivel' => $row->idNivel,
                'nivel' => $row->nivel,
                
            );
        }
        echo json_encode($dados);
    }

    public function listarUtilizadores() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $pesquisa = ($_POST["search"] ["value"]);
        $draw = $this->input->post("draw");
        $this->load->model('mUsuario');
        $totalRecords = $this->mUsuario->totalUsuarios();
        $filteredRecords = $this->mUsuario->obter_total_registos_filtrados($pesquisa);

        $idPonto = '';
        $dados = array();
        foreach ($this->mUsuario->listar_usuarios_internos($start, $limit, $pesquisa) as $row) {
            $idcaixa = $row->idcaixa;
            $idUsuario = $row->id_usiario;
            $idPonto = $this->mUsuario->cat_posto_venda($idUsuario);
            $idTipoFatura = $this->mUsuario->formatoFaturaPontoVenda($idUsuario);
            $reimprimir = $this->mUsuario->reimprimir($idUsuario);
            $desconto = $this->mUsuario->desconto($idUsuario);

            $dados[] = array(
                'idUsuario' => $idUsuario,
                'nome' => $row->usuario,
                'utilizador' => $row->utilizador,
                'nivel' => $row->nivel,
                'email' => $row->email,
                'data' => $row->datacadastro,
                'unome' => $row->unome,
                'vender' => $row->pv,
                'idPonto' => $idPonto,
                'idTipoFatura' => $idTipoFatura,
                'reimprimir' => $reimprimir,
                'desconto' => $desconto,
            );
        }
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $totalRecords,
            "recordsFiltered" => $filteredRecords,
            "data" => $dados
        ));
    }

    public function pegadados_utilizador_editar() {
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('musuario');
        $this->load->model('mLojas');
        $array = $this->musuario->listar_usuarios_internos_edit($idUsuario);
        // Inicializar o array de armazéns
        $armazens = array();
        // Iterar sobre os resultados de mlistaLojas
        foreach ($this->mLojas->mlistaLojas() as $lin) {
            // Verificar condição para definir o valor de "checked"
            $checked = ($this->musuario->verificaPermissaoArmazem($idUsuario, $lin->id)) ? 's' : 'n';
            // Adicionar os dados ao array de armazéns
            $armazens[] = array(
                'id' => $lin->id,
                'checked' => $checked
            );
        }
        foreach ($array as $row) {
            $desconto = $this->musuario->desconto($idUsuario);
            $data = array(
                'nome' => $row->usuario,
                'idNivel' => $row->nivel,
                'email' => $row->email,
                'data' => $row->datacadastro,
                'unome' => $row->unome,
                'vender' => $row->pv,
                'nivelUtilzador' => $row->utilizador,
                'desconto' => $desconto,
                'armazens' => $armazens, // Adicionar o array de armazéns
            );
        }
        echo json_encode($data);
    }

    public function permissoesUsuarios() {
        $idUsuario = $this->input->get('idUsuario');
        $this->load->model('musuario');
        // $status = 'n';
        //  $dados = []; // Inicializa o array de dados
        foreach ($this->musuario->mpermissoesIndividuais() as $linha) {
            $idPermissao = $linha->id;
            $status = $this->musuario->statuPermissaoUsuario($idPermissao, $idUsuario);
            $dados[] = array(
                'idPermissao' => $idPermissao,
                'per' => $linha->per,
                'status' => $status,
                'idUsuario' => $idUsuario,
            );
        }
        echo json_encode($dados);
    }

}
