<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cFaturaGlobal
 *
 * @author VINEVALA
 */
class cFaturaGlobal extends CI_Controller {

    public function acharTotal($desconto, $qtd, $valor) {
        if ($desconto > 0) {
            $desconto1 = ($valor * $desconto) / 100;
            $preco = $valor - $desconto1;
            return $total = $preco * $qtd;
        } else {
            return $total = $valor * $qtd;
        }
    }

    public function custoDesconto($desconto, $valor) {

        $desconto1 = ($valor * $desconto) / 100;
        $preco = $valor - $desconto1;
        return $preco;
    }

    public function calcuralDesconto($desconto, $qtd, $valor) {
        $desconto1 = ($valor * $desconto) / 100;
        return $desconto1 * $qtd;
    }

    public function calcularDescontoGeral($idFatura, $subtotal) {
        $this->load->model('mFatura');
        $percentagemGeral = $this->mFatura->pegaDescontoGlobal($idFatura);
        return ($percentagemGeral * $subtotal) / 100;
    }

    public function cash($idFatura) {
        $this->db->select('cash');
        $this->db->from('pagamentos_parcelados');
        $this->db->where('idfatura', $idFatura);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $value->cash;
        }
        return $total;
    }

    public function tpa($idFatura) {
        $this->db->select('tpa');
        $this->db->from('pagamentos_parcelados');
        $this->db->where('idfatura', $idFatura);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $value->tpa;
        }
        return $total;
    }

    public function formaPagamento($idForma) {
        if ($idForma == 1) {
            return 'Numerário';
        } else {
            return $this->mFatura->forma_pagamento($idForma);
        }
    }

    public function impostoRegime($idRegime) {
        if ($idRegime == 2) {
            return 'IVA -  Regime de Exclusão';
        } else {
            return 'IVA -  Regime Simplificado';
        }
    }

    public function dadosEmpresa() {
        $consulta = $this->mempresa->empresa();
        $data = array();
        foreach ($consulta as $row) {
            $data = array(
                'nomeEmpresa' => $row->empresa,
                'nif' => $row->nif,
                'endereco' => $row->endereco,
                'idRegime' => $row->idRegime,
                'fone' => $row->fone,
                'fone1' => $row->fone1,
                'email' => $row->email,
                'provincia' => $row->provincia,
                'img' => $row->img,
            );
        }
        return $data;
    }

    public function dadosEntidade($idCliente) {
        $this->load->model('mClientes');
        $consulta = $this->mClientes->pegaDadosCliente($idCliente);
        $data = array();
        foreach ($consulta as $linha) {
            $data = array(
                'nome' => $linha->nome,
                'fone' => $linha->fone,
                'fone1' => $linha->fone1,
                'email' => $linha->email,
                'nif' => $linha->nif,
                'localizacao' => $linha->localizacao
            );
        }
        return $data;
    }

    public function dadosBanco() {
        $bancos = $this->Mbanco->mlistaContaBanco2();
        foreach ($bancos as $linha) {
            $data[] = array(
                'banco' => $linha->banco,
                'conta' => $linha->conta,
                'iban' => $linha->iban,
            );
        }
        return $data;
    }

    public function quadroImpostos($idFatura) {
        $taxas = $this->mFatura->taxaIva($idFatura);
        foreach ($taxas as $linha) {
            $taxa = $linha->ivaVenda;
            $incidencia = $this->mFatura->incidencia($idFatura, $taxa);
            $imposto = $incidencia * $taxa / 100;
            $data[] = array(
                'taxa' => $taxa,
                'incidencia' => $incidencia,
                'imposto' => $imposto,
            );
        }
        return $data;
    }

    public function docFaturaConsolidadaPDF() {
        $idCliente = $this->input->get('idCliente');
        $dataminima = $this->input->get('dataminima');
        $datamaxima = $this->input->get('datamaxima');

        $this->load->model('mClientes');
        $this->load->model('mMoeda');
        $this->load->model('mIva');
        $this->load->model('mFatura');
        $this->load->model('Mbanco');
        $this->load->model('mempresa');
        $subtotal = 0;
        $totalDescontos = 0;
        $totalIva = 0;
        $totalIvaFornecedor = 0;
        $conta = 0;
        $totalSemDesconto = '';
        $totalSemDescontoGera = '';
        setlocale(LC_ALL, "pt_BR", "pt_BR.iso-8859-1", "pt_BR.utf-8", "portuguese");
        $tipoPagamento = '';

        $entidade = $this->dadosEntidade($idCliente);
        $empresa = $this->dadosEmpresa();
        $banco = $this->dadosBanco();

        $dVenc = "";
        $dataPagamento = "";
        $produtos = array();

        foreach ($consuta = $this->mFatura->imprimir_documentos_fatura_cliente($idCliente, $dataminima, $datamaxima) as $linha) {
            $conta++;
            $idFatura = $linha->fatura;
            $idForma = $this->mFatura->tipoPagamento($idFatura);
            $tipo = $this->formaPagamento($idForma);
            $serie = $this->mFatura->serie($idFatura);
            $idTipoDocumento = $this->mFatura->tipoVenda($idFatura);
            if ($idTipoDocumento == 1) {
                $abrDoc = 'FT';
                $tipoDocumento = 'Factura';
                $dataV = $this->mfluxoCaixa->pega_data_vencimento($idFatura);
                $dtn = new DateTime($dataV);
                $dVenc = utf8_encode(strftime(" %d de %B de %Y", strtotime($dtn->format("d. M. Y "))));
                $dataPagamento = $dVenc;
                $numero = $this->mFatura->pegaNumeroFtPorIdFatura($idFatura);
            } else {
                $abrDoc = 'FR';
                $tipoDocumento = 'Factura/Recibo'; // 
                $tipo = $this->mFatura->forma_pagamento($this->mFatura->tipoPagamento($idFatura));
                $tipoPagamento = $tipo;
                $numero = $this->mFatura->pegaNumeroFrPorIdFatura($idFatura);
            }
            $data = $linha->data;
            $idproduto = $linha->idpr;
            $produto = $linha->produto . ' ' . $linha->referencia . ' ' . $this->mIva->pega_exepcao($idproduto);
            $qtd = $linha->qtd;
            $custo = $linha->custo;
            $hora = $linha->hora;
            $iditem = $linha->iditem;
            $sd = new DateTime($data);
            $ano = utf8_encode(strftime(" %Y", strtotime($sd->format("d. M. Y "))));
            $dt = utf8_encode(strftime("%d de %B de %Y", strtotime($sd->format("d. M. Y "))));

            $percentagemDesconto = $this->mFatura->descontos($idFatura, $iditem);
            $desconto = $this->calcuralDesconto($percentagemDesconto, $qtd, $custo);
            $ivafornecedor = $this->mIva->iva_fornecedor($idproduto);
            $totalIvaFornecedor = $totalIvaFornecedor + $ivafornecedor;
            $hashcontrol = $linha->hashcontrol;
            $nunidade = $linha->nunidade;
            $total = $this->acharTotal($percentagemDesconto, $qtd, $custo);
            $totalDescontos = $totalDescontos + $desconto;
            $iva = $this->mIva->calculo_iva($total, $idproduto); // valor convertido em formato de moeda
            $ivaInt = $this->mIva->calculo_iva_int($total, $idproduto);

            if ($this->mempresa->pegaRegime() != 1) {
                $ivaInt = 0;
            }
            if ($percentagemDesconto == 100) {
                $iva = 0;
            }

            $totalIva = $totalIva + $ivaInt;
            $subtotal = $subtotal + $total;
            $totalSemDesconto = $custo * $qtd;
            $totalSemDescontoGera = $totalSemDescontoGera + $totalSemDesconto;

            if ($totalIva > $totalIvaFornecedor) {
                $retecao = $totalIva - $totalIvaFornecedor;
            } else {
                $retecao = $totalIvaFornecedor - $totalIva;
            }
            if ($this->mempresa->pegaRegime() == 2 || $this->mempresa->pegaRegime() == 3) {
                $iva = 0.00;
            }
           

            $produtos[] = array(
                'idFatura' => $idFatura,
                'artigo' => $produto,
                'qtd' => $qtd,
                'nunidade' => $nunidade,
                'custo' => $custo,
                'percentagemDesconto' => $percentagemDesconto,
                'taxa' => $iva,
                'tipoDocumento' => $tipoDocumento,
                'numeroFatuta' => $abrDoc . ' ' . $serie . '/' . $numero,
                'dataEmissaoA4' => $dt . ' ' . $hora,
                'subTotal' => $total,
                'iva' => $ivaInt,
                'total' => $total + $ivaInt,
            );
        } // fim do  foreach
        $detalhesDoc = array(
            'dataminima' => $dataminima,
            'datamaxima' => $datamaxima,
        );
        echo json_encode(array(
            "produtos" => $produtos,
            "entidade" => $entidade,
            "empresa" => $empresa,
            "dadosBanco" => $banco,
            "detalhesDoc" => $detalhesDoc,
        ));
    }

    public function pegaTipoProduto($idproduto) {
        $this->load->model('ProdutosM');
        return $this->ProdutosM->classe_produto($idproduto);
    }

    public function calculoIrt($irt, $total) {
        return ($irt * $total) / 100;
    }

    function calcularDias($dtInicio) {
        $date2 = date('Y-m-d'); //
        $diff = abs(strtotime($dtInicio) - strtotime($date2)); //'1999-11-04'
        $years = floor($diff / (365 * 60 * 60 * 24));
        $months = floor(($diff - $years * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24));
        $days = floor(($diff - $years * 365 * 60 * 60 * 24) / (60 * 60 * 24));
//        $days = floor(($diff - $years * 365*60*60*24 - $months*30*60*60*24)/ (60*60*24));
        return $days;
    }

    public function acharTotalPP($qtd, $valor) {
        return $total = $valor * $qtd;
    }

    public function quadroImpostosPP($idFatura) {
        $taxas = $this->mFatura->taxaIvaPP($idFatura);
        foreach ($taxas as $linha) {
            $taxa = $linha->ivaVenda;
            $incidencia = $this->mFatura->incidenciaPP($idFatura, $taxa);
            $imposto = $incidencia * $taxa / 100;
            $data[] = array(
                'taxa' => $taxa,
                'incidencia' => $incidencia,
                'imposto' => $imposto,
            );
        }
        return $data;
    }

    public function imprimirFaturaPPPDF() {
        $idDocumento = $this->input->get('idFatura');

        $this->load->model('mFatura');
        $this->load->model('mFaturaProforma');
        $this->load->model('mMoeda');
        $this->load->model('mIva');
        $this->load->model('Mbanco');
        $this->load->model('mClientes');
        $this->load->model('mempresa');
        setlocale(LC_ALL, "pt_BR", "pt_BR.iso-8859-1", "pt_BR.utf-8", "portuguese");
        $totalIva = 0;
        $totalIvaFornecedor = 0;
        $conta = 0;
        $subtotal = 0;
        $totalSemDesconto = '';
        $totalSemDescontoGera = '';
        $idCliente = $this->mFaturaProforma->idCliente($idDocumento);
        $entidade = $this->dadosEntidade($idCliente);
        $empresa = $this->dadosEmpresa();
        $banco = $this->dadosBanco();
        $resumoImpostos = $this->quadroImpostosPP($idDocumento);

        foreach ($consuta = $this->mFaturaProforma->imprimirVendasProforma($idDocumento) as $linha) {
            $idMoeda = $linha->idMoeda;
            $moeda = $this->mMoeda->pegaSimbolo($idMoeda);
            $data = $linha->data;
            $sd = new DateTime($data);
            $dt = utf8_encode(strftime("%d de %B de %Y", strtotime($sd->format("d. M. Y "))));
            $ano = utf8_encode(strftime(" %Y", strtotime($sd->format("d. M. Y "))));
            $usuario = $linha->unome;
            $idproduto = $linha->idpr;
            $ivafornecedor = $this->mIva->iva_fornecedor($idproduto);
            $totalIvaFornecedor = $totalIvaFornecedor + $ivafornecedor;
            $produto = $linha->produto . ' ' . $linha->referencia;

            $qtd = $linha->qtd;
            $dataValidade = $linha->dataValidade;
            $dias = $this->calcularDias($dataValidade);
            $custo = $linha->custo;
            $total = $this->acharTotalPP($qtd, $custo);
            $subtotal = $subtotal + $total;
            //$total_venda = $linha->total_venda;
            $hora = $linha->hora;
            //    $nunidade = $linha->nunidade; 

            $hashcontrol = $linha->hashcontrol;
            $iva = $this->mIva->calculo_iva($total, $idproduto); // valor convertido em formato de moeda
            $ivaInt = $this->mIva->calculo_iva_int($total, $idproduto);
            $totalIva = $totalIva + $ivaInt;
            $totalSemDesconto = $custo * $qtd;
            $totalSemDescontoGera = $totalSemDescontoGera + $totalSemDesconto;

            $conta++;

            $produtos[] = array(
                'conta' => $conta,
                'produto' => $produto,
                'qtd' => $qtd,
                'custo' => $custo,
                'iva' => $iva,
                'total' => $total + $ivaInt,
            );
        }
        $idRegime = $this->impostoRegime($this->mempresa->pegaRegime());
        if ($this->mempresa->pegaRegime() == 2 || $this->mempresa->pegaRegime() == 3) {
            $impostoRegime = 'IVA ' . $this->impostoRegime($this->mempresa->pegaRegime());
        } else {
            $impostoRegime = '';
        }
        $detalhesDoc = array(
            'tipoDocumento' => "Factura Pró-forma",
            'numerodocumento' => "Factura Pró-forma :PP" . $ano . '/' . $idDocumento,
            'dataEmissaoA4' => $dt . ' ' . $hora,
            'dataEntrega' => $dt,
            'totalIliquidi' => $totalSemDescontoGera,
            'subtotal' => $subtotal,
            'totalIva' => $totalIva,
            'totalGeral' => $subtotal + $totalIva,
            'idRegime' => $idRegime,
            'impostoRegime' => $impostoRegime,
            'hashcontrol' => $hashcontrol,
            'unome' => $usuario,
            'totalGeralAOA' => number_format($subtotal + $totalIva, 2, '.', '')
        );
        echo json_encode(array(
            "produtos" => $produtos,
            "entidade" => $entidade,
            "empresa" => $empresa,
            "detalhesDoc" => $detalhesDoc,
            "dadosBanco" => $banco,
            "resumoImpostos" => $resumoImpostos,
        ));
    }

    public function imprimirOrcamentoPDF() {
        $idDocumento = $this->input->get('idFatura');

        $this->load->model('mFatura');
        $this->load->model('mOrcaento');
        $this->load->model('mMoeda');
        $this->load->model('mIva');
        $this->load->model('Mbanco');
        $this->load->model('mClientes');
        $this->load->model('mempresa');
        setlocale(LC_ALL, "pt_BR", "pt_BR.iso-8859-1", "pt_BR.utf-8", "portuguese");
        $totalIva = 0;
        $totalIvaFornecedor = 0;
        $conta = 0;
        $subtotal = 0;
        $totalSemDesconto = '';
        $totalSemDescontoGera = '';
        $idCliente = $this->mOrcaento->idCliente($idDocumento);
        $entidade = $this->dadosEntidade($idCliente);
        $empresa = $this->dadosEmpresa();
        $banco = $this->dadosBanco();
        $resumoImpostos = $this->quadroImpostos($idDocumento);

        foreach ($consuta = $this->mOrcaento->imprimirVendasProforma($idDocumento) as $linha) {
            $idMoeda = $linha->idMoeda;
            $moeda = $this->mMoeda->pegaSimbolo($idMoeda);
            $data = $linha->data;
            $sd = new DateTime($data);
            $dt = utf8_encode(strftime("%A %d de %B de %Y", strtotime($sd->format("d. M. Y "))));
            $ano = utf8_encode(strftime(" %Y", strtotime($sd->format("d. M. Y "))));
            $usuario = $linha->unome;
            $idproduto = $linha->idpr;
            $ivafornecedor = $this->mIva->iva_fornecedor($idproduto);
            $totalIvaFornecedor = $totalIvaFornecedor + $ivafornecedor;
            $produto = $linha->produto;
            $nome = $linha->nome;
            $qtd = $linha->qtd;
            $dataValidade = $linha->dataValidade;
            $dias = $this->calcularDias($dataValidade);

            $custo = $linha->custo;
            $total = $this->acharTotalPP($qtd, $custo);
            $subtotal = $subtotal + $total;
            //$total_venda = $linha->total_venda;
            $hora = $linha->hora;
            //    $nunidade = $linha->nunidade; 

            $hashcontrol = $linha->hashcontrol;
            $iva = $this->mIva->calculo_iva($total, $idproduto); // valor convertido em formato de moeda
            $ivaInt = $this->mIva->calculo_iva_int($total, $idproduto);
            $totalIva = $totalIva + $ivaInt;
            $totalSemDesconto = $custo * $qtd;
            $totalSemDescontoGera = $totalSemDescontoGera + $totalSemDesconto;

            $conta++;

            $produtos[] = array(
                'conta' => $conta,
                'produto' => $produto,
                'qtd' => $qtd,
                'custo' => $custo,
                'iva' => $iva,
                'total' => $total + $ivaInt,
            );
        }
        $idRegime = $this->impostoRegime($this->mempresa->pegaRegime());
        if ($this->mempresa->pegaRegime() == 2 || $this->mempresa->pegaRegime() == 3) {
            $impostoRegime = 'IVA ' . $this->impostoRegime($this->mempresa->pegaRegime());
        } else {
            $impostoRegime = '';
        }
        $detalhesDoc = array(
            'tipoDocumento' => "Factura Pró-forma",
            'numerodocumento' => "FOrçamento :OR" . $ano . '/' . $idDocumento,
            'dataEmissaoA4' => $dt . ' ' . $hora,
            'dataEntrega' => $dt,
            'totalIliquidi' => $totalSemDescontoGera,
            'subtotal' => $subtotal,
            'totalIva' => $totalIva,
            'totalGeral' => $subtotal + $totalIva,
            'idRegime' => $idRegime,
            'impostoRegime' => $impostoRegime,
            'hashcontrol' => $hashcontrol,
            'unome' => $usuario,
            'totalGeralAOA' => number_format($subtotal + $totalIva, 2, '.', '')
        );
        echo json_encode(array(
            "produtos" => $produtos,
            "entidade" => $entidade,
            "empresa" => $empresa,
            "detalhesDoc" => $detalhesDoc,
            "dadosBanco" => $banco,
            "resumoImpostos" => $resumoImpostos,
        ));
    }

    public function imprimirDocsAnuladosPDF() {
        $idNota = $this->input->post('idNota');
        setlocale(LC_ALL, "pt_BR", "pt_BR.iso-8859-1", "pt_BR.utf-8", "portuguese");
        $this->load->model('mNotaCredito');
        $this->load->model('mFatura');
        $this->load->model('mIva');
        $this->load->model('mempresa');
        $this->load->model('Mbanco');
        $idFatura = $this->mNotaCredito->idFatura($idNota);
        $idCliente = $this->mFatura->pegaIdCliente($idFatura);
        $serie = $this->mFatura->serie($idFatura);
        $entidade = $this->dadosEntidade($idCliente);
        $resumoImpostos = $this->quadroImpostos($idFatura);
        $empresa = $this->dadosEmpresa();
        $banco = $this->dadosBanco();
        $totalGeral = 0;
        $tipoNotaCredito = "";
        $ano = "";
        $subtotal = 0;
        $totalDescontos = 0;
        $totalIva = 0;
        $totalSemDesconto = '';
        $totalSemDescontoGera = '';
        $hashcontrol = '';
        $unome = '';
        $produtos = array();
        $idTipoDocumento = $this->mFatura->tipoVenda($idFatura);
        if ($this->mNotaCredito->consultar_nota_credito($idNota)) {// se existe nota de credito parcial
            $consuta = $this->mNotaCredito->imprimirNotaCreditoParcial($idNota);
            $tipoNotaCredito = 'RECTIFICAÇÃO';
        } else {
            $consuta = $this->mNotaCredito->imprimirNotaCredito($idNota);
            $tipoNotaCredito = 'ANULAÇÃO';
        }
        if ($idTipoDocumento == 1) {
            $abrDoc = 'FT';
            $numero = $this->mFatura->pegaNumeroFtPorIdFatura($idFatura);
        } else {
            $abrDoc = 'FR';
            $numero = $this->mFatura->pegaNumeroFrPorIdFatura($idFatura);
        }
        $conta = 0;
        foreach ($consuta as $linha) {
            $idProduto = $linha->idpr;
            $produto = $linha->produto;
            $hora = $linha->hora;
            $hashcontrol = $linha->hashcontrol;
            $unome = $linha->unome;
            $nunidade = $linha->nunidade;
            $data = $linha->data;
            $sd = new DateTime($data);
            $dt = utf8_encode(strftime(" %d de %B de %Y", strtotime($sd->format("d. M. Y "))));
            $ano = utf8_encode(strftime(" %Y", strtotime($sd->format("d. M. Y "))));
            $qtd = $this->mNotaCredito->qtd($idFatura, $idProduto);
            $percentagemDesconto = $this->mNotaCredito->desconto($idFatura, $idProduto);
            $custo = $this->mNotaCredito->custo($idFatura, $idProduto);
            $desconto = $this->calcuralDesconto($this->mNotaCredito->desconto($idFatura, $idProduto), $qtd, $custo);
            $total = $this->acharTotal($this->mNotaCredito->desconto($idProduto, $idFatura), $qtd, $custo);
            $iva = $this->mIva->calculo_iva($desconto + $total, $idProduto); // valor convertido em formato de moeda
            $ivaInt = $this->mIva->calculo_iva_int($desconto + $total, $idProduto);
            if ($this->mempresa->pegaRegime() != 1) {
                $ivaInt = 0;
            }
            if ($percentagemDesconto == 100) {
                $iva = 0;
            }
            $totalIva = $totalIva + $ivaInt;
            $totalDescontos = $totalDescontos + $desconto;
            $subtotal = $subtotal + $total;
            $totalSemDesconto = $custo * $qtd;
            $totalSemDescontoGera = $totalSemDescontoGera + $totalSemDesconto;
            $totalGeral = $totalIva + $subtotal;
            $conta++;
            $produtos[] = array(
                'produto' => $produto,
                'nunidade' => $nunidade,
                'conta' => $conta,
                'qtd' => $qtd,
                'custo' => $custo,
                'percentagemDesconto' => $percentagemDesconto,
                'iva' => $iva,
                'total' => $total + $ivaInt,
            );
        }
        $impostoRegime = '';
        $idRegime = $this->impostoRegime($this->mempresa->pegaRegime());
        if ($this->mempresa->pegaRegime() == 2 || $this->mempresa->pegaRegime() == 3) {
            $impostoRegime = 'IVA ' . $this->impostoRegime($this->mempresa->pegaRegime());
        } else {
            $impostoRegime = '';
        }

        $detalhesDoc = array(
            'tipoDocumento' => "Nota de crédito:",
            'numerodocumento' => "NC" . $ano . '/' . $idNota,
            'referencia' => $abrDoc . ' ' . $serie . '/' . $numero,
            'dataEmissao' => $dt . ' ' . $hora,
            'totalIliquidi' => $totalSemDescontoGera,
            'subtotal' => $subtotal,
            'totalIva' => $totalIva,
            'totalGeral' => $subtotal + $totalIva,
            'totalIliquidi' => $totalSemDescontoGera,
            'descoComercial' => $totalDescontos,
            'totalGeral' => $totalGeral,
            'idRegime' => $idRegime,
            'impostoRegime' => $impostoRegime,
            'hashcontrol' => $hashcontrol,
            'unome' => $unome,
            'tipoNotaCredito' => $tipoNotaCredito,
            'totalGeralAOA' => number_format($totalGeral, 2, '.', '')
        );
        echo json_encode(array(
            "produtos" => $produtos,
            "entidade" => $entidade,
            "empresa" => $empresa,
            "detalhesDoc" => $detalhesDoc,
            "dadosBanco" => $banco,
            "resumoImpostos" => $resumoImpostos,
        ));
    }

}
