<?php
defined('BASEPATH') OR exit('No direct script access allowed');

if ( ! function_exists('json_encode'))
{
    function json_encode($data)
    {
        $CI =& get_instance();
        // Carrega a biblioteca se ainda não estiver carregada
        if ( ! isset($CI->Services_JSON))
        {
            $CI->load->library('Services_JSON');
        }
        return $CI->services_json->encode($data);
    }
}

if ( ! function_exists('json_decode'))
{
    function json_decode($json_string)
    {
        $CI =& get_instance();
        if ( ! isset($CI->Services_JSON))
        {
            $CI->load->library('Services_JSON');
        }
        return $CI->services_json->decode($json_string);
    }
}
