<?php

// application/migrations/001_create_stock_table.php
defined('BASEPATH') OR exit('No direct script access allowed');

class Migration_Create_stock_table extends CI_Migration {

    public function up() {
        // SQL para criar a tabela
        $sql = "CREATE TABLE stock_loja_dt_caducidade (
                    id_stock INT AUTO_INCREMENT PRIMARY KEY,
                    idProduto INT NOT NULL,
                    qtd DECIMAL(10, 2) NOT NULL,
                    lote VARCHAR(255),
                    dt_caducidade DATE,
                    CONSTRAINT fk_produto FOREIGN KEY (idProduto) REFERENCES produtos(idProduto) ON DELETE CASCADE
                )";

        // Executar a query
        $this->db->query($sql);
    }

    public function down() {
        // Se precisar desfazer a migração
        $this->db->query("DROP TABLE IF EXISTS stock_loja_dt_caducidade");
    }
}
