<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mFatura
 *
 * @author VINEVALA
 */
class mFatura extends CI_Model {

    public function registarItemEscluidos($idProduto, $qtd, $total, $idUsuario) {
        $dados = array(
            'idProduto' => $idProduto,
            'qtd' => $qtd,
            'total' => $total,
            'idUsuario' => $idUsuario,
            'data' => date('Y-m-d'),
        );
        $this->db->insert('item_cancelados', $dados);
        return $this->db->insert_id();
    }

    public function registarVendaManual($datapagamento, $serie, $numero) {
        $dados = array(
            'dataFaturaManual' => $datapagamento,
            'serie' => $serie,
            'numero' => $numero,
        );
        $this->db->insert('numero_fatura_manual', $dados);
        return $this->db->insert_id();
    }

    public function associarVendaFaturaManual($idDocManual, $idFatura) {
        $this->db->where('idDocManual', $idDocManual);
        $this->db->set('idFatura', $idFatura);
        $this->db->update('numero_fatura_manual');
    }

    public function numero_fatura_manual($numero) {
        $this->db->select('numero');
        $this->db->from('numero_fatura_manual');
        $this->db->where('numero', $numero);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function serie_fatura_manual($serie) {
        $this->db->select('serie');
        $this->db->from('numero_fatura_manual');
        $this->db->where('serie', $serie);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function grava_serie($fatura, $erie) {// grava as primeiras iniciais da serie
        $dados = array(
            'idFatura' => $fatura,
            'serie' => $erie,
        );
        $this->db->insert('serie_fatura', $dados);
    }

    public function registarVenda($idfunc, $idcliente, $total, $tatus, $formavenda, $idtipo, $idcaixa, $idMoeda, $desconto, $valorRecebido, $idLoja) {
        date_default_timezone_set('Africa/Luanda');
        $dados = array(
            'data' => @date('Y-m-d'),
            'iduser' => $idfunc,
            'idcliente' => $idcliente,
            'total_venda' => $total,
            'status' => $tatus,
            'idtipo' => $idtipo,
            'idTipopagamento' => $formavenda,
            'hora' => @date('H:i:s'),
            'idcaixa' => $idcaixa,
            'idMoeda' => $idMoeda,
            'desc_global' => $desconto,
            'valorRecebido' => $valorRecebido,
            'idLoja' => $idLoja
        );
        $this->db->insert('faturas', $dados);
        return $this->db->insert_id();
    }

    // atualizar total somando
    public function atualizarTotal($fatura, $total) {
        $this->db->where('fatura', $fatura);
        $this->db->set('total_venda', 'total_venda+' . $total, FALSE);
        $this->db->update('faturas');
    }

    // atualizar totam subtraido
    public function atualizarTotalS($fatura, $total) {
        $this->db->where('fatura', $fatura);
        $this->db->set('total_venda', 'total_venda-' . $total, FALSE);
        $this->db->update('faturas');
    }

    public function itemfatura($fatura, $idpr, $preco, $desconto, $quantidade, $total, $ivaVenda, $irt, $idUnidade) {
        date_default_timezone_set('Africa/Luanda');
        $dados = array(
            'fatura' => $fatura,
            'idpr' => $idpr,
            'qtd' => $quantidade,
            'desconto' => $desconto,
            'custo' => $preco,
            'total' => $total,
            'datavenda' => $data = @date('Y/m/d'),
            'ivaVenda' => $ivaVenda,
            'idUnidadeMedida' => $idUnidade,
            'irt' => $irt,
        );
        $this->db->insert('item_fatura', $dados);
    }

    public function regitar_pagamentos_parcelados($fatura, $cash, $tpa) {
        $dados = array(
            'idfatura' => $fatura,
            'cash' => $cash,
            'tpa' => $tpa,
        );
        $this->db->insert('pagamentos_parcelados', $dados);
    }

    public function regitar_pagamentos_parcelados2($fatura, $dinheiro, $vrtpa, $ccorrente, $tbancaria) {
        $dados = array(
            'idfatura' => $fatura,
            'cash' => $dinheiro,
            'tpa' => $vrtpa,
            'ccorrente' => $ccorrente,
            'tbancaria' => $tbancaria,
        );
        $this->db->insert('pagamentos_parcelados', $dados);
    }

    public function mregistarFormasPagamento($idFatura, $idTipo) {
        $dados = array(
            'idFatura' => $idFatura,
            'idTipo' => $idTipo,
        );
        $this->db->insert('faturas_tipo_pagamentos', $dados);
    }

    public function auxiliarM($fatura, $idfunc) {
        $dados = array(
            'fatura' => $fatura,
            'iduser' => $idfunc
        );
        $this->db->insert('auxiliarfaturas', $dados);
    }

    public function pegarNumeroFatura($idusuario) {
//        echo'modelo   '. $fatura.'   ';
        $this->db->select('fatura');
        $this->db->from('auxiliarfaturas');
        $this->db->where('iduser', $idusuario);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    //metodo auxiliar para pegra o numero da fatura 
    public function apagrUxiliarfaturaM($idusuario) {
        $this->db->where('iduser', $idusuario);
        $this->db->delete('auxiliarfaturas');
    }

    //Metodo para carregar item na carrinha de vendas
    public function listaritemM($fatura) {
        $this->db->select('*');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('fatura', $fatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo para remover Item da carrinha
    public function removerItem($id) {
        $this->db->where('iditem', $id);
        $this->db->delete('item_fatura');
    }

    // metodo que lista as vendas diarias por cada utilizador
    public function mlista_documentos_faturas($limit, $offset, $dataInicial, $dataFinal, $idFatura, $anuladas) {
        // Selecionar apenas os campos necessários
        $this->db->select('faturas.fatura as idFatura,idtipo,data,nome');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');

        // Filtro por data inicial e final
        if (!empty($dataInicial) && !empty($dataFinal)) {
            $this->db->where('faturas.data >=', $dataInicial);
            $this->db->where('faturas.data <=', $dataFinal);
        }
//
//        // Filtro por ID da fatura, se fornecido
//        if (!empty($idFatura)) {
//            $this->db->where('faturas.fatura', $idFatura);
//        }
//
//        // Filtro para faturas anuladas
//        if ($anuladas === 's') {
//            $this->db->where('faturas.status !=', 'ativa');
//        }
        // Limitar os resultados e aplicar offset
        $this->db->limit($limit, $offset);

        // Ordenar por data e hora de forma decrescente
        $this->db->order_by('faturas.data', 'DESC');

        // Executar a consulta
        $consulta = $this->db->get();

        // Retornar o resultado
        return $consulta->result();
    }

    public function somaTotalVendas($idFatura) {
        // Usando SQL para calcular diretamente o total
        $this->db->select('SUM(item_fatura.custo * item_fatura.qtd) AS totalGeral');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr = prodt.idpr');
        $this->db->where('item_fatura.fatura', $idFatura);

        // Executar a consulta
        $consulta = $this->db->get();

        // Retornar o total calculado (ou 0 se não houver resultado)
        if ($consulta->num_rows() > 0) {
            return (float) $consulta->row()->totalGeral;
        }

        return 0; // Retornar 0 caso não haja itens na fatura
    }

    public function somaTotalDesconto($idFatura) {
        // Usar SQL para calcular o total de descontos diretamente
        $this->db->select('SUM((item_fatura.custo * item_fatura.desconto / 100) * item_fatura.qtd) AS totalDescontos');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);

        // Executar a consulta
        $consulta = $this->db->get();

        // Retornar o total calculado (ou 0 se não houver resultado)
        if ($consulta->num_rows() > 0) {
            return (float) $consulta->row()->totalDescontos;
        }

        return 0; // Retornar 0 caso não haja itens na fatura
    }

    public function mTotalRegistosDockFaturas() {
        $this->db->select('COUNT(*) as total'); // Apenas conta o número de registros
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');

        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }

    public function obter_total_registos_filtrados_faturas($dataInicial, $dataFinal, $idFatura, $anuladas) {
        $this->db->select('COUNT(*) as total'); // Apenas conta o número de registros
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        if (!empty($dataInicial) && !empty($dataFinal)) {
            $this->db->where('faturas.data >=', $dataInicial);
            $this->db->where('faturas.data <=', $dataFinal);
        }

        // Filtro por ID da fatura, se fornecido
//        if (!empty($idFatura)) {
//            $this->db->where('faturas.fatura', $idFatura);
//        }
        // Filtro para faturas anuladas
//        if ($anuladas === 's') {
//            $this->db->where('faturas.status !=', 'ativa');
//        }
        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }

//metodo para contar o numero de registo existente na bd
    public function contarRegistosDeVendas($dataminima, $datamaxima, $id) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        if ($id != '')
            $this->db->where('iduser', $id);
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        } else {
            $this->db->where('data', $data);
        }
        return $this->db->count_all_results();
    }

    public function mlista_item_por_fatura($idFatura) {
        $this->db->select('');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // Consultar produto ligado a uma fatura
    public function ConsultarItem($idpr, $fatura) {
        $this->db->where('fatura', $fatura);
        $this->db->where('idpr', $idpr);
        $this->db->from('item_fatura');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    // atualizara quantidade de produto vendido por fatura
    public function atualizarItem($idpr, $fatura, $qtd, $total) {
        $this->db->where('fatura', $fatura);
        $this->db->where('idpr', $idpr);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->set('total', 'total+' . $total, FALSE);
        $this->db->update('item_fatura');
    }

    // metodo pra imprimir fatura
    public function imprimir_vendas($fatura) { // pega as item de uma fatura
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->where('faturas.fatura', $fatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo pra imprimir fatura
    public function imprimir_documentos_fatura_cliente($idCliente, $dataminima, $datamaxima) { // pega as item de uma fatura
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->where('faturas.idcliente', $idCliente);
        $this->db->where('data >=', $dataminima);
        $this->db->where('data <=', $datamaxima);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function finalizarVendasM($fatura, $tatus) {
        $this->db->where('fatura', $fatura);
        $this->db->set('status', $tatus);
        $this->db->update('faturas');
    }

    public function consultarStatusM($fatura, $tatus) {
        $this->db->where('fatura', $fatura);
        $this->db->where('status', $tatus);
        $this->db->from('faturas');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    // metodo para listar as vendas 
    public function listaDeVendas($start, $limit, $dataminima, $datamaxima, $id) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        if ($id != '')
            $this->db->where('iduser', $id);
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        } else {
            $this->db->where('data', $data);
        }
        $this->db->limit($limit, $start);
        $this->db->order_by('data', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo venda relatorio
    public function mlistaVendasPorData($dataminima, $datamaxima) {

        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->where('data >=', $dataminima);
        $this->db->where('data <=', $datamaxima);
        $this->db->order_by('data', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // soma a as vendas  no Bd
    public function somarvendasRelatorio($dataminima, $datamaxima, $id) {
        $data = date('Y/m/d');
        $this->db->select('*');
        $this->db->select_sum('total_venda');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        if ($id != '')
            $this->db->where('iduser', $id);
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        } else {
            $this->db->where('data', $data);
        }
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo para listar os produtos vendidos 
    public function listarProdutosVendidos($start, $limit, $dataminima, $datamaxima, $idproduto) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->select_sum('qtd');
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        if ($datamaxima != '') {
            $this->db->where('datavenda >=', $dataminima);
            $this->db->where('datavenda <=', $datamaxima);
        } else {
            $this->db->where('datavenda', $data);
        }
        if ($idproduto) {
            $this->db->where('prodt.idpr', $idproduto);
        }
        $this->db->limit($limit, $start);
        $this->db->group_by('prodt.idpr');
        $this->db->order_by('datavenda', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // listar produtos vendidos
    public function listarProdutosVendidosRelatorio($dataminima, $datamaxima, $idproduto) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->select_sum('qtd');
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        if ($datamaxima != '') {
            $this->db->where('datavenda >=', $dataminima);
            $this->db->where('datavenda <=', $datamaxima);
        } else {
            $this->db->where('datavenda', $data);
        }
        if ($idproduto) {
            $this->db->where('prodt.idpr', $idproduto);
        }
        $this->db->group_by('prodt.idpr');
        $this->db->order_by('datavenda', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contarProdutosVendidos() {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('item_fatura');
        return $this->db->count_all_results();
    }

    public function listarStokDiponivel() {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto=prodt.idpr');
        $this->db->order_by('produto', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo para listar os produtos mas vndidos 
    public function listarProdutosPorQauatidade($dataminima, $Qtdminimo, $Qtdmaximo, $datamaxima) {

        $this->db->select('*');
        $this->db->select_sum('qtd');
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('datavenda >=', $dataminima);
        $this->db->where('datavenda <=', $datamaxima);
        $this->db->where('qtd >=', $Qtdminimo);
        $this->db->where('qtd <=', $Qtdmaximo);
        $this->db->group_by('prodt.idpr');
        $this->db->order_by('qtd', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function consultar_fatura($fatura) {
        $this->db->where('fatura', $fatura);

        $this->db->from('faturas');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function listarTipo($fatura) {
        $this->db->where('fatura', $fatura);
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto=prodt.idpr');
        $this->db->order_by('produto', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
        $this->db->from('faturas');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function mListaFaturas() {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->where('idcliente !=', 60);
        $this->db->order_by('fatura', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mListaProdutosFaturas($idFatura, $idProduto) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('faturas.fatura', $idFatura);
        if ($idProduto != '') {
            $this->db->where('prodt.idpr', $idProduto);
        }
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mListaProdutosFaturasAnular($idFatura) {
        $this->db->select('*');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('item_fatura.fatura', $idFatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function tipoVenda($idFatura) {
        $this->db->select('idtipo');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $tipo = $value->idtipo;
            if ($tipo == 1) {
                return 'FT';
            } else {
                return 'FR';
            }
        }
    }
    public function tipoDocumento($idFatura) {
        $this->db->select('idtipo');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idtipo;      
        }
    }

    public function systemEntryate($idFatura) {
        $this->db->select('data,hora');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->data . 'T' . $value->hora;
        }
    }

    public function inVoiceDate($idFatura) {
        $this->db->select('data');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $dt->format('Y-m-d');
        }
    }

    public function serieInicio($idFatura) {
        $this->db->select('serie');
        $this->db->from('serie_fatura');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        $serie = '';
        foreach ($consulta->result() as $value) {
            return $serie = $value->serie;
        }
    }

    public function serie($idFatura) {
        $this->db->select('data');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        $s = $this->serieInicio($idFatura);
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $s . '' . $dt->format('Y');
        }
    }

    public function grossTotal($idFatura) {
        $this->db->select('total_venda');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total_venda;
        }
    }

    public function contarRegistosFaturaFt() {// verifica se ja existe registo no bd
        $this->db->select('total_venda');
        $this->db->from('faturas');
        $this->db->where('faturas.idtipo', 1);
        return $this->db->count_all_results();
    }

    public function contarRegistosFaturaFr() {// verifica se ja existe registo no bd
        $this->db->select('total_venda');
        $this->db->from('faturas');
        $this->db->where('faturas.idtipo', 2);
        return $this->db->count_all_results();
    }

    public function hash_da_ultima_fatura($idFatura, $idtipo) {
        $this->db->select('hash');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura <', $idFatura);
        $this->db->where('faturas.idtipo', $idtipo);
        $this->db->order_by('fatura', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->hash;
        }
    }

    public function matualizar_hash($fatura, $registoHash, $hasControl) {
        $dados = array(
            'hash' => $registoHash,
            'hashcontrol' => $hasControl,
        );
        $this->db->where('fatura', $fatura);
        $this->db->set($dados);
        $this->db->update('faturas');
    }

    public function ultimaData() {// pega a ultima data
        $this->db->select('data');
        $this->db->from('faturas');
        $this->db->order_by('fatura', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->data;
        }
    }

    public function pegaUltimaHora() {// pega a ultima data
        $this->db->select('hora');
        $this->db->from('faturas');
        $this->db->order_by('fatura', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->hora;
        }
    }

     public function retornaUltimaDataHora() {
        // Seleciona data e hora da tabela faturas, ordenando pela coluna "fatura" de forma decrescente
        $this->db->select('data, hora');
        $this->db->from('faturas');
        $this->db->order_by('fatura', 'DESC');
        $this->db->limit(1);

        $consulta = $this->db->get();
        $resultado = $consulta->row();
        if ($resultado) {
            return $resultado->data . ' ' . $resultado->hora;
        } else {
            return ''; // ou retorne null, conforme a necessidade
        }
    }

    public function pegaUltimaHoraFatura($idFatura) {//pega a hora por fatura
        $this->db->select('hora');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->hora;
        }
    }

    public function retornaUltimaDataHoraPorFatura($idFatura) {// pega a data por fatura
        $this->db->select('data');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->data . ' ' . $this->pegaUltimaHoraFatura($idFatura);
        }
    }

    public function verifica_fatura_reportada_agt($idFatura) {
        $this->db->select('idFatura');
        $this->db->from('faturas_reportadas_agt');
        $this->db->where('idFatura', $idFatura);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function registarFaturaPendente($idcliente, $totalgeral) {

        $dados = array(
            'data' => date('Y-m-d'),
            'idcliente' => $idcliente,
            'total_pendente' => $totalgeral,
            'status' => 'Em espera',
        );
        $this->db->insert('faturas_pendente', $dados);
        return $this->db->insert_id();
    }

    public function itemfaturaPendente($idFaturaPendente, $idProduto, $valor, $desconto, $qtd, $total, $iva) {
        $dados = array(
            'idpendente' => $idFaturaPendente,
            'idpr' => $idProduto,
            'qtd' => $qtd,
            'desconto' => $desconto,
            'custo' => $valor,
            'total' => $total,
            'iva' => $iva,
        );
        $this->db->insert('item_fatura_pendente', $dados);
    }

    public function mlistaVendaPendentes() {
        $this->db->select('*');
        $this->db->from('faturas_pendente');
        $this->db->join('clientes', 'faturas_pendente.idcliente=clientes.idcliente');
        $this->db->where('faturas_pendente.status', 'Em espera');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mlistaVendaPendentesItem($idPendente) {
        $this->db->select('*');
        $this->db->from('item_fatura_pendente');
        $this->db->join('prodt', 'item_fatura_pendente.idpr=prodt.idpr');
        $this->db->join('faturas_pendente', 'item_fatura_pendente.idpendente=faturas_pendente.id');
        $this->db->join('clientes', 'faturas_pendente.idcliente=clientes.idcliente');
        $this->db->where('item_fatura_pendente.idpendente', $idPendente);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mapagarVendasPendentes($idPendente) {
        $this->db->where('faturas_pendente.id', $idPendente);
        $this->db->delete('faturas_pendente');
    }

    public function mFinalizaVendePendente($idPendete) {
        $this->db->where('id', $idPendete);
        $this->db->set('status', 'Finalizada');
        $this->db->update('faturas_pendente');
    }

    public function malterarVendePendente($idPendete) {
        $this->db->where('id', $idPendete);
        $this->db->set('status', 'Alterada');
        $this->db->update('faturas_pendente');
    }

    public function pegaDescontoGlobal($idFatura) {
        $this->db->select('desc_global');
        $this->db->from('faturas');
        $this->db->where('faturas.fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->desc_global;
        }
    }

    public function grserieFaturaCliente($idFatura, $serie) {
        $dados = array(
            'idFatura' => $idFatura,
            'serie' => $serie,
        );
        $this->db->insert('serieFaturaCliente', $dados);
    }

    public function consultaSerieFatura($idFatura) {// verifica se a fatura possui a serie fornecida pelo cliente
        $this->db->select('idFatura');
        $this->db->from('serieFaturaCliente');
        $this->db->where('idFatura', $idFatura);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function pegaSerie($idFatura) {// serie fornecida pelo cliente
        $this->db->select('serie');
        $this->db->from('serieFaturaCliente');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->serie;
        }
    }

    public function verificarProduto($idpr) {
        $this->db->select('idpr');
        $this->db->from('item_fatura');
        $this->db->where('idpr', $idpr);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function estado($idFatura) {
        $this->db->select('estado');
        $this->db->from('faturas');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->estado;
        }
    }

    public function atualizarEstado($fatura, $estado) {
        $this->db->where('fatura', $fatura);
        $this->db->set('estado', $estado);
        $this->db->update('faturas');
    }

    public function gravanumeroFt($idFatura, $numero) {

        $dados = array(
            'idFatura' => $idFatura,
            'numero' => $numero,
        );
        $this->db->insert('numero_fatura_ft', $dados);
    }

    public function gravanumeroFr($idFatura, $numero) {

        $dados = array(
            'idFatura' => $idFatura,
            'numero' => $numero,
        );
        $this->db->insert('numero_fatura_fr', $dados);
    }

    public function pegaIdCliente($idFatura) {
        $this->db->select('idcliente');
        $this->db->from('faturas');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idcliente;
        }
    }

    public function pegaIdUsuario($idFatura) {
        $this->db->select('iduser');
        $this->db->from('faturas');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->iduser;
        }
    }

    public function pegaProdutosResumo($dataVenda, $idUsuario) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('faturas.data', $dataVenda);
        $this->db->where('faturas.iduser', $idUsuario);
        $this->db->group_by('item_fatura.idpr');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function serieConsultaMesa($idFatura) {
        $this->db->select('data');
        $this->db->from('faturas_pendente');
        $this->db->where('faturas_pendente.id', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $dt->format('Y');
        }
    }

    public function serieConsultaMesa2($idVenda) {
        $this->db->select('data');
        $this->db->from('carrinho');
        $this->db->where('carrinho.idVenda', $idVenda);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $dt->format('Y');
        }
    }

    public function serieConsultaContaBalcao($idVenda) {
        $this->db->select('data');
        $this->db->from('carrinho');
        $this->db->where('carrinho.idVenda', $idVenda);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $dt->format('Y');
        }
    }

    public function consulta_fatura_manual($idFatura) {
        $this->db->select('idFatura');
        $this->db->from('numero_fatura_manual');
        $this->db->where('idFatura', $idFatura);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function pega_serie_manual($idFatura) {
        $this->db->select('serie');
        $this->db->from('numero_fatura_manual');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->serie;
        }
    }

    public function pega_numero_manual($idFatura) {
        $this->db->select('numero');
        $this->db->from('numero_fatura_manual');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->numero;
        }
    }

    public function pega_data_fatura_manual($idFatura) {
        $this->db->select('dataFaturaManual');
        $this->db->from('numero_fatura_manual');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->dataFaturaManual;
        }
    }

    public function pega_data_fatura($idFatura) {
        $this->db->select('data');
        $this->db->from('faturas');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->data;
        }
    }

    public function descontos($idFatura, $idProduto) {
        $this->db->select('desconto');
        $this->db->from('item_fatura');
        $this->db->where('iditem', $idProduto);
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->desconto;
        }
    }

    // atualiza o total Geral na carrinha de venda para restaurante
    public function atualizarTotalGeral($idVenda, $total) {
        $this->db->where('idVenda', $idVenda);
        $this->db->where('idVenda', $idVenda);
        $this->db->set('total_geral', 'total_geral+' . $total, FALSE);
        $this->db->update('carrinho_mesas');
    }

    public function atualizarTotalGeralCarrinha($idVenda, $total) {
        $this->db->where('idVenda', $idVenda);
        $this->db->set('total_geral', 'total_geral+' . $total, FALSE);
        $this->db->update('carrinho');
    }

    public function atualizarTotalQtd($idVenda, $total, $idpr, $qtd) {
        $this->db->where('idVenda', $idVenda);
        $this->db->where('idpr', $idpr);
        $this->db->set('total', 'total+' . $total, FALSE);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->update('item_carrinho_mesas');
    }

    public function atualizarTotalQtd2($idVenda, $total, $idpr, $qtd, $idUnidade) {
        $this->db->where('idVenda', $idVenda);
        $this->db->where('idpr', $idpr);
        $this->db->where('idUnidade', $idUnidade);
        $this->db->set('total', 'total+' . $total, FALSE);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->update('item_carrinho');
    }

    public function verificarItemCarrinho($idVenda, $idpr) {
        return $this->db->from('item_carrinho_mesas')
                        ->where('idVenda', $idVenda)
                        ->where('idpr', $idpr)
                        ->get()
                        ->num_rows();
    }

    public function verificarItemCarrinho2($idVenda, $idpr, $idUnidade) {
        return $this->db->from('item_carrinho')
                        ->where('idVenda', $idVenda)
                        ->where('idpr', $idpr)
                        ->where('idUnidade', $idUnidade)
                        ->get()
                        ->num_rows();
    }

    public function registaItemCarrinho2($idVenda, $idProduto, $qtd, $desconto, $custo, $total, $iva, $idGrupoPreco) {
        $dados = array(
            'idVenda' => $idVenda,
            'idpr' => $idProduto,
            'qtd' => $qtd,
            'desconto' => $desconto,
            'custo' => $custo,
            'total' => $total,
            'iva' => $iva,
            'idGrupoPreco' => $idGrupoPreco,
        );
        $this->db->insert('item_carrinho', $dados);
    }

    public function registaItemCarrinho($idVenda, $idProduto, $qtd, $desconto, $custo, $total, $iva) {
        $dados = array(
            'idVenda' => $idVenda,
            'idpr' => $idProduto,
            'qtd' => $qtd,
            'desconto' => $desconto,
            'custo' => $custo,
            'total' => $total,
            'iva' => $iva,
        );
        $this->db->insert('item_carrinho_mesas', $dados);
    }

    public function mlistaItemCarrinhoMesa($idMesa, $idUsuario) {
        $this->db->select('*');
        $this->db->from('carrinho_mesas');
        $this->db->join('item_carrinho_mesas', 'carrinho_mesas.idVenda=item_carrinho_mesas.idVenda');
        $this->db->join('prodt', 'item_carrinho_mesas.idpr=prodt.idpr');
        $this->db->where('carrinho_mesas.idMesa', $idMesa);
        $this->db->where('carrinho_mesas.idUsuario', $idUsuario);
        $this->db->where('status', 'Aberta');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mlistaItemCarrinhoMesa2($idVenda, $idMesa, $idUsuario) {
        $this->db->select('*');
        $this->db->from('carrinho');
        $this->db->join('item_carrinho', 'carrinho.idVenda=item_carrinho.idVenda');
        $this->db->join('prodt', 'item_carrinho.idpr=prodt.idpr');
        if (!empty($idMesa)) {
            $this->db->join('mesa_uso', 'carrinho.idVenda=mesa_uso.idVenda');
            $this->db->where('idUsuario', $idUsuario);
            $this->db->where('idMesa', $idMesa);
            $this->db->where('statu_mesa', 'Aberta');
        } else {
            $this->db->where('carrinho.idVenda', $idVenda);
        }

        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pegaDescontoItemCarrinho($idVenda, $iditem) {
        $this->db->select('desconto');
        $this->db->from('item_carrinho');
        $this->db->where('idVenda', $idVenda);
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->desconto;
        }
    }

   public function mlistaItemCarrinhoPorFinalizar() {
    $this->db->select("carrinho.idVenda, ANY_VALUE(carrinho.total_geral) as total_geral, ANY_VALUE(prodt.idpr) as idpr", false);
    $this->db->from('carrinho');
    $this->db->join('item_carrinho', 'carrinho.idVenda = item_carrinho.idVenda');
    $this->db->join('usuarios', 'carrinho.idUsuario = usuarios.id_usiario');
    $this->db->join('prodt', 'item_carrinho.idpr = prodt.idpr');
    $this->db->where('status', 'Em curso');
    $this->db->group_by('carrinho.idVenda');
    $consulta = $this->db->get();
    return $consulta->result();
}

    public function contaDocumentosPorFinalizar() {
        $status = 'Em curso';
        $this->db->select('carrinho.idVenda');  // Seleciona o idVenda para contar
        $this->db->from('carrinho');
        $this->db->join('item_carrinho', 'carrinho.idVenda=item_carrinho.idVenda');
        $this->db->join('usuarios', 'carrinho.idUsuario=usuarios.id_usiario');
        $this->db->join('prodt', 'item_carrinho.idpr=prodt.idpr');
        $this->db->where('status', $status);  // Filtro de status 'Em curso'
        $this->db->group_by('carrinho.idVenda');  // Agrupa por idVenda
        // Executa a consulta e retorna o número de registros
        return $this->db->get()->num_rows();
    }

    public function mdetalhesDocumento($idVenda) {
        $this->db->select('*');
        $this->db->from('item_carrinho');
        $this->db->join('prodt', 'item_carrinho.idpr=prodt.idpr');
        $this->db->where('idVenda', $idVenda);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contarNumerosLinhas($idVenda) {
        return $this->db->from('item_carrinho')
                        ->where('idVenda', $idVenda)
                        ->get()
                        ->num_rows();
    }

    public function totalCarrinhoMesa($idMesa, $idUsuario) {// serie fornecida pelo cliente
        $this->db->select('total_geral');
        $this->db->from('carrinho');
        $this->db->join('mesa_uso', 'carrinho.idVenda=mesa_uso.idVenda');
        $this->db->where('mesa_uso.idMesa', $idMesa);
        $this->db->where('carrinho.idUsuario', $idUsuario);
        $this->db->where('statu_mesa', 'Aberta');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total_geral;
        }
    }

    public function idVenda($idMesa, $idUsuario) {// pega id da venda por Mesa e Utilizador
        $this->db->select('mesa_uso.idVenda');
        $this->db->from('carrinho');
        $this->db->join('mesa_uso', 'carrinho.idVenda=mesa_uso.idVenda');
        $this->db->where('mesa_uso.idMesa', $idMesa);
        $this->db->where('carrinho.idUsuario', $idUsuario);
        $this->db->where('statu_mesa', 'Aberta');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idVenda;
        }
    }

    public function idVenda2($iditem) {// pega id da venda por item nas vendas para restautante
        $this->db->select('idVenda');
        $this->db->from('item_carrinho_mesas');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idVenda;
        }
    }

    public function idVenda3($iditem) {
        $this->db->select('idVenda');
        $this->db->from('item_carrinho');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idVenda;
        }
    }

    public function tota_por_linha($iditem) {// 
        $this->db->select('total');
        $this->db->from('item_carrinho_mesas');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function tota_por_linha2($iditem) {// 
        $this->db->select('total');
        $this->db->from('item_carrinho');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function mremoveItemCarrinha($iditem) {
        $this->db->where('iditem', $iditem);
        if ($this->db->delete('item_carrinho_mesas')) {
            return true;
        } else {
            return false;
        }
    }

    public function contarNumerosItemRestaurante($idVenda) {
        return $this->db->from('item_carrinho_mesas')
                        ->where('idVenda', $idVenda)
                        ->get()
                        ->num_rows();
    }

    public function cancelarVendaRestaurante($idVenda) {
        $this->db->where('idVenda', $idVenda);
        if ($this->db->delete('carrinho_mesas')) {
            return true;
        } else {
            return false;
        }
    }

    public function mremoveItemCarrinha2($iditem) {
        $this->db->where('iditem', $iditem);
        if ($this->db->delete('item_carrinho')) {
            return true;
        } else {
            return false;
        }
    }

    public function contarNumerosItemBalcao($idVenda) {
        return $this->db->from('item_carrinho')
                        ->where('idVenda', $idVenda)
                        ->get()
                        ->num_rows();
    }

    public function subtrairTotalGeral($idVenda, $total) {
        $this->db->where('idVenda', $idVenda);
        $this->db->set('total_geral', 'total_geral-' . $total, FALSE);
        $this->db->update('carrinho_mesas');
    }

    public function subtrairTotalGeral2($idVenda, $total) {
        $this->db->where('idVenda', $idVenda);
        $this->db->set('total_geral', 'total_geral-' . $total, FALSE);
        $this->db->update('carrinho');
    }

    public function tota_qtd($idMesa, $idUsuario) {// 
        $this->db->select_sum('qtd');
        $this->db->from('carrinho_mesas');
        $this->db->join('item_carrinho_mesas', 'carrinho_mesas.idVenda=item_carrinho_mesas.idVenda');
        $this->db->where('carrinho_mesas.idMesa', $idMesa);
        $this->db->where('carrinho_mesas.idUsuario', $idUsuario);
        $this->db->where('status', 'Aberta');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function tota_qtd2($idVenda) {// 
        $this->db->select_sum('qtd');
        $this->db->from('carrinho');
        $this->db->join('item_carrinho', 'carrinho.idVenda=item_carrinho.idVenda');
        $this->db->where('carrinho.idVenda', $idVenda);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function itemCarrinho($idVenda) {
        $this->db->select('*');
        $this->db->from('carrinho');
        $this->db->join('item_carrinho', 'carrinho.idVenda=item_carrinho.idVenda');
        $this->db->join('prodt', 'item_carrinho.idpr=prodt.idpr');
        $this->db->where('carrinho.idVenda', $idVenda);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function itemCarrinhoMesas($idVenda) {
        $this->db->select('*');
        $this->db->from('carrinho_mesas');
        $this->db->join('item_carrinho_mesas', 'carrinho_mesas.idVenda=item_carrinho_mesas.idVenda');
        $this->db->join('prodt', 'item_carrinho_mesas.idpr=prodt.idpr');
        $this->db->where('carrinho_mesas.idVenda', $idVenda);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // Finalizar Venda Restaurante
    public function atualizarEstadoCarrinhoMesas($idVenda) {
        $this->db->where('idVenda', $idVenda);
        $this->db->set('statu_mesa', 'Finalizada');
        $this->db->update('mesa_uso');
    }

    // Finalizar outras Venda 
    public function atualizarEstadoCarrinho($idVenda) {
        $this->db->where('idVenda', $idVenda);
        $this->db->set('status', 'Finalizada');
        $this->db->update('carrinho');
    }

    public function cancelarVendam($idVenda) {
        $this->db->where('idVenda', $idVenda);
        if ($this->db->delete('carrinho')) {
            return true;
        } else {
            return false;
        }
    }

    public function consulta_emei_produto($idVenda, $idpr) {
        $this->db->select('imei');
        $this->db->from('item_carrinho_imei');
        $this->db->where('idVenda', $idVenda);
        $this->db->where('idpr', $idpr);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function consulta_sim_produto($idVenda, $idpr) {
        $this->db->select('sim_numero');
        $this->db->from('item_carrinho_sim');
        $this->db->where('idVenda', $idVenda);
        $this->db->where('idpr', $idpr);

        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function mRegistaImeil($idFatura, $idpr, $imei) {
        $dados = array(
            'idFatura' => $idFatura,
            'idpr' => $idpr,
            'imei' => $imei,
        );
        $this->db->insert('item_fatura_imei', $dados);
    }

    public function mRegistaSim($idFatura, $idpr, $sim_numero) {
        $dados = array(
            'idFatura' => $idFatura,
            'idpr' => $idpr,
            'sim_numero' => $sim_numero,
        );
        $this->db->insert('item_fatura_sim', $dados);
    }

    public function listaImeii($idVenda, $idProduto) {
        $this->db->select('*');
        $this->db->from('item_carrinho_imei');
        $this->db->where('idVenda', $idVenda);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaSim($idVenda, $idProduto) {
        $this->db->select('*');
        $this->db->from('item_carrinho_sim');
        $this->db->where('idVenda', $idVenda);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaImeiFatura($idVenda, $idProduto) {
        $this->db->select('*');
        $this->db->from('item_fatura_imei');
        $this->db->where('idFatura', $idVenda);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaSimFatura($idVenda, $idProduto) {
        $this->db->select('*');
        $this->db->from('item_fatura_sim');
        $this->db->where('idFatura', $idVenda);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function consultaCliente($idcliente) {
        $this->db->select('idcliente');
        $this->db->from('faturas');
        $this->db->where('idcliente', $idcliente);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function mListaUsuarioCaixa() {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->group_by('iduser');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mListaLojas() {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('armanzes', 'faturas.idLoja=armanzes.id');
        $this->db->group_by('idLoja');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaResumoVendas($dataminima, $datamaxima, $idUsuario, $idLoja) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->where('data >=', $dataminima);
        $this->db->where('data <=', $datamaxima);
        if ($idUsuario != 0) {
            $this->db->where('iduser', $idUsuario);
        }
        if ($idLoja != 0) {
            $this->db->where('idLoja', $idLoja);
        }
        $this->db->group_by('item_fatura.idpr');
        $this->db->order_by('produto', 'ASC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaResumoVendasOperador($dataminima, $datamaxima, $idUsuario) {
        $this->db->select('*');
        $this->db->from('faturas');

        $this->db->where('data >=', $dataminima);
        $this->db->where('data <=', $datamaxima);
        if (!empty($idUsuario)) {
            $this->db->where('iduser', $idUsuario);
        }
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mpega_qtd($dataminima, $datamaxima, $idUsuario, $idLoja, $idProduto) {
        $this->db->select_sum('qtd');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("idpr", $idProduto);
        if ($idUsuario != 0) {
            $this->db->where('iduser', $idUsuario);
        }
        if ($idLoja != 0) {
            $this->db->where('idLoja', $idLoja);
        }
        $this->db->where("datavenda >=", $dataminima);
        $this->db->where("datavenda <=", $datamaxima);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->qtd) {
                return $value->qtd;
            } else {
                return 0;
            }
        }
    }

    public function mpega_preco_venda($dataminima, $datamaxima, $idUsuario, $idLoja, $idProduto) {
        $this->db->select_sum('custo');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("idpr", $idProduto);
        if ($idUsuario != 0) {
            $this->db->where('iduser', $idUsuario);
        }
        if ($idLoja != 0) {
            $this->db->where('idLoja', $idLoja);
        }
        $this->db->where("datavenda >=", $dataminima);
        $this->db->where("datavenda <=", $datamaxima);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->custo) {
                return $value->custo;
            } else {
                return 0;
            }
        }
    }

    public function conta_vezes_produto($dataminima, $datamaxima, $idUsuario, $idLoja, $idProduto) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("idpr", $idProduto);
        if ($idUsuario != 0) {
            $this->db->where('iduser', $idUsuario);
        }
        if ($idLoja != 0) {
            $this->db->where('idLoja', $idLoja);
        }
        $this->db->where("datavenda >=", $dataminima);
        $this->db->where("datavenda <=", $datamaxima);
        return $this->db->count_all_results();
    }

    public function mpega_total($dataminima, $datamaxima, $idUsuario, $idLoja, $idProduto) {
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("idpr", $idProduto);
        if ($idUsuario != 0) {
            $this->db->where('iduser', $idUsuario);
        }
        if ($idLoja != 0) {
            $this->db->where('idLoja', $idLoja);
        }
        $this->db->where("datavenda >=", $dataminima);
        $this->db->where("datavenda <=", $datamaxima);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->total) {
                return $value->total;
            } else {
                return 0;
            }
        }
    }

    public function registar_documentos_emitidos($tipoVenda, $idVenda) {
        $dados = array(
            'idVenda' => $idVenda,
            'idTipoDocumento' => $tipoVenda,
        );
        $this->db->insert('documentos_emitidos', $dados);
        return $this->db->insert_id();
    }

    public function registar_docs_ft_fr($idFatura, $idDocumentoEmitido) {
        $dados = array(
            'idFatura' => $idFatura,
            'idDocumentoEmitido' => $idDocumentoEmitido,
        );
        $this->db->insert('docs_ft_fr', $dados);
    }

    public function pega_idDocumentoEmitido($idFatura) {// 
        $this->db->select('idDocumentoEmitido');
        $this->db->from('docs_ft_fr');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idDocumentoEmitido;
        }
    }

    public function p_idVenda($idTipoDocumento) {// 
        $this->db->select('idVenda');
        $this->db->from('documentos_emitidos');
        $this->db->where('idDocumentoEmitido', $idTipoDocumento);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idVenda;
        }
    }

    public function total_geral_id_venda($idVenda) {// 
        $this->db->select_sum('total');
        $this->db->from('item_carrinho');
        $this->db->where('idVenda', $idVenda);
        $consulta = $this->db->get();

        // Verifica se há resultados
        if ($consulta->num_rows() > 0) {
            $resultado = $consulta->row(); // Obtém a primeira linha do resultado
            return $resultado->total; // Retorna a soma total
        }

        return 0; // Retorna 0 se não houver resultados
    }

    public function total_item($iditem) {// 
        $this->db->select('total');
        $this->db->from('item_carrinho');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function alterarTotalCarinho($idVenda, $total) {
        $this->db->where('idVenda', $idVenda);
        $this->db->set('total_geral', $total);
        $this->db->update('carrinho');
    }

    public function alterarItemCarinho($iditem, $qtd, $desconto, $custo, $total, $iva, $idGrupoPreco) {
        $this->db->where('iditem', $iditem);
        $this->db->set('qtd', $qtd);
        $this->db->set('desconto', $desconto);
        $this->db->set('custo', $custo);
        $this->db->set('total', $total);
        $this->db->set('iva', $iva);
        $this->db->set('idGrupoPreco', $idGrupoPreco);
        $this->db->update('item_carrinho');
    }

    public function verifica_idVenda_mesa($idVenda) {
        $this->db->where('idVenda', $idVenda);
        $this->db->from('mesa_uso');
        return $this->db->count_all_results();
    }

//    public function mVendasPorArtigo($dataminima, $datamaxima) {
//        $this->db->select('categorias.idcategoria,categorias.categoria');
//        $this->db->from('faturas');
//        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
//        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
//        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');
//        $this->db->where("datavenda >=", $dataminima);
//        $this->db->where("datavenda <=", $datamaxima);
////        if (!empty($idCategoriaView)) {
////            $this->db->where('prodt.idcategoria', $idCategoriaView);
////        }
//        $this->db->group_by('categorias.idcategoria');
//        $this->db->order_by('categorias.categoria', 'ASC');
//        $consulta = $this->db->get();
//        return $consulta->result();
//    }

    public function mResumoVendasPorArtigo($dataminima, $datamaxima) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->where('data >=', $dataminima);
        $this->db->where('data <=', $datamaxima);
        $this->db->group_by('item_fatura.idpr');
        $this->db->order_by('prodt.idcategoria,prodt.produto', 'ASC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mpega_total2($dataminima, $datamaxima, $idProduto) {
        // Seleciona a soma do campo 'total' da tabela 'faturas'
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura = item_fatura.fatura');

        // Filtra pelo ID do produto e intervalo de datas
        $this->db->where('idpr', $idProduto);
        $this->db->where('datavenda >=', $dataminima);
        $this->db->where('datavenda <=', $datamaxima);

        // Executa a consulta
        $consulta = $this->db->get();
        $row = $consulta->row();
        // Retorna o valor da soma ou 0 se for nulo
        return isset($row->total) ? $row->total : 0;
    }

    public function idProdutoByItem($iditem) {// 
        $this->db->select('idpr');
        $this->db->from('item_carrinho');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idpr;
        }
    }

    public function qtdByItem($iditem) {// 
        $this->db->select('qtd');
        $this->db->from('item_carrinho');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function custoByItem($iditem) {// 
        $this->db->select('custo');
        $this->db->from('item_carrinho');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custo;
        }
    }

    public function ivaByItem($iditem) {// 
        $this->db->select('iva');
        $this->db->from('item_carrinho');
        $this->db->where('iditem', $iditem);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->iva;
        }
    }

    public function contaIdProduto($idVenda, $idProduto) {
        return $this->db->from('item_carrinho')
                        ->where('idVenda', $idVenda)
                        ->where('idpr', $idProduto)
                        ->get()
                        ->num_rows();
    }

    public function idUsuario($idVenda) {// 
        $this->db->select('idUsuario');
        $this->db->from('carrinho');
        $this->db->where('idVenda', $idVenda);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idUsuario;
        }
    }

    public function grafico_tota_mes_por_fatura_fr($idMes) {// 
        $ano = date('Y');
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where('idtipo', 2);
        $this->db->where("YEAR(datavenda)=$ano");
        $this->db->where("MONTH(datavenda)=$idMes");
        $this->db->where("item_fatura.estado", 'N');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function grafico_tota_mes_por_fatura_ft($idMes) {// 
        $ano = date('Y');
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where('idtipo', 1);
        $this->db->where("YEAR(datavenda)=$ano");
        $this->db->where("MONTH(datavenda)=$idMes");
        $this->db->where("item_fatura.estado", 'N');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function mgrafico_tota_mes($idMes) {// 
        $ano = date('Y');
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("YEAR(datavenda)=$ano");
        $this->db->where("MONTH(datavenda)=$idMes");
        $this->db->where("item_fatura.estado", 'N');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function mNovaDocumento($idUsuario) {

        $dados = array(
            'data' => @date('Y-m-d'),
            'idUsuario' => $idUsuario,
            'total_geral' => 0,
            'status' => 'Em curso',
        );
        $this->db->insert('carrinho', $dados);
        return $this->db->insert_id();
    }

    public function pegaUltimafaturaFr() {
        $this->db->select('idFatura');
        $this->db->from('numero_fatura_fr');
        $this->db->order_by('id', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        $idFatura = 0;
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->idFatura;
        }
    }

    public function pegaDataFatura($fatura) {
        $this->db->select('data');
        $this->db->from('faturas');
        $this->db->where('fatura', $fatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $dt->format('Y');
        }
    }

    public function pegaUltimoNumeroFr() {// pega o ultimo numero da fatura
        $this->db->select('numero');
        $this->db->from('numero_fatura_fr');
        $this->db->order_by('id', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        $idFatura = 0;
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->numero;
        }
    }

    public function pegaUltimafaturaFt() {
        $this->db->select('idFatura');
        $this->db->from('numero_fatura_ft');
        $this->db->order_by('id', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        $idFatura = 0;
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->idFatura;
        }
    }

    public function pegaUltimoNumeroFt() {
        $this->db->select('numero');
        $this->db->from('numero_fatura_ft');
        $this->db->order_by('id', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        $idFatura = 0;
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->numero;
        }
    }

    public function pegaNumeroFtPorIdFatura($idFatura) {// pega  numero da fatura 
        $this->db->select('numero');
        $this->db->from('numero_fatura_ft');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->numero;
        }
    }

    public function pegaUltimafaturaFTPorNumero($numero) {
        $this->db->select('idFatura');
        $this->db->from('numero_fatura_ft');
        $this->db->where('numero', $numero);
        $this->db->order_by('id', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        $idFatura = 0;
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->idFatura;
        }
    }

    public function pegaNumeroFrPorIdFatura($idFatura) {// pega  numero da fatura 
        $this->db->select('numero');
        $this->db->from('numero_fatura_fr');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->numero;
        }
    }

    public function pegaUltimafaturaFrPorNumero($numero) {
        $this->db->select('idFatura');
        $this->db->from('numero_fatura_fr');
        $this->db->where('numero', $numero);
        $this->db->order_by('id', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        $idFatura = 0;
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->idFatura;
        }
    }

    public function tipoPagamento($fatura) {
        $this->db->select('idTipopagamento');
        $this->db->from('faturas');
        $this->db->where('fatura', $fatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idTipopagamento;
        }
    }

    public function forma_pagamento($idTipo) {// pegar o tipo de pagamento
        $this->db->select('tipo');
        $this->db->from('tipopagamento');
        $this->db->where('idTipo', $idTipo);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->tipo;
        }
    }

    public function valorRecebido($idFatura) {// pega  numero da fatura 
        $this->db->select('valorRecebido');
        $this->db->from('faturas');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->valorRecebido;
        }
    }

    public function troco($idFatura) {// pega  numero da fatura 
        $this->db->select('troco');
        $this->db->from('faturas');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->troco;
        }
    }

    public function taxaIva($idFatura) {
        $this->db->select('IFNULL(ivaVenda, 0) as ivaVenda'); // Substitui NULL por 0
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->group_by('item_fatura.ivaVenda');
        $this->db->order_by('ivaVenda', 'ASC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function taxaIvaPP($idFatura) {
        $this->db->select('IFNULL(ivaVenda, 0) as ivaVenda'); // Substitui NULL por 0
        $this->db->from('item_fatura_pro_forma');
        $this->db->where('idFatura', $idFatura);
        $this->db->group_by('item_fatura_pro_forma.ivaVenda');
        $this->db->order_by('ivaVenda', 'ASC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function incidencia($idFatura, $taxa) {
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->where('ivaVenda', $taxa);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->total;
        }
    }

    public function incidenciaPP($idFatura, $taxa) {
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->where('ivaVenda', $taxa);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $idFatura = $value->total;
        }
    }

    public function pegaTotalParcial14($idFatura) {  // pega o total das faturas anuladas Parcialmete com imposto de 14
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->where('estado', 'P');
        $this->db->where('ivaVenda', 14);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function pegaTotalParcialIsento($idFatura) {  // pega o total das faturas anuladas Parcialmete sentos de iva
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->where('estado', 'P');
        $this->db->where('ivaVenda', 0);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function listaItensFctura($idFatura) {
        $this->db->select('');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaResumoVendasDivisoes($dataminima, $datamaxima) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->where("data >=", $dataminima);
        $this->db->where("data <=", $datamaxima);
        $this->db->group_by('iduser');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function conta_tota_faturas($dataminima, $datamaxima, $iduser) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->where("data >=", $dataminima);
        $this->db->where("data <=", $datamaxima);
        $this->db->where('iduser', $iduser);
        return $this->db->count_all_results();
    }

    public function listar_vendas_cash($dataminima, $datamaxima, $iduser) {
        // Always specify tables for columns to avoid ambiguity
        $this->db->select_sum('item_fatura.total', 'total_sum'); // Explicit alias
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura = item_fatura.fatura');

        // Specify table names for each column
        $this->db->where('faturas.iduser', $iduser);
        $this->db->where('item_fatura.datavenda >=', $dataminima);
        $this->db->where('item_fatura.datavenda <=', $datamaxima);
        $this->db->where('faturas.idTipopagamento', 1); // Assuming payment type is in faturas

        $query = $this->db->get();

        // Directly get the result row
        $result = $query->row();

        // Handle cases where no rows are returned
        return ($result && $result->total_sum) ? $result->total_sum : 0;
    }

    public function soma_vendas_a_credito($dataminima, $datamaxima, $iduser) {
        $this->db->select_sum('total_venda');
        $this->db->from('faturas');
        $this->db->where("data >=", $dataminima);
        $this->db->where("data <=", $datamaxima);
        $this->db->where('iduser', $iduser);
        $this->db->where('idtipo', 1);

        $consulta = $this->db->get();
        $resultado = $consulta->row(); // Retorna um único objeto

        return isset($resultado->total_venda) ? $resultado->total_venda : 0;
    }

    public function listar_vendas_tpa($dataminima, $datamaxima, $iduser) {
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura = item_fatura.fatura');
        $this->db->where('iduser', $iduser);
        $this->db->where('item_fatura.datavenda >=', $dataminima);
        $this->db->where('item_fatura.datavenda <=', $datamaxima);
        $this->db->where('idTipopagamento', 2);

        $consulta = $this->db->get();
        $resultado = $consulta->row(); // Obtém um único resultado

        return isset($resultado->total) && $resultado->total > 0 ? $resultado->total : 0;
    }

    public function listar_vendas_trans_banc($dataminima, $datamaxima, $iduser) {  // lista as vendas em cash para tela de control do ponto de venda
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura = item_fatura.fatura');
        $this->db->where('iduser', $iduser);
        $this->db->where('item_fatura.datavenda >=', $dataminima);
        $this->db->where('item_fatura.datavenda <=', $datamaxima);
        $this->db->where('idTipopagamento', 7);
        $consulta = $this->db->get();
        $resultado = $consulta->row(); // Obtém um único resultado
        return isset($resultado->total) && $resultado->total > 0 ? $resultado->total : 0;
    }

}
