<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of MProvincias
 *
 * @author VINEVALA
 */
class MProvincias extends CI_Model {

    public function gravarProvinciaM($provincia, $idpais) {
        $dados = array(
            'provincia' => $provincia,
            'idpais' => $idpais
        );
        $this->db->insert('provinciais', $dados);
    }

    public function listarProvincia($id) {
        $this->db->where('idpais', $id);
        $this->db->from('provinciais');
        $query = $this->db->get();
        return $query->result();
    }

    //Lista todas as Provincias de Angola
    public function mgetAllProvincias() {
        $this->db->where('idpais', 1);
        // Ordena as províncias em ordem alfabética pela coluna "nome"
        $this->db->order_by('provincia', 'ASC');
        $query = $this->db->get('provinciais');
        return $query->result();
    }

    public function consultarProvincia($provincia) {
        $this->db->select('provincia');
        $this->db->where('provincia', $provincia);
        $this->db->from('provinciais');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function consultaporID($idforn) {
        $this->db->where('idprovincia', $idforn);
        $this->db->from('provinciais');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function mlistaProvincia($start, $limit) {   // pegar subModulos   
        $this->db->select();
        $this->db->from('provinciais');
        $this->db->join('paises', 'provinciais.idpais=paises.idpais');
        $this->db->order_by('provincia');
        $this->db->limit($limit, $start);
        $query = $this->db->get();
        return $query->result();
    }

    public function contarProvincia() {
        $this->db->select('*');
        $this->db->from('provinciais');
        $this->db->join('paises', 'provinciais.idpais=paises.idpais');
        return $this->db->count_all_results();
    }

    public function listaProvincia($id) {
        $this->db->where('idprovincia', $id);
        $this->db->from('provinciais');
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->provincia;
        }
    }

}

?>
