<?php

class mUsuario extends CI_Model {

    var $teste = 'Ola';

    function __construct() {
        parent::__construct();
    }

    public function mregistarUtilizador($unome, $usuario, $senha, $email, $nivel, $idcaixa, $vender) {
        $data = array(
            'unome' => $unome,
            'usuario' => $usuario,
            'senha' => $senha,
            'email' => $email,
            'nivel' => $nivel,
            'idcaixa' => $idcaixa,
            'datacadastro' => @date('Y-m-d'),
            'pv' => $vender,
        );
        $this->db->insert('usuarios', $data);
        return $this->db->insert_id();
    }

    public function usuarioPontoVenda($idUsuario, $idPonto, $reimprimir, $idTipoFatura, $idInterface, $desconto) {
        $data = array(
            'idCategoriaPontoVenda' => $idPonto,
            'idUsuario' => $idUsuario,
            'reimprimir' => $reimprimir,
            'idTipoFatura' => $idTipoFatura,
            'IdInterface' => $idInterface,
            'desconto' => $desconto,
        );
        $this->db->insert('usuario_ponto_venda', $data);
    }

    public function verificaLojaUsuario($idUsuario, $idLoja) {
        $this->db->select('idUsuario');
        $this->db->from('usuariolojas');
        $this->db->where('idUsuario', $idUsuario);
        $this->db->where('idLoja', $idLoja);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function usuarioscaixaloja($idUsuario) {
        $data = array(
            'idUsuario' => $idUsuario,
            'idCaixa' => 1,
        );
        $this->db->insert('usuarioscaixaloja', $data);
    }

    public function registaLojaUsuario($idUsuario, $idLoja, $ativo) {
        $data = array(
            'idUsuario' => $idUsuario,
            'idLoja' => $idLoja,
            'ativo' => $ativo,
        );
        $this->db->insert('usuariolojas', $data);
    }

    public function verificaPermissaoArmazem($idUsuario, $idLoja) {
        $this->db->select('ativo');
        $this->db->from('usuarioLojas');
        $this->db->where('idUsuario', $idUsuario);
        $this->db->where('idLoja', $idLoja);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->ativo;
        }
    }

    public function mpermissoesIndividuais() {
        $this->db->select('*');
        $this->db->from('outras_permissoes');
        $this->db->order_by('per');
        $query = $this->db->get();
        return $query->result();
    }

    public function statuPermissaoUsuario($idPermissao, $idUsuario) {
        $this->db->select('statu');
        $this->db->from('permissoes_por_usuario');
        $this->db->where('idPermissao', $idPermissao);
        $this->db->where('idUsuario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->statu;
        }
    }

    public function atualizarLojaUsuario($idUsuario, $idLoja, $ativo) {
        $dados = array(
            'ativo' => $ativo,
        );
        $this->db->where('idUsuario', $idUsuario);
        $this->db->where('idLoja', $idLoja);
        $this->db->set($dados);
        $this->db->update('usuariolojas');
    }

    public function matualizarUsuario($id, $unome, $usuario, $email, $nivel, $vender) {//  atualiza senha  por id do usuario
        $data = array(
            'usuario' => $usuario,
            'unome' => $unome,
            'email' => $email,
            'nivel' => $nivel,
            'pv' => $vender,
        );
        $this->db->where('id_usiario', $id);
        $this->db->set($data);
        $this->db->update('usuarios');
    }

    public function validatede($usuario, $senha) {
        $this->db->where('usuario', $usuario);
        $this->db->where('senha', $senha);
        //$query = $this->db->get('usuarios'); 
        $this->db->from('usuarios');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function validarPorId($id_usiario, $senha) {
        $this->db->where('id_usiario', $id_usiario);
        $this->db->where('senha', $senha);
        //$query = $this->db->get('usuarios'); 
        $this->db->from('usuarios');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function mregistarUsuarios($unome, $email, $enha, $idnivel) {
        $data = array(
            'nome' => $unome,
            'email' => $email,
            'senha' => $enha,
            'idnivel' => $idnivel,
            'datacadastro' => @date('Y-m-d'),
        );
        if ($this->db->insert('usuarios', $data)) {
            return true;
        } else {
            return false;
        }
    }

    public function mregistarUsuarios2($unome, $email, $enha, $idnivel) {
        $data = array(
            'nome' => $unome,
            'email' => $email,
            'senha' => $enha,
            'idnivel' => $idnivel,
            'datacadastro' => @date('Y-m-d'),
        );
        $this->db->insert('usuarios', $data);
        return $this->db->insert_id();
    }

    public function mregistarUsuariosProfessor($idUsuario, $idFuncionario) {
        $data = array(
            'idUsuario' => $idUsuario,
            'idFuncionario' => $idFuncionario,
        );
        $this->db->insert('usuarios_professores', $data);
    }

    public function mregistaNivel($nivel) {
        $data = array(
            'nivel' => $nivel,
        );
        $this->db->insert('nivel_acesso', $data);
    }

    public function atuaizarNivel($idNivel, $nivel) {//  atualiza senha  por id do usuario
        $data = array(
            'nivel' => $nivel,
        );
        $this->db->where('idNivel', $idNivel);
        $this->db->set($data);
        $this->db->update('nivel_acesso');
    }

    public function nomeUtilizador($unome) {//verifica o Nome Utilizador
        $this->db->where('unome', $unome);
//        $this->db->where('senha', $senha);
        //$query = $this->db->get('usuarios'); 
        $this->db->from('usuarios');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function nomeUsuario($usuario) {// verifica o Nome do Usuario
        $this->db->where('usuario', $usuario);

        //$query = $this->db->get('usuarios'); 
        $this->db->from('usuarios');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    # VERIFICA SE O USUÁRIO ESTÁ LOGADO

    public function listar_usuarios() {
        $this->db->select('*');
        $this->db->from('usuarios');
        $this->db->join('nivel', 'usuarios.nivel = nivel.id');
        $query = $this->db->get();
        return $query->result();
    }

    public function listar_usuarios_internos($start, $limit, $pesquisa) {
        $this->db->select('*');
        $this->db->from('usuarios');
        $this->db->join('grupo', 'usuarios.nivel = grupo.id');
        if (!empty($pesquisa)) {
            $this->db->where("(usuario LIKE '%" . $this->db->escape_like_str($pesquisa) . "%' or 
                unome LIKE '%" . $this->db->escape_like_str($pesquisa) . "%' or
                nivel LIKE '%" . $this->db->escape_like_str($pesquisa) . "%' or
                email LIKE '%" . $this->db->escape_like_str($pesquisa) . "%')");
        }
        $this->db->limit($limit, $start);
        $this->db->order_by('unome');
        $query = $this->db->get();
        return $query->result();
    }

    public function contar_usuarios_interno() {
        $this->db->select('*');
        $this->db->from('usuarios');
        $this->db->join('nivel_acesso', 'usuarios.idnivel = nivel_acesso.idNivelAcesso');

        return $this->db->count_all_results();
    }

    public function listar_usuarios_internos_edit($idUsuario) {
        $this->db->select('*');
        $this->db->from('usuarios');
        $this->db->join('grupo', 'usuarios.nivel = grupo.id');
        $this->db->where('usuarios.id_usiario', $idUsuario);
        $query = $this->db->get();
        return $query->result();
    }

    public function listar_niveis_data_table() {
        $this->db->select('*');
        $this->db->from('nivel_acesso');
        $this->db->where('nivel_acesso.idNivelAcesso !=', 1);
        $this->db->where('nivel_acesso.idNivelAcesso !=', 2);
        $query = $this->db->get();
        return $query->result();
    }

    public function contar_niveis_data_table($limit, $offset, $servico) {
        $this->db->select('*');
        $this->db->from('nivel_acesso');
        return $this->db->count_all_results();
    }

    public function listar_nivela_aluno_encaregados() {
        $this->db->select('*');
        $this->db->from('nivel_acesso');
        $this->db->where('idNivelAcesso', 1);
        $this->db->or_where('idNivelAcesso', 2);
        $query = $this->db->get();
        return $query->result();
    }

    public function mlistar_nivela_acesso_util_internos() {
        $this->db->select('*');
        $this->db->from('nivel_acesso');
        $this->db->where('idNivelAcesso !=', 1);
        // $this->db->where('idNivelAcesso !=',2);
        $query = $this->db->get();
        return $query->result();
    }

    public function listar_usuarios_por_id($id) {
        $this->db->select('*');
        $this->db->from('usuarios');
        $this->db->join('grupo', 'usuarios.nivel = grupo.id');
        if ($id != '')
            $this->db->where('id_usiario', $id);
        $query = $this->db->get();
        return $query->result();
    }

    public function Mlistar($id) {
        if ($id != "")
            $this->db->where('id_usiario', $id);
        $query = $this->db->get('usuarios');
        return $query->result();
    }

    // rotina para lista o nivel de usuario logado
    public function idUsuario($usuario) {
        $this->db->select('id');
        $this->db->from('usuarios');
        $this->db->where('nome', $usuario);
        $query = $this->db->get();
        return $query->result();
    }

    public function idNivel($usuario) {
        $this->db->select('nivel');
        $this->db->from('usuarios');
        $this->db->where('usuario', $usuario);
        $query = $this->db->get();
        return $query->result();
    }

    public function pegarlogo() {
        $this->db->select('img');
        $this->db->from('empresas');
        $query = $this->db->get();
        return $query->result();
    }

    public function pegarCaminhoImg($usuario) {
        $this->db->select('imgusuario');
        $this->db->from('usuarios');
        $this->db->where('usuario', $usuario);
        $query = $this->db->get();
        return $query->result();
    }

    // rotina par listar grupo de acesso disponiveis
    public function listarGruupoM() {
        $this->db->from('grupo');
        $this->db->order_by('utilizador');
        $query = $this->db->get();
        return $query->result();
    }

    public function Consultar($Nome) {

        $this->db->where('usuario', $Nome);
        //$query = $this->db->get('usuarios'); 
        $this->db->from('usuarios');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function atuaizarSenha($senhanova, $usuario) {//  atualiza senha  por nome do usuario
        $data = array(
            'senha' => $senhanova,
        );
        $this->db->where('usuario', $usuario);
        $this->db->set($data);
        $this->db->update('usuarios');
    }

    public function atuaizarSenhan($id, $enha) {//  atualiza senha  por id do usuario
        $data = array(
            'senha' => $enha,
        );
        $this->db->where('id_usiario', $id);
        $this->db->set($data);
        $this->db->update('usuarios');
    }

    public function mApagaUsuarioCaica($id) {
        $this->db->where('idUsuario', $id);
        $this->db->delete('usuariocaixa');
    }

    public function atualizarUsuario($idUsuario, $unome, $email, $idnivel) {//  atualiza senha  por id do usuario
        $data = array(
            'nome' => $unome,
            'email' => $email,
            'idnivel' => $idnivel,
        );
        $this->db->where('id', $idUsuario);
        $this->db->set($data);
        $this->db->update('usuarios');
    }

    public function elimina_utilizador($id) {
        $this->db->where('id', $id);
        $this->db->delete('usuarios');
    }

    public function caminhoImangem($idUsuario) {
        $this->db->select('imgusuario');
        $this->db->from('usuarios');
        $this->db->where('id_usiario', $idUsuario);
        $consuta = $this->db->get();
        return $consuta->result();
    }

    public function atualizarCaminho($nome_imagem, $idUsuario) {
        $dados = array('imgusuario' => $nome_imagem,);
        $this->db->where('id_usiario', $idUsuario);
        $this->db->set($dados);
        $this->db->update('usuarios');
    }

    public function consultaUsuarioCaixa($idUsuario) {// verifica o Nome do Usuario
        $this->db->where('idUsuario', $idUsuario);

        $this->db->from('usuariocaixa');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function mlistarIdUsuario($usuario) {
        $this->db->select('id_usiario');
        $this->db->from('usuarios');
        $this->db->where('usuario', $usuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->id_usiario;
        }
    }

    public function mlistaridNome($idUsuario) {
        $this->db->select('unome');
        $this->db->from('usuarios');
        $this->db->where('id_usiario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->unome;
        }
    }

    public function usuario($nome) {
        $this->db->select('usuario');
        $this->db->from('usuarios');
        $this->db->where('usuario', $nome);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->usuario;
        }
    }

    public function nivelUsuario($idUsuario) {
        $this->db->select('nivel');
        $this->db->from('usuarios');
        $this->db->where('id_usiario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->nivel;
        }
    }

    public function usuarioId($email) {
        $this->db->select('id_usiario');
        $this->db->from('usuarios');
        $this->db->where('usuario', $email);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->id_usiario;
        }
    }

    public function categoriaPontoVenda($idUsuario) {
        $this->db->select('idCategoriaPontoVenda');
        $this->db->from('usuario_ponto_venda');
        $this->db->where('idUsuario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->idCategoriaPontoVenda;
        }
    }

    public function reimprimir($idUsuario) {
        $this->db->select('reimprimir');
        $this->db->from('usuario_ponto_venda');
        $this->db->where('idUsuario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->reimprimir;
        }
    }

    public function desconto($idUsuario) {
        $this->db->select('desconto');
        $this->db->from('usuario_ponto_venda');
        $this->db->where('idUsuario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->desconto;
        }
    }

    public function mlistaridCaixa($idUsuario) {
        $this->db->select('idcaixa');
        $this->db->from('usuarios');
        $this->db->where('id_usiario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->idcaixa;
        }
    }

    public function cat_posto_venda($idUsuario) {
        $this->db->select('idCategoriaPontoVenda');
        $this->db->from('usuario_ponto_venda');
        $this->db->where('idUsuario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->idCategoriaPontoVenda;
        }
    }

    public function formatoFaturaPontoVenda($idUsuario) {
        $this->db->select('idTipoFatura');
        $this->db->from('usuario_ponto_venda');
        $this->db->where('idUsuario', $idUsuario);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->idTipoFatura;
        }
    }

    public function obter_total_registos_filtrados($pesquisa) {
        if (!empty($pesquisa)) {
            $this->db->like('usuario', $pesquisa);
        }
        return $this->db->count_all_results('usuarios');
    }

    //funcao que conta as linhas exitente na tabela clientes modelo
    public function totalUsuarios() {
        $this->db->select('*');
        $this->db->from('usuarios');
        return $this->db->count_all_results();
    }

    public function cansulta_posto_venda($idUsuario) {
        $this->db->select('*');
        $this->db->from('usuario_ponto_venda');
        $this->db->where('idUsuario', $idUsuario);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function atualizaPontoVenda($idUsuario, $idPonto, $reimprimir, $idTipoFatura, $idInterface, $desconto) {
        $dados = array(
            'idCategoriaPontoVenda' => $idPonto,
            'reimprimir' => $reimprimir,
            'idTipoFatura' => $idTipoFatura,
            'IdInterface' => $idInterface,
            'desconto' => $desconto,
        );
        $this->db->where('idUsuario', $idUsuario);
        $this->db->set($dados);
        $this->db->update('usuario_ponto_venda');
    }

    public function m_eliminar_utilizador($id) {
        $this->db->where('id_usiario', $id);
        if ($this->db->delete('usuarios')) {
            return true;
        } else {
            return false;
        }
    }

    public function verificaFatura($idUsuario) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->where('iduser', $idUsuario);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function mpega_niveis_acesso() {
        $this->db->select('id as idNivel, utilizador as nivel');
        $this->db->from('grupo');
//        $this->db->where("(nome LIKE '%" . $this->db->escape_like_str($pesquisa) . "%' or
//                nomeSocial LIKE '%" . $this->db->escape_like_str($pesquisa) . "%')");

        $query = $this->db->get();
        return $query->result();
    }

}
