<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mfluxoCaixa
 *
 * @author GRAFICA BILL
 */
class mfluxoCaixa extends CI_Model {

    public function registarEntradasCaixa($referencia, $valor, $movimento, $idtipoconta, $iduser, $idtipoPagamentoSaida, $idTipoMovimentoCaixa) {
        $dados = array(
            'datamovimento' => date('Y-m-d'),
            'tipomovimento' => $movimento,
            'idusuario' => $iduser,
            'referencia' => $referencia,
            'valor' => $valor,
            'idtipoConta' => $idtipoconta,
            'idtipoPagamentoSaida' => $idtipoPagamentoSaida,
            'idTipoMovimentoCaixa' => $idTipoMovimentoCaixa,
        );
        $this->db->insert('movimentacoes', $dados);
    }

    public function mregistarSaidas($referencia, $valor, $movimento, $idtipoconta, $iduser, $idtipoPagamentoSaida, $idTipoMovimentoCaixa) {
        $dados = array(
            'datamovimento' => @date('Y-m-d'),
            'tipomovimento' => $movimento,
            'idusuario' => $iduser,
            'referencia' => $referencia,
            'valor' => $valor,
            'idtipoConta' => $idtipoconta,
            'idtipoPagamentoSaida' => $idtipoPagamentoSaida,
            'idTipoMovimentoCaixa' => $idTipoMovimentoCaixa,
        );
        $this->db->insert('movimentacoes', $dados);
    }

    public function atualizarEntradasCaixa($idtipopagamento, $iduser, $referencia, $preco) {
        $this->db->where('idtipoPagamentoSaida', $idtipopagamento);
        $this->db->where('datamovimento', @date('Y-m-d'));
        $this->db->where('idusuario', $iduser);
        $this->db->where('referencia', $referencia);
        $this->db->set('valor', 'valor+' . $preco, FALSE);
        $this->db->update('movimentacoes');
    }

    public function atualizarSadoNasContas($idtipoConta, $preco) { // função que adiciona o saldo no campo valor do debito
        $this->db->where('idtipoconta', $idtipoConta);
        $this->db->set('valordebito', 'valordebito+' . $preco, FALSE);
        $this->db->update('saldo');
    }

    public function atualizarSadoNasContasSub($idtipoConta, $preco) { // função que subtrai o saldo no campo valor do debito
        $this->db->where('idtipoconta', $idtipoConta);
        $this->db->set('valordebito', 'valordebito-' . $preco, FALSE);
        $this->db->update('saldo');
    }

    public function atualizarSadoNasContasDebito($idtipoConta, $preco) { //funão que adiciona e subtrai ao mesmo tempo
        $this->db->where('idtipoconta', $idtipoConta);
        $this->db->set('valordebito', 'valordebito-' . $preco, FALSE);
        $this->db->set('valorcredito', 'valorcredito+' . $preco, FALSE);
        $this->db->update('saldo');
    }

    public function atualizarSadoNasContasBanco($idBanco, $preco) { //funão que adiciona e subtrai ao mesmo tempo
        $this->db->where('idBanco', $idBanco);
        $this->db->set('valordebito', 'valordebito-' . $preco, FALSE);
        $this->db->set('valorcredito', 'valorcredito+' . $preco, FALSE);
        $this->db->update('saldobanco');
    }

    public function atualizarDebitoBanco($idBanco, $preco) { // função que soma o saldo no campo valor do debito no banco
        $this->db->where('idBanco', $idBanco);
        $this->db->set('valordebito', 'valordebito-' . $preco, FALSE);
        $this->db->update('saldobanco');
    }

    public function vendasCredito($idcliente, $datapagamento, $total, $fatura) {
        $dados = array(
            'idcliente' => $idcliente,
            'datavenda' => @date('Y-m-d'),
            'data_vencimento' => $datapagamento,
            'valor' => $total,
            'idFatura' => $fatura,
            'hora' => @date('H:i:s'),
        );
        $this->db->insert('contasreceber', $dados);
    }

    public function consultarVendaCredito($idcliente) {
        $this->db->where('datavenda', @date('Y-m-d'));
        $this->db->where('idcliente', $idcliente);
        $this->db->from('contasreceber');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function atualizarVendaCredito($idcliente, $total) {
        $this->db->where('datavenda', date('Y-m-d'));
        $this->db->where('idcliente', $idcliente);
        $this->db->set('valor', 'valor+' . $total, FALSE);
        $this->db->update('contasreceber');
    }

    public function liquidarVendaCredito($idrecebimento, $idEstadoPagFatura) {// atualiza o saldo por pagar em cada fatura do cliente
        $status = 'PAGA';
        $this->db->where('idrecebimento', $idrecebimento);
        $this->db->set('idEstadoPagFatura', $idEstadoPagFatura);
        $this->db->update('contasreceber');
    }

    public function liquidarVendaCreditoFornecedores($idcontaPagar, $valor) {// atualiza o saldo por pagar em cada fatura do cliente
        $this->db->where('idcontaPagar', $idcontaPagar);
        $this->db->set('valor', 'valor-' . $valor, FALSE);
        $this->db->update('contaspagar');
    }

    public function liquidarfornecedorDivoda($idpagamento) {
        $status = 'PAGA';
        $this->db->set('statu', $status);
        $this->db->where('idpagamento', $idpagamento);
        $this->db->update('contaspagar');
    }

    public function suprimentoSangria($idUsuario, $valorCaixa, $idtipopagamento, $descricao, $tipo, $hora) {

        $dados = array(
            'data' => @date('Y-m-d'),
            'idusuario' => $idUsuario,
            'valor' => $valorCaixa,
            'idtipopagamento' => $idtipopagamento,
            'descricao' => $descricao,
            'tipomovimento' => $tipo,
            'hora' => $hora,
        );
        $this->db->insert('fluxodiario', $dados);
    }

    public function abrirCaixam($idcaixa, $idUsuario, $hora) {
        $tatu = 'Aberto';
        $dados = array(
            'data' => @date('Y-m-d'),
            'horaabertura' => $hora,
            'idcaixa' => $idcaixa,
            'idusuario' => $idUsuario,
            'status' => $tatu,
        );
        $this->db->insert('caixaaberturafeixo', $dados);
    }

    public function reaberturaDeCaixa($idUsuario) {
        $data = @date('Y/m/d');
        $tatu = 'Aberto';
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $data);
        $dados = array(
            'status' => $tatu,
        );
        $this->db->set($dados);
        $this->db->update('caixaaberturafeixo');
    }

    public function listarvMovimentosEntradasSaidas($start, $limit, $dataminima) {
        $this->db->select('*');
        $this->db->from('movimentacoes');
        $this->db->join('tipoconta', 'movimentacoes.idtipoPagamentoSaida = tipoconta.idtipoconta');
        $this->db->join('tipopagamento', 'movimentacoes.idtipoConta = tipopagamento.idTipo');
        $this->db->join('tipo_movimento_caixa', 'movimentacoes.idTipoMovimentoCaixa = tipo_movimento_caixa.idTipoMovimentoCaixa');
        $this->db->where('datamovimento', $dataminima);
        $this->db->limit($limit, $start);
        $this->db->order_by('idmovimento', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarEntradasRelatorio($dataminima, $datamaxima) {
        $this->db->select('*');
        $this->db->from('movimentacoes');
        $this->db->where('datamovimento >=', $dataminima);
        $this->db->where('datamovimento<=', $datamaxima);
        //    $this->db->where('tipomovimento', 'Entrada');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contarMovimentos() {
        $this->db->select('*');
        $this->db->from('movimentacoes');
        return $this->db->count_all_results();
    }

    public function listarcaixa() {
        $this->db->select('*');
        $this->db->from('caixa');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarcaixa1($idcaixa) {
        $this->db->select('*');
        $this->db->from('caixa');
        $this->db->where('idcaixa', $idcaixa);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarResumoCaixa($idcaixa, $idUsuario) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->select_sum('total_venda');
        $this->db->from('faturas');
        $this->db->join('caixa', 'faturas.idcaixa = caixa.idcaixa');
        $this->db->join('tipopagamento', 'faturas.idTipopagamento = tipopagamento.idTipo');
        $this->db->join('usuarios', 'faturas.iduser = usuarios.id_usiario');
        $this->db->where('faturas.iduser', $idUsuario);
        $this->db->where('faturas.idcaixa', $idcaixa);
        $this->db->where('data', $data);
        $this->db->order_by('tipopagamento.idTipo');
        $this->db->group_by('tipopagamento.idTipo');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarSuprimento($idTipo) {
        $data = @date('Y/m/d');
        $tipo = 'Suprimento';
        $this->db->select('*');
        $this->db->select_sum('valor');
        $this->db->from('fluxodiario');
        $this->db->join('usuarios', 'fluxodiario.idusuario = usuarios.id_usiario');
        $this->db->join('tipopagamento', 'fluxodiario.idtipopagamento = tipopagamento.idTipo');
        $this->db->where('fluxodiario.idtipopagamento', $idTipo);
        $this->db->where('tipomovimento', $tipo);
        $this->db->where('data', $data);
        $this->db->order_by('tipopagamento.idTipo');
        $this->db->group_by('tipomovimento');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarSangria($idTipo) {
        $data = @date('Y/m/d');
        $tipo = 'Sangria';
        $this->db->select('*');
        $this->db->select_sum('valor');
        $this->db->from('fluxodiario');
        $this->db->join('usuarios', 'fluxodiario.idusuario = usuarios.id_usiario');
        $this->db->join('tipopagamento', 'fluxodiario.idtipopagamento = tipopagamento.idTipo');
        $this->db->where('fluxodiario.idtipopagamento', $idTipo);
        $this->db->where('tipomovimento', $tipo);
        $this->db->where('data', $data);
        $this->db->order_by('tipopagamento.idTipo');
        $this->db->group_by('tipomovimento');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarSangriaSuprimentos($idUsuario) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('fluxodiario');
        $this->db->join('usuarios', 'fluxodiario.idusuario = usuarios.id_usiario');
        $this->db->join('tipopagamento', 'fluxodiario.idtipopagamento = tipopagamento.idTipo');
        $this->db->where('fluxodiario.idusuario', $idUsuario);
        $this->db->where('data', $data);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarSangriaSuprimentos2($idUsuario, $data) {
        //  $data;
        $this->db->select('*');
        $this->db->from('fluxodiario');
        $this->db->join('usuarios', 'fluxodiario.idusuario = usuarios.id_usiario');
        $this->db->join('tipopagamento', 'fluxodiario.idtipopagamento = tipopagamento.idTipo');
        $this->db->where('fluxodiario.idusuario', $idUsuario);
        $this->db->where('data', $data);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function dadosDoCaixa($idUsuario) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('caixaaberturafeixo');
        $this->db->join('usuarios', 'caixaaberturafeixo.idusuario = usuarios.id_usiario');
        $this->db->join('caixa', 'caixaaberturafeixo.idcaixa = caixa.idcaixa');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $data);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function verificaCaixa($idUsuario) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('caixaaberturafeixo');
        $this->db->join('usuarios', 'caixaaberturafeixo.idusuario = usuarios.id_usiario');
        $this->db->where('caixaaberturafeixo.idusuario', $idUsuario);
        $this->db->where('data', $data);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function fechamentDeCaixa($idUsuario, $hora) {// encerrar o caixa partir da tela do extjs
        $data = @date('Y-m-d');
        $tatu = 'Fechado';
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $data);
        $dados = array(
            'horafeixo' => $hora,
            'status' => $tatu,
            'dataEncerramento' => $data,
        );
        $this->db->set($dados);
        $this->db->update('caixaaberturafeixo');
    }

    public function fechamentDeCaixaGerente($idUsuario, $hora, $entregue, $dataCaixa) {// encerrar o caixa partir da tela do extjs
        $data = @date('Y-m-d');
        $tatu = 'Fechado';
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $dados = array(
            'horafeixo' => $hora,
            'status' => $tatu,
            'valorEntregue' => $entregue,
            'dataEncerramento' => $data,
        );
        $this->db->set($dados);
        $this->db->update('caixaaberturafeixo');
    }

    public function consultarEntradasCaixa($idtipopagamento, $iduser, $referencia) {
        $this->db->where('idtipoPagamentoSaida', $idtipopagamento);
        $this->db->where('datamovimento', @date('Y-m-d'));
        $this->db->where('idusuario', $iduser);
        $this->db->where('referencia', $referencia);
        $this->db->from('movimentacoes');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function registarContasPagar($idfornecedor, $data, $datapagamento, $iduser, $preco, $referencia, $statu, $idCompra) {
        $dados = array(
            'idfornecedor' => $idfornecedor,
            'data' => $data,
            'datapagamento' => $datapagamento,
            'idusuario' => $iduser,
            'valor' => $preco,
            'referencia' => $referencia,
            'statu' => $statu,
            'idCompra' => $idCompra,
        );
        $this->db->insert('contaspagar', $dados);
    }

    public function contasPagarLista($limit, $start, $fornecedor) {
        $this->db->select('*');
        $this->db->from('contaspagar');
        $this->db->join('compras', 'contaspagar.idCompra = compras.idCompra');
        $this->db->join('usuarios', 'contaspagar.idusuario = usuarios.id_usiario');
        $this->db->join('fonecedores', 'contaspagar.idfornecedor = fonecedores.idfornecedor');

        if ($fornecedor != '') {
            $this->db->like('fornecedor', $fornecedor);
        }
        $this->db->limit($limit, $start);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contarDividas() {
        $this->db->select('*');
        $this->db->from('contaspagar');
        return $this->db->count_all_results();
    }

    public function mlistaGeralContaCorrente($limit, $offset, $pesquisa) {
        $this->db->select('*');
        $this->db->from('contasreceber');
        $this->db->join('clientes', 'contasreceber.idcliente = clientes.idcliente');
        $this->db->join('cliente_contacto', 'clientes.idcliente = cliente_contacto.idcliente');
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('nome', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('fone1', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('nif', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }

        $this->db->limit($limit, $offset);
        $this->db->group_by('clientes.idcliente');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // Obter a contagem de registros filtrados
    public function obter_total_registos_filtrados($pesquisa) {
        $this->db->select("COUNT(*) as total");
        // Define a tabela base e alias
        $this->db->from('contasreceber as cr');
        $this->db->join('clientes as c', 'cr.idcliente = c.idcliente', 'left');
        $this->db->join('cliente_contacto as cc', 'c.idcliente = cc.idcliente', 'left');
        // Se houver uma pesquisa, aplica os filtros
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('c.nome', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('cc.fone1', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('cc.nif', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }
        $query = $this->db->get();
        $resultado = $query->row();
        return ($resultado->total !== null) ? $resultado->total : 0;
    }

    public function total_registos() {
        $this->db->select("COUNT(*) as total");
        $this->db->from('contasreceber');
        $query = $this->db->get();
        $resultado = $query->row();
        return ($resultado->total !== null) ? $resultado->total : 0;
    }

    public function contarRecebimentos() {
        $this->db->select('*');
        $this->db->from('contasreceber');
        return $this->db->count_all_results();
    }

    public function contasReceberLista($limit, $offset, $idCliente) {
        $this->db->select('*');
        $this->db->from('contasreceber');
        $this->db->join('clientes', 'contasreceber.idcliente = clientes.idcliente');
        $this->db->join('cliente_contacto', 'clientes.idcliente = cliente_contacto.idcliente');
        $this->db->where('contasreceber.idcliente', $idCliente);
        $this->db->limit($limit, $offset);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function regTrasferncia($idtipocontaorigem, $idtipocontadestino, $preco, $iduser, $data) {
        $dados = array(
            'idcontaorigem' => $idtipocontaorigem,
            'idcontadestino' => $idtipocontadestino,
            'datatrasferencia' => $data,
            'valor' => $preco,
            'idusuario' => $iduser,
        );
        $this->db->insert('trasferencia', $dados);
    }

    public function listTraferencias($limit, $start) {
        $this->db->select('*');
        $this->db->from('trasferencia');
        $this->db->join('usuarios', 'trasferencia.idusuario = usuarios.id_usiario');
        $this->db->limit($limit, $start);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contarTrasnferencias() { // contar o ttal de trasnferencias feitas
        $this->db->select('*');
        $this->db->from('trasferencia');
        return $this->db->count_all_results();
    }

    public function listConta($idtipoconta) { // listar nome da conta por Id slicitado 
        $this->db->select('*');
        $this->db->from('tipoconta');
        $this->db->where('idtipoconta', $idtipoconta);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function somaSaldoconta() { // modelo que pega o total de saldo disponivel nas contas
        $this->db->select('*');
        $this->db->select_sum('valordebito');
        $this->db->from('saldo');
        $this->db->where('idtipoconta!=', 2);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pegarSaldoBanco() { // modelo que pega o saldo na conta banco
        $idtipoconta = 1;
        $this->db->select('*');
        $this->db->from('tipoconta');
        $this->db->join('saldo', 'tipoconta.idtipoconta=saldo.idtipoconta');
        $this->db->where('tipoconta.idtipoconta', $idtipoconta);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pegarSaldoContaCorrente() { // modelo que pega o saldo na conta corrente
        $idtipoconta = 2;
        $this->db->select('*');
        $this->db->from('tipoconta');
        $this->db->join('saldo', 'tipoconta.idtipoconta=saldo.idtipoconta');
        $this->db->where('tipoconta.idtipoconta', $idtipoconta);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pegarSaldoContaFundoCaixa() { // modelo que pega o saldo na conta fundo de caixa
        $idtipoconta = 3;
        $this->db->select('*');
        $this->db->from('tipoconta');
        $this->db->join('saldo', 'tipoconta.idtipoconta=saldo.idtipoconta');
        $this->db->where('tipoconta.idtipoconta', $idtipoconta);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valordebito;
        }
    }

    public function contasApagrSoma() { // modelo que pega o total de dividas
        $this->db->select('*');
        $this->db->select_sum('valor');
        $this->db->where('statu', 'ACTIVA');
        $this->db->from('contaspagar');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contasReceberSoma() { // modelo que pega o total de dividas
        $this->db->select('*');
        $this->db->select_sum('valor');
        //  $this->db->where('status', 'ATIVA');
        $this->db->from('contasreceber');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function receberVSpagarAtualizar($tipo, $valor) {
        $valor1 = 0;
        $this->db->where('tipo', $tipo);
        $this->db->set('valor', $valor1);
        $this->db->set('valor', 'valor+' . $valor, FALSE);
        $this->db->update('receberVSpagar');
    }

    public function receberVSpagarListar() {
        $this->db->select('*');
        $this->db->from('receberVSpagar');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function entradaSaidas() { // modelo que pega o total de dividas
        $this->db->select('*');
        $this->db->select_sum('valor'); //
        $this->db->from('movimentacoes');
        $this->db->group_by('tipomovimento');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function subtrair_total_divida($valor, $tipo) {
        $this->db->where('id', $tipo);
        $this->db->set('valor', 'valor-' . $valor, FALSE);
        $this->db->update('receberVSpagar');
    }

    public function atualizarSadoNasContasSub1($idtipoConta, $preco) { // função que subtrai o saldo no campo valor do debito
        $this->db->where('idtipoconta', $idtipoConta);
        $this->db->set('valordebito', 'valordebito-' . $preco, FALSE);
        $this->db->update('saldo');
    }

    public function registarPagamentosDividas($idrecebimento, $idtipopagamento, $idusuario, $valor) {

        $dados = array(
            'data' => date('Y-m-d'),
            'hora' => date('H:i:s'),
            'idusuario' => $idusuario,
            'valor' => $valor,
            'idTipoPagamento' => $idtipopagamento,
            'idCredito' => $idrecebimento,
        );
        $this->db->insert('pagamentos_credito', $dados);
        return $this->db->insert_id();
    }

    public function pegaIdFaturaCredito($idPagamento) {
        $this->db->select('idFatura'); //
        $this->db->from('contasreceber');
        $this->db->where('idrecebimento', $idPagamento);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idFatura;
        }
    }

    public function valor_retido_recibo($idPagamento, $retidoIva) {
        $dados = array(
            'idPagamento' => $idPagamento,
            'ivaRetido' => $retidoIva,
        );
        $this->db->insert('valorRetidoRecibos', $dados);
    }

    public function registarPagamentosDividasFornecedores($idCompra, $fpagamento, $idusuario, $valor, $dataPagamento) {

        $dados = array(
            'data' => @date('Y-m-d'),
            'hora' => @date('H:i:s'),
            'idusuario' => $idusuario,
            'valor' => $valor,
            'idTipoPagamento' => $fpagamento,
            'idCredito' => $idCompra,
            'dataPagamento' => $dataPagamento,
        );
        if ($this->db->insert('pagamentos_fornecedores', $dados)) {
            return true;
        } else {
            return false;
        }
    }

    public function totalDividaPgago($idCredito) { // pega o total pago de uma divida
        $this->db->select_sum('valor'); //
        $this->db->from('pagamentos_credito');
        $this->db->where('idCredito', $idCredito);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function totalDividaPgagoFornecedores($idCredito) { // pega o total de dividas pagas a fornecedores
        $this->db->select_sum('valor'); //
        $this->db->from('pagamentos_fornecedores');
        $this->db->where('idCredito', $idCredito);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    /**
     * Retorna o total geral pago de uma dívida para um cliente específico.
     *
     * Este método realiza a soma dos valores de pagamentos registrados na
     * tabela "pagamentos_credito" que estão associados aos registros da
     * tabela "contasreceber" para o cliente informado.
     *
     * @param int $idCliente ID do cliente
     * @return float Valor total pago, ou 0 se não houver registros.
     */
    public function totalGeralDividaPgago($idCliente) {
        // Seleciona a soma dos valores do pagamento, nomeando o resultado como "total_pago"
        $this->db->select_sum('p.valor', 'total_pago');
        $this->db->from('contasreceber as c');
        // Realiza um join à tabela pagamentos_credito, com a condição:
        // c.idrecebimento (da tabela contasreceber) = p.idCredito (da tabela pagamentos_credito)
        $this->db->join('pagamentos_credito as p', 'c.idrecebimento = p.idCredito', 'left');
        // Filtra pelo ID do cliente
        $this->db->where('c.idcliente', $idCliente);

        $consulta = $this->db->get();
        $resultado = $consulta->row();

        // Retorna o total pago ou 0 se não houver valor
        return ($resultado->total_pago !== null) ? $resultado->total_pago : 0;
    }

    public function totalGeralDivida($idCliente) { // pega o total pago de uma divida
        $this->db->select_sum('valor'); //
        $this->db->from('contasreceber as c');
        $this->db->where('c.idcliente', $idCliente);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function totalGeralDividaPgagoPorEntidade() { // pega o total pago de uma divida
        $this->db->select_sum('valor'); //
        $this->db->from('pagamentos_credito');
        //  $this->db->where('idCredito', $idCredito); 
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function mdividasPagas($idrecebimento) {  // pega o total da divida paga atraves do id de recebimento 
        $this->db->select('*');
        $this->db->from('pagamentos_credito');
        $this->db->where('idCredito', $idrecebimento);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mdividasPagasPorFatura($idFatuta) {  // pega o total da divida paga atraves do id das fatura
        $this->db->select('valor');
        $this->db->from('pagamentos_credito');
        $this->db->join('contasreceber', 'pagamentos_credito.idCredito=contasreceber.idrecebimento');
        $this->db->where('idFatura', $idFatuta);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function pegaTipoPagamentoNotaCredito($idTipo) {  // pega o total da divida paga atraves do id das fatura
        $this->db->select('tipo');
        $this->db->from('tipopagamento');

        $this->db->where('idTipo', $idTipo);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->tipo;
        }
    }

    public function mdividasPagasImprimir($idrecebimento) {
        $this->db->select('pagamentos_credito.idPagamento,pagamentos_credito.data,pagamentos_credito.valor as valorPgo,pagamentos_credito.hora,pagamentos_credito.idTipoPagamento,
               faturas.data as dataFatura,faturas.fatura,faturas.idTipopagamento,faturas.idtipo,faturas.idMoeda, pagamentos_credito.idTipoPagamento as formaPagamento,
               clientes.nome,prodt.produto,item_fatura.qtd,item_fatura.total,usuarios.unome,prodt.idpr,contasreceber.idrecebimento,contasreceber.datavenda,
               cliente_contacto.fone,cliente_contacto.nif,cliente_contacto.localizacao');
        $this->db->from('pagamentos_credito');
        $this->db->join('contasreceber', 'pagamentos_credito.idCredito=contasreceber.idrecebimento');
        $this->db->join('faturas', 'contasreceber.idFatura=faturas.fatura');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('usuarios', 'pagamentos_credito.idUsuario=usuarios.id_usiario');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('idPagamento', $idrecebimento);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarvMovimentosSaidas($datamaxima) {
        $this->db->select('*');
        $this->db->from('movimentacoes');
        $this->db->join('tipoconta', 'movimentacoes.idtipoPagamentoSaida = tipoconta.idtipoconta');
        $this->db->join('tipopagamento', 'movimentacoes.idtipoConta = tipopagamento.idTipo');
        $this->db->where('tipomovimento', 'Saida');
        $this->db->where('datamovimento', $datamaxima);
        $this->db->order_by('idmovimento', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarvMovimentosEntradaGeral($datamaxima) {
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->join('tipoconta', 'movimentacoes.idtipoPagamentoSaida = tipoconta.idtipoconta');
        $this->db->join('tipopagamento', 'movimentacoes.idtipoConta = tipopagamento.idTipo');
        $this->db->where('tipomovimento', 'Entrada');
        $this->db->where('referencia !=', 'vendas');
        $this->db->where('datamovimento', $datamaxima);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function listarvMovimentosEntradaCash($datamaxima) {  // listas as entradas pagas em dinheiro
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->join('tipoconta', 'movimentacoes.idtipoPagamentoSaida = tipoconta.idtipoconta');
        $this->db->join('tipopagamento', 'movimentacoes.idtipoConta = tipopagamento.idTipo');
        $this->db->where('movimentacoes.idtipoConta', 1);
        $this->db->where('tipomovimento', 'Entrada');
        $this->db->where('referencia !=', 'vendas');
        $this->db->where('datamovimento', $datamaxima);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function listarvMovimentosSaidasCahs($datamaxima) {
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->join('tipoconta', 'movimentacoes.idtipoPagamentoSaida = tipoconta.idtipoconta');
        $this->db->join('tipopagamento', 'movimentacoes.idtipoConta = tipopagamento.idTipo');
        $this->db->where('tipomovimento', 'Saida');
        $this->db->where('movimentacoes.idtipoConta', 1);
        $this->db->where('datamovimento', $datamaxima);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function verificar_caixa_aberto() {// verifica se o saldo inicial do caixa ja foi aberto
        $data = @date('Y-m-d');
        $this->db->select('*');
        $this->db->from('saldo_caixa_diario');
        $this->db->where('data', $data);
        $this->db->where('idtipoconta', 3);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function registarEntradasCaixaDiario($valor) {
        $dados = array(
            'data' => @date('Y-m-d'),
            'valor' => $valor,
            'idtipoConta' => 3,
        );
        $this->db->insert('saldo_caixa_diario', $dados);
    }

    public function listarvSaldoDiario() {
        $this->db->select('*');
        $this->db->from('saldo_caixa_diario');
        $this->db->order_by('idsaldoconta', 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function listar_abertura_por_usuario($idUsuario) { // pega o ultimo id da abertur ada caixa por usuario  
        $this->db->select('id,data');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->limit(1);
        $this->db->order_by('id', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listar_abertura_por_usuario_resumo($idUsuario, $dataCaixa) {
        $this->db->select('');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listar_abertura_por_usuario_gerente($idUsuario) {
        $this->db->select('id,data');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('status', "Aberto");
        $this->db->order_by('id', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listar_abertura_por_Historico() {
        $this->db->select('id,data,idusuario,dataEncerramento');
        $this->db->from('caixaaberturafeixo');
        $this->db->order_by('id', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listar_valor_entregue($data, $iduser) {  // lista as vendas em cash para tela de control do ponto de venda
        $this->db->select_sum('valorEntregue');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $iduser);
        $this->db->where('data', $data);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->valorEntregue > 0) {
                return $value->valorEntregue;
            } else {
                return 0;
            }
        }
    }

    public function data_caixa($idUsuario, $idCaixaAberto) {
        $this->db->select('data');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('id', $idCaixaAberto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->data;
        }
    }

    public function listar_vendas_cash($data, $iduser) {  // lista as vendas em cash para tela de control do ponto de venda
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura = item_fatura.fatura');
        $this->db->where('iduser', $iduser);
        $this->db->where('item_fatura.datavenda', $data);
        $this->db->where('idTipopagamento', 1);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->total > 0) {
                return $value->total;
            } else {
                return 0;
            }
        }
    }

    public function listar_vendas_tpa($data, $iduser) {  // lista as vendas em cash para tela de control do ponto de venda
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura = item_fatura.fatura');
        $this->db->where('iduser', $iduser);
        $this->db->where('item_fatura.datavenda', $data);
        $this->db->where('idTipopagamento', 2);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->total > 0) {
                return $value->total;
            } else {
                return 0;
            }
        }
    }

    public function listarSaldo_caixa_abertuta($data, $iduser) {

        $this->db->select('*');
        $this->db->select_sum('valor');
        $this->db->from('fluxodiario');
        $this->db->where('idusuario', $iduser);
        $this->db->where('data', $data);
        $this->db->where('tipomovimento', 'Suprimento');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->valor > 0) {
                return $value->valor;
            } else {
                return 0;
            }
        }
    }

    public function listarSaldo_caixa_sagria($data, $iduser) {

        $this->db->select('*');
        $this->db->select_sum('valor');
        $this->db->from('fluxodiario');
        $this->db->where('idusuario', $iduser);
        $this->db->where('data', $data);
        $this->db->where('tipomovimento', 'Sangria');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->valor > 0) {
                return $value->valor;
            } else {
                return 0;
            }
        }
    }

    public function feicho_caixa($idUsuario, $dataCaixa) {// encerrar o caixa partir da tela feit aem bootstra
        $hora = $data = @date('H:m:s');
        $tatu = 'Fechado';

        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $dados = array(
            'horafeixo' => $hora,
            'status' => $tatu,
        );
        $this->db->set($dados);
        $this->db->update('caixaaberturafeixo');
    }

    public function verifica_caixa_aberto_na_data_atual($idUsuario) {// verifica se o caixa esta aberto na data atual
        $data = date('Y-m-d');
        $this->db->select('*');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $data);
        $this->db->where('status', 'Aberto');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function verifica_caixa_aberto_por_utilizador($idUsuario) {// verifica se o utilizador possui um caixa q nao foi encerrado
        $data = date('Y-m-d');
        $this->db->select('*');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data<', $data);
        $this->db->where('status', 'Aberto');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function estado($idGuia) {
        $this->db->select('estado');
        $this->db->from('pagamentos_credito');
        $this->db->where('idPagamento', $idGuia);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->estado;
        }
    }

    public function atualizarEstado($idGuia, $estado) {
        $this->db->where('idPagamento', $idGuia);
        $this->db->set('estado', $estado);
        $this->db->update('pagamentos_credito');
    }

    public function pega_estado_caixa($dataCaixa, $idUsuario) {// verifica se o utilizador possui um caixa q nao foi encerrado
        $this->db->select('status');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->status;
        }
    }

    public function pega_hora_abertura($dataCaixa, $idUsuario) {// verifica se o utilizador possui um caixa q nao foi encerrado
        $this->db->select('horaabertura');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->horaabertura;
        }
    }

    public function pega_data_encerramemto($dataCaixa, $idUsuario) {// verifica se o utilizador possui um caixa q nao foi encerrado
        $this->db->select('dataEncerramento');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->dataEncerramento;
        }
    }

    public function pega_hora_encerramemto($dataCaixa, $idUsuario) {// verifica se o utilizador possui um caixa q nao foi encerrado
        $this->db->select('horafeixo');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->horafeixo;
        }
    }

    public function pega_data_vencimento($idFatura) {// 
        $this->db->select('data_vencimento');
        $this->db->from('contasreceber');
        $this->db->where('idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->data_vencimento;
        }
    }

    public function valor_retido_recibo22($idPagamento, $retidoIva) {
        $dados = array(
            'idPagamento' => $idPagamento,
            'ivaRetido' => $retidoIva,
        );
        $this->db->insert('valorRetidoRecibos', $dados);
    }

    public function totalIvaPago($idCredito) { // pega o total pago de iva 
        $this->db->select_sum('ivaRetido'); //
        $this->db->from('valorRetidoRecibos');
        $this->db->join('pagamentos_credito', 'valorRetidoRecibos.idPagamento = pagamentos_credito.idPagamento');
        $this->db->where('idCredito', $idCredito);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->ivaRetido;
        }
    }

    public function ivaRetido($idPagamento) { // pega o total de iva por pagamento
        $this->db->select('ivaRetido'); //
        $this->db->from('valorRetidoRecibos');
        $this->db->where('idPagamento', $idPagamento);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->ivaRetido;
        }
    }

    public function listar_historico_notas() {
        $this->db->select('idNota,denominacao,pu');
        $this->db->from('notas');
        //  $this->db->order_by('id','DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pega_id_caixa($idUsuario) {
        $this->db->select('id');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('status', "Aberto");
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->id;
        }
    }

    public function pega_id_caixa_pela_data($idUsuario, $data) {
        $this->db->select('id');
        $this->db->from('caixaaberturafeixo');
        $this->db->where('idusuario', $idUsuario);
        $this->db->where('data', $data);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->id;
        }
    }

    public function registaNotas($idCaixaAbF, $idNota, $qtd) {
        $dados = array(
            'idCaixaAbF' => $idCaixaAbF,
            'idNota' => $idNota,
            'qtd' => $qtd,
            'data' => date('Y-m-d'),
        );
        $this->db->insert('historicoNotas', $dados);
    }

    public function pega_qtd_Notas($idCaixaAbF, $idNota) {
        $this->db->select('qtd');
        $this->db->from('historicoNotas');
        $this->db->where('idCaixaAbF', $idCaixaAbF);
        $this->db->where('idNota', $idNota);
        $consulta = $this->db->get();
        $qtd = 0;
        foreach ($consulta->result() as $value) {
            if ($value->qtd != null) {
                return $qtd = $value->qtd;
            } else {
                return $qtd;
            }
        }
    }

    public function consultarNota($idCaixaAbF, $idNota) {
        $this->db->select('idCaixaAbF,idNota');
        $this->db->from('historicoNotas');
        $this->db->where('idCaixaAbF', $idCaixaAbF);
        $this->db->where('idNota', $idNota);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function atualizaTotalNotas($idCaixaAbF, $idNota, $qtd) {
        $this->db->where('idCaixaAbF', $idCaixaAbF);
        $this->db->where('idNota', $idNota);
        $this->db->set('qtd', 0);
        $this->db->set('qtd', $qtd);
        $this->db->update('historicoNotas');
    }

    public function totalProdutosComprados($idCompra) {
        $this->db->select_sum('qtd');
        $this->db->from('item_compras');
        $this->db->where('idCompra', $idCompra);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function mlistaContaPagarPorFacturaFornevedor($idCompra) {
        $this->db->select('*');
        $this->db->from('compras');
        $this->db->join('contaspagar', 'compras.idCompra = contaspagar.idCompra');
        $this->db->where('compras.idCompra', $idCompra);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mpegaTotalCompra($idCompra) {
        $this->db->select('valorFatura');
        $this->db->from('compras');
        $this->db->where('idCompra', $idCompra);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valorFatura;
        }
    }

    public function contarPagamentosFatura($idPagamento) {
        return $this->db->from('pagamentos_fornecedores')
                        ->where('idCredito', $idPagamento)
                        ->get()
                        ->num_rows();
    }

    public function mpegaTotalPaga($idPagamento) {
        $this->db->select_sum('valor');
        $this->db->from('pagamentos_fornecedores');
        $this->db->where('idCredito', $idPagamento);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->valor;
        }
    }

    public function idContaPagar($idPagamento) {
        $this->db->select('idcontaPagar');
        $this->db->from('contaspagar');
        $this->db->where('idCompra', $idPagamento);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idcontaPagar;
        }
    }

    public function pagoHoje() {
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->where('tipomovimento', 'Saida');
        $this->db->where('datamovimento', date('Y-m-d'));
        $query = $this->db->get();
        // Get the single result row directly
        $row = $query->row();
        // If the row exists and valor is not null, return it. Otherwise return 0
        return isset($row->valor) ? $row->valor : 0;
    }

    public function RecebidoHoje() { // modelo que pega o total de dividas
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->where('tipomovimento', 'Entrada');
        $this->db->where('datamovimento', date('Y-m-d'));
        $query = $this->db->get();
        // Get the single result row directly
        $row = $query->row();
        // If the row exists and valor is not null, return it. Otherwise return 0
        return isset($row->valor) ? $row->valor : 0;
    }

    public function pagoMes() { // Modelo que calcula o total pago no mês
        // Define o intervalo do mês atual
        $primeiroDia = date('Y-m-01');
        $ultimoDia = date('Y-m-t');

        // Configura a consulta de soma
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->where('tipomovimento', 'Saida');

        // Filtra por datas dentro do mês
        $this->db->where('datamovimento >=', $primeiroDia);
        $this->db->where('datamovimento <=', $ultimoDia);

        $query = $this->db->get();
        $resultado = $query->row();

        // Retorna o total ou 0 se não houver valores
        return isset($resultado->valor) ? $resultado->valor : 0;
    }

    public function RecebidoMes() { // Modelo que calcula o total recebido no mês
        // Define o intervalo do mês atual
        $primeiroDia = date('Y-m-01');
        $ultimoDia = date('Y-m-t');

        // Configura a consulta de soma
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->where('tipomovimento', 'Entrada');

        // Filtra por datas dentro do mês
        $this->db->where('datamovimento >=', $primeiroDia);
        $this->db->where('datamovimento <=', $ultimoDia);

        $query = $this->db->get();
        $resultado = $query->row();

        // Retorna o total ou 0 se não houver valores
        return isset($resultado->valor) ? $resultado->valor : 0;
    }

    public function pagoAno() { // Modelo que calcula o total pago no ano
        // Define intervalo do ano atual
        $primeiroDia = date('Y-01-01'); // Primeiro dia do ano
        $ultimoDia = date('Y-12-31');   // Último dia do ano

        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->where('tipomovimento', 'Saida');

        // Filtra por datas dentro do ano corrente
        $this->db->where('datamovimento >=', $primeiroDia);
        $this->db->where('datamovimento <=', $ultimoDia);

        $query = $this->db->get();
        $resultado = $query->row();

        return isset($resultado->valor) ? $resultado->valor : 0;
    }

    public function recebidoAno() { // modelo que pega o total de dividas
        // Define intervalo do ano atual
        $primeiroDia = date('Y-01-01'); // Primeiro dia do ano
        $ultimoDia = date('Y-12-31');   // Último dia do ano
        $this->db->select_sum('valor');
        $this->db->from('movimentacoes');
        $this->db->where('tipomovimento', 'Entrada');
        // Filtra por datas dentro do ano corrente
        $this->db->where('datamovimento >=', $primeiroDia);
        $this->db->where('datamovimento <=', $ultimoDia);

        $query = $this->db->get();
        $resultado = $query->row();

        return isset($resultado->valor) ? $resultado->valor : 0;
    }

    public function a_pagar_hoje() {// Dividas  por pagar com os fornecedores
        // Inicia a construção da consulta
        $this->db->select_sum('valor');     // Soma a coluna 'valor'
        $this->db->from('contaspagar');     // Define a tabela de contas a pagar
        $this->db->where('datapagamento', date('Y-m-d'));  // Filtra pela data atual

        $consulta = $this->db->get();  // Executa a consulta no banco de dados
        // Obtém diretamente a única linha de resultado
        $row = $consulta->row();

        // Retorna o valor total ou 0 caso não haja registros
        return ($row && $row->valor !== null) ? $row->valor : 0;
    }

    public function a_receber_hoje() { // Dividas  a receber de Clientes
        $this->db->select_sum('valor');
        $this->db->from('contasreceber');
        $this->db->where('data_vencimento', date('Y-m-d'));
        $consulta = $this->db->get();  // Executa a consulta no banco de dados
        // Obtém diretamente a única linha de resultado
        $row = $consulta->row();

        // Retorna o valor total ou 0 caso não haja registros
        return ($row && $row->valor !== null) ? $row->valor : 0;
    }

    public function a_pagar_mes() {
        // Obtém o primeiro e último dia do mês atual
        $primeiroDia = date('Y-m-01');
        $ultimoDia = date('Y-m-t');

        // Configura a consulta para somar valores
        $this->db->select_sum('valor');
        $this->db->from('contaspagar');

        // Filtra contas entre o primeiro e último dia do mês
        $this->db->where('datapagamento >=', $primeiroDia);
        $this->db->where('datapagamento <=', $ultimoDia);

        $query = $this->db->get();
        $resultado = $query->row();

        // Retorna o total ou 0 se não houver registros
        return isset($resultado->valor) ? $resultado->valor : 0;
    }

    public function a_receber_mes() { // Modelo que pega o total de recebíveis
        // Define intervalo do mês atual
        $primeiroDia = date('Y-m-01');
        $ultimoDia = date('Y-m-t');

        // Configura a soma dos valores a receber
        $this->db->select_sum('valor');
        $this->db->from('contasreceber');

        // Filtra por datas dentro do mês corrente
        $this->db->where('data_vencimento >=', $primeiroDia);
        $this->db->where('data_vencimento <=', $ultimoDia);

        $query = $this->db->get();
        $resultado = $query->row();

        // Retorna total ou 0 se não houver valores
        return isset($resultado->valor) ? $resultado->valor : 0;
    }

    public function a_pagar_ano() { // modelo que pega o total de dividas
        $data = new DateTime(date('Y-m-d'));
        $mes = $data->format('m');
        $Ano = $data->format('Y');
        $this->db->select_sum('valor');
        $this->db->from('contaspagar');
        $this->db->where("YEAR(datapagamento)=$Ano");
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->valor) {
                return $value->valor;
            } else {
                return 0;
            }
        }
    }

    public function a_receber_ano() { // modelo que pega o total de dividas
        $data = new DateTime(date('Y-m-d'));
        $mes = $data->format('m');
        $Ano = $data->format('Y');
        $this->db->select_sum('valor');
        $this->db->from('contasreceber');
        $this->db->where("YEAR(data_vencimento)=$Ano");
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->valor) {
                return $value->valor;
            } else {
                return 0;
            }
        }
    }

    /**
     * Retorna o idcliente associado a um pagamento, com base no idPagamento.
     *
     * Realiza um join entre a tabela pagamentos_credito (alias pc) e a tabela contasreceber (alias cr)
     * para obter o campo idcliente da fatura relacionada ao pagamento.
     *
     * @param int $idPagamento Identificador do pagamento.
     * @return int|null Retorna o idcliente ou null se não for encontrado.
     */
    public function idCliente($idPagamento) {
        $this->db->select('cr.idcliente');
        $this->db->from('pagamentos_credito as pc');
        $this->db->join('contasreceber as cr', 'pc.idCredito = cr.idrecebimento', 'left');
        $this->db->where('pc.idPagamento', $idPagamento);
        $query = $this->db->get();
        $resultado = $query->row();
        return ($resultado && isset($resultado->idcliente)) ? $resultado->idcliente : null;
    }
     public function idFatura($idPagamento) {
        $this->db->select('cr.idFatura');
        $this->db->from('pagamentos_credito as pc');
        $this->db->join('contasreceber as cr', 'pc.idCredito = cr.idrecebimento', 'left');
        $this->db->where('pc.idPagamento', $idPagamento);
        $query = $this->db->get();
        $resultado = $query->row();
        return ($resultado && isset($resultado->idFatura)) ? $resultado->idFatura : null;
    }

    public function mpega_tipo_movimento_caixa() {
        $this->db->select('');
        $this->db->from('tipo_movimento_caixa');
        $this->db->where('idTipoMovimentoCaixa !=', 1);
        $this->db->where('idTipoMovimentoCaixa !=', 8);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    //METODO AUXILIAR Q PARA ATUALIZAR idTipoMovimentoCaixa

    public function mpega_movimentacoes() {
        $this->db->select('');
        $this->db->from('movimentacoes');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mpega_atualiza_movimentacoes($idmovimento, $idTipoMovimentoCaixa) {
        $this->db->where('idmovimento', $idmovimento);
        $this->db->set('idTipoMovimentoCaixa', $idTipoMovimentoCaixa);
        $this->db->update('movimentacoes');
    }

    public function listaCashParcelado($dataCaixa, $idUsuario) {
        $this->db->select('fatura');
        $this->db->from('faturas');
        $this->db->where('iduser', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $this->cash($value->fatura);
        }
        return $total;
    }

    public function listaTpaParcelado($dataCaixa, $idUsuario) {
        $this->db->select('fatura');
        $this->db->from('faturas');
        $this->db->where('iduser', $idUsuario);
        $this->db->where('data', $dataCaixa);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $this->tpa($value->fatura);
        }
        return $total;
    }

    public function cash($idFatura) {
        $this->db->select('cash');
        $this->db->from('pagamentos_parcelados');
        $this->db->where('idfatura', $idFatura);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $value->cash;
        }
        return $total;
    }

    public function tpa($idFatura) {
        $this->db->select('tpa');
        $this->db->from('pagamentos_parcelados');
        $this->db->where('idfatura', $idFatura);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $value->tpa;
        }
        return $total;
    }

    public function mresetSaldoEmpresesa() {
        $this->db->where('idtipoconta', 1);
        $this->db->set('valordebito', 0);
        $this->db->set('valorcredito', 0);
        $this->db->update('saldo');
    }

    public function mresetSaldoEmpresesa2() {
        $this->db->where('idtipoconta', 2);
        $this->db->set('valordebito', 0);
        $this->db->set('valorcredito', 0);
        $this->db->update('saldo');
    }

    public function mresetSaldoEmpresesa3() {
        $this->db->where('idtipoconta', 3);
        $this->db->set('valordebito', 0);
        $this->db->set('valorcredito', 0);
        $this->db->update('saldo');
    }

    public function movimentacoes() {
        $this->db->delete('movimentacoes');
    }

    public function fluxodiario() {
        $this->db->delete('fluxodiario');
    }

    public function caixaaberturafeixo() {
        $this->db->delete('caixaaberturafeixo');
    }

    public function carrinho() {
        $this->db->delete('carrinho');
    }

}
