<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mFornecedor
 *
 * @author VINEVALA
 */
class mFornecedor extends CI_Model {

    public function gravarFornecedorM($idPro, $fornecedor, $rua, $fone1, $fone2, $email, $portanumero, $nif, $idpais, $nomeContacto) {

        $dados = array(
            'fornecedor' => $fornecedor,
            'idprovincia' => $idPro,
            'rua' => $rua,
            'nif' => $nif,
            'nif' => $nif,
            'idpais' => $idpais,
            'nomeContacto' => $nomeContacto,
        );
        $this->db->insert('fonecedores', $dados);
        $ultimoId = $this->db->insert_id();
        $dadostelefone = array(
            'idfornecedor' => $ultimoId,
            'tlm1' => $fone1,
            'tlm2' => $fone2,
            'email' => $email,
            'portanumero' => $portanumero,
        );
        $this->db->insert('contatofornecedor', $dadostelefone);
    }

//    Metodo que lista fornecedores para a combo box
    public function mgetFornecedoresCB() {
        $this->db->select('idfornecedor,fornecedor');
        $this->db->from('fonecedores');
        $this->db->order_by('fornecedor', 'asc');
        $query = $this->db->get();
        return $query->result();
    }

//   fim do metodo 
    public function ConsultarFornecedor($fornecedor) {
        $this->db->select('idfornecedor');
        $this->db->where('idfornecedor', $fornecedor);
        $this->db->from('fonecedores');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function pegarIdfornecedor($fornecedor) {
        $this->db->select('idfornecedor');
        $this->db->where('fonecedores', $fornecedor);
        $consulta = $this->db->get('fornecedor');
        return $consulta->result();
    }

//    Metodo que ista fornecedores para a Grid
    public function listaFornecedoresM($start, $limit) {
        $this->db->select('*');
        $this->db->from('fonecedores');
        $this->db->join('contatofornecedor', 'fonecedores.idfornecedor=contatofornecedor.idfornecedor');
        $this->db->join('paises', 'fonecedores.idpais=paises.idpais');
        $this->db->join('provinciais', 'fonecedores.idprovincia=provinciais.idprovincia');
        $this->db->order_by('fonecedores.fornecedor');
        $this->db->limit($start, $limit);
        $consulta = $this->db->get();
        return $consulta->result();
    }

//    Metodo para totalizar
    public function contarFornecedor() {
        $this->db->select('*');
        $this->db->from('fonecedores');
        $this->db->join('contatofornecedor', 'fonecedores.idfornecedor=contatofornecedor.idfornecedor');
        return $this->db->count_all_results();
    }

    public function pegarTelefornecedor($idfornecedor) {
        $this->db->select('tlm1');
        $this->db->from('fonecedores');
        $this->db->join('contatofornecedor', 'fonecedores.idfornecedor=contatofornecedor.idfornecedor');
        $this->db->where('contatofornecedor.idfornecedor', $idfornecedor);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->tlm1;
        }
    }

    public function apagarFornecedorM($id) {
        $dados = array(
            'codigo' => $id
        );

        $this->db->where('idfornecedor', $id);
        $this->db->delete('fonecedores');
    }

}

?>
