<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of faturaproformarelatorioM
 *
 * @author VINEVALA
 */
class mOrcaento extends CI_Model {
    public function registar($idusuario,$dataValidade,$idCliente,$totalgeral,$idMoeda){
        $dados=array(
          'data'=> @date('Y-m-d'),
          'idUsaurio'=>$idusuario,
          'idCliente' =>$idCliente ,
          'total_venda'=>$totalgeral ,
          'dataValidade'=>$dataValidade ,
          'hora'=>@date('H:i:s'),
          'idMoeda'=>$idMoeda
        );
        $this->db->insert('orcamentos',$dados);
        return $this->db->insert_id();
        
    }
  
    public function itemFaturaforma($idFatura,$idProduto,$valor,$qtd,$total,$ivaVenda,$ivaCompra,$irt){
       $dados=array(
          'idFatura'=>$idFatura, 
          'idpr'=>$idProduto,
          'qtd'=>$qtd,  
          'custo'=>$valor,
          'total'=>$total ,
          'datavenda'=> $data =@date('Y/m/d'),
          'ivaVenda'=>$ivaVenda,
          'ivaCompra'=>$ivaCompra,
          'irt'=>$irt,
        );
        $this->db->insert('item_orcamentos',$dados);
        
    }
    

  
    //Metodo para carregar item na carrinha de vendas
    public function imprimirVendasProforma($idfatura){  
        $this->db->select('*');
        $this->db->from('orcamentos');
        $this->db->join('item_orcamentos','orcamentos.idFatura=item_orcamentos.idFatura');
        $this->db->join('clientes','orcamentos.idCliente=clientes.idcliente');
        $this->db->join('cliente_contacto','clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('usuarios','orcamentos.idUsaurio=usuarios.id_usiario');
        $this->db->join('prodt','item_orcamentos.idpr=prodt.idpr');
        $this->db->where('orcamentos.idFatura',$idfatura);
        $consulta=  $this->db->get();
        return $consulta->result();
    }
    // metodo para remover Item da carrinha da venda por forma
    
    // metodo que lista as vendas diarias por cada utilizador
    public function listarvendasFaturasProformas($start,$limit){  
        $this->db->select('*');
        $this->db->from('orcamentos');
        $this->db->join('item_orcamentos','orcamentos.idFatura=item_orcamentos.idFatura');
        $this->db->join('clientes','orcamentos.idCliente=clientes.idcliente');
        $this->db->join('cliente_contacto','clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('usuarios','orcamentos.idUsaurio=usuarios.id_usiario');
        $this->db->join('prodt','item_orcamentos.idpr=prodt.idpr');
        $this->db->order_by('orcamentos.idFatura','desc');
        $this->db->limit($limit,$start);
        $this->db->group_by('orcamentos.idFatura');
        $this->db->order_by('hora', 'DESC');
        $consulta=  $this->db->get();
        return $consulta->result();
    }
    
    //metodo para contar o numero de registo existente na bd
    public function contarFaturasProformas(){
        $this->db->select('*');
        $this->db->from('orcamentos');
        return $this->db->count_all_results();
    }
     public function contarFaturasProformasPordData($dataminima,$datamaxima){
        $this->db->select('*');
        $this->db->from('orcamentos');
         $this->db->where('data>=',$dataminima);          
        $this->db->where('data <=',$datamaxima);
        return $this->db->count_all_results();
    }

    public function consultar_faturaForma($fatura){
     $this->db->where('fatura', $fatura);
        
        $this->db->from('orcamentos');
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
          return false;  
   }
   public function pegarTotalProforma ($dataminima,$datamaxima){// 
    $this->db->select_sum('total');
     $this->db->from('item_orcamentos');
    $this->db->where('datavenda>=',$dataminima);          
    $this->db->where('datavenda <=',$datamaxima);       
    $consulta=  $this->db->get();
    $valor=0.00;
    foreach ($consulta->result() as $value) {
        return $valor= $value->total;
    }
   }
       //Metodo para carregar item na carrinha de vendas
    public function produtosFaturaProforma($idfatura){  
        $this->db->select('*');
        $this->db->from('orcamentos');
        $this->db->join('item_orcamentos','orcamentos.idFatura=item_orcamentos.idFatura');
        $this->db->join('clientes','orcamentos.idCliente=clientes.idcliente');
        $this->db->join('cliente_contacto','clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('usuarios','orcamentos.idUsaurio=usuarios.id_usiario');
        $this->db->join('prodt','item_orcamentos.idpr=prodt.idpr');
        $this->db->where('orcamentos.idFatura',$idfatura);
        $consulta=  $this->db->get();
        return $consulta->result();
    }
       //Metodo para carregar item na carrinha de vendas
    public function pegaFaturaProforma($dataminima,$datamaxima){  
        $this->db->select('*');
        $this->db->from('orcamentos');
//       
        $this->db->where('data>=',$dataminima);          
        $this->db->where('data <=',$datamaxima); 
        $consulta=  $this->db->get();
        return $consulta->result();
    }
    
    public function serie($idFatura){// serie da nota de credito
        $this->db->select('data');
        $this->db->from('orcamentos');
        $this->db->where('orcamentos.idFatura',$idFatura);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt= new DateTime($value->data);
            return $dt->format('Y');
                
        }
       
    }
    public function systemEntryate($idFatura){ // data e hora da fatura
        $this->db->select('data,hora');
        $this->db->from('orcamentos');
        $this->db->where('orcamentos.idFatura',$idFatura);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
                return $value->data.'T'.$value->hora;
                
        }
       
    }
    public function inVoiceDate($idFatura){
        $this->db->select('data');
        $this->db->from('orcamentos');
        $this->db->where('orcamentos.idFatura',$idFatura);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt= new DateTime($value->data);
            return $dt->format('Y-m-d');
                
        }
       
    }
     public function grossTotal($idFatura){
        
            $this->db->select('total_venda');
            $this->db->from('orcamentos');
            $this->db->where('orcamentos.idFatura',$idFatura);
            $consulta=  $this->db->get();
            foreach ($consulta->result() as $value) {
               return $value->total_venda;             
    }
 
    }
    public function contarRegistosFaturasProforma(){// verifica se ja existe registo no bd
     $this->db->select('idFatura');
     $this->db->from('orcamentos');
    return $this->db->count_all_results() ;
   }
   public function hash_da_ultima_fatura($idFatura){
        $this->db->select('hash');
        $this->db->from('orcamentos');
        $this->db->where('orcamentos.idFatura',$idFatura-1);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
           return $value->hash;             
        }
       
    }
    public function matualizar_hash($idFatura,$registoHash,$hasControl){
        $dados=array(
         'hash'=> $registoHash,
         'hashcontrol'=> $hasControl,   
        );
	$this->db->where('idFatura',$idFatura);
        $this->db->set($dados);
        $this->db->update('orcamentos'); 
  
    }
     //Metodo para carregar item na carrinha de vendas
    public function faturaProformaClientes($dataminima,$datamaxima){  
        $this->db->select('*');
        $this->db->from('orcamentos');
        $this->db->join('clientes','orcamentos.idCliente=clientes.idcliente');
        $this->db->join('cliente_contacto','clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where('data>=',$dataminima);          
        $this->db->where('data <=',$datamaxima); 
        $consulta=  $this->db->get();
        return $consulta->result();
    }
    public function contarRegistosFaturas($dataminima,$datamaxima,$idcliente){// verifica se ja existe registo no bd
     $this->db->select('idcliente'); 
     $this->db->from('orcamentos');
     $this->db->where('idcliente',$idcliente);
     $this->db->where('data>=',$dataminima);      
     $this->db->where('data <=',$datamaxima); 
     return $this->db->count_all_results(); 
   }
    public function produtosFaturaProformaSaft($dataminima,$datamaxima){  
        $this->db->select('*');
        $this->db->from('orcamentos');
        $this->db->join('item_orcamentos','orcamentos.idFatura=item_orcamentos.idFatura');
        $this->db->join('prodt','item_fatura_pro_forma.idpr=prodt.idpr');
        $this->db->where('data>=',$dataminima);      
        $this->db->where('data <=',$datamaxima); 
        $consulta=  $this->db->get();
        return $consulta->result();
    }
    public function contarRegistosProdutosFaturas($dataminima,$datamaxima,$idpr){// verifica se ja existe registo no bd 
     $this->db->select('idcliente'); 
     $this->db->from('faturas');
      $this->db->join('item_fatura','faturas.fatura=item_fatura.fatura');
     $this->db->where('idpr',$idpr);
     $this->db->where('faturas.data>=',$dataminima);      
     $this->db->where('faturas.data <=',$datamaxima); 
     return $this->db->count_all_results(); 
   }
    public function total_por_fatura_sem_iva ($idFatura){// 
    $this->db->select_sum('total');
     $this->db->from('item_orcamentos');
    $this->db->where('idFatura',$idFatura);                
    $consulta=  $this->db->get();
    foreach ($consulta->result() as $value) {
        return $value->total;
    }
   }
   public function mlista_orcamento(){  
        $this->db->select('*');
        $this->db->from('orcamentos');
         $this->db->order_by('idFatura','DESC');
         $consulta=  $this->db->get();
        return $consulta->result();
    }
    public function registar_docs_or($idFatura,$idDocumentoEmitido){ 
        $dados=array( 
          'idFatura'=>$idFatura,
          'idDocumentoEmitido'=>$idDocumentoEmitido,
        );
        $this->db->insert('docs_or',$dados);
    }
    public function pega_idDocumentoEmitido($idFatura){// 
        $this->db->select('idDocumentoEmitido');
        $this->db->from('docs_or');
        $this->db->where('idFatura',$idFatura);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
           return $value->idDocumentoEmitido;             
        } 
    }
    public function p_idVenda($idTipoDocumento){// 
        $this->db->select('idVenda');
        $this->db->from('documentos_emitidos');
        $this->db->where('idDocumentoEmitido',$idTipoDocumento);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
           return $value->idVenda;             
        }  
    }
     public function idCliente($idFatura){// 
        $this->db->select('idCliente');
        $this->db->from('orcamentos');
        $this->db->where('idFatura',$idFatura);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
           return $value->idCliente;             
        }
       
    }
}

?>
