﻿<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mResumoVendasArtigo
 *
 * @author VINEVALA
 */
class mResumoVendasArtigo extends CI_Model {

    var $hpdf = '';

    public function pegaNomeUsuario($id) {
        $this->db->select('*');
        $this->db->from('usuarios');
        $this->db->where('id_usiario', $id);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->unome;
        }
    }

    public function conta_vezes_produto($dataminima, $datamaxima, $idProduto) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("idpr", $idProduto);
        $this->db->where("datavenda >=", $dataminima);
        $this->db->where("datavenda <=", $datamaxima);
        return $this->db->count_all_results();
    }

    public function pegaNomeLoja($id) {
        $this->db->select('*');
        $this->db->from('armanzes');
        $this->db->where('id', $id);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->narmanze;
        }
    }

    public function consulta_idproduto_compra($idproduto) {
        $this->db->select('idproduto');
        $this->db->from('compras');
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where("idproduto", $idproduto);
        return $this->db->count_all_results();
    }

    public function mpega_custo($idproduto) {
        $this->db->select('custo');
        $this->db->from('item_compras');
        $this->db->where("idproduto", $idproduto);
        $this->db->order_by("idstock", 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->custo) {
                return $value->custo;
            } else {
                return 0;
            }
        }
    }

    public function pega_custo_produto($dataminima, $datamaxima, $idproduto) {
        $this->load->model('mGestaoStock');
        $this->load->model('mLucro');
        if ($this->consulta_idproduto_compra($dataminima, $datamaxima, $idproduto) > 0) {
            $custo_grosso = $this->mpega_custo($idproduto);
            $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idproduto);
            $custo = number_format($custo_grosso / $total_por_unidade, 2);
            return $custo;
        } else {
            return $this->mLucro->mpega_custo_produto($idproduto);
        }
    }

    public function qtd($dataminima, $datamaxima, $idProduto) {
        $this->db->select_sum('qtd');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("idpr", $idProduto);
        $this->db->where("datavenda >=", $dataminima);
        $this->db->where("datavenda <=", $datamaxima);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->qtd) {
                return $value->qtd;
            } else {
                return 0;
            }
        }
    }

    public function total_preco_venda($dataminima, $datamaxima, $idProduto) {
        $this->db->select_sum('custo');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where("idpr", $idProduto);
        $this->db->where("datavenda >=", $dataminima);
        $this->db->where("datavenda <=", $datamaxima);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->custo) {
                return $value->custo;
            } else {
                return 0;
            }
        }
    }

    public function valor_media_venda($dataminima, $datamaxima, $idProduto) {
        $qtd = $this->conta_vezes_produto($dataminima, $datamaxima, $idProduto);
        $total = $this->total_preco_venda($dataminima, $datamaxima, $idProduto);
        return ($total / $qtd);
    }

    public function total_gastos($dataminima, $datamaxima, $idProduto) {
        $qtd = $this->qtd($dataminima, $datamaxima, $idProduto);
        return $this->pega_custo_produto($dataminima, $datamaxima, $idProduto) * $qtd;
        //  return $this->pega_custo_produto($dataminima,$datamaxima,$idProduto);
    }

}
