<script src="<?php echo base_url(); ?>src/pos/empresas.js"></script>
<style>
    /* Força o container do intlTelInput a ocupar 100% da largura do seu elemento pai */
    .intl-tel-input {
        width: 100% !important;
        display: block !important;
        box-sizing: border-box;
    }

    /* Força o input interno a ocupar 100% */
    .intl-tel-input input[type="tel"] {
        width: 100% !important;
        box-sizing: border-box;
    }
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .icon-action i {
        font-size: 20px;          /* Tamanho do ícone */
        /*color: #5bc0de;            Azul claro */
        transition: transform 0.2s ease, color 0.2s ease;
    }

    .icon-action:hover i {
        transform: scale(1.2);    /* Aumenta a escala no hover */
        color: #3399cc;           /* Azul um pouco mais escuro no hover */
    }
    /* Sombreamento extra para a modal */
    .modal-content {
        box-shadow: 0 5px 15px rgba(0, 0, 0, 0.5);
    }
    /* Animações e transições para campos e botões */
    .form-control {
        transition: border-color 0.3s, box-shadow 0.3s;
    }
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .header-entrada-saldo-cliente {
        background-color: #6f42c1;
        color: #fff;
    }
</style>

<main>
    <div class="container-fluid py-4">
        <!-- Header principal -->
        <div class="d-flex flex-column flex-sm-row justify-content-between align-items-center main-header mb-2">
            <!--div que recebe o nome da entidade-->
            <div> <h4 class="mb-2 mb-sm-0 nomeEmpresa">Registar empresa</strong></h4></div>
            <div>
                <button class="btn btn-outline-primary listaEmpresas"> <i class="fas fa-ellipsis-v"></i> Empresas</button>
            </div>
        </div>
        <div class="card mb-3">
            <div class="card-body">
                <!-- Início do Formulário -->
                <form id="formEmpresa">
                    <!-- Nav Tabs -->
                    <ul class="nav nav-tabs" role="tablist">
                        <li class="nav-item">
                            <a class="nav-link active" id="dados-empresa-tab" data-toggle="tab" href="#dados-empresa" role="tab" aria-controls="dados-empresa" aria-selected="true">
                                Dados da empresa
                            </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" id="dados-estrutura-tab" data-toggle="tab" href="#dados-estrutura" role="tab" aria-controls="dados-estrutura" aria-selected="false">
                                Estrutura da Empresa
                            </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" id="info-comercial-tab" data-toggle="tab" href="#info-comercial" role="tab" aria-controls="info-comercial" aria-selected="false">
                                Informação Comercial
                            </a>
                        </li>
                    </ul>

                    <!-- Conteúdo das Tabs -->
                    <div class="tab-content p-3" id="myTabContent">
                        <!-- Aba: Dados da Empresa -->
                        <div class="tab-pane fade show active" id="dados-empresa" role="tabpanel" aria-labelledby="dados-empresa-tab">
                            <div class="row mb-3">
                                <div class="col-md-6">
                                    <label for="provincia"class="form-label has-float-label mb-4 position-relative">
                                        <select class="form-control" id="idProvincia" name="idProvincia">

                                        </select>
                                        <span>Província </span>
                                    </label> 
                                </div>
                                <div class="col-md-6">
                                    <label for="nome" class="form-label has-float-label mb-4 position-relative">
                                        <input type="text" class="form-control" id="nempresa" name="nempresa" placeholder="Ex: EMPRESA & FILHOS, LDA">
                                        <span>Nome </span>
                                    </label>
                                </div>
                            </div>

                            <div class="row mb-3">
                                <div class="col-md-6">
                                    <label for="nif" class="form-label has-float-label mb-4 position-relative">
                                        <input type="text" class="form-control" id="nif" name="nif" placeholder="Ex: 5128001563">
                                        <span>NIF </span>
                                    </label>
                                </div>
                                <div class="col-md-6">
                                    <label for="endereco" class="form-label has-float-label mb-4 position-relative">
                                        <input type="text" class="form-control" id="endereco" name="endereco" placeholder="Ex: Dango">
                                        <span>Endereço </span>
                                    </label>
                                </div>
                            </div>

                            <div class="row mb-3">
                                <div class="col-md-3">
                                    <label for="telefone" class="form-label has-float-label mb-4 position-relative">
                                        <input type="text" class="form-control" id="telefone" name="telefone" >
                                        <span>Telefone </span>
                                    </label>
                                </div>
                                <div class="col-md-3">
                                    <label for="telefone" class="form-label has-float-label mb-4 position-relative">
                                        <input type="text" class="form-control" id="telefone2" name="telefone2" >
                                        <span>Telefone </span>
                                    </label>
                                </div>
                                <div class="col-md-6">
                                    <label for="email" class="form-label has-float-label mb-4 position-relative">
                                        <input type="email" class="form-control" id="email" name="email" placeholder="Ex: email@empresa.com">
                                        <span>E-mail:</span>
                                    </label>
                                </div>
                            </div>

                            <div class="row mb-3">
                                <div class="col-md-6">
                                    <label for="website" class="form-label has-float-label mb-4 position-relative">
                                        <input type="text" class="form-control" id="website" name="website" placeholder="Ex: www.empresa.com">
                                        <span>Website </span>
                                    </label>
                                </div>
                                <div class="col-md-6">
                                    <label for="regime" class="form-label has-float-label mb-4 position-relative">
                                        <select class="form-control" id="idRegime" name="idRegime">

                                        </select>
                                        <span>Regime </span>
                                    </label>
                                </div>
                            </div>

                            <div class="row mb-3">
                                <div class="col-md-6">
                                    <div class="form-check mb-2">
                                        <input class="form-check-input" type="checkbox" value="1" id="logoDadosEmpresa" name="logoDadosEmpresa">
                                        <label class="form-check-label" for="logoDadosEmpresa">
                                            Logotipo com dados da empresa?
                                        </label>
                                    </div>
                                    <small class="text-muted">
                                        Recomendamos a utilização do logo em formato retangular, por exemplo 300x60px
                                    </small>
                                </div>
                                <div class="col-md-6">
                                    <label for="logo" class="form-label">Logotipo</label>
                                    <input class="form-control" type="file" id="logo" name="logo">
                                    <!-- Pré-visualização do logo (opcional) -->
                                    <div class="mt-2">
                                        <img id="previewLogo" src="#" alt="Sem foto" style="max-width: 150px; display: none;">
                                    </div>
                                    <!-- Botão para eliminar a imagem -->
                                    <button type="button" id="removeLogo" class="btn btn-danger btn-sm mt-2" style="display: none;">
                                        Remover Imagem
                                    </button>
                                </div>
                            </div>
                        </div>

                        <!-- Aba: Estrutura da Empresa -->
                        <div class="tab-pane fade" id="dados-estrutura" role="tabpanel" aria-labelledby="dados-estrutura-tab">
                            <p>Aqui vão os campos relativos à estrutura da empresa.</p>
                            <div class="form-group">
                                <label for="departamentos">Departamentos</label>
                                <input type="text" class="form-control" id="departamentos" name="departamentos" placeholder="Ex: Financeiro, RH, Comercial">
                            </div>
                        </div>

                        <!-- Aba: Informação Comercial -->
                        <div class="tab-pane fade" id="info-comercial" role="tabpanel" aria-labelledby="info-comercial-tab">
                            <p>Aqui vão os campos relativos à informação comercial.</p>
                            <div class="form-group">
                                <label for="linhasNegocio">Linhas de Negócio</label>
                                <input type="text" class="form-control" id="linhasNegocio" name="linhasNegocio" placeholder="Ex: Venda de Materiais, Consultoria, etc.">
                            </div>
                        </div>
                    </div>
                    <!-- Fim do Conteúdo das Tabs -->

                    <!-- Botões de Ação -->
                    <div class="mt-4 text-right">
                        <button type="reset" class="btn btn-outline-secondary">  <i class="fas fa-times"></i>  Cancelar</button>
                        <button type="submit" class="btn btn-primary"> <i class="fas fa-check"></i> Finalizar</button>
                    </div>
                </form>
                <!-- Fim do Formulário -->
            </div>
        </div>



    </div>
</main>



<script>
    document.querySelectorAll('[data-bs-toggle="tooltip"]').forEach(tooltipEl => {
        new bootstrap.Tooltip(tooltipEl);
    });
    // Quando o usuário seleciona uma imagem, exibe a pré-visualização com efeito fade-in
    document.getElementById('logo').addEventListener('change', function (event) {
        const [file] = event.target.files;
        if (file) {
            const preview = document.getElementById('previewLogo');
            preview.src = URL.createObjectURL(file);
            // Usando jQuery para exibir com efeito fadeIn
            $(preview).hide().fadeIn('slow');
            // Exibe o botão de remover
            $('#removeLogo').show();
        }
    });

    // Evento para remover a imagem e limpar o input
    document.getElementById('removeLogo').addEventListener('click', function () {
        const preview = document.getElementById('previewLogo');
        // Limpa a pré-visualização
        preview.src = '#';
        preview.style.display = 'none';
        // Limpa o input de arquivo
        document.getElementById('logo').value = '';
        // Esconde o botão de remover
        $(this).hide();
    });

    var input = document.querySelector("#telefone");
    var input2 = document.querySelector("#telefone2");
    var iti = window.intlTelInput(input, {
        initialCountry: "ao", // ou outro país padrão
        utilsScript: utilsScriptPath, // Caminho local do arquivo utils.js
        validationNumberType: "ANY", // Validação para números móveis
        customFlags: flags, // Caminho para as bandeiras
        preferredCountries: ['ao', 'us', 'fr', 'br'], // Exemplo de países preferidos
        inputMode: "tel", // Sugere números
        customPlaceholder: function (selectedCountryPlaceholder, selectedCountryData) {
            return  selectedCountryPlaceholder;
        }

    });

    // Inicializa o intlTelInput para o segundo campo
//    window.intlTelInput(input2, {
//        initialCountry: "ao", // País inicial
//        validationNumberType: "FIXED_LINE",
//        utilsScript: utilsScriptPath, // Caminho para o utils.js
//        preferredCountries: ['ao', 'us', 'fr', 'br']  // Países preferidos
//    });
    window.intlTelInput(input2, {
        initialCountry: "ao", // ou outro país padrão
        utilsScript: utilsScriptPath, // Caminho local do arquivo utils.js
        validationNumberType: "ANY", // Validação para números móveis
        customFlags: flags, // Caminho para as bandeiras
        preferredCountries: ['ao', 'us', 'fr', 'br'], // Exemplo de países preferidos
        inputMode: "tel", // Sugere números
        customPlaceholder: function (selectedCountryPlaceholder, selectedCountryData) {
            return  selectedCountryPlaceholder;
        }
    });
    input.addEventListener('input', function () {
        this.value = this.value.replace(/\D/g, ''); // Remove tudo que não for número
    });
    // Após inicializar, remove qualquer estilo inline de largura que o plugin tenha aplicado:
    var container = input2.closest('.intl-tel-input');
    if (container) {
        container.style.width = "100%";
    }
    input2.style.width = "100%";
    lista_provincias();
    function lista_provincias() {
        $.ajax({
            url: BASE_URL + "CProvincias/getAllProvincias", // URL da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                var option = '<option value="">Selecione</option>'; // Opção padrão "Selecione"
                if (dados.length > 0) {
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idProvincia + '">' + obj.provincia + '</option>';
                    });
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhum provincia selecionada  selecionada</option>';
                }
                $('#idProvincia').html(option).show();
            },
            error: function () {
                // Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar as províncias</option>';
                $('#idProvincia').html(option).show();
            }
        });
    }
    lista_regimes();
    function lista_regimes() {
        $.ajax({
            url: BASE_URL + "CEmpresa/listar_regime_empresa", // URL da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                var option = '<option value="">Selecione o regime</option>'; // Opção padrão "Selecione"
                if (dados.length > 0) {
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idRegime + '">' + obj.nregime + '</option>';
                    });
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhum regime selecionado  </option>';
                }
                $('#idRegime').html(option).show();
            },
            error: function () {
                // Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar os regimes</option>';
                $('#idRegime').html(option).show();
            }
        });
    }
    var idEmpresa = localStorage.getItem('idEmpresa');
    var nomeEmpresa = localStorage.getItem('nomeEmpresa');
    var nif = localStorage.getItem('nif');

   
    if(idEmpresa) {
        atualizarCliente(nomeEmpresa, nif);
        function atualizarCliente(nomeEmpresa, nif) {
            nome = nomeEmpresa.toUpperCase(); // Converter para maiúsculas
            let titulo = $("h4.mb-2.nomeEmpresa");
            titulo.fadeOut(300, function () {
                $(this).html(`Inf / <strong>${nome}</strong> <small style="font-size: 14px; color: gray;">(${nif})</small>`);
                $(this).fadeIn(300);
            });
        }
        getEmpresaEditar(idEmpresa);
        function getEmpresaEditar(idEmpresa) {
            $.ajax({
                type: 'get',
                url: BASE_URL + "CEmpresa/pega_empresa_edit", // Substitua pela URL do seu endpoint
                dataType: 'json',
                data: {
                    idEmpresa: idEmpresa
                },
                success: function (dados) {
                    $('#idProvincia').val(dados.idprovincia);
                    $('#nempresa').val(dados.nome);
                    $('#nif').val(dados.nif);
                    $('#endereco').val(dados.endereco);
                    $('#telefone').val(dados.telefone);
                    $('#fone1').val(dados.telefone2);
                    $('#email').val(dados.email);
                    $('#website').val(dados.website);
                    $('#idRegime').val(dados.idRegime);
//                
                },
                error: function (xhr, status, error) {
                    console.error("Erro ao obter os produtos:", error);
                    // Trate o erro como necessário
                }

            });
        }

    } else {
        atualizarCliente(nomeEmpresa, nif);
        function atualizarCliente(nomeEmpresa, nif) {
            nome = nomeEmpresa.toUpperCase(); // Converter para maiúsculas
            let titulo = $("h4.mb-2.nomeEmpresa");
            titulo.fadeOut(300, function () {
                $(this).html(`Inf / <strong>${nome}</strong>`);
                $(this).fadeIn(300);
            });
        }
        $("#formEmpresa")[0].reset();
    }


</script>


