<script src="<?php echo base_url(); ?>src/pos/empresas.js"></script>
<style>
  
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .icon-action i {
        font-size: 20px;          /* Tamanho do ícone */
        /*color: #5bc0de;            Azul claro */
        transition: transform 0.2s ease, color 0.2s ease;
    }

    .icon-action:hover i {
        transform: scale(1.2);    /* Aumenta a escala no hover */
        color: #3399cc;           /* Azul um pouco mais escuro no hover */
    }
    /* Sombreamento extra para a modal */
    .modal-content {
        box-shadow: 0 5px 15px rgba(0, 0, 0, 0.5);
    }
    /* Animações e transições para campos e botões */
    .form-control {
        transition: border-color 0.3s, box-shadow 0.3s;
    }
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .header-entrada-saldo-cliente {
        background-color: #6f42c1;
        color: #fff;
    }
</style>

<main>
    <div class="container-fluid py-4">
        <!-- Header principal -->
        <div class="d-flex flex-column flex-sm-row justify-content-between align-items-center main-header mb-2">
            <!--div que recebe o nome da entidade-->
            <div> <h4 class="mb-2 mb-sm-0 nomeDaEntidade2"></strong></h4></div>
            <button class="btn btn-outline-primary crudEmpresas"> <i class="fas fa-plus"></i>  Adicionar</button>
        </div>
    </div>


    <div class="card mb-3">
        <div class="card-body">

            <ul class="nav nav-tabs" role="tablist">
                <li class="nav-item">
                    <a class="nav-link active" id="dados-empresa-tab" data-toggle="tab" href="#dados-empresa" role="tab" aria-controls="dados-empresa" aria-selected="true">
                        Dados da empresa
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="dados-estrutura-tab" data-toggle="tab" href="#dados-estrutura" role="tab" aria-controls="dados-estrutura" aria-selected="false">
                        Estrutura da Empresa
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="info-comercial-tab" data-toggle="tab" href="#info-comercial" role="tab" aria-controls="info-comercial" aria-selected="false">
                        Informação Comercial
                    </a>
                </li>
            </ul>

            <!-- Conteúdo das Tabs -->
            <div class="tab-content p-3" id="myTabContent">
                <!-- Aba: Dados da Empresa -->
                <div class="tab-pane fade show active" id="dados-empresa" role="tabpanel" aria-labelledby="dados-empresa-tab">
                    <div class="table-responsive">
                        <table class="data-table  responsive tabelaListaEmpresa" id="tabelaListaEmpresa">
                            <thead class="table-light">
                                <tr>
                                    <th width="35%">Empresa</th>
                                    <th width="35%">Contactos</th>
                                    <th width="23%">Sede</th>
                                    <th width="7%">Ações</th>
                                </tr>
                            </thead>
                            <tbody>
                                <!-- Linhas geradas via jQuery -->
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

    </div>

</div>
</main>
<!--Modal para RegistarSaldo do Cliente-->



<script>
    document.querySelectorAll('[data-bs-toggle="tooltip"]').forEach(tooltipEl => {
        new bootstrap.Tooltip(tooltipEl);
    });
    document.getElementById('logo').addEventListener('change', function (event) {
        const [file] = event.target.files;
        if (file) {
            const preview = document.getElementById('previewLogo');
            preview.src = URL.createObjectURL(file);
            preview.style.display = 'block';
        }
    });
</script>


