 
<script src="<?php echo base_url(); ?>src/pos/entidades.js"></script>
<style>
    /* Estilização do Accordion */
    #accordion .card {
        border: 1px solid #ddd; /* Borda suave ao redor do card */
        border-radius: 0.25rem; /* Arredondamento leve nos cantos */
        margin-bottom: 5px; /* Espaço entre os cards */
    }

    #accordion .card-header {
        display: flex; /* Usar flexbox para alinhar os itens */
        height: 35px; /* Ajuste o valor conforme necessário */
        /*background-color: #f8f9fa;  Fundo claro do header */
        border-bottom: 1px solid #ddd; /* Borda inferior */
        justify-content: space-between; /* Espaço entre o título e o botão link */
        align-items: flex-start; /* Alinha verticalmente os itens */
        border-bottom: 1px solid #ddd; /* Borda inferior */
        /*padding: 1rem;  Espaçamento no header */
    }

    #accordion .btn-link {
        color: #007bff; /* Cor azul do botão */
        font-weight: bold; /* Texto em negrito */
        text-decoration: none; /* Remove o sublinhado */
    }

    #accordion .btn-link:hover {
        color: #0056b3; /* Cor mais escura no hover */
        text-decoration: underline; /* Sublinhado ao passar o mouse */
    }

    #accordion .collapse.show {
        border-top: 1px solid #ddd; /* Borda entre o header e o body */
    }

    #accordion .card-body {
        padding: 1.25rem; /* Espaçamento interno do conteúdo */
        background-color: #f9f9f9; /* Fundo claro para o conteúdo */
    }

    /* Ajuste para botões colapsados */
    #accordion .btn-link.collapsed {
        color: #333; /* Cor personalizada quando o item está colapsado */
        font-weight: normal;
    }

    #accordion .btn-link.collapsed:hover {
        color: #555; /* Cor mais escura ao passar o mouse no botão colapsado */
    }

    /* Remover setas no Chrome, Safari, Edge, Opera */
    input[type="number"]::-webkit-inner-spin-button,
    input[type="number"]::-webkit-outer-spin-button {
        -webkit-appearance: none;
        margin: 0;
    }

    /* Remover setas no Firefox */
    input[type="number"] {
        -moz-appearance: textfield;
    }
    .icon-action {
        margin-right: 10px;
        color: #333;
        text-decoration: none;
    }

    .icon-action i {
        font-size: 18px;
    }
    .icon-action2 {
        margin-right: 10px;
        text-decoration: none;
    }

    .icon-action2 i {
        font-size: 20px;
    }
    .my-custom-swal {
        z-index: 1050; /* O z-index da modal do Bootstrap é 1040, então isso deve ser maior */
    }
    dataTable tbody td,
    .dataTable thead th {
        padding:2px 4px; /* Diminui o padding (espaçamento) das células */
        line-height: 0.5; /* Diminui a altura da linha */
        height: 5px;     /* Define uma altura fixa para as linhas */
    }

    .dataTable tbody tr {
        height: auto; /* Permite que a altura da linha seja ajustada automaticamente com base no conteúdo */
    }
    .btn-circle {
        width: 40px;
        height: 40px;
        padding: 0;
        border-radius: 50%;
        text-align: center;
        line-height: 40px; /* Para centralizar o texto verticalmente */
        font-size: 16px;
    }
    .entidade-card {
        background: #fff;
        border: 1px solid #ccc;
        padding: 10px;
        box-shadow: 0px 0px 5px rgba(0,0,0,0.1);
        position: absolute;
        z-index: 1060; /* Z-index maior para garantir que fique acima da modal */
    }
    /* Alterar a aparência do campo de pesquisa */
    .dataTables_filter input {
        width: 300px; /* Largura maior */
        padding: 10px; /* Espaçamento interno */
        border-radius: 20px; /* Bordas arredondadas */
        border: 2px solid #007bff; /* Borda azul */
        outline: none;
    }

    .dataTables_filter input:focus {
        border-color: #28a745; /* Borda verde ao focar */
        box-shadow: 0 0 10px rgba(0, 123, 255, 0.5); /* Sombra ao focar */
    }
    /* Estilização do campo de pesquisa com o ícone de lupa */
    .search-with-icon {
        padding-left: 30px; /* Espaço para o ícone */
        /*background-image: url('../../src/img/icon/search.png');  URL do ícone de lupa */
        background-repeat: no-repeat;
        background-position: 5px center; /* Posição do ícone no campo */
        background-size: 16px 16px; /* Tamanho do ícone */
        border: 1px solid #ced4da; /* Estilização da borda */
        border-radius: 4px; /* Bordas arredondadas */
        height: 35px; /* Altura do campo de pesquisa */
    }
    #modalListaProdutos .modal-dialog {
        max-width: 500px; /*  Ajuste o valor conforme necessário */
    }

    .section-title {
        font-size: 1.25rem;
        font-weight: bold;
        margin-bottom: 10px;
    }

    /* Estilos para o grupo de radio buttons personalizado */
    .custom-radio-group {
        /*        border-left: 4px solid #007bff;
                padding-left: 15px;
                margin-bottom: 20px;*/
    }

    /* Cor personalizada para a retificação */
    .custom-radio-group.retificacao {
        border-left-color: #ff8000;
    }

    /* Estilos gerais para cada radio button */
    .custom-radio {
        display: flex;
        align-items: center;
        margin-bottom: 5px;
        padding: 10px;
        border: 1px solid #ddd; /* Borda ao redor dos radio buttons */
        border-radius: 4px; /* Cantos levemente arredondados */
        position: relative; /* Para posicionar a barra de cor */
    }

    /* Barra de cor personalizada à esquerda de cada radio */
    .custom-radio::before {
        content: '';
        width: 5px;
        height: 100%;
        position: absolute;
        left: 0;
        top: 0;
        bottom: 0;
        border-top-left-radius: 4px;
        border-bottom-left-radius: 4px;
    }

    /* Cor específica para cada opção de radio */
    .custom-radio.fatura::before {
        background-color: #007bff; /* Azul para Fatura */
    }

    .custom-radio.fatura-global::before {
        background-color: #28a745; /* Verde para Fatura Global */
    }

    .custom-radio.fatura-recibo::before {
        background-color: #ffc107; /* Amarelo para Fatura Recibo */
    }

    .custom-radio.nota-credito::before {
        background-color: #ff8000; /* Laranja para Nota de Crédito */
    }

    .custom-radio.factura-proforma::before {
        background-color: #c4a000; /* Amarelo para Factura Pró-Forma */
    }

    .custom-radio.orcamento::before {
        background-color: #007bff; /* Azul para Orçamento */
    }

    .custom-radio.encomenda::before {
        background-color: #28a745; /* Verde para Encomenda */
    }
    .custom-radio.guia-transporte::before {
        background-color: #ff1493; /* Rosa para Transporte */
    }


    /* Ajuste de estilo para os radio buttons */
    .custom-radio input[type="radio"] {
        margin-right: 10px;
    }

    /* Estilos adicionais para o informativo */
    .informativo h5 {
        font-weight: bold;
        margin-bottom: 10px;
    }

    .informativo-item {
        display: flex;
        align-items: center;
        border: 1px solid #ddd;
        padding: 10px;
        margin-bottom: 5px;
        background-color: #fff; /* Fundo padrão */
    }

    .informativo-item:nth-child(1) {
        border-left: 5px solid #c4a000; /* Cor amarela */
    }

    .informativo-item:nth-child(2) {
        border-left: 5px solid #007bff; /* Cor azul */
    }

    .informativo-item:nth-child(3) {
        border-left: 5px solid #28a745; /* Cor verde */
    }

    .informativo-item input[type="radio"] {
        margin-right: 10px;
    }

    .informativo-item label {
        font-weight: normal;
        color: #333;
    }

    /*Modal detalhes de pagamento*/
    .modal-content {
        background-color: white; /* Fundo branco */
        border: 2px solid #007bff; /* Borda azul */
        border-radius: 8px; /* Bordas arredondadas */
        padding: 5px;
    }



    .modal-body {
        padding: 1px;
    }

    .modal-footer {
        background-color: #f8f9fa;
        border-top: 2px solid #007bff;
        display: flex;
        justify-content: flex-end;
    }

    .custom-radio-group {
        margin-bottom: 5px;

    }
    /* Ajuste de estilo para os radio buttons */
    .custom-control-input {
        margin-left: 1050px;
    }
    .custom-control {
        display: flex;
        align-items: center;
        margin-bottom: 10px;

    }

    .custom-control-label {
        margin-left: 10px;
    }


    .modal-footer {
        background-color: #f8f9fa;
        border-top: 2px solid #007bff;
        display: flex;
        justify-content: flex-end;
    }
    .modal-footer {
        padding: 2px 5px; /* Ajuste a altura do rodapé */
    }
    .error-tooltip {
        position: absolute;
        background-color:#ffffff;
        border: .5px solid #ff5c5c;
        color: #d8000c;
        padding: 2px;
        border-radius: 5px;
        font-size: 11px;
        box-shadow: 0 2px 5px rgba(0, 0, 0, 0.2);
        z-index: 1000;
    }

    .error-tooltip::after {
        content: '';
        position: absolute;
        top: 50%;
        left: 100%;
        margin-left: -8px;
        border-width: 8px;
        border-style: solid;
        border-color: transparent transparent transparent #ffdddd;
    }
    /* Animação para o botão: efeito de escala e sombra */
    .top-right-button-container .btn.novoEntidade {
        transition: transform 0.3s ease, box-shadow 0.3s ease;
    }
    .top-right-button-container .btn.novoEntidade:hover {
        transform: scale(1.05);
        box-shadow: 0 4px 8px rgba(0,0,0,0.2);
    }
    /* Estilo base para os ícones com transição para animação */
    .icon-action i {
        transition: transform 0.2s ease, color 0.2s ease;
    }

    /* Efeito de hover: aumenta levemente */
    .icon-action:hover i {
        transform: scale(1.1);
    }

    /* Efeito de clique: reduz um pouco */
    .icon-action:active i {
        transform: scale(0.95);
    }

    /* Cores para cada ícone no modo claro */
    .selecionarEtidade i {
        color: #17a2b8;  /* Azul */
    }

    .editar i {
        color: #28a745;  /* Verde */
    }

    .eliminar i {
        color: #dc3545;  /* Vermelho */
    }

    /* Adaptação para modo escuro */
    @media (prefers-color-scheme: dark) {
        .selecionarEtidade i {
            color: #66d9ef;  /* Azul claro */
        }
        .editar i {
            color: #9fff80;  /* Verde claro */
        }
        .eliminar i {
            color: #ff8a80;  /* Vermelho claro */
        }
    }
    /* Sombreamento extra para a modal */
    .modal-content {
        box-shadow: 0 5px 15px rgba(0, 0, 0, 0.5);
    }
    /* Animações e transições para campos e botões */
    .form-control {
        transition: border-color 0.3s, box-shadow 0.3s;
    }
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .header-entrada-saldo-cliente {
        background-color: #6f42c1;
        color: #fff;
    }
</style>



<main>
    <div class="container-fluid disable-text-selection">
        <div class="row">
            <div class="col-12">
                <div class="mb-2">
                    <h1>Entidades</h1>
                    <div class="top-right-button-container">
                        <button type="button" class="btn btn-outline-primary top-right-button mr-1 novoEntidade" ><i class="fas fa-user-tie"> </i> Nova entidade</button>
                        <div class="btn-group">

                        </div>
                    </div>

                </div>
                <div class="separator mb-5"></div>
            </div>
        </div> 
        <!--        FIM DAA PRIMEIRA DIV ROW QUE MOSTRA OS PRODUCTOS EM LISTA--> 
        <div class="row">
            <div class="col-12">
                <div class="card mb-3">
                    <div class="card-body"> 
                        <table class="data-table data-table-scrollable responsive nowrap " id="tabelaEntidades" width="100%">
                            <thead>
                                <tr class="p-1">
                                    <th  width="25%">Nome</th>
                                    <th  width="10%">Telefone</th>
                                    <th  width="12%">Telefone emp</th>
                                    <th  width="12%">NIF</th>
                                    <th  width="20%">Email</th>
                                    <th  width="25%">Endereço</th>
                                    <th  width="10%">Acções</th>
                                </tr>
                            </thead>
                            <tbody>
                                <!-- Dados da tabela serão preenchidos aqui -->
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

    </div>
</main>
<!--Modal para aplicar a qtd  e desconto de produto-->
<div class="modal fade modal-left" id="exampleEntidades" tabindex="-1" role="dialog"
     aria-labelledby="exampleModalLeft" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">

            <div class="modal-body">

                <form id="formEntidade" novalidate>

                    <input type="hidden"   id="action" value="gravar">

                    <div class="section-title">Entidade</div>
                    <h6>Tipo de entidade</h6>
                    <div class="mb-4">
                        <div class="custom-radio-group">
                            <div class="custom-radio fatura-recibo">
                                <input type="radio" name="tipoEntidade" id="tipoEntidade" value="pessoal" checked >
                                <label for="fatura-recibo">Individual</label>
                            </div>
                            <div class="custom-radio fatura">
                                <input type="radio" name="tipoEntidade" id="tipoEntidade" value="empresa">
                                <label for="fatura">Empresa</label>
                            </div>
                        </div>                                           
                    </div>
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <input type="text" class="form-control" name="nome" id="nome" required />
                            <span>Nome</span>
                        </label>
                    </div>
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <input type="text" class="form-control" name="nif" id="nif"  />
                            <span>Nif</span>
                        </label>
                    </div>
                    <div class="section-title">Endereço e contaco</div>
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <input type="text" class="form-control" name="endereco" id="endereco"  />
                            <span>Localização</span>
                        </label>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label class="form-group has-float-label mb-4 position-relative error-l-50">
                                <input type="tel" class="form-control"  name="fone" id="fone"  />
                                <span>Telefone entidade</span>
                            </label>
                        </div>
                        <div class="form-group col-md-6">
                            <label class="form-group has-float-label mb-4 position-relative error-l-50">
                                <input type="tel" class="form-control" name="fone1" id="fone1"  />
                                <span>Telefone pessoal</span>
                            </label>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <input type="email" class="form-control" name="email" id="email"  />
                            <span>E-mail</span>
                        </label>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-outline-primary fechaModalEntidade" >Cancelar</button>
                        <button  class="btn btn-primary adicionar" type="submit">Gravar</button>
                    </div>

                </form>
            </div>

        </div>
    </div>
</div>
