<script src="<?php echo base_url(); ?>src/pos/reciboPagamento.js"></script>
<script src="<?php echo base_url(); ?>src/pos/liquidar_fatura.js"></script>

<style>

    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .icon-action i {
        font-size: 20px;          /* Tamanho do ícone */
        /*color: #5bc0de;            Azul claro */
        transition: transform 0.2s ease, color 0.2s ease;
    }

    .icon-action:hover i {
        transform: scale(1.2);    /* Aumenta a escala no hover */
        color: #3399cc;           /* Azul um pouco mais escuro no hover */
    }
    /* Sombreamento extra para a modal */
    .modal-content {
        box-shadow: 0 5px 15px rgba(0, 0, 0, 0.5);
    }
    /* Animações e transições para campos e botões */
    .form-control {
        transition: border-color 0.3s, box-shadow 0.3s;
    }
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .header-entrada-saldo-cliente {
        background-color: #6f42c1;
        color: #fff;
    }
</style>

<main>
    <div class="container-fluid py-4">
        <!-- Header principal -->
        <div class="d-flex flex-column flex-sm-row justify-content-between align-items-center main-header mb-2">
            <!--div que recebe o nome da entidade-->
            <div> <h4 class="mb-2 mb-sm-0 nomeDaEntidade2"></strong></h4></div>
            <div>
                <button class="btn btn-outline-primary me-2 mb-2 mb-sm-0 ccorrente">💰 Cl.Correntes</button>
                <button class="btn btn-primary me-2 mb-2 mb-sm-0 regularizar">✔ Regularizar</button>
                <button class="btn btn-outline-primary backEntidades"> <i class="fas fa-user-tie"></i> Entidades</button>
            </div>
        </div>


        <div class="card mb-3">
            <div class="card-body">
                <!-- Tabela de movimentações -->
                <div class="table-responsive mt-3">
                    <table class="data-table data-table-scrollable responsive" id="tabelaLiquidarFatura">
                        <thead class="table-light">
                            <tr>
                                <th width="18%">Dt.Documento</th>
                                <th width="12%">Referencia</th>
                                <th width="14%">Total</th>
                                <th width="15%">Credito</th>
                                <th width="15%">Debito</th>
                                <th width="18%">Dt.Vencimento</th>
                                <th width="13%">Ações</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
</main>
<!--Modal para RegistarSaldo do Cliente-->
<!-- Modal -->
<div class="modal fade modal-right" id="idRegistarPagamentoCliente" tabindex="-1" role="dialog" aria-labelledby="idRegistarPagamentoClienteLabel" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <!-- Header principal -->
            <div class="main-header p-3 border-bottom  header-entrada-saldo-cliente">
                <h6 class="mb-0 referenciaFatura">Registar Saldo</strong></h6>
            </div>
            <!-- Corpo do modal -->
            <div class="modal-body">
                <form id="formRegistarPagamentoCliente">
                    <!-- Campo de Data do Movimento -->
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <strong  for="qtd">Por liquidar</strong > 
                        </div>
                        <div class="form-group col-md-6 text-right" >
                            <strong name="totalApagar"  id="totalApagar2" >0,00</strong >
                            <label hidden id="totalApagar" >0,00</label >
                        </div>
                    </div>
                    <!-- Campo de Forma de Pagamento -->
                    <div class="form-group mb-3">
                        <label for="formaPagamento" class="form-group has-float-label mb-4 position-relative">
                            <select class="form-control" id="idFormaPagamento" name="idFormaPagamento">

                            </select>
                            <span> Forma de Pagamento</span>
                        </label>
                    </div>
                    <!-- Campo de Valor -->
                    <div class="form-group mb-3">
                        <label for="valorSaldo" class="form-group has-float-label mb-4 position-relative">
                            <input type="number" step="0.01" class="form-control" id="valorPago" name="valorPago" placeholder="Insira o valor" required>
                            <span>Valor </span>
                        </label>
                    </div>


                    <hr>
                    <button type="button" class="btn btn-outline-danger closeModalPagamento">
                        <i class="fas fa-times"></i> Cancelar
                    </button>
                    <button  type="submit" class="btn btn-primary adicionar">
                        <i class="fas fa-check"></i> Registar
                    </button>
                </form>
            </div>

        </div>
    </div>
</div>
<div class="modal fade modal-right" id="modalImprimeRecibo" tabindex="-1" role="dialog" aria-labelledby="modalImprimeReciboLabel" aria-hidden="true">
    <div class="modal-dialog " role="document">
        <div class="modal-content">
            <!-- Header principal -->
            <div class="main-header p-3 border-bottom  header-entrada-saldo-cliente">
                <h6 class="mb-0 referenciaFatura2">Registar Saldo</strong></h6>
            </div>
            <!-- Corpo do modal -->
            <div class="modal-body">
                <table class="table table-borderless listarPagamentosFaturas">
                    <thead>
                        <tr>
                            <th scope="col">Dt/Pagamento</th>
                            <th scope="col">Valor</th>
                            <th scope="col">Ação</th>
                        </tr>
                    </thead>
                    <tbody>
                        <!-- As linhas serão inseridas aqui via jQuery -->
                    </tbody>

                </table>
            </div>

        </div>
    </div>
</div>

<script>
    document.querySelectorAll('[data-bs-toggle="tooltip"]').forEach(tooltipEl => {
        new bootstrap.Tooltip(tooltipEl);
    });
</script>


