 
<script src="<?php echo base_url(); ?>src/pos/pagamentos_entidades.js"></script>

<style>

    .icon-action.visualizar i {
        font-size: 20px;          /* Tamanho do ícone */
        /*color: #5bc0de;            Azul claro */
        transition: transform 0.2s ease, color 0.2s ease;
    }

    .icon-action.visualizar:hover i {
        transform: scale(1.2);    /* Aumenta a escala no hover */
        color: #3399cc;           /* Azul um pouco mais escuro no hover */
    }
</style>

<main>
    <div class="container-fluid py-4">
        <!-- Header principal -->
        <div class="d-flex flex-column flex-sm-row justify-content-between align-items-center main-header mb-2">
            <!--div que recebe o nome da entidade-->
            <div> <h4 class="mb-2 mb-sm-0 nomeDaEntidade2"></strong></h4></div>
            <div>

                <button class="btn btn-outline-primary backEntidades"> <i class="fas fa-user-tie"></i> Entidades</button>
            </div>
        </div>

        <div class="card mb-3">
            <div class="card-body">
                <!-- Tabela de movimentações -->
                <div class="table-responsive mt-3">
                    <table class="data-table data-table-scrollable responsive" id="tabelaPagamentoDeCliente">
                        <thead class="table-light">
                            <tr>
                                <th width="25%">Entidade</th>
                                <th width="15%">Nif</th>
                                <th width="15%">Contactos</th>
                                <th width="15%">Total</th>
                                <th width="15%">Credito</th>
                                <th width="20%">Debito</th>
                                <th width="10%">Ações</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

</main>


<script>
    document.querySelectorAll('[data-bs-toggle="tooltip"]').forEach(tooltipEl => {
        new bootstrap.Tooltip(tooltipEl);
    });
</script>


