<!-- Sidebar menu--> 
<style>
    .svg-button {
        cursor: pointer;
        background-color: #0056b3; /* Azul padrão do Bootstrap */
        border: none;
        transition: background-color 0.3s ease;
    }
    /* Quando ativo (teclado ativado) */
    #toggle-button.active {
        background-color: #00365a; /* Cor verde para indicar ativo */
        color: #0056b3 !important; /* Ícone cinza quando ativo */
    }
    .svg-button:hover {
        background-color: #0056b3; /* Azul mais escuro ao passar o mouse */
    }

    .svg-button svg {
        width: 30px;
        height: 30px;
        fill: #fff; /* Cor branca para o ícone */
    }

    .svg-button.active {
        background-color: #0056b3; /* Verde quando ativo */
    }
</style>
<nav class="navbar fixed-top">
    <!--INICIO DIV LADO ESQUERDO NA NAV BAR -->
    <div class="d-flex align-items-center navbar-left"> 
        <!--INICIO ANCORA-->
        <a href="#" class="menu-button d-none d-md-block">
            <svg class="main" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 9 17">
                <rect x="0.48" y="0.5" width="7" height="1" />
                <rect x="0.48" y="7.5" width="7" height="1" />
                <rect x="0.48" y="15.5" width="7" height="1" />
            </svg>
            <svg class="sub" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 18 17">
                <rect x="1.56" y="0.5" width="16" height="1" />
                <rect x="1.56" y="7.5" width="16" height="1" />
                <rect x="1.56" y="15.5" width="16" height="1" />
            </svg>
        </a>
        <!--FIM ANCORA-->
        <!--INICIO ANCORA-->
        <a href="#" class="menu-button-mobile d-xs-block d-sm-block d-md-none">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 26 17">
                <rect x="0.5" y="0.5" width="25" height="1" />
                <rect x="0.5" y="7.5" width="25" height="1" />
                <rect x="0.5" y="15.5" width="25" height="1" />
            </svg>
        </a>
        <!--FIM ANCORA-->
        <!--        <div class="search" data-search-path="Pages.Search.html?q=">
                    <input placeholder="Procurar...">
                        <span class="search-icon">
                            <i class="simple-icon-magnifier"></i>
                        </span>
                </div>-->

    </div>
    <!--FIM DIV LADO ESQUERDO NA NAV BAR-->
    <a class="navbar-logo">
        <img src="<?php echo base_url('src/img/LogoVineSoft.png'); ?>" width="110" height="30">
        <!--<span class="logo-mobile d-block d-xs-none"></span>-->
    </a>
    <!--INICIO DIV LADO DIREITO NA NAV BAR -->
    <div class="navbar-right">

        <div class="position-relative d-none d-sm-inline-block">
            <div class="d-none d-md-inline-block align-text-bottom mr-3">
                <div class="custom-switch custom-switch-primary-inverse custom-switch-small pl-1" 
                     data-toggle="tooltip" data-placement="left" title="Modo Escuro">
                    <input class="custom-switch-input" id="switchDark" type="checkbox" >
                        <label class="custom-switch-btn" for="switchDark"></label>
                </div>
            </div>
            <button class="header-icon btn btn-empty svg-button" data-toggle="tooltip" id="toggle-button" title="Ativar/Desativar Teclado">
                <i class="simple-icon-menu"></i>
            </button>
            <!--            <button class="header-icon btn btn-empty" type="button" id="iconMenuButton" data-toggle="dropdown"
                                aria-haspopup="true" aria-expanded="false">
                            <i class="simple-icon-grid"></i>
                        </button>
                        <div class="dropdown-menu dropdown-menu-right mt-3  position-absolute" id="iconMenuDropdown">
                            <a href="#" class="icon-menu-item">
                                <i class="iconsminds-equalizer d-block"></i>
                                <span>Settings</span>
                            </a>
            
                            <a href="#" class="icon-menu-item">
                                <i class="iconsminds-male-female d-block"></i>
                                <span>Users</span>
                            </a>
            
                            <a href="#" class="icon-menu-item">
                                <i class="iconsminds-puzzle d-block"></i>
                                <span>Components</span>
                            </a>
            
                            <a href="#" class="icon-menu-item">
                                <i class="iconsminds-bar-chart-4 d-block"></i>
                                <span>Profits</span>
                            </a>
            
                            <a href="#" class="icon-menu-item">
                                <i class="iconsminds-file d-block"></i>
                                <span>Surveys</span>
                            </a>
            
                            <a href="#" class="icon-menu-item">
                                <i class="iconsminds-suitcase d-block"></i>
                                <span>Tasks</span>
                            </a>
            
                        </div>-->
        </div>

        <!--FIM DIV-->
        <!--INICIO DIV-->
        <div class="position-relative d-inline-block">
            <!--            <button class="header-icon btn btn-empty" type="button" id="notificationButton"
                                data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            <i class="simple-icon-bell"></i>
                            <span class="count">3</span>
                        </button>-->
            <!--INICIO DA DIV QUE  CARREGA AS VENDA EM ESPERA-->
            <!--            <div class="dropdown-menu dropdown-menu-right mt-3 position-absolute" id="notificationDropdown">
                            <div class="scroll">
                                <div class="d-flex flex-row mb-3 pb-3 border-bottom">
                                    <a href="#">
                                        <img <?php echo base_url('src/img/profiles/l-4.jpg'); ?>" width="20" height="20"  alt="Notification Image"
                                                                                                class="img-thumbnail list-thumbnail xsmall border-0 rounded-circle" />
                                    </a>
                                    <div class="pl-3">
                                        <a href="#">
                                            <p class="font-weight-medium mb-1">Joisse Kaycee just sent a new comment!</p>
                                            <p class="text-muted mb-0 text-small">09.04.2018 - 12:45</p>
                                        </a>
                                    </div>
                                </div>
                            </div>
                        </div>-->
            <button class="header-icon btn btn-empty d-none d-sm-inline-block" type="button" id="fullScreenButton">
                <i class="simple-icon-size-fullscreen"></i>
                <i class="simple-icon-size-actual"></i>
            </button>
        </div>
        <!--FIM DIV-->
        <div class="user d-inline-block">
            <button class="btn btn-empty p-0" type="button" data-toggle="dropdown" aria-haspopup="true"
                    aria-expanded="false">
                <span class="name"><?php echo $usuario ?></span>
                <span>
                    <img alt="Profile Picture" src="<?php echo base_url('src/img/profiles/photo.jpg'); ?>" />
                </span>
            </button>

            <div class="dropdown-menu dropdown-menu-right mt-3">
                <!--                <a class="dropdown-item" href="#">Account</a>
                                <a class="dropdown-item" href="#">Features</a>
                                <a class="dropdown-item" href="#">History</a>-->
                <a class="dropdown-item" href="#"><?php echo $nomeLoja ?></a>
                <a class="dropdown-item" href="<?php echo base_url('cPos/logout'); ?>">Log out</a>
            </div>
        </div>
    </div>
    <!--FIM DIV LADO DIREITO NA NAV BAR-->

</nav>