<script src="<?php echo base_url(); ?>src/pos/stockLojas.js"></script>
<style>
    .section-title {
        font-size: 1.25rem;
        font-weight: bold;
        margin-bottom: 10px;
    }
    .icon-action {
        margin-right: 10px;
        color: #333;
        text-decoration: none;
    }

    .icon-action i {
        font-size: 18px;
    }
    .icon-action2 {
        margin-right: 10px;
        text-decoration: none;
    }

    .icon-action2 i {
        font-size: 20px;
    }
    .my-custom-swal {
        z-index: 1050; /* O z-index da modal do Bootstrap é 1040, então isso deve ser maior */
    }
    dataTable tbody td,
    .dataTable thead th {
        padding:2px 4px; /* Diminui o padding (espaçamento) das células */
        line-height: 0.5; /* Diminui a altura da linha */
        height: 5px;     /* Define uma altura fixa para as linhas */
    }
    .dataTable tbody tr {
        height: auto; /* Permite que a altura da linha seja ajustada automaticamente com base no conteúdo */
    }
    /* Alterar a aparência do campo de pesquisa */
    .dataTables_filter input {
        width: 300px; /* Largura maior */
        padding: 10px; /* Espaçamento interno */
        border-radius: 20px; /* Bordas arredondadas */
        border: 2px solid #007bff; /* Borda azul */
        outline: none;
    }
    .dataTables_length {
        font-size: 14px;
        color: #333;
        margin-bottom: 10px;
    }
    .dataTables_length label {
        font-weight: bold;
    }
    .dataTables_length select {
        border-radius: 5px;
        border: 1px solid #ccc;
        padding: 5px;
    }
    .dataTables_filter input:focus {
        border-color: #28a745; /* Borda verde ao focar */
        box-shadow: 0 0 10px rgba(0, 123, 255, 0.5); /* Sombra ao focar */
    }
    /* Estilização do campo de pesquisa com o ícone de lupa */
    .search-with-icon {
        padding-left: 30px; /* Espaço para o ícone */
        background-image: url('<?php echo base_url(); ?>src/img/icon/search.png'); /* URL do ícone de lupa */
        background-repeat: no-repeat;
        background-position: 5px center; /* Posição do ícone no campo */
        background-size: 16px 16px; /* Tamanho do ícone */
        border: 1px solid #ced4da; /* Estilização da borda */
        border-radius: 20px; /* Bordas arredondadas */
        /*height: 35px;  Altura do campo de pesquisa */
    }
    /* Estilização do campo de pesquisa com o ícone de lupa */
    .txtBorder {
        padding-left: 30px; /* Espaço para o ícone */
        background-repeat: no-repeat;
        background-position: 5px center; /* Posição do ícone no campo */

        border: 1px solid #ced4da; /* Estilização da borda */
        border-radius: 20px; /* Bordas arredondadas */
        /*height: 35px;  Altura do campo de pesquisa */
    }
    /* Remove as setas em navegadores baseados em Webkit (Chrome, Edge, Safari) */
    input[type="number"].no-spin::-webkit-inner-spin-button,
    input[type="number"].no-spin::-webkit-outer-spin-button {
        -webkit-appearance: none;
        margin: 0;
    }

    /* Remove as setas em navegadores baseados em Firefox */
    input[type="number"].no-spin {
        -moz-appearance: textfield;
    }
    /* Modal Fullscreen */
    .modal-dialog {
        max-width: 100%; /* Garante que a modal ocupe a tela inteira */
        height: 100%; /* A modal ocupa toda a altura da tela */
        margin: 0;
    }

    .modal-content {
        height: 100%; /* A modal ocupa toda a altura disponível */
        border-radius: 0;
    }

    .modal-body {
        max-height: calc(100vh - 120px); /* Ajuste para permitir rolagem vertical */
        overflow-y: auto;
        padding: 20px; /* Adiciona um padding para não ficar colado nas bordas */
    }

    /* Responsividade para dispositivos móveis */
    @media (max-width: 768px) {
        .modal-dialog {
            margin: 0; /* Remove a margem */
            max-width: 100vw; /* Garante que a modal ocupe toda a largura da tela */
        }

        .modal-content {
            border-radius: 0; /* Remove bordas arredondadas, caso necessário */
        }

        .modal-body {
            max-height: calc(100vh - 100px); /* Ajuste do tamanho da altura da modal para dispositivos menores */
        }
    }
    /* Responsividade para telas menores, como smartphones */
    @media (max-width: 576px) {
        .modal-body {
            padding: 10px; /* Menor padding para telas pequenas */
        }
    }
</style>

<main>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-12 ">
                <div class="card mb-3">
                    <!-- Cabeçalho do Card -->
                    <div class="card-header">
                        <h5 class="card-title">Lista de Artigos por data de caducidade</h5>
                        <p class="card-subtitle text-muted">Gerencie os artigos com caducidade e lote.</p>
                    </div>
                    <div class="card-body"> 
                        <table class="data-table data-table-scrollable responsive" id="tabelaStokLojasDtCaducidade"  style="width:100%">
                            <thead>
                                <tr>
                                    <th width="40%">Artigo</th>
                                    <th width="20%">Qtd.Disp</th>
                                    <th width="20%">Lote</th>
                                    <th width="20%">Dt.Validade</th>  
                                </tr>
                            </thead>
                            <tbody>
                                <!-- Dados da tabela serão preenchidos aqui -->
                            </tbody>
                        </table>
                    </div>  
                </div>  
            </div>
        </div>

    </div>
</main>



<script>
    function checkValue(input) {
        const minValue = 0; // Valor mínimo para todos os campos
        const maxValue = input.getAttribute('max'); // Obtém o valor máximo, se definido

        if (input.value < minValue) {
            input.value = ''; // Limpa o campo se o valor for menor que o mínimo
        } else if (maxValue !== null && input.value > maxValue) {
            input.value = maxValue; // Ajusta para o máximo permitido, se houver
        }
    }
</script>