<script src="<?php echo base_url(); ?>src/pos/stockPorArtigo.js"></script>
<style>
    .section-title {
        font-size: 1.25rem;
        font-weight: bold;
        margin-bottom: 10px;
    }
    .icon-action {
        margin-right: 10px;
        color: #333;
        text-decoration: none;
    }

    .icon-action i {
        font-size: 18px;
    }
     /* Sombreamento extra para a modal */
    .modal-content {
      box-shadow: 0 5px 15px rgba(0, 0, 0, 0.5);
    }
    /* Animações e transições para campos e botões */
    .form-control {
        transition: border-color 0.3s, box-shadow 0.3s;
    }
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }

</style>

<main>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-12">
                <div class="mb-2">
                    <h1 class="meuTitulo">Lista de artigos</h1>
                    <div class="top-right-button-container" style="margin-top: 0;">
                        <div class="btn-group">
                            
                            <button type="button" 
                                    class="btn  btn-primary dropdown-toggle dropdown-toggle-split"
                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                 <i class="fas fa-ellipsis-v"></i>
                                <span class="sr-only">Toggle Dropdown</span>
                            </button>
                            <div class="dropdown-menu dropdown-menu-right">
                                <a class="dropdown-item" href="#">Histórico do artigo</a>
                                <a class="dropdown-item" href="#">Por lotes</a>
                            </div>
                        </div>
                    </div>


                    <div class="mb-2">
                        <a class="btn pt-0 pl-0 d-inline-block d-md-none" data-toggle="collapse" href="#displayOptions"
                           role="button" aria-expanded="true" aria-controls="displayOptions">
                            Opções de exibição
                            <i class="simple-icon-arrow-down align-middle"></i>
                        </a>
                        <div class="collapse dont-collapse-sm" id="displayOptions">
                            <span class="mr-3 mb-2 d-inline-block float-md-left">
                                <a href="<?php echo base_url('cPainel/panel?pg=produtoList'); ?>" class="mr-2 view-icon active">
                                    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 19 19">
                                        <path class="view-icon-svg" d="M17.5,3H.5a.5.5,0,0,1,0-1h17a.5.5,0,0,1,0,1Z" />
                                        <path class="view-icon-svg" d="M17.5,10H.5a.5.5,0,0,1,0-1h17a.5.5,0,0,1,0,1Z" />
                                        <path class="view-icon-svg" d="M17.5,17H.5a.5.5,0,0,1,0-1h17a.5.5,0,0,1,0,1Z" />
                                    </svg>
                                </a>


                            </span>


                        </div>
                    </div>
                    <div class="separator mb-5" style="margin-top: 30px;"></div>
                </div>
            </div> 
        </div> 
        <!-- Coluna maior (12/12 da tela) -->
        <div class="col-12 col-md-12">
            <div class="card mb-3">
                <div class="card-header  d-flex justify-content-between align-items-center bg-primary text-white" >
                    <div class="d-flex align-items-center">
                        <span  class="mt-3 ml-2 me-2 fw-bold fs-1 "><h3 id="tituloDocumento">Nome do Artigo</h3></span> <!-- Título ao centro -->
                    </div>
                </div>
                <div class="card-body pt-0">
                    <table class="data-table data-table-scrollable responsive" id="tabeTotalStockl"  style="width:100%">
                        <thead>
                            <tr>
                                <th width="50%">Loja/Armanzém</th>
                                <th width="38%">Stock</th>
                                <th width="15%">Ações</th>
                            </tr>
                        </thead>
                        <tbody>
                            <!-- Dados da tabela serão preenchidos aqui -->
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        <!-- Coluna maior (12/12 da tela) -->
        <div class="col-12 col-md-12">
            <div class="card mb-3">
                <div class="container-labels d-flex justify-content-between align-items-center">
                    <label class="label-left section-title m-2">Total</label>
                    <label id="totalProdutos" class="label-right section-title m-2">0</label>
                </div>
            </div>
        </div>

       
        <!-- Coluna maior (12/12 da tela) -->
       <div class="col-12 col-md-12" id="gridHistoricostock" hidden>
            <div class="card mb-3">
                <div class="card-header  d-flex justify-content-between align-items-center bg-primary text-white" >
                    <div class="d-flex align-items-center">
                        <span  class="mt-3 ml-2 me-2 fw-bold fs-1 "><h3 id="tituloDocumento2">Nome do Artigo</h3></span> <!-- Título ao centro -->
                    </div>
                </div>
                <div class="card-body pt-0">
                    <table class="data-table data-table-scrollable responsive" id="tabelaHistoricoStock"  style="width:100%">
                        <thead>
                            <tr>
                                <!--<th width="20%">Loja/Armanzém</th>-->
                                <th width="20%">Data</th>
                                <th width="25%">Operação</th>
                                <th width="40%">Observações</th>
                                <th width="15%">Observações</th>


                            </tr>
                        </thead>
                        <tbody>
                            <!-- Dados da tabela serão preenchidos aqui -->
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
       
</main>
<!--Modal para adicionar stock por produto-->
<div class="modal fade modal-left" id="modalAdicionarStockPorProduto" tabindex="-1" role="dialog" aria-labelledby="modalAdicionarStockPorProduto" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document" style="max-width: 25%;">
        <div class="modal-content">

            <div class="modal-body">         
                <form id="formStockPorProduto" novalidate>
                    <div class="section-title m-2">Adicionar stock</div>
                    <div class="form-row m-2">

                        <div class="form-group col-md-6">
                            <label for="qtd">Quantidade</label>
                            <input type="number" class="form-control" oninput="checkValue(this)" min="0" name="qtd"   id="qtd">

                        </div>
                        <div class="form-group col-md-6">
                            <label for="custo">Custo</label>
                            <input type="number" class="form-control" oninput="checkValue(this)" min="0" name="preco_compra"  id="preco_compra">
                        </div>
                    </div>
                    <div class="form-row m-2" id="loteCaducidade">
                        <div class="form-group col-md-6">
                            <label for="dtcaducidade">Dt.Caducidade</label>
                            <input type="date" class="form-control"   id="dtcaducidade">

                        </div>
                        <div class="form-group col-md-6">
                            <label for="obs">Lote</label>
                            <input type="text" class="form-control"   id="obs">
                        </div>
                    </div>

                    <div class="d-flex justify-content-between m-2">
                        <button type="button" class="btn btn btn-outline-danger cancelarStockPorProduto"><i class="fas fa-times"></i> Cancelar</button>
                        <button class="btn btn-primary adicionar" type="submit"><i class="fas fa-check"></i> Adicionar</button>
                    </div>
                </form>
            </div>

        </div>
    </div>
</div>
<!--Modal tranfere stock por produto-->
<div class="modal fade modal-left" id="modalTransfereStock" tabindex="-1" role="dialog" aria-labelledby="modalTransfereStock" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document" style="max-width: 25%;">
        <div class="modal-content">

            <div class="modal-body">  
                 <input type="hidden"   id="idArmazenAtual" value="0">
                 <input type="hidden"   id="qtdExistente" value="0">
                <form id="formTransStockProduto" novalidate>
                     <div class="section-title m-2">Transferir stock</div>
                    <div class="form-row m-2">

                        <div class="form-group col-md-12">
                            <label for="qtd">Destino</label>
                            <select class="form-control" name="idArmanzeDestino" id="idArmanzeDestino">
                               
                            </select>
                        </div>
                       
                    </div>
                      <div class="form-row m-2">

                        <div class="form-group col-md-12">
                            <label for="custo">Quantidade a transferir</label>
                            <input type="number" class="form-control" oninput="checkValue(this)" min="0" name="qtd" value="0"  id="qtd">
                        </div>
                    </div>
                     

                    <div class="d-flex justify-content-between m-2">
                        <button type="button" class="btn btn btn-outline-danger cancelarStockTransf"> <i class="fas fa-times"></i> Cancelar</button>
                        <button class="btn btn-primary " type="submit"> <i class="fas fa-check"></i> Transferir</button>
                    </div>
                </form>
            </div>

        </div>
    </div>
</div>

<script>
    function checkValue(input) {
        const minValue = 0; // Valor mínimo para todos os campos
        const maxValue = input.getAttribute('max'); // Obtém o valor máximo, se definido

        if (input.value < minValue) {
            input.value = ''; // Limpa o campo se o valor for menor que o mínimo
        } else if (maxValue !== null && input.value > maxValue) {
            input.value = maxValue; // Ajusta para o máximo permitido, se houver
        }
    }

</script>