<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cArtigos
 *
 * @author VINEVALA,
 */
class cArtigos extends CI_Controller {

    public function atualizar_ImpostoIva() {
        $this->load->model('ProdutosM');
        $idImpostoVenda = 1;
        foreach ($this->ProdutosM->listaProdutosParaAtualizarIVA()as $row) {
            $idProduto = $row->idpr;
            if ($this->ProdutosM->cansulta_impostoProdutoVenda($idProduto)) {
                $this->ProdutosM->impostoAtualizarVendaIva($idProduto, $idImpostoVenda);
            } else {
                $this->ProdutosM->impostoVendaIva($idProduto, $idImpostoVenda);
            }

            echo 'OK';
        }
    }

    public function copiarProdutos() {
        ini_set('memory_limit', '256M');
        ini_set('upload_max_filesize', '20M');
        ini_set('download_max_filesize', '20M');
        ini_set('post_max_size', '20M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);
        $this->load->model('ProdutosM');
        $this->load->model('StockM');
        $cont = 0;
        foreach ($this->ProdutosM->listaProdutosAlcino()as $row) {
            $idprodutoAlcino = $row->idpr;
            //    $categoria=$row->idpr;
            $cont++;
            $categoria = $row->idcategoria;
            $idIsencao = 4;
            $stockMinimo = 0;
            $stockMaximo = 0;
            $idUnidade = 2;
            $idTipo = 3;
            $produto = $row->produto;
            $bbr = $row->codigodebara;
            $vender = 's';
            $comprar = 's';
            $control = 's';
            $desconto = 0;
            $qtd = $this->ProdutosM->qtd($idprodutoAlcino);
            $custo = $this->ProdutosM->custo($idprodutoAlcino);
            $totalcompras = $qtd * $custo;
            $venda = $this->ProdutosM->venda($idprodutoAlcino);
            $idProduto = $this->ProdutosM->registarProdutoM($categoria, $produto, $bbr, $idIsencao, $stockMaximo, $stockMinimo, $idUnidade, $idTipo, $vender, $comprar, $custo, $venda, $desconto, $control);
            $this->ProdutosM->registarPrecoProdutoGrupo(1, $idProduto, $venda);
            $this->StockM->registarQtdLoja($idProduto, $qtd, $custo, $totalcompras, 2);
            //  $this->StockM->registarQtd($idProduto,$qtd,$custo,$totalcompras); 
            $this->ProdutosM->ponto_venda_produto($idProduto, 2);
        }
        $this->json->success('Dados salvos sem imagem');
    }

    public function grupoEdit($itemGrupo, $idProduto) {
        $cont = 0;

        foreach ($itemGrupo as $value) {
            $cont++;
            $valor = $value->valor;
            if ($cont == 1) {
                $this->ProdutosM->atualizaPrecoProduto($idProduto, $valor);
            }
            $idGrupoPreco = $value->idGrupoPreco;
            if ($this->ProdutosM->consultaPrecoProduto($idProduto, $idGrupoPreco)) {
                $this->ProdutosM->atualizarPrecoProdutoGrupo($idGrupoPreco, $idProduto, $valor);
            } else {
                $this->ProdutosM->registarPrecoProdutoGrupo($idGrupoPreco, $idProduto, $valor);
            }
        }
    }

    public function grupoGrupo($itemGrupo, $idProduto) {
        $cont = 0;
        foreach ($itemGrupo as $value) {
            $cont++;
            $valor = $value->valor;
            if ($cont == 1) {
                $this->ProdutosM->atualizaPrecoProduto($idProduto, $valor);
            }
            $idGrupoPreco = $value->idGrupoPreco;
            $this->ProdutosM->registarPrecoProdutoGrupo($idGrupoPreco, $idProduto, $valor);
        }
    }

    public function grupoPrecoDisponiblidadeLojas() {

        $grupoPreco = $this->input->post('grupoPreco');
        $disponiblidade = $this->input->post('disponiblidade');
        $idProduto = $this->input->post('idProduto');
        $this->load->model('ProdutosM');
        $itemGrupo = json_decode($grupoPreco);
        $itemDisponiblidade = json_decode($disponiblidade);
        $this->grupoGrupo($itemGrupo, $idProduto);
        $this->disponiblidadeProduto($itemDisponiblidade, $idProduto);
        $this->json->success('OK');
    }

    public function grupoPrecoDisponiblidadeLojasEdit() {
        $grupoPreco = $this->input->post('grupoPreco');
        $disponiblidade = $this->input->post('disponiblidade');
        $idProduto = $this->input->post('idProduto');
        $this->load->model('ProdutosM');
        $itemGrupo = json_decode($grupoPreco);
        $itemDisponiblidade = json_decode($disponiblidade);
        $this->grupoEdit($itemGrupo, $idProduto);
        $this->disponiblidadeProdutoEdit($itemDisponiblidade, $idProduto);
        $this->json->success('OK');
    }

    public function registaVariacaoProduto($idVariacao, $idProduto) {
        if (!empty($idVariacao) && is_numeric($idVariacao)) {
            $this->ProdutosM->regVariacaoProduto($idVariacao, $idProduto);
        }
    }

    public function disponiblidadeProdutoEdit($itemDisponiblidade, $idProduto) {

        foreach ($itemDisponiblidade as $lin) {
            if (!$this->ProdutosM->consultaDiponiblidadeLoja($idProduto, $lin->idArmanze)) {
                $this->load->model('mStock');
                $this->mStock->registarQtdLoja($idProduto, 0, 0, 0, $lin->idArmanze);
            }
        }
        foreach ($itemDisponiblidade as $linha) {
            $idArmanze = $linha->idArmanze;
            $this->ProdutosM->atualizaDisponiblidade($idProduto, $idArmanze, $linha->value);
        }
    }

    public function lojaFaturacao($idProduto) {
        $this->load->model('mLojas');

        foreach ($this->mLojas->mlistaLojas() as $lin) {
            if (!$this->mArtigos->consultaDiponiblidadeLoja($idProduto, $lin->id)) {
                $this->load->model('mStock');
                $this->mStock->registarQtdLoja($idProduto, 0, 0, 0, $lin->id, 'n');
            }
        }
    }

    public function registarArtigos() {
        ini_set('upload_max_filesize', '40M');
        $idCategoria = $this->input->post('idCategoria');
        $idNatureza = $this->input->post('idNatureza');
        $idTipo = $this->input->post('idTipo');
        $stockMinimo = 0;
        $stockMaximo = 0;
        $idUnidade = $this->input->post('idUnidade');
        $produto = $this->input->post('artigo');
        $idIsencao = $this->input->post('idIsencao');
        $vender = $this->input->post('vender');
        $comprar = $this->input->post('comprar');
        $custo = $this->input->post('custo');
        $venda = $this->input->post('venda');
        $desconto = 0;
        $iscecao = $this->input->post('iscecao');
        if (isset($iscecao)) {
            $impostosIsencao = 's'; // Está isento
        } else {
            $impostosIsencao = 'n'; // Não está isento
        }
        $caducidade = $this->input->post('dtcaducidade');
        if (isset($caducidade)) {
            $dtcaducidade = 's'; // Está isento
        } else {
            $dtcaducidade = 'n'; // Não está isento
        }
        $idImpostoVenda = $this->input->post('idImpostoVenda');
        $control = $this->input->post('control');
        $ativo = $this->input->post('ativo');
        $referencia = $this->input->post('referencia');
        $checkboxes = $this->input->post('checkboxes');
        $this->load->model('mempresa');
        $idRegime = $this->mempresa->pegaRegime();
        if ($idRegime == 2) {
            $idIsencao = 4;
        } elseif ($idRegime == 3 && !is_int($idIsencao)) {
            $idIsencao = 2;
        } elseif ($idRegime == 1 && !is_int($idIsencao)) {
            $idIsencao = 1;
        } else {
            $idIsencao = $this->input->post('idIsencao');
        }

        $bbr = $this->input->post('codeBar');
        $this->load->model('mArtigos');
        $this->load->model('mStock');
        $idProduto = $this->mArtigos->registarProdutoM($idCategoria, $produto, $bbr, $idIsencao, $idUnidade, $idTipo, $vender, $comprar, $custo, $venda, $desconto, $control, $referencia, $ativo, $dtcaducidade);
        $this->mArtigos->registarPrecoProdutoGrupo(1, $idProduto, $venda);
        $this->mArtigos->ponto_venda_produto($idProduto, 2);
        $this->lojaFaturacao($idProduto);
        foreach ($checkboxes as $idArmanze) {
            $this->mArtigos->atualizaDisponiblidade($idProduto, $idArmanze, 's');
        }

        if ($idTipo == 2) { // sefor um serviço
            $this->registaTipoServico($idProduto, $idNatureza);
        }

        if ($impostosIsencao == 'n' && $idRegime == 1) {
            $this->mArtigos->impostoVendaIva($idProduto, $idImpostoVenda);
        }
        echo json_encode('OK');
    }

    public function registaTipoServico($idProduto, $idNatureza) {
        $this->load->model('mNatureza');
        $this->mNatureza->gravarNaturezaServico2($idProduto, $idNatureza);
    }

    public function atualizarTipoServico($idProduto, $idNatureza) {
        $this->load->model('mNatureza');
        if ($this->mNatureza->consultarNaturezaServico($idProduto)) {
            $this->mNatureza->atualizarNaturezaServico2($idProduto, $idNatureza);
        } else {
            $this->mNatureza->gravarNaturezaServico2($idProduto, $idNatureza);
        }
    }

    public function pegaNaturezaServico($idProduto) {
        $this->load->model('mNatureza');
        return $this->mNatureza->pegaNaturezaServiço($idProduto);
    }

    public function precoComIVa($preco, $idpr) {
        if ($this->mempresa->pegaRegime() == 2 || $this->mempresa->pegaRegime() == 3) {
            return '--';
        } else {
            $iva = $this->mIva->calculo_iva_int($preco, $idpr);
//            $iva= $this->mIva->calculo_iva($preco, $idpr); 
            return number_format($iva + $preco,2); 
        }
    }

    public function listarArtigosDataList() {

        $this->load->model('mArtigos');
        $this->load->model('mempresa');
        $this->load->model('mIva');
        $idPonto = '';
        $idNatureza = '';
        $taxa = 0.00;
        $searchValue = ($_POST["search"] ["value"]);
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start'); // Offset para paginação
        // Obter o total de registros
        $totalRecords = $this->mArtigos->contarTotalArtigos();

        // Obter os registros filtrados
        $filteredRecords = $this->mArtigos->obter_total_registos_filtrados($searchValue);

        // Obter os dados com limite e offset para paginação
        $data = array();
        foreach ($this->mArtigos->mlistarArtigos($searchValue, $limit, $offset)as $row) {
            $idpr = $row->idpr;

            $idPonto = $this->mArtigos->pegaPontoVendaProduto($row->idpr);

            $idNatureza = $this->pegaNaturezaServico($idpr);
            $taxa = $this->mArtigos->pegaIvaVenda($idpr);
            $data[] = array(
                'idProduto' => $idpr,
                'produto' => $row->produto,
                'codigodebara' => $row->codigodebara,
                'categoria' => $row->categoria,
                'preco' => $row->preco,
                'idcategoria' => $row->idcategoria,
                'motivo' => $row->motivo,
                'idIsencao' => $row->idIsencao,
                'stockMaximo' => $row->stockMaximo,
                'stockMinimo' => $row->stockMinimo,
                'nunidade' => $row->nunidade,
                'idUnidade' => $row->idUnidade,
                'vender' => $row->vender,
                'comprar' => $row->comprar,
                'custo' => $row->custopr,
                'preco' => $row->preco,
                'precoIVA' => $this->precoComIVa($row->preco, $idpr),
                'desconto' => $row->desconto,
                'tipoPr' => $row->tipoPr,
                'idTipo' => $row->idTipo,
                'control' => $row->control,
                'ponto' => $row->vender,
                'idPonto' => $idPonto,
                'idNatureza' => $idNatureza,
                'referencia' => $row->referencia,
                'iva' => $taxa . '%',
            );
        }
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $totalRecords,
            "recordsFiltered" => $filteredRecords,
            "data" => $data
        ));
    }

    public function pega_artigo_por_id() {
        $idProduto = $this->input->get('idProduto');
        $this->load->model('mArtigos');
        $this->load->model('mempresa');
        $this->load->model('mLojas');
        $this->load->model('mStock');
        $idPonto = '';
        $idNatureza = '';
        $taxa = 0.00;
        // Inicializar o array de armazéns
        $armazens = array();
        // Iterar sobre os resultados de mlistaLojas
        foreach ($this->mLojas->mlistaLojas() as $lin) {
            // Verificar condição para definir o valor de "checked"
            $checked = ($this->mStock->verificaDiponiblidadeArmazem($idProduto, $lin->id)) ? 's' : 'n';
            // Adicionar os dados ao array de armazéns
            $armazens[] = array(
                'id' => $lin->id,
                'checked' => $checked
            );
        }
        $data = array();
        foreach ($this->mArtigos->mlistarArtigosPorId($idProduto)as $row) {


            $idPonto = $this->mArtigos->pegaPontoVendaProduto($idProduto);

            $idNatureza = $this->pegaNaturezaServico($idProduto);
            $taxa = $this->mArtigos->pegaIvaVenda($idProduto);
            $data = array(
                'produto' => $row->produto,
                'idTipoArtigo' => $row->idTipo,
                'idCategoria' => $row->idcategoria,
                'codebar' => $row->codigodebara,
                'referencia' => $row->referencia,
                'idUnidade' => $row->idUnidade,
                'control' => $row->control,
                'ativo' => $row->ativo,
                'dtcaducidade' => $row->dtcaducidade,
                'preco' => $row->preco,
                'armazens' => $armazens, // Adicionar o array de armazéns
            );
        }
        echo json_encode($data);
    }

    public function pega_estado_dt_caducidade() {
        $idProduto = $this->input->get('idProduto');
        $this->load->model('mArtigos');

        $data = array();
        foreach ($this->mArtigos->pega_estado_dt_caducidade($idProduto)as $row) {
            $data = array(
                'dtcaducidade' => $row->dtcaducidade,
            );
        }
        echo json_encode($data);
    }

    public function pegarCaminhoImagem() {
        $idProduto = $this->input->get('idProduto');

        $this->load->model('ProdutosM');
        if ($this->ProdutosM->listarPathImagem($idProduto)) {
            foreach ($this->ProdutosM->listarPathImagem($idProduto)as $row) {
                if ($row->path == '') {
                    $path = 'imagem_defoult.jpg';
                } else {
                    $path = $row->path;
                }
                $imprimir[] = array(
                    'path' => $path,
                );
                $total = 1;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listar_Produto_Servicos() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $produto = $this->input->get('produto');
        $this->load->model('ProdutosM');
        if ($this->ProdutosM->listar_produto_servicoM($start, $limit, $produto)) {
            foreach ($this->ProdutosM->listar_produto_servicoM($start, $limit, $produto)as $row) {
                $imprimir[] = array(
                    'idpr' => $row->idpr,
                    'produto' => $row->produto,
                    'preco' => $row->preco
                );
                $total = $this->ProdutosM->contarProdutosGeral();
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:true, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarProdutosServicos() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $this->load->model('ProdutosM');
        if ($this->ProdutosM->produtosServicos($start, $limit)) {
            foreach ($this->ProdutosM->produtosServicos($start, $limit)as $row) {
                $imprimir[] = array(
                    'idpr' => $row->idpr,
                    'produto' => $row->produto,
                );
                $total = 100;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    // Controlador para echer a combo com produtos
    public function listaId() {
        $this->load->model('ProdutosM');
        $listar = $this->ProdutosM->listaPrID();
        foreach ($listar as $linha) {
            $dados = array(
                'idpr' => $linha->idpr,
                'produto' => $linha->produto
            );
            $resposta['combo'][] = $dados;
        }
        echo json_encode($resposta);
    }

    // Controlador para preecher formulario
    public function pegarProdutos() {
        $id = $this->input->get('id');
        $this->load->model('ProdutosM');
        $listar = $this->ProdutosM->pegarPr($id);
        foreach ($listar as $linha) {
            $dados = array(
                'idpr' => $linha->idpr,
                'pr' => $linha->produto,
                'preco' => $linha->preco
            );
            $resposta['combo'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function atualizaImpostos($idProduto, $impostosIsencao, $idImpostoVenda) {
        $this->load->model('mempresa');
        $idRegime = $this->mempresa->pegaRegime();
        if ($impostosIsencao == 'n' && $idRegime == 1) {
            if ($this->ProdutosM->cansulta_impostoProdutoVenda($idProduto)) {
                $this->ProdutosM->impostoAtualizarVendaIva($idProduto, $idImpostoVenda);
            } else {
                $this->ProdutosM->impostoVendaIva($idProduto, $idImpostoVenda);
            }
        }
    }

    public function editarArtigo() {
        ini_set('upload_max_filesize', '40M');
        $idProduto = $this->input->post('idProduto');
        $idCategoria = $this->input->post('idCategoria');
        $idNatureza = $this->input->post('idNatureza');
        $idTipo = $this->input->post('idTipo');
        $idUnidade = $this->input->post('idUnidade');
        $produto = $this->input->post('artigo');
        $idIsencao = $this->input->post('idIsencao');
        $vender = $this->input->post('vender');
        $comprar = $this->input->post('comprar');
        $custo = $this->input->post('custo');
        $venda = $this->input->post('venda');
        $desconto = 0;
        $iscecao = $this->input->post('iscecao');
        if (isset($iscecao)) {
            $impostosIsencao = 's'; // Está isento
        } else {
            $impostosIsencao = 'n'; // Não está isento
        }
        $caducidade = $this->input->post('dtcaducidade');
        if (isset($caducidade)) {
            $dtcaducidade = 's'; // Está isento
        } else {
            $dtcaducidade = 'n'; // Não está isento
        }
        $idImpostoVenda = $this->input->post('idImpostoVenda');
        $control = $this->input->post('control');
        $ativo = $this->input->post('ativo');
        $referencia = $this->input->post('referencia');
        $checkboxes = $this->input->post('checkboxes');
        $this->load->model('mempresa');
        $idRegime = $this->mempresa->pegaRegime();
        if ($idRegime == 2) {
            $idIsencao = 4;
        } elseif ($idRegime == 3 && !is_int($idIsencao)) {
            $idIsencao = 2;
        } elseif ($idRegime == 1 && !is_int($idIsencao)) {
            $idIsencao = 1;
        } else {
            $idIsencao = $this->input->post('idIsencao');
        }

        $bbr = $this->input->post('codeBar');
        $this->load->model('mArtigos');
        $this->load->model('mStock');

        $this->mArtigos->atualizaArtigo($idProduto, $produto, $idCategoria, $bbr, $idIsencao, $idUnidade, $idTipo, $vender, $comprar, $custo, $venda, $desconto, $control, $referencia, $ativo, $dtcaducidade);
        $this->mArtigos->atualizaPrecoProduto($idProduto, $venda);
        if ($idTipo == 2) { // sefor um serviço
            $this->atualizarTipoServico($idProduto, $idNatureza);
        }
        if ($impostosIsencao == 'n' && $idRegime == 1) {
            $this->mArtigos->impostoVendaIva($idProduto, $idImpostoVenda);
        }
        if ($impostosIsencao == 's' && $idRegime == 1 && $idIsencao == 1) {
            $this->mArtigos->atualiza_imposto_venda($idProduto, 1);
        }
        if ($impostosIsencao == 's' && $idRegime == 1 && $idIsencao != 1) {
            $this->mArtigos->atualiza_imposto_venda($idProduto, 2);
        }
        $this->atualizaImpostos($idProduto, $impostosIsencao, $idImpostoVenda, $idIsencao);
        echo json_encode('OK');
    }

    public function editarServico() {
        $idpr = $this->input->post('idpr');
        $pr = $this->input->post('pr');
        $idIsencao = $this->input->post('idIsencao');
        $valor = $this->input->post('valor');
        $idUnidade = $this->input->post('idUnidade');
        $this->load->model('ProdutosM');
        $this->ProdutosM->atualizaServicoM($idpr, $pr, $valor, $idIsencao, $idUnidade);
        $this->json->success('Serviço alterado');
    }

    public function produtosc() {
        // $produtos = $this->input->get('produtos');
        $this->load->model('ProdutosM');
        $listar = $this->ProdutosM->produtos();
        foreach ($listar as $linha) {
            $dados = array(
                'idproduto' => $linha->idpr,
                'produto' => $linha->produto,
            );
            $resposta['combo'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function produtosProforma() {
        // $produtos = $this->input->get('produtos');
        $this->load->model('ProdutosM');
        $listar = $this->ProdutosM->produtosProForma();
        foreach ($listar as $linha) {
            $dados = array(
                'idproduto' => $linha->idpr,
                'produto' => $linha->produto,
            );
            $resposta['combo'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function pega_exepcao($idproduto) {
        $this->load->model('ProdutosM');
        $this->load->model('mempresa');
        if ($this->mempresa->pegaRegime() == 1) {// se a empresa estiver no regime geral
            if ($this->ProdutosM->produto_isencao($idproduto) == 1) {// SE O TIPO DE ISENÇÃO FOR IGUA A 1 QUER DIZER Q O PRODUTO TEM IVA
                return $this->ProdutosM->pegaIvaVenda($idproduto);
            } else {
                return 0.00;
            }
        } else {
            return 0.00;
        }
    }

    public function produtos_servicos_qtd_proforma() {
        $idproduto = $this->input->get('idproduto');
        $this->load->model('ProdutosM');
        $this->load->model('StockM');
        $listar = $this->ProdutosM->pegarPrProforma($idproduto);

        foreach ($listar as $linha) {
            $idTipo = $linha->idTipo;
            $control = $linha->control;
            if ($idTipo == 3 && $control == 's') {
                $stock = $linha->qtd;
            } else {
                $stock = '';
            }
            $preco = $linha->preco;
            $dados = array(
                'preco' => $preco,
                'idproduto' => $linha->idpr,
                'stock' => $stock,
                'produto' => $linha->produto,
                'tipo' => $idTipo,
                'control' => $control,
                'desconto' => $linha->desconto,
                'imei' => $linha->imei,
                'sim' => $linha->sim,
                'iva' => $this->pega_exepcao($idproduto),
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function produtos_servicos_qtd_orcamento() {
        $idproduto = $this->input->get('idproduto');
        $this->load->model('ProdutosM');
        $this->load->model('StockM');
        $listar = $this->ProdutosM->pegarPrOrcamento($idproduto);

        foreach ($listar as $linha) {
            $idTipo = $linha->idTipo;
            $control = $linha->control;
            if ($idTipo == 3 && $control == 's') {
                $stock = $linha->qtd;
            } else {
                $stock = '';
            }
            $preco = $linha->preco;
            $dados = array(
                'preco' => $preco,
                'idproduto' => $linha->idpr,
                'stock' => $stock,
                'produto' => $linha->produto,
                'tipo' => $idTipo,
                'control' => $control,
                'desconto' => $linha->desconto,
                'imei' => $linha->imei,
                'sim' => $linha->sim,
                'iva' => $this->pega_exepcao($idproduto),
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function preco_promocao($preco, $idProduto) {
        $hoje = date('Y-m-d');
        $this->load->model('mpromocao');
        if ($this->mpromocao->conta_produto_existe_procao($idProduto)) {
            foreach ($this->mpromocao->mpega_lista_mpromocao2($idProduto) as $linha) {
                $data_fim = $linha->data_fim;
                $data_inicio = $linha->data_inicio;
                if (strtotime($hoje) < strtotime($data_inicio)) {
                    return $preco;
                } elseif (strtotime($hoje) > strtotime($data_fim)) {
                    return $preco;
                } else {
                    $percentagem = number_format(($linha->desconto * $preco) / 100, 2);
                    return number_format($preco - $percentagem, 2);
                }
            }
        } else {
            return $preco;
        }
    }

    public function calcula_qtd($total_por_unidade, $td) {
        if ($total_por_unidade > $td) {
            return 0;
        } else {
            return $td / $total_por_unidade;
        }
    }

    public function pega_qtd($td, $idGrupoPreco, $idProduto) {
        if ($this->mGestaoStock->tipo_grupo($idGrupoPreco) == 'gr') {
            if ($this->mGestaoStock->mconsulta_idproduto_compra($idProduto)) {
                $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idProduto);
                return intval($this->calcula_qtd($total_por_unidade, $td));
            } else {
                return $td;
            }
        } else {
            return $td;
        }
    }

    public function produtos_servicos_qtd() {
        $idproduto = $this->input->get('idproduto');
        $idLoja = $this->input->get('idLoja');
        $idGrupoPreco = $this->input->get('idGrupoPreco');
        $this->load->model('ProdutosM');
        $this->load->model('StockM');
        $this->load->model('mGestaoStock');
        $listar = $this->ProdutosM->pegarPr($idproduto, $idLoja);

        foreach ($listar as $linha) {
            $idTipo = $linha->idTipo;
            $control = $linha->control;
            if ($idTipo == 3 && $control == 's') {
                $stock = $this->pega_qtd($linha->qtd, $idGrupoPreco, $linha->idpr);
            } else {
                $stock = '';
            }
            $preco = $this->preco_promocao($this->StockM->pegaPrecoPorGrupo($idGrupoPreco, $linha->idpr), $linha->idpr);
            $dados = array(
                'preco' => $preco,
                'idproduto' => $linha->idpr,
                'stock' => $stock,
                'produto' => $linha->produto,
                'tipo' => $idTipo,
                'control' => $control,
                'desconto' => $linha->desconto,
                'imei' => $linha->imei,
                'sim' => $linha->sim,
                'iva' => $this->pega_exepcao($idproduto),
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function motivo_insecao() {
        $this->load->model('mArtigos');
        foreach ($this->mArtigos->mlista_insecao() as $linha) {
            $dados[] = array(
                'idMotivoIsecao' => $linha->id,
                'motivo' => $linha->motivo,
            );
        }
        echo json_encode($dados);
    }

    // listar produtos do tipo A
    public function pegaIdProduto() { // pega o id do produto atravez do codigo de barraidPr
        $codeBar = $this->input->get('codeBar');
        $referencia = $this->input->get('referencia');
        $idPr = $this->input->get('idPr');
        $this->load->model('ProdutosM');
        if ($this->ProdutosM->mpegaIdProduto($codeBar, $referencia, $idPr)) {
            foreach ($this->ProdutosM->mpegaIdProduto($codeBar, $referencia, $idPr)as $row) {
                $imprimir[] = array(
                    'idpr' => $row->idpr,
                    'produto' => $row->produto,
                );
                $total = 1;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function produtoExiste() {
        $idproduto = $this->input->get('idproduto');
        $this->load->model('ProdutosM');
        if ($this->ProdutosM->mpegaIdProdutoPorid($idproduto)) {
            foreach ($this->ProdutosM->mpegaIdProdutoPorid($idproduto)as $row) {
                $imprimir[] = array(
                    'idproduto' => $row->idpr,
                    'produto' => $row->produto,
                );
                $total = 1;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function gerarCodigoDeBarra() {
        $idProduto = $this->input->post('idProduto');
        $this->load->model('ProdutosM');
        $this->ProdutosM->gerarCoigoDeBarra($idProduto);
        $this->json->success('OK');
    }

    public function imprimirCodigoBarra() {
        $this->load->model('mImprimeCodeBar');
        $idProduto = $this->input->post('idProduto');
        $this->mImprimeCodeBar->imprimirCodeBarPDF($idProduto);
        $this->json->success('OK');
    }

    // Controlador para preecher formulario
    public function lista_unidade_medida() {
        $this->load->model('mArtigos');
        $listar = $this->mArtigos->unidadeMedida();
        foreach ($listar as $linha) {
            $dados[] = array(
                'idUnidade' => $linha->idUnidade,
                'nunidade' => $linha->nunidade,
            );
        }
        echo json_encode($dados);
    }

// Controlador para preecher formulario
    public function lista_unidade_medida2() {
        $idUnidade = $this->input->get('idUnidade');
        $this->load->model('ProdutosM');
        $listar = $this->ProdutosM->unidadeMedida2($idUnidade);
        foreach ($listar as $linha) {
            $dados = array(
                'idUnidade' => $linha->idUnidade,
                'nunidade' => $linha->nunidade,
            );
            $resposta['combo'][] = $dados;
        }
        echo json_encode($resposta);
    }

// Controlador para preecher formulario
    public function listaTipoProduto() {
        $this->load->model('mArtigos');
        $listar = $this->mArtigos->tipoProduto();
        foreach ($listar as $linha) {
            $dados[] = array(
                'idTipo' => $linha->idTipo,
                'tipoPr' => $linha->tipoPr,
            );
        }
        echo json_encode($dados);
    }

    public function listaImpostos() {
        $this->load->model('mArtigos');
        $listar = $this->mArtigos->pegaImpostos();
        foreach ($listar as $linha) {
            $dados[] = array(
                'idImposto' => $linha->idImposto,
                'nimposto' => $linha->nimposto,
                'percentagem' => $linha->percentagem,
                'percenteDivisao' => $linha->percenteDivisao,
            );
        }
        echo json_encode($dados);
    }

    public function percentagemImpostos() {
        $idImposto = $this->input->get('idImposto');
        $this->load->model('mArtigos');
        foreach ($this->mArtigos->percentagemImposto($idImposto) as $linha) {
            $dados = array(
                'percentagem' => $linha->percentagem,
                'percenteDivisao' => $linha->percenteDivisao,
            );
        }
        echo json_encode($dados);
    }

    public function listaImpostosIrt() {
        $this->load->model('ProdutosM');
        $listar = $this->ProdutosM->pegaImpostosIrtm();
        foreach ($listar as $linha) {
            $dados = array(
                'idImposto' => $linha->idImposto,
                'percentagem' => $linha->percentagem . '%' . $linha->nimposto,
            );
            $resposta['combo'][] = $dados;
        }
        echo json_encode($resposta);
    }

// lista os produtos para a tela responsiva
    public function listaProdutosTelaMobile() {
        ini_set('memory_limit', '556M');

        set_time_limit(3600);
        $produto = $this->input->get('produto');
        $idCategoria = $this->input->get('idCategoria');
        $descontoPermitido = $this->input->get('descontoPermitido');
        $idLoja = $this->input->get('idLoja');
        $idGrupoPreco = $this->input->get('idGrupoPreco');
        $this->load->model('StockM');
        $this->load->model('ProdutosM');
        $this->load->library('fucoes');
        $stock = 0.00;
        if ($this->ProdutosM->listarQtdMTelaMobile($produto, $idCategoria, $idLoja)) {
            foreach ($this->ProdutosM->listarQtdMTelaMobile($produto, $idCategoria, $idLoja) as $linha) {
                $qtd = $linha->qtd;
                // $venda=  $venda= $this->StockM->pega_preco_venda($linha->idproduto);
                $venda = $this->StockM->pegaPrecoPorGrupo($idGrupoPreco, $linha->idproduto);
                if ($linha->path == '') {
                    $path = 'semImagem.png';
                } else {
                    $path = $linha->path;
                }
                $idTipo = $linha->idTipo;
                $control = $linha->control;
//                    if($idTipo==3 && $control=='s'){
//                        $stock=  $this->ProdutosM->pegaQtd($linha->idproduto);
//                    }

                $dados[] = array(
                    'idProduto' => $linha->idpr,
                    'produto' => $linha->produto,
                    'path' => $path,
                    'nunidade' => $linha->nunidade,
                    'nunidade' => $linha->nunidade,
                    'idDesconto' => $descontoPermitido == 's' ? $linha->desconto : 0,
                    'quantidade' => $control == 's' ? $qtd : 0,
                    'stock' => $control == 's' ? $qtd : 0,
                    'tipo' => $idTipo,
                    'control' => $control,
                    'venda' => $this->fucoes->formatarDinheiro($venda, true),
                    'venda2' => $venda,
                    'ivaPercentagem' => $this->pega_exepcao($linha->idpr),
                    'codebar' => $linha->codigodebara,
                    'categoria' => $linha->categoria,
                    'imei' => $linha->imei,
                    'sim' => $linha->sim,
                );
                $total = $this->StockM->contarlinhasM();
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    function eiminarArtigo() {
        $idpr = $this->input->post('idProduto');
        $this->load->model('mFatura');
        if ($this->mFatura->verificarProduto($idpr)) {
            echo json_encode('ON');
        } else {
            $this->load->model('mArtigos');
            $this->mArtigos->mdeleteProduto($idpr);
            echo json_encode('OK');
        }
    }

    // lista os produtos para a tela responsiva
    public function verificarProduto() { // verifica se o produtoja consta em um documento
        $idProduto = $this->input->get('idProduto');
        $this->load->model('ProdutosM');

        if ($this->ProdutosM->verificaProduto($idProduto)) {
            $resposta = "{success: true, total:1, data:''}";
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function categoriaProdutosAvenda() {
        ini_set('memory_limit', '256M');
        ini_set('upload_max_filesize', '20M');
        ini_set('download_max_filesize', '20M');
        ini_set('post_max_size', '20M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);
        $this->load->model('ProdutosM');
        if ($this->ProdutosM->listarCategoriaMTelaMobile()) {
            foreach ($this->ProdutosM->listarCategoriaMTelaMobile() as $linha) {
                $dados[] = array(
                    'idCategoria' => $linha->idcategoria,
                    'categoria' => $linha->categoria,
                );
                $total = count($this->ProdutosM->listarCategoriaMTelaMobile());
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarProdutosLojas() {
        $idProduto = $this->input->post('idpr');
        $this->load->model('mArtigos');
        $totalProdutos = $this->mArtigos->totaLojasProductos($idProduto);
        $dados = array(); // Inicializa a variável para evitar erros
        foreach ($this->mArtigos->mlistaProdutosLoja($idProduto) as $linha) {
            $qtd = $linha->qtd;
            $dados[] = array(
                'narmanze' => $linha->narmanze,
                'qtd' => $qtd,
                'idArmaze' => $linha->idArmaze,
            );
        }
        echo json_encode(array(
            "data" => $dados,
            "totalProdutos" => $totalProdutos,
        ));
    }

    public function listaArmanze() {
        $idArmanze = $this->input->get('idArmanze');
        $this->load->model('ProdutosM');

        $listar = $this->ProdutosM->mlistaArmanzes($idArmanze);
        $resposta = '';
        $value = '';
        foreach ($listar as $linha) {
            $dados = array(
                'idArmanze' => $linha->id,
                'narmanze' => $linha->narmanze,
                'value' => $value,
            );
            $resposta['combo'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listaArmanzeTransferir() {
        $this->load->model('mArtigos');
        $dados = array();
        foreach ($this->mArtigos->mlistaArmanzes2() as $linha) {
            $dados[] = array(
                'idArmanzeDestino' => $linha->id,
                'narmanze' => $linha->narmanze,
            );
        }
        echo json_encode($dados);
    }

    public function listaGrupoPreco() {
        $this->load->model('ProdutosM');
        $valor = 0;
        if ($this->ProdutosM->mlistaGrupoPreco()) {
            foreach ($this->ProdutosM->mlistaGrupoPreco() as $linha) {

                $dados[] = array(
                    'idGrupoPreco' => $linha->idGrupoPreco,
                    'nome' => $linha->nome,
                    'valor' => $valor,
                );
                $total = 1;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listaArmanzeCkeckBox() {
        $this->load->model('ProdutosM');
        $listar = $this->ProdutosM->mlistaArmanzesView();
        $resposta = '';
        $value = 'n';
        foreach ($listar as $linha) {
            $dados = array(
                'idArmanze' => $linha->id,
                'narmanze' => $linha->narmanze,
                'value' => $value,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function listaGrupoPrecoEdit() {
        $idProduto = $this->input->get('idProduto');
        $this->load->model('ProdutosM');
        $valor = 0;
        if ($this->ProdutosM->mlistaGrupoPreco()) {
            foreach ($this->ProdutosM->mlistaGrupoPreco() as $linha) {
                $idGrupoPreco = $linha->idGrupoPreco;
                $valor = $this->ProdutosM->pegaPrecoProduto($idGrupoPreco, $idProduto);
                $dados[] = array(
                    'idGrupoPreco' => $idGrupoPreco,
                    'nome' => $linha->nome,
                    'valor' => $valor,
                );
                $total = 1;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listaArmanzeCkeckBoxEdit() {
        $idProduto = $this->input->get('idProduto');
        $this->load->model('ProdutosM');
        $value = 'n';
        if ($this->ProdutosM->mlistaArmanzesView()) {
            foreach ($this->ProdutosM->mlistaArmanzesView() as $linha) {
                $idArmanze = $linha->id;
                $value = $this->ProdutosM->pegaDisponiblidadeProduto($idArmanze, $idProduto);
                $dados[] = array(
                    'idArmanze' => $idArmanze,
                    'narmanze' => $linha->narmanze,
                    'value' => $value,
                );
                $total = 1;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarClasseBemCB() {
        $this->load->model('ProdutosM');
        $cont = 0;
        if ($this->ProdutosM->mlistaClassemBemCB()) {
            foreach ($this->ProdutosM->mlistaClassemBemCB() as $linha) {
                $cont++;

                if ($cont == 1) {
                    $clnome = '<i>' . $linha->clnome . '</i>';
                } else {
                    $clnome = $linha->clnome;
                }

                $dados[] = array(
                    'idClasseBem' => $linha->idClasseBem,
                    'clnome' => $clnome,
                );
                $total = count($this->ProdutosM->mlistaClassemBemCB());
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarMarcasCB() {
        $this->load->model('ProdutosM');
        $cont = 0;
        if ($this->ProdutosM->mlistaMarcasCB()) {
            foreach ($this->ProdutosM->mlistaMarcasCB() as $linha) {
                $cont++;

                if ($cont == 1) {
                    $nmarca = '<i>' . $linha->nmarca . '</i>';
                } else {
                    $nmarca = $linha->nmarca;
                }

                $dados[] = array(
                    'idMarca' => $linha->idMarca,
                    'nmarca' => $nmarca,
                );
                $total = count($this->ProdutosM->mlistaMarcasCB());
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarVariacoesProdutos() {
        $idProduto = $this->input->get('idProduto');
        $this->load->model('ProdutosM');
        $this->load->model('mVariacao');
        if ($this->ProdutosM->mlistaVariacaoProduto($idProduto)) {
            foreach ($this->ProdutosM->mlistaVariacaoProduto($idProduto) as $linha) {

                $dados[] = array(
                    'idVariacao' => $linha->idVariacao,
                    'variacao' => $this->mVariacao->idVariacao($linha->idVariacao),
                );
                $total = 1;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function contaVaricaoCor($itemCores) {
        $cont = 0;
        foreach ($itemCores as $linha) {
            if ($linha->value == 's') {
                $cont++;
            }
        }
        return $cont;
    }

    public function contaVaricaoTamanho($itemTamanho) {
        $cont = 0;
        foreach ($itemTamanho as $linha) {
            if ($linha->value == 's') {
                $cont++;
            }
        }
        return $cont;
    }

    public function finalizarGravacaoTamanhoProduto($idProduto, $idVariacao, $idCor, $idTamanho) {
        $this->load->model('StockM');
        foreach ($this->StockM->pegaLojasProduto() as $linha) {
            $this->ProdutosM->mregistaVariacaoTamanhoProduto($idProduto, $idVariacao, $idCor, $idTamanho, $linha->idArmaze);
        }
    }

    public function percorrerTamanho($idProduto, $idVariacao, $itemTamanho, $idCor) {
        // se uma cor for selecionada esta fução será chamada

        foreach ($itemTamanho as $item) {
            $idTamanho = $item->idTamanho;
            if ($item->value == 's') {
                $this->finalizarGravacaoTamanhoProduto($idProduto, $idVariacao, $idCor, $idTamanho);
            }
        }
    }

    public function percorrerCores($idProduto, $idVariacao, $itemCores, $itemTamanho) { // verifica se uma cor foi selecionda
        foreach ($itemCores as $item) {
            $item->idCor;
            if ($item->value == 's') {
                $this->percorrerTamanho($idProduto, $idVariacao, $itemTamanho, $item->idCor);
            }
        }
    }

    public function registaVariacaoTamanhoProduto() {
        $cores = $this->input->post('cores');
        $tamanho = $this->input->post('tamanho');
        $idProduto = $this->input->post('idProduto');
        $idVariacao = $this->input->post('idVariacao');
        $this->load->model('ProdutosM');
        $itemCores = json_decode($cores);
        $itemTamanho = json_decode($tamanho);
        if ($this->contaVaricaoCor($itemCores) < 1) {
            $this->json->success('c');
        } elseif ($this->contaVaricaoTamanho($itemTamanho) < 1) {
            $this->json->success('t');
        } else {
            $this->percorrerCores($idProduto, $idVariacao, $itemCores, $itemTamanho);
            $this->json->success('OK');
        }
    }

    public function registaVariacaoTamanhoProdutoPorCor() {
        $idCor = $this->input->post('idCor');
        $tamanho = $this->input->post('tamanho');
        $idProduto = $this->input->post('idProduto');
        $idVariacao = $this->input->post('idVariacao');
        $this->load->model('ProdutosM');
        $itemTamanho = json_decode($tamanho);
        if ($this->contaVaricaoTamanho($itemTamanho) < 1) {
            $this->json->success('t');
        } else {
            $this->percorrerTamanho($idProduto, $idVariacao, $itemTamanho, $idCor);
            $this->json->success('OK');
        }
    }

    public function listaVariacoesTamanhoQtd() {
        $this->load->model('ProdutosM');
        $cont = 0;
        if ($this->ProdutosM->mlistaMarcasCB()) {
            foreach ($this->ProdutosM->mlistaMarcasCB() as $linha) {
                $cont++;

                $dados[] = array(
                    'idMarca' => $linha->idMarca,
                    'nmarca' => $linha->nmarca,
                );
                $total = count($this->ProdutosM->mlistaMarcasCB());
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function qtdPorArmaze() {
        $idProduto = $this->input->get('idProduto');
        $this->load->model('ProdutosM');
        $value = 'n';
        $qtAlterar = '';
        if ($this->ProdutosM->mlistaArmanzesView()) {
            foreach ($this->ProdutosM->mlistaArmanzesView() as $linha) {
                $idArmanze = $linha->id;
                $qtd = $this->ProdutosM->mqtdArmaze($idArmanze, $idProduto);
                $dados[] = array(
                    'idArmanze' => $idArmanze,
                    'narmanze' => $linha->narmanze,
                    'value' => $value,
                    'qtAlterar' => $qtAlterar,
                    'qtd' => $qtd,
                );
                $total = 1;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function imprimirListaGeral() {
        $this->load->model('mListaGeralProduto');
        $idProduto = $this->input->post('idProduto');
        $this->mListaGeralProduto->imprimirGeralProdutos($idProduto);
        $this->json->success('OK');
    }

}

?>
