<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cCliente
 *
 * @author VINEVALA
 */
class cCliente extends CI_Controller {

    public function registaEntidade() {  // Regista o clinte a partir da ficha principal do cliente
        $nome = $this->input->post('nome');
        $fone = $this->input->post('fone');
        $fone1 = $this->input->post('fone1');
        $nif = $this->input->post('nif');
        $email = $this->input->post('email');
        $localizacao = $this->input->post('endereco');
        $desconto = $this->input->post('desconto');
        $tipo = $this->input->post('tipoEntidade');
        $genero = $this->input->post('genero');
        $this->load->model('mClientes');
        $this->mClientes->registarclM($nome, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo, $genero);
        echo json_encode('OK');
    }

    public function salvaClientes() {
        $nome = $this->input->post('nome');
        $fone = $this->input->post('fone');
        $fone1 = $this->input->post('fone1');
        $nif = $this->input->post('nif');
        $email = $this->input->post('email');
        $localizacao = $this->input->post('localizacao');
        $desconto = $this->input->post('desconto');
        $tipo = $this->input->post('tipo');
        $this->load->model('ClientesM');

        $this->json->success($this->ClientesM->mRegistaClientes($nome, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo));
    }

    public function editarCliente() {
        $idCliente = $this->input->post('idCliente');
        $nome = $this->input->post('nome');
        $fone = $this->input->post('fone');
        $fone1 = $this->input->post('fone1');
        $nif = $this->input->post('nif');
        $email = $this->input->post('email');
        $localizacao = $this->input->post('localizacao');
        $desconto = $this->input->post('desconto');
        $tipo = $this->input->post('tipo');
        $this->load->model('ClientesM');
        if (isset($nome) && isset($nif)) {
            $this->ClientesM->atualizarClientem($idCliente, $nome, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo);
            $this->json->success('Dados alterados');
        } else if (isset($nome) && !isset($nif)) {
            $this->ClientesM->atualizarClienteNome($idCliente, $nome, $email, $fone, $fone1, $localizacao, $desconto, $tipo);
            $this->json->success('Dados alterados');
        } else if (isset($nif) && !isset($nome)) {
            $this->ClientesM->atualizarClienteNif($idCliente, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo);
            $this->json->success('Dados alterados');
        } else {
            $this->ClientesM->atualizarDadosClientes($idCliente, $email, $fone, $fone1, $localizacao, $desconto, $tipo);
            $this->json->success('Dados alterados');
        }
    }

    //funcao que lista clientes para a grid
    public function listarEntidades() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
       $pesquisa = ($_POST["search"] ["value"]);
     //   $pesquisa = $this->input->get('pesquisa');
        $draw = $this->input->post("draw");
        $this->load->model('mClientes');
        $totalRecords = $this->mClientes->totalClientes();
        $filteredRecords = $this->mClientes->obter_total_registos_filtrados($pesquisa);
        $dados = array();
        foreach ($this->mClientes->mlistar_entidades($start, $limit, $pesquisa) as $linha) {
            $dados[] = array(
                'nome' => $linha->nome,
                'telefonePessoal' => $linha->fone1,
                'telefoneEmp' => $linha->fone,
                'nif' => $linha->nif,
                'email' => $linha->email,
                'localizacao' => $linha->localizacao,
//                'desconto' => $linha->desconto,
//                'tipo' => $linha->tipo,
                'idcliente' => $linha->idcliente,
            );
        }
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $totalRecords,
            "recordsFiltered" => $filteredRecords,
            "data" => $dados
        ));
    }

    // lista os clientes no campo de pesquisa
    public function lista_entidades_txt_search() {
        $pesquisa = $this->input->get('term');
        $this->load->model('mClientes');
        echo json_encode($this->mClientes->mlista_entidades_txt_search($pesquisa));
    }

    //Combo para precher o form 
    public function listaclienteForm() {
        $this->load->model('ClientesM');
        $id = $this->input->get('idcliente');
        $consulta = $this->ClientesM->listarClientesformM($id);
        foreach ($consulta as $linha) {
            $dados = array(
                'idcliente' => $linha->idcliente,
                'nome' => $linha->nome,
            );
            $resposta['resultado'][] = $dados;
        }
        echo json_encode($resposta);
    }

    public function telefoneCliente() {
        $idcliente = $this->input->get('idcliente');
        $this->load->model('ClientesM');
        $dados = array(
            'telefone' => $this->ClientesM->pegaTelefone($idcliente),
        );
        $resposta['resultado'][] = $dados;

        echo json_encode($resposta);
    }

    public function descontoGlobal() {
        $idcliente = $this->input->get('idcliente');
        $this->load->model('ClientesM');
        $dados = array(
            'descontoglobal' => $this->ClientesM->mdescontoGlobal($idcliente),
        );
        $resposta['resultado'][] = $dados;

        echo json_encode($resposta);
    }

    public function verifica_cliente_fez_compra() {
        $idCliente = $this->input->get('idCliente');
        $this->load->model('ClientesM');
        if ($this->ClientesM->verifica_cliente_fez_compraM($idCliente)) {
            foreach ($this->ClientesM->verifica_cliente_fez_compraM($idCliente) as $linha) {
                $dados[] = array(
                    'idcliente' => $linha->idcliente,
                    'nome' => $linha->nome,
                    'nif' => $linha->nif,
                );
                $total = 1;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function pega_dados_cliente_tooltip() {
        $idCliente = $this->input->get('idCliente');
        $this->load->model('mClientes');
        echo json_encode($this->mClientes->mpega_dados_cliente_tooltip($idCliente));
    }

    public function eliminarCliente() {
        $idCliente = $this->input->post('idCliente');
        $this->load->model('mClientes');
        $this->load->model('mFatura');
        if ($this->mFatura->consultaCliente($idCliente)) {
            echo json_encode('N');
        } else {
            $this->mClientes->eliminaCliente($idCliente);
           echo json_encode('OK');
        }
    }

}

?>
