<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cContaCliente
 *
 * @author GRAFICA BILL
 */
class cContaCliente extends CI_Controller {

    public function acharTotal($desconto, $qtd, $valor) {
        if ($desconto > 0) {
            $desconto1 = ($valor * $desconto) / 100;
            $preco = $valor - $desconto1;
            return $total = $preco * $qtd;
        } else {
            return $total = $valor * $qtd;
        }
    }

    public function custoDesconto($desconto, $valor) {

        $desconto1 = ($valor * $desconto) / 100;
        $preco = $valor - $desconto1;
        return $preco;
    }

    public function regularizar() {
        $idCliente = $this->input->post('idCliente');
        $montante = $this->input->post('valorSaldo');
        $observacao = $this->input->post('descricaoSaldo');
        $idTipoMovimento = $this->input->post('tipoOperacao');
        $dataMovimento = $this->input->post('dataMovimento');
        $idFormaPagamento = $this->input->post('idFormaPagamento');
        $this->load->model('mContaCliente');
        if ($idTipoMovimento == 3) {
            $this->mContaCliente->regularizacaoCredito($idCliente, $montante, $observacao, $idTipoMovimento, $dataMovimento, $idFormaPagamento);
            echo json_encode('OK');
        } else {
            $this->mContaCliente->regularizacaoDebito($idCliente, $montante, $observacao, $idTipoMovimento);
            $this->json->success('OK');
        }
    }

    public function listarContaCorrente() {
        $idCliente = $this->input->post('idCliente');
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start');

        $dataminima = $this->input->get('dataminima');
        $datamaxima = $this->input->get('datamaxima');
        $this->load->model('mContaCliente');
        $dados = array();
        $cont = 0;
        $saldoTotal = 0;
        $dividaTransitada = $this->mContaCliente->dividaTransitadaCliente2($idCliente, $datamaxima);
        $totalFiltrados = $this->mContaCliente->obter_total_registos_filtrados($idCliente, $dataminima, $datamaxima);
        foreach ($this->mContaCliente->mlistaContaCliente($idCliente, $dataminima, $datamaxima)as $row) {
            $divida = $row->divida;
            $pagamento = $row->pagamento;

            if ($cont == 1) {
                $saldoTotal = $dividaTransitada + $divida - $pagamento;
            } else {
                $saldoTotal = $saldoTotal + $divida - $pagamento;
            }

            $dados[] = array(
                'data' => $row->data,
                'designacao' => $row->designacao,
                'saldo' => 0,
                'divida' => $divida,
                'pagamento' => $pagamento,
                'saldoTotal' => $saldoTotal,
                'totalGeral' => $saldoTotal,
                    //'valor'=>$this->fucoes->formatarDinheiro($row->valor,true),
            );
        }

        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $this->mContaCliente->contarClienteContaCorrente($idCliente),
            "recordsFiltered" => $totalFiltrados,
            "data" => $dados
        ));
    }

    public function pegaInfoContaCliente() {
        $idCliente = $this->input->post('idCliente');
//        $idCliente = 77;
////        $idCliente = 82;
        $this->load->model('mContaCliente');
        $dividaTransitada = $this->mContaCliente->dividaTransitadaCliente($idCliente);

        $dividas = $this->mContaCliente->pegaDivida($idCliente);
        $pagamentos = $this->mContaCliente->pegaPagamentos($idCliente);
        $dividasCorrente = $this->mContaCliente->dividasCorrente($idCliente);
        $saldoTotal = $dividas - $pagamentos;
        $saldos = array(
            'saldoTotal' => $saldoTotal,
            'dividasCorrente' => $dividasCorrente,
            'dividaTransitada' => $dividaTransitada,
        );
        echo json_encode(array(
            "saldos" => $saldos,
        ));
    }

    public function lista_tipo_movimento() {
        $this->load->model('mContaCliente');
        $dados = array();
        foreach ($this->mContaCliente->mlista_tipo_movimento()as $row) {
            $idTipoMovimento = $row->idTipoMovimento;
            if ($idTipoMovimento == 3) {
                $designacao = 'Crédito(Adiantamento - Diminui o saldo a favor do cliente)';
            } else {
                $designacao = 'Débito(aumenta o saldo a favor do cliente)';
            }
            $dados[] = array(
                'idTipoMovimento' => $idTipoMovimento,
                'designacao' => $designacao,
            );
        }
        echo json_encode($dados);
    }

    public function listaGeralContaCorrente() {
        $pesquisa = $this->input->get('pesquisa');
        $draw = $this->input->get("draw");
        $limit = $this->input->get('length'); // Número de registros por página
        $offset = $this->input->get('start');
        $this->load->model('mfluxoCaixa');
        $cont = 0;
        $dados = array();
        $totalFiltrados = $this->mfluxoCaixa->obter_total_registos_filtrados($pesquisa);
        foreach ($this->mfluxoCaixa->mlistaGeralContaCorrente($limit, $offset, $pesquisa)as $row) {
            $idrecebimento = $row->idrecebimento;
            $idCliente = $row->idcliente;
            $pago = $this->mfluxoCaixa->totalGeralDividaPgago($idCliente);
            $totalDivida = $this->mfluxoCaixa->totalGeralDivida($idCliente);
            $credito = $totalDivida - $pago;

            $dados[] = array(
                'idCliente' => $idCliente,
                'nome' => $row->nome,
                'idcliente' => $row->idcliente,
                'fone' => $row->fone,
                'nif' => $row->nif,
                'total' => $totalDivida,
                'debito' => $pago,
                'credito' => $credito,
            );
        }
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $this->mfluxoCaixa->total_registos(),
            "recordsFiltered" => $totalFiltrados,
            "data" => $dados
        ));
    }

    public function calculaIvaDaFT($fatura) {
        $totalIva = 0;
        foreach ($consuta = $this->mFatura->imprimir_vendas($fatura) as $linha) {
            $idproduto = $linha->idpr;
            $qtd = $linha->qtd;
            $custo = $linha->custo;
            $total = $this->acharTotal($linha->desconto, $qtd, $custo);
            $ivaInt = $this->mIva->calculo_iva_int($total, $idproduto);
            $totalIva = $totalIva + $ivaInt;
        }
        return $totalIva;
    }

    public function listarContasReceber() {
        $pesquisa = $this->input->get('pesquisa');
        $draw = $this->input->get("draw");
        $limit = $this->input->get('length'); // Número de registros por página
        $offset = $this->input->get('start');
        $idCliente = $this->input->get('idCliente');
        $this->load->model('mfluxoCaixa');
        $this->load->model('mFatura');
        $this->load->model('mIva');
        $this->load->model('mContaCliente');
        $debito = 0;
        $dados = array();
        $totalFiltrados = $this->mfluxoCaixa->obter_total_registos_filtrados('');
        foreach ($this->mfluxoCaixa->contasReceberLista($limit, $offset, $idCliente)as $row) {
            $idrecebimento = $row->idrecebimento;
            $debito = $this->mfluxoCaixa->totalDividaPgago($idrecebimento);
            $totalIvaPago = $this->mfluxoCaixa->totalIvaPago($idrecebimento);
            $totalDivida = $this->mContaCliente->totalDivida($idrecebimento);
            $idFatura = $row->idFatura;
            $serie = $this->mFatura->serie($idFatura);
            $numero = $this->mFatura->pegaNumeroFtPorIdFatura($idFatura);
            $data = $row->datavenda;
            $sd3 = new DateTime($data);

            $iva = $this->calculaIvaDaFT($idFatura);
            $dados[] = array(
                'idrecebimento' => $idrecebimento,
                'idEstadoPagFatura' =>  $data = $row->idEstadoPagFatura,
                'nome' => $row->nome,
                'fone' => $row->fone,
                'email' => $row->email,
                'datavenda' => $row->datavenda,
                'data_vencimento' => $row->data_vencimento,
                'valor' => $row->valor,
                'debito' => $debito,
                'valorNConvertido' => $row->valor,
                'idFatura' => $idFatura,
                'credito' => $totalDivida - $debito,
                //  'iva' => $this->fucoes->formatarDinheiro($iva - $totalIvaPago, true),
                'referencia' => 'FT' . ' ' . $serie . '/' . $numero,
            );
        }
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $this->mfluxoCaixa->contarRecebimentos(),
            "recordsFiltered" => $totalFiltrados,
            "data" => $dados
        ));
    }

    public function listaSaldoCliente() {
        $idCliente = $this->input->get('idCliente');
        $this->load->model('mContaCliente');

        $pagamento = $this->mContaCliente->somaPagamentos($idCliente);
        $divida = $this->mContaCliente->somaDividas($idCliente);
        $saldo = $pagamento - $divida;

        $imprimir[] = array(
            'saldoTotalCliente' => number_format($saldo, 2, '.', ''),
        );
        $total = 1;
        $ados = json_encode($imprimir);
        $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
        echo $resposta;
    }

    public function tipoVenda($idtipo) {
        if ($idtipo == 1) {
            return 'FT';
        } else {
            return 'FR';
        }
    }

    public function calcularIva($idFatura) {
        $totalIva = 0;
//         $taxa= $this->ProdutosM->pegaIvaVenda($idproduto);
//              $iva=$custo*$taxa/100;
        foreach ($this->FaturasM->listaDeVendasProduto($idFatura)as $linha) {
            $custo = $linha->custo;
            $qtd = $linha->qtd;
            $idproduto = $linha->idpr;
            $total = $this->acharTotal($linha->desconto, $qtd, $custo);
            $ivaInt = $this->mIva->calculo_iva_int($total, $idproduto);
            $totalIva = $totalIva + $ivaInt;
        }
        return $totalIva;
    }

    public function lista_conta_corrente() {
        ini_set('memory_limit', '256M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);

        $dataminima = $this->input->get('dataminima');
        $datamaxima = $this->input->get('datamaxima');
        $idCliente = $this->input->get('idCliente');
        $this->load->model('mContaCliente');
        $this->load->model('FaturasM');
        $this->load->model('mfaturaM2');
        $this->load->model('mempresa');
        $this->load->model('mIva');
        $tipoVenda = '';
        $subtotal = 0;
        $totalGeral = 0;
        $credito = 0;
        $debito = 0;

        $totalIvaFornecedor = 0;
        if ($this->mContaCliente->faturas($dataminima, $datamaxima, $idCliente)) {
            foreach ($this->mContaCliente->faturas($dataminima, $datamaxima, $idCliente)as $row) {
                $idFatuta = $row->fatura;
                $serie = $this->mfaturaM2->serie($idFatuta);
                $data = $row->data;
                $sd3 = new DateTime($data);
                $dtv = $sd3->format('d-m-Y');
                $tipoVenda = $this->tipoVenda($row->idtipo);
                $subtotal = $this->FaturasM->somaTotalVendas($idFatuta);
                $descontos = $this->FaturasM->somaTotalDesconto($idFatuta);
                $iva = $this->calcularIva($idFatuta);
                if ($this->mempresa->pegaRegime() != 1) {
                    $iva = 0;
                }
                $totalGeral = $subtotal - $descontos;
                if ($tipoVenda == 'FT') {
                    $credito = $totalGeral;
                    $debito = 0;
                } else {
                    $debito = $totalGeral;
                    $credito = 0;
                }
                $numero = 0;
                if ($row->idtipo == 1) {
                    $numero = $this->FaturasM->pegaNumeroFtPorIdFatura($idFatuta);
                } else {
                    $numero = $this->FaturasM->pegaNumeroFrPorIdFatura($idFatuta);
                }

                $imprimir[] = array(
                    'data' => $data,
                    'documento' => $tipoVenda . ' ' . $serie . '/' . $numero,
                    'data' => $dtv,
                    'cliente' => $row->nome,
                    'subtotal' => $this->fucoes->formatarDinheiro($subtotal, true),
                    'totalDescontos' => $this->fucoes->formatarDinheiro($descontos, true),
                    'totalgeral' => $this->fucoes->formatarDinheiro($totalGeral, true),
                    'credito' => $this->fucoes->formatarDinheiro($credito, true),
                    'debito' => $this->fucoes->formatarDinheiro($debito, true),
                    'totalIva' => $this->fucoes->formatarDinheiro($iva, true),
                );
                $total = $this->FaturasM->contarRegistosDeVendas();
                //    $total=20;
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

}
