<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cFaturas
 * 
 *
 * @author VINEVALA
 */
class cFaturas extends CI_Controller {

    public function exemploHora() {

        echo @date('H:i:s');
    }

    public function custoDesconto($desconto, $valor) {

        $desconto1 = ($valor * $desconto) / 100;
        $preco = $valor - $desconto1;
        return $preco;
    }

    public function calcuralDesconto($desconto, $qtd, $valor) {
        $desconto1 = ($valor * $desconto) / 100;
        return $desconto1 * $qtd;
    }

    public function calcularDescontoGeral($idFatura, $subtotal) {
        $this->load->model('mfaturaM2');
        $percentagemGeral = $this->mfaturaM2->pegaDescontoGlobal($idFatura);
        return ($percentagemGeral * $subtotal) / 100;
    }

    public function pegarIva() {
        $idProduto = $this->input->post('idProduto');
        $total = $this->input->post('total');
        $this->load->model('mIva');
        $this->json->success($this->mIva->calculo_iva_int($total, $idProduto));
    }

    public function extenso() {
        $valor = $this->input->get('valor');
        $this->load->library('numeroPorExtenso');
        $this->extenso = new NumeroPorExtenso;
        $dados = array(
            'extenso' => $this->extenso->converter($valor, true),
        );
        $resposta['resultado'][] = $dados;

        echo json_encode($resposta);
    }

    public function registarEntrada($idtipovenda, $idtipopagamento, $preco, $iduser, $idCliente) {
        if ($idtipopagamento == 2) {//se a forma de pagamento for com o tpa
            $idTipovenda = 1;  //O dinheiro cai  Banco 
        } else {// senao 
            $idTipovenda = 3;   //o tipo de pagamento em cash
        }
        if ($idtipovenda == 2) {//  //senao no caixa
            $this->load->model('mfluxoCaixa');
            $tipomovimento = 'Entrada';
            $idTipoMovimentoCaixa = 8;
            $referencia = $this->mClientes->clienteNome($idCliente);
            $this->mfluxoCaixa->registarEntradasCaixa($referencia, $preco, $tipomovimento, $idtipopagamento, $iduser, $idTipovenda, $idTipoMovimentoCaixa); // chama modelo que contem a função para registar a entrada 
//       $consulta=   $this->mfluxoCaixa->consultarEntradasCaixa($idtipopagamento,$iduser,$referencia);
//       if($consulta){
//           $this->mfluxoCaixa->atualizarEntradasCaixa($idtipopagamento,$iduser,$referencia,$preco);// chama modelo que contem a função para atualizar a entrada 
//       }  else {
//          
//        //   $this->mfluxoCaixa->mregistarSaidas($referencia,$valor,$movimento,$fpagamento,$iduser,$idTipovenda);// 
//       }
        }
    }

    public function registarSaldoConta($idtipovenda, $idtipopagamento, $preco) {
        if ($idtipovenda == 2) {// se a venda for a pronto pagamento
            $this->load->model('mfluxoCaixa');
            $this->load->model('MBanco');
            if ($idtipopagamento == 1) { // e o pagamento for feito em dinheiro
                $this->mfluxoCaixa->atualizarSadoNasContas(2, $preco); // chama modelo que contem a função para o saldo na conta corrente
                $this->mfluxoCaixa->atualizarSadoNasContas(3, $preco); // chama modelo que contem a função para o saldo na conta caixa
            } else { // se o pagamento não for em dineiro o saldo caira na conta banco
                $this->mfluxoCaixa->atualizarSadoNasContas(1, $preco); // chama modelo que contem a função para o saldo na conta banco
                $this->mfluxoCaixa->atualizarSadoNasContas(2, $preco); // chama modelo que contem a função para o saldo na conta corrente
                $this->mfluxoCaixa->atualizarDebitoBanco($this->Mbanco->idContaActiva(), $preco); // chama modelo que contem a função para o saldo nas contas 
            }
        }
    }

    public function registarVendasCredito($idtipovenda, $idcliente, $datapagamento, $total, $fatura) {
        if ($idtipovenda == 1) {// se a venda for a credito
            $this->load->model('mfluxoCaixa');
            $this->load->model('mContaCliente');
            $this->mfluxoCaixa->vendasCredito($idcliente, $datapagamento, $total, $fatura); // chama modelo que contem a função para registar  a venda credito 
            $this->mContaCliente->dividaPeriodo($idcliente, $total);
        }
    }

    public function copiarTabelaStock() {
        $this->load->model('StockM');
        $pegaStock = $this->StockM->CopiarStock();

        $this->load->model('InventarioM'); // carrega o  Modelo
        foreach ($pegaStock as $linha) { // fas a impreção da mesma
            $idStock = $linha->idstock;
            $qtd = $linha->qtd;
            $custo = $linha->custo;
            $totalcompras = $linha->totalcompras;

            $punitario = $custo;
            $qtd_saidas = 0;
            $valorfinal1 = $qtd * $punitario;
            $valorsaidas = 0;
            $qtdinicial = $qtd;
            $this->InventarioM->regirtarInventarioM($idStock, $qtdinicial, $qtd, $totalcompras, $qtd_saidas, $punitario, $valorsaidas, $valorfinal1);
        }
    }

    public function calcula_preco_grosso($total_por_unidade, $preco) {
        return $preco / $total_por_unidade;
    }

    public function preco_compra($idGrupoPreco, $idProduto) {
        $this->load->model('mGestaoStock');
        if ($this->mGestaoStock->tipo_grupo($idGrupoPreco) == 'gr') {
            if ($this->mGestaoStock->mconsulta_idproduto_compra($idProduto)) {
                $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idProduto);
                $preco = $this->mGestaoStock->pega_total_preco_grosso($idProduto);
                return $this->calcula_preco_grosso($total_por_unidade, $preco);
            } else {
                return $this->mGestaoStock->pega_total_preco_grosso($idProduto);
            }
        } else {
            return $this->mGestaoStock->pega_total_preco_retalho($idProduto);
        }
    }

    public function inventario($idpr, $quantidade, $dta, $idLoja, $idGrupoPreco) {

        $this->load->model('mStock');
        $consulta = $this->mStock->selecionarIdStock($idpr, $idLoja); // Pega o produto no stock com id passado
        foreach ($consulta as $linha) { // fas a impreção da mesma
            $idStock = $linha->idstock;
        }
        $custo = $this->preco_compra($idGrupoPreco, $idpr);
        $punitario = $custo;

        $novovalorsaidas = $punitario * $quantidade;
        $novovalofinal = $punitario * $quantidade;
        $this->load->model('mInventario'); // carrega o  Modelo
        $this->mInventario->atualizaInventario($idStock, $quantidade, $novovalorsaidas, $novovalofinal, $dta);
        $this->mStock->atualizarValor($idStock, $novovalofinal);
    }

    public function ivaVenda($idproduto) {
        $this->load->model('mArtigos');
        if ($this->mArtigos->produto_isencao($idproduto) == 1) {// SE O TIPO DE ISENÇÃO FOR IGUA A 1 QUER DIZER Q O PRODUTO TEM IVA
            return $this->mArtigos->pegaIvaVenda($idproduto);
        } else {
            return 0;
        }
    }

    public function ivaCompra($idproduto) {
        $this->load->model('ProdutosM');
        if ($this->mArtigos->produto_isencao($idproduto) == 1) {// SE O TIPO DE ISENÇÃO FOR IGUA A 1 QUER DIZER Q O PRODUTO TEM IVA
            return $this->mArtigos->pegaIvaCompra($idproduto);
        } else {
            return 0;
        }
    }

    public function pagamentosParcelados($fatura, $fpagamento, $cash, $tpa) {
        if ($fpagamento == 5) {
            $this->mfaturaM2->regitar_pagamentos_parcelados($fatura, $cash, $tpa);
        }
    }

    public function pagamentosParcelados2($fatura, $fpagamento, $dinheiro, $vrtpa, $ccorrente, $tbancaria) {
        if ($fpagamento == 5) {
            $this->mFatura->regitar_pagamentos_parcelados2($fatura, $dinheiro, $vrtpa, $ccorrente, $tbancaria);
        }
    }

    public function registarFormasPagamento($fatura, $fpagamento, $dinheiro, $vrtpa, $ccorrente, $tbancaria) {
        if ($fpagamento == 5) {
            if ($dinheiro > 0) {
                $this->mFatura->mregistarFormasPagamento($fatura, 1);
            }
            if ($vrtpa > 0) {
                $this->mFatura->mregistarFormasPagamento($fatura, 2);
            }
            if ($ccorrente > 0) {
                $this->mFatura->mregistarFormasPagamento($fatura, 6);
            }
            if ($tbancaria > 0) {
                $this->mFatura->mregistarFormasPagamento($fatura, 7);
            }
        } else {
            $this->mFatura->mregistarFormasPagamento($fatura, $fpagamento);
        }
    }

    public function registaSerie($fatura, $serie) {
        $this->load->model('mempresa');
        if ($this->mempresa->pegaRamoAtividade() == 2 && !empty($serie)) {
            $this->mfaturaM2->grserieFaturaCliente($fatura, $serie);
        }
    }

    public function dadosCliente($idCliente, $idFatura) {
        if ($idCliente != 60) {
            foreach ($this->mClientes->pegaDadosCliente($idCliente) as $linha) {
                $this->mClientes->registaDadosFaturacliente($idFatura, $linha->nome, $linha->localizacao, $linha->fone);
            }
        }
    }

    public function gravaNumeroFaturaFt($ano, $anoAtual, $idFatura) {
        if ($ano == $anoAtual) {
            $numero = $this->mFatura->pegaUltimoNumeroFt() + 1;
            $this->mFatura->gravanumeroFt($idFatura, $numero);
        } else {
            $numero = 1;
            $this->mFatura->gravanumeroFt($idFatura, $numero);
        }
    }

    public function numeroFaturaFt($idFatura) {
        if ($this->mFatura->pegaUltimafaturaFt()) { //se a fatura ja exite
            $ano = $this->mFatura->pegaDataFatura($this->mFatura->pegaUltimafaturaFt());
            $anoAtual = @date('Y');
            $this->gravaNumeroFaturaFt($ano, $anoAtual, $idFatura);
        } else {
            $this->mFatura->gravanumeroFt($idFatura, 1);
        }
    }

    public function gravaNumeroFaturafr($ano, $anoAtual, $idFatura) {
        if ($ano == $anoAtual) {
            $numero = $this->mFatura->pegaUltimoNumeroFr() + 1;
            $this->mFatura->gravanumeroFr($idFatura, $numero);
        } else {
            $numero = 1;
            $this->mFatura->gravanumeroFr($idFatura, $numero);
        }
    }

    public function numeroFaturaFr($idFatura) {
        if ($this->mFatura->pegaUltimafaturaFr() != 0) { //se a fatura ja exite
            $ano = $this->mFatura->pegaDataFatura($this->mFatura->pegaUltimafaturaFr());
            $anoAtual = @date('Y');
            $this->gravaNumeroFaturafr($ano, $anoAtual, $idFatura);
        } else {
            $this->mFatura->gravanumeroFr($idFatura, 1);
        }
    }

    public function associarVendasManuais() {
        $datapagamento = $this->input->post('datapagamento');
        $serie = $this->input->post('serie');
        $numero = $this->input->post('numero');
        $this->load->model('mfaturaM2');
        if ($this->mfaturaM2->numero_fatura_manual($numero) && $this->mfaturaM2->serie_fatura_manual($serie)) {
            $this->json->success('existe');
        } else {
            $this->json->success($this->mfaturaM2->registarVendaManual($datapagamento, $serie, $numero));
        }
    }

    public function irt($idProduto, $idCliente) {
        if ($this->mClientes->tipoCliete($idCliente) == 'Empresa' && $this->mArtigos->classe_produto($idProduto) == 2) {
            return $this->mClientes->pegaIrt(4);
        } elseif ($this->mClientes->tipoCliete($idCliente) == 'Individual' && $this->mArtigos->classe_produto($idProduto) == 2) {
            return $this->mClientes->pegaIrt(3);
        } else {
            return 0;
        }
    }

    public function atualiza_stock($idProduto, $qtd) {
        if ($this->ProdutosM->controlo($idProduto) == 's') {
            $this->StockM->atualizarSubtrairQtd($idProduto, $qtd);
        }
    }

    public function atualiza_stock2($idProduto, $qtd, $idGuia, $dataInvntario, $idLoja) {
        if (!isset($idGuia)) {// se a variavel n#ao existe
            if ($this->StockM->consulta($idProduto)) {
                if ($this->ProdutosM->controlo($idProduto) == 's') {
                    $this->StockM->atualizarSubtrairQtd($idProduto, $qtd, $idLoja);
                    //   $this->inventario($idProduto, $qtd,$dataInvntario);// chama da fucao inventario
                }
            }
        }
    }

    public function arredondar() {
        $this->json->success(round($this->input->post('total')));
    }

    public function acharTotal($desconto, $qtd, $valor) {
        if ($desconto > 0) {
            $desconto1 = ($valor * $desconto) / 100;
            $preco = $valor - $desconto1;
            return $total = $preco * $qtd;
        } else {
            return $total = $valor * $qtd;
        }
    }

    public function listaFaturas() {
        $this->load->model('mfaturaM2');
        $this->load->model('FaturasM');
        foreach ($this->mfaturaM2->mListaFaturas() as $row) {
            if ($this->FaturasM->tipoVenda($row->fatura) == 1) {
                $tipoVenda = 'FT';
                $numero = $this->FaturasM->pegaNumeroFtPorIdFatura($row->fatura);
            } else {
                $tipoVenda = 'FR';
                $numero = $this->FaturasM->pegaNumeroFrPorIdFatura($row->fatura);
            }
            $serie = $this->mfaturaM2->serie($row->fatura);
            $data = array(
                'idFatura' => $row->fatura,
                'fatura' => $tipoVenda . ' ' . $serie . '/' . $numero,
            );
            $response['results'][] = $data;
        }
        echo json_encode($response);
    }

    public function listaProdutosFaturas() {
        $idFatura = $this->input->get('idFatura');
        $idProduto = $this->input->get('idProduto');
        $this->load->model('mfaturaM2');

        foreach ($this->mfaturaM2->mListaProdutosFaturas($idFatura, $idProduto) as $row) {
            $data = array(
                'idFatura' => $row->fatura,
                'idProduto' => $row->idpr,
                'produto' => $row->produto,
                'preco' => $row->custo,
                'total' => $row->total,
                'qtd' => $row->qtd,
            );
            $response['results'][] = $data;
        }
        echo json_encode($response);
    }

    public function listaProdutosFaturasAnular() {
        $idFatura = $this->input->get('idFatura');
        $this->load->model('mFatura');
        $lista = $this->mFatura->mListaProdutosFaturasAnular($idFatura);
            $data =array();
            foreach ($lista as $row) {
                $data[] = array(
                    'idProduto' => $row->idpr,
                    'produto' => $row->produto,
                );
            }
        echo json_encode($data);
    }

    public function totalAGrosso($fatura) {// calcula  o total a grosso
        $subtotal = 0;
        $totalDescontos = 0;
        $totalIva = 0;
        $this->load->model('mIva');
        foreach ($consuta = $this->FaturasM->imprimir_vendas($fatura) as $linha) {
            $idproduto = $linha->idpr;
            $qtd = $linha->qtd;
            $custo = $linha->custo;
            $desconto = $this->calcuralDesconto($linha->desconto, $qtd, $custo);
            $total = $this->acharTotal($linha->desconto, $qtd, $custo);
            $totalDescontos = $totalDescontos + $desconto;
            $subtotal = $subtotal + $total;
            $iva = $this->mIva->calculo_iva($total, $idproduto); // valor convertido em formato de moeda
            $ivaInt = $this->mIva->calculo_iva_int($total, $idproduto);
            $totalIva = $totalIva + $ivaInt;
            //  $totalSemDesconto=$custo*$qtd;
            //    $totalSemDescontoGera=$totalSemDescontoGera+$totalSemDesconto;
        }
        return number_format($totalGeral = $totalIva + $subtotal, 2);
    }

    public function gerarHash($fatura, $tipoVenda) { // gera a assinatura digital para as faturas
        if ($tipoVenda == 1) {
            $numero = $this->mFatura->pegaNumeroFtPorIdFatura($fatura);
            $idFatura = $this->mFatura->pegaUltimafaturaFTPorNumero($numero);
        } else {
            $numero = $this->mFatura->pegaNumeroFrPorIdFatura($fatura);
            $idFatura = $this->mFatura->pegaUltimafaturaFrPorNumero($numero);
        }

        $this->load->model('mCalculoTotalCrdito');
        $this->load->model('mRsa');
        $stipoVenda = $this->mFatura->tipoVenda($fatura);
        $inVoiceDate = $this->mFatura->inVoiceDate($fatura);
        $systemEntrydate = $this->mFatura->systemEntryate($fatura);
        $grossTotal = $this->mFatura->grossTotal($fatura);
        //   $grossTotal= $this->totalAGrosso($fatura);
        $serie = $this->mFatura->serie($fatura);
        $inVoiceNo = $stipoVenda . ' ' . $serie . '/' . $numero;
        if ($tipoVenda == 1 && $this->mFatura->contarRegistosFaturaFt() > 1) {// se ja existe mas de uma  venda com a fatura ft
            //pega o hash da ultima fatura
            $hasUltimo = $this->mFatura->hash_da_ultima_fatura($fatura, $tipoVenda);
            $registo = $inVoiceDate . ';' . $systemEntrydate . ';' . $inVoiceNo . ';' . $grossTotal . ';' . $hasUltimo;
        } elseif ($tipoVenda == 2 && $this->mFatura->contarRegistosFaturaFr() > 1) { // ou se ja existe mas de uma  venda com a fatura fr
            //pega o hash da ultima fatura
            $hasUltimo = $this->mFatura->hash_da_ultima_fatura($fatura, $tipoVenda);
            $registo = $inVoiceDate . ';' . $systemEntrydate . ';' . $inVoiceNo . ';' . $grossTotal . ';' . $hasUltimo;
        } else {
            //
            $registo = $inVoiceDate . ';' . $systemEntrydate . ';' . $inVoiceNo . ';' . $grossTotal . ';';
        }
        $priv_key = file_get_contents('./ChavePrivada/ChavePrivada.pem');
        $key = openssl_get_privatekey($priv_key);
        $ignature = '';
        openssl_sign($registo, $ignature, $key, OPENSSL_ALGO_SHA1);
        $registoHash = base64_encode($ignature);
        $control1 = $registoHash[0];
        $control2 = $registoHash[10];
        $control3 = $registoHash[20];
        $control4 = $registoHash[30];

        $hasControl = $control1 . '' . $control2 . '' . $control3 . '' . $control4;
        $this->mFatura->matualizar_hash($fatura, $registoHash, $hasControl);
    }

    public function listaVendasPendentes() {

        $this->load->model('mfaturaM2');
        if ($this->mfaturaM2->mlistaVendaPendentes()) {
            foreach ($this->mfaturaM2->mlistaVendaPendentes()as $row) {


                $imprimir[] = array(
                    'id' => $row->id,
                    'nome' => $row->nome,
                    'data' => $row->data,
                );
                $total = count($this->mfaturaM2->mlistaVendaPendentes());
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listaVendasPendentesItem() {
        $idPendente = $this->input->get('idPendente');
        $this->load->model('mfaturaM2');
        $totalGeral = 0;
        if ($this->mfaturaM2->mlistaVendaPendentesItem($idPendente)) {
            foreach ($this->mfaturaM2->mlistaVendaPendentesItem($idPendente)as $row) {
                $totalGeral = $totalGeral + $row->total;
                $imprimir[] = array(
                    'idpendente' => $row->idpendente,
                    'idpr' => $row->idpr,
                    'produto' => $row->produto,
                    'qtd' => $row->qtd,
                    'desconto' => $row->desconto,
                    'custo' => $row->custo,
                    'total' => $row->total,
                    'totalGeral' => $totalGeral,
                    'cliente' => $row->nome,
                    'idcliente' => $row->idcliente,
                    'total_pendente' => $row->total_pendente,
                    'iva' => $row->iva,
                );
                $total = count($this->mfaturaM2->mlistaVendaPendentesItem($idPendente));
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function apagaVendaPendente() {
        $idPendente = $this->input->post('idPendente');
        $this->load->model('mfaturaM2');
        $this->mfaturaM2->mapagarVendasPendentes($idPendente);
    }

    public function finalizaVendaPendente($idPendente) {
        $this->load->model('mfaturaM2');
        $this->mfaturaM2->mFinalizaVendePendente($idPendente);
    }

    public function alterarVendaPendente($idPendente) {
        $this->load->model('mfaturaM2');
        $this->mfaturaM2->malterarVendePendente($idPendente);
    }

    public function gravar_serie() {// grava a nota maxima permitida em um arquivo de texto 
        $arquivo = "serie.txt";
        //Variável $fp armazena a conexão com o arquivo e o tipo de ação.
        $fp = fopen($arquivo, "w");
        //Escreve no arquivo aberto.
        $texto = $this->input->post('serieFact');
        fwrite($fp, $texto);
        //Fecha o arquivo.
        fclose($fp);
        $this->json->success('OK');
    }

    public function pegar_serie() {// abre a nota maxima permitida em um arquivo de texto 
        $arquivo = "serie.txt";
        //Variável $fp armazena a conexão com o arquivo e o tipo de ação.
        $fp = fopen($arquivo, "r");
        //Lê o conteúdo do arquivo aberto.
        $conteudo = fread($fp, filesize($arquivo));
        //Fecha o arquivo.
        fclose($fp);
        $dados[] = array('serieDoc' => $conteudo);
        $json = json_encode($dados);
        echo $resposta = '{success: true, total:1, data:' . $json . '}';
    }

    public function abre_serie_fatura() {// 
        $arquivo = "serie.txt";
        //Variável $fp armazena a conexão com o arquivo e o tipo de ação.
        $fp = fopen($arquivo, "r");
        //Lê o conteúdo do arquivo aberto.
        $conteudo = fread($fp, filesize($arquivo));
        //Fecha o arquivo.
        fclose($fp);
        //retorna o conteúdo.
        return $conteudo;
    }

    public function imprimirConsultaMesa() {
        $idPendente = $this->input->post('idPendente');
        $this->load->model('mConsultaMesa');
        $this->mConsultaMesa->imprimirConsultaMesaPDF($idPendente);
        $this->json->success('OK');
    }

    public function testetarHora() {
        //  date_default_timezone_set('Angola/Luanda');
        $this->load->model('mfaturaM2');
        echo $dataComputador = date('Y-m-d H:i:s');
        $ultimaDta = $this->mfaturaM2->retornaUltimaDataHora();
        if (strtotime($dataComputador) >= strtotime($ultimaDta)) {
//             echo'maior'; 
//          } else {
//              echo'menor';  
        }
    }

    public function corrinho_mesas_restaurante() {// 
        $total = $this->input->post('total');
        $custo = $this->input->post('custo');
        $idProduto = $this->input->post('idProduto');
        $desconto = $this->input->post('desconto');
        $iva = $this->input->post('iva');
        $qtd = $this->input->post('qtd');
        $idVenda = $this->input->post('idVenda');
        $this->load->model('mfaturaM2');
        $this->mfaturaM2->atualizarTotalGeral($idVenda, $total);

        if ($this->mfaturaM2->verificarItemCarrinho($idVenda, $idProduto) > 0) {
            $this->mfaturaM2->atualizarTotalQtd($idVenda, $total, $idProduto, $qtd);
        } else {
            $this->mfaturaM2->registaItemCarrinho($idVenda, $idProduto, $qtd, $desconto, $custo, $total, $iva);
        }
        $this->json->success('ok');
    }

    public function pega_unidade_medida($idGrupoPreco, $idProduto) {
        if ($this->mGestaoStock->tipo_grupo($idGrupoPreco) == 'gr') {
            return $this->mGestaoStock->mpega_unidade_medida($idProduto);
        } else {
            return $this->mArtigos->pega_unidade_medida($idProduto);
        }
    }

    public function corrinho() {// 
        $total = $this->input->post('total');
        $custo = $this->input->post('custo');
        $idProduto = $this->input->post('idProduto');
        $desconto = $this->input->post('desconto');
        $iva = $this->input->post('iva');
        $qtd = $this->input->post('qtd');
        $imei = $this->input->post('imei');
        $sim = $this->input->post('sim');
        $idVenda = $this->input->post('idVenda');
        $action = $this->input->post('action');
        $iditem = $this->input->post('iditem');
        $idGrupoPreco = $this->input->post('idGrupoPreco');
        $this->load->model('mFatura');
        $this->load->model('mGestaoStock');
        $this->load->model('mArtigos');
        if ($action == 'editar') {
            $this->atualizar_item_carrinho($idVenda, $qtd, $desconto, $custo, $total, $iva, $idGrupoPreco, $iditem);
            echo json_encode('OK');
        } else {
            $idUnidade = $this->pega_unidade_medida($idGrupoPreco, $idProduto);
            $this->mFatura->atualizarTotalGeralCarrinha($idVenda, $total);
            $this->mFatura->registaItemCarrinho2($idVenda, $idProduto, $qtd, $desconto, $custo, $total, $iva, $idGrupoPreco);
            $this->registaImei($idVenda, $idProduto, $imei);
            $this->registaNumeroSim($idVenda, $idProduto, $sim);

//        }
            echo json_encode('OK');
        }
    }

    public function atualizar_item_carrinho_restauracao_retalho() {
        $idVenda = $this->input->post('idVenda');
        $qtd = $this->input->post('qtd');
        $desconto = $this->input->post('desconto');
        $custo = $this->input->post('custo');
//        $total = $this->input->post('total');
        $iva = $this->input->post('iva');
        $iditem = $this->input->post('iditem');
        $total = $qtd * $custo;
        $idGrupoPreco = $this->input->post('idGrupoPreco');
        $this->load->model('mfaturaM2');
        $totalBd = $this->mfaturaM2->total_geral_id_venda($idVenda);
        $totalItem = $this->mfaturaM2->total_item($iditem);
        $this->mfaturaM2->alterarTotalCarinho($idVenda, $totalBd - $totalItem);
        $this->mfaturaM2->atualizarTotalGeralCarrinha($idVenda, $total);
        $this->mfaturaM2->alterarItemCarinho($iditem, $qtd, $desconto, $custo, $total, $iva, $idGrupoPreco);
        $this->json->success('ok');
    }

    public function atualizar_item_carrinho($idVenda, $qtd, $desconto, $custo, $total, $iva, $idGrupoPreco, $iditem) {
        $totalBd = $this->mFatura->total_geral_id_venda($idVenda);
        $totalItem = $this->mFatura->total_item($iditem);
        $this->mFatura->alterarTotalCarinho($idVenda, $totalBd - $totalItem);
        $this->mFatura->atualizarTotalGeralCarrinha($idVenda, $total);
        $this->mFatura->alterarItemCarinho($iditem, $qtd, $desconto, $custo, $total, $iva, $idGrupoPreco);
//        $this->load->model('mMesas');
//        $this->json->success( $this->mMesas->mAbreMesa($idUsuario,$idMesa));          
    }

    public function abrirMesa() {
        $idMesa = $this->input->post('idMesa');
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mMesas');
        $idVenda = $this->mMesas->mNovaVendaMesa($idUsuario);
        $this->mMesas->abreMesa($idVenda, $idMesa);
        $this->json->success($idVenda);
    }

    public function registaImei($idVenda, $idpr, $imei) {
        if ($imei != '') {
            $this->load->model('ProdutosM');
            $this->ProdutosM->mRegistaImeil($idVenda, $idpr, $imei);
        }
    }

    public function registaNumeroSim($idVenda, $idpr, $sim_numero) {
        if ($sim_numero != '') {
            $this->load->model('ProdutosM');
            $this->ProdutosM->mRegistaSim($idVenda, $idpr, $sim_numero);
        }
    }

    public function novoDocumento() {
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mFatura');
        echo json_encode($this->mFatura->mNovaDocumento($idUsuario));
    }

    public function removeItemCarrinha() {// Remove os item da carrinha de venda para restaurante
        $iditem = $this->input->post('iditem');
        $this->load->model('mfaturaM2');
        $total = $this->mfaturaM2->tota_por_linha($iditem);
        $idVenda = $this->mfaturaM2->idVenda2($iditem);
        if ($this->mfaturaM2->contarNumerosItemRestaurante($idVenda) < 2) {
            $this->mfaturaM2->cancelarVendaRestaurante($idVenda);
            $this->json->success('cancelada');
        } else {
            if ($this->mfaturaM2->mremoveItemCarrinha($iditem)) {
                $this->mfaturaM2->subtrairTotalGeral($idVenda, $total);
                $this->json->success('ok');
            }
        }
    }

    public function removeItemCarrinha2() {
        $iditem = $this->input->post('iditem');
        $this->load->model('mFatura');
        $total = $this->mFatura->tota_por_linha2($iditem);
        $idVenda = $this->mFatura->idVenda3($iditem);
        $idProduto = $this->mFatura->idProdutoByItem($iditem);
        $qtd = $this->mFatura->qtdByItem($iditem);
        $idUsuario = $this->mFatura->idUsuario($idVenda);
        $this->mFatura->registarItemEscluidos($idProduto, $qtd, $total, $idUsuario);
        $this->mFatura->contarNumerosItemBalcao($idVenda);
        if ($this->mFatura->contarNumerosItemBalcao($idVenda) < 2) {
            $this->mFatura->cancelarVendam($idVenda);
            echo json_encode('cancelada');
        } else {
            if ($this->mFatura->mremoveItemCarrinha2($iditem)) {
                $this->mFatura->subtrairTotalGeral2($idVenda, $total);
                echo json_encode('ok');
            }
        }
    }

    public function pega_qtd($idpr, $idLoja) {// 
        $this->db->select('qtd');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idpr);
        $this->db->where('idArmaze', $idLoja);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function listaItemCarrinho2() {

        $idVenda = $this->input->post('idVenda');
        $idLoja = $this->input->post('idLoja');
        $idMesa = $this->input->post('idMesa');
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mFatura');
        $data = array();
        $totalLinha = count($this->mFatura->mlistaItemCarrinhoMesa2($idVenda, $idMesa, $idUsuario));
        $unidadeProdutos = $this->mFatura->tota_qtd2($idVenda);
        $totalGeral = $this->mFatura->total_geral_id_venda($idVenda);
        foreach ($this->mFatura->mlistaItemCarrinhoMesa2($idVenda, $idMesa, $idUsuario)as $row) {

            $stock = $this->pega_qtd($row->idpr, $idLoja);
            $data[] = array(
                'produto' => $row->produto,
                'custo' => $row->custo,
                'desconto' => $this->mFatura->pegaDescontoItemCarrinho($row->idVenda, $row->iditem),
                'qtd' => $row->qtd,
                'iva' => $row->iva,
                'total' => $row->total,
                'idProduto' => $row->idpr,
                'stock' => $stock,
                'idTipo' => $row->idTipo,
                'idItem' => $row->iditem
            );
        }
        echo json_encode(array(
            "draw" => 1,
            "totalLinha" => $totalLinha . ' Produtos' . ' / ' . $unidadeProdutos . ' Unid',
            "totalLinha2" => $totalLinha,
            "recordsTotal" => 1,
            "recordsFiltered" => 1,
            "totalGeral" => $totalGeral,
            "data" => $data
        ));
    }

    public function documentosPorFinalizar() {
        $this->load->model('mFatura');
        $total = $this->mFatura->contaDocumentosPorFinalizar();
        $data = array();
        foreach ($this->mFatura->mlistaItemCarrinhoPorFinalizar()as $row) {
            $idVenda = $row->idVenda;
            $unidadeProdutos = $this->mFatura->tota_qtd2($idVenda);
            $totalLinha = $this->mFatura->contarNumerosLinhas($idVenda);
            $data[] = array(
                'totalGeral' => $row->total_geral,
                'totalLinha' => $totalLinha . ' Pr' . ' / ' . $unidadeProdutos . ' Unid',
                'idVenda' => $idVenda,
                'idProduto' => $row->idpr,
            );
        }
        echo json_encode(array(
            "draw" => 1,
            "recordsTotal" => $total,
            "recordsFiltered" => 1,
            "data" => $data
        ));
    }

//     public function detalhesDocumento() {
//       $idVenda = $this->input->post('idVenda');
//        $consulta = $this->mFatura->mdetalhesDocumento();
//        $data = array();
//        foreach ($consulta as $row) {
//            $data = array(
//                'produto' => $row->produto,
//                'quantidade' => $row->qtd,
//                'preco' => $row->preco,
//                'subtotal' => $row->subtotal,
//            );
//        }
//        return $data;
//    }
    public function detalhesDocumento() {
        $idVenda = $this->input->post('idVenda');
        $this->load->model('mFatura');
        $consulta = $this->mFatura->mdetalhesDocumento($idVenda); // Passa o idVenda para filtrar os dados
        $data = array();

        foreach ($consulta as $row) {
            $data[] = array(
                'produto' => $row->produto,
                'quantidade' => $row->qtd,
                'preco' => $row->custo,
                'total' => $row->total // Calcula o subtotal aqui
            );
        }
        echo json_encode($data);
    }

    public function consultaMesa() {
        $idVenda = $this->input->post('idVenda');
        $this->load->model('mfaturaM2');
        if ($this->mfaturaM2->verifica_idVenda_mesa($idVenda) > 0) {
            $this->load->model('mConsultaMesa2');
            $this->mConsultaMesa2->imprimirConsultaMesaPDF2($idVenda);
            $this->json->success('OK');
        } else {
            $this->load->model('mConsultaContaBalcao');
            $this->mConsultaContaBalcao->imprimirConsultaContaPDF2($idVenda);
            $this->json->success('OK');
        }
    }

    public function registaSaidaSaldoCliente($idTipoPagamento, $totalgeral, $idCliente) {

        $this->load->model('mContaCliente');
        if ($idTipoPagamento == 8) {
            $this->mContaCliente->pagamentoMercadoria($idCliente, $totalgeral);
        }
    }

    public function se_tem_control_stock($idProduto, $qtd, $dataInvntario, $idLoja, $idGrupoPreco) {
        if ($this->mArtigos->controlo($idProduto) == 's') {
            if ($this->mGestaoStock->tipo_grupo($idGrupoPreco) == 'gr') {
                $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idProduto);
                $qtdTotal = $qtd * $total_por_unidade;
                $this->mStock->atualizarSubtrairQtd($idProduto, $qtdTotal, $idLoja);
                $this->inventario($idProduto, $qtdTotal, $dataInvntario); // chama da fucao inventario 
            } else {
                $this->mStock->atualizarSubtrairQtd($idProduto, $qtd, $idLoja);
                $this->inventario($idProduto, $qtd, $dataInvntario, $idLoja, $idGrupoPreco); // chama da fucao inventario 
            }
        }
    }

    public function se_stock_existe($idProduto, $qtd, $dataInvntario, $idLoja, $idGrupoPreco) {
        if ($this->mStock->consulta($idProduto)) { // se o prduto possui stock
            $this->se_tem_control_stock($idProduto, $qtd, $dataInvntario, $idLoja, $idGrupoPreco);
        }
    }

    public function atualiza_stock3($idProduto, $qtd, $idGuia, $dataInvntario, $idLoja, $idGrupoPreco) {
        if (!isset($idGuia)) {// se a variavel n#ao existe
            $this->se_stock_existe($idProduto, $qtd, $dataInvntario, $idLoja, $idGrupoPreco);
        }
    }

    public function finalizarDocsFatura() {
        date_default_timezone_set('Africa/Luanda');
        ini_set('memory_limit', '256M');
        ini_set('upload_max_filesize', '20M');
        ini_set('download_max_filesize', '20M');
        ini_set('post_max_size', '20M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);
        ini_set('max_input_time', '2000');
        $idTipoDocumento = $this->input->post('idTipoDocumento');
        $idTipoPagamento = $this->input->post('idTipoPagamento');
        $idCliente = $this->input->post('idCliente');
        $entidade = $this->input->post('entidade');
        if ($idCliente == 0 && empty($entidade)) {
            $idCliente = 60;
        }
        if ($idCliente == 0 && !empty($entidade)) {
            $this->load->model('mClientes');
            $idCliente = $this->mClientes->registarclM2($entidade);
        }
        $dinheiro = $this->input->post('dinheiro');
        $vrtpa = $this->input->post('vrtpa');
        $tbancaria = $this->input->post('tbancaria');
        $datapagamento = $this->input->post('datapagamento');
        $descontoGlobal = $this->input->post('descontoGlobal');
        if ($idTipoDocumento == 1) {
            $idTipoPagamento = 4;
        }
        $idUsuario = $this->input->post('idUsuario');
        $idcaixa = $this->input->post('idcaixa');
        $valorRecebido = $this->input->post('valorRecebido');
        $troco = $this->input->post('troco');
        $totalgeral = $this->input->post('totalgeral');
        $idVenda = $this->input->post('idVenda');
        $idMesa = $this->input->post('idMesa');
        $idGuia = $this->input->post('idGuia');
        $idLoja = $this->input->post('idLoja');
        $idDocManual = $this->input->post('idDocManual');

        $idVendaOrigemGR = $this->input->post('idVendaOrigemGR');
        $idGuiaReme = $this->input->post('idGuiaReme');
        $idLoja = $this->input->post('idLoja');
        $tatus = 'ativa';
        $tipo = 'SAIDA';
        $dataComputador = date('Y-m-d H:i:s');
        $dataInvntario = date('Y-m-d');
        $this->load->model('mFatura');
        $this->load->model('mStock');
        $this->load->model('mInventario');
        $this->load->model('mhistorico');
        $this->load->model('mMoeda');
        $this->load->model('mIva');
        $this->load->model('mClientes');
        $this->load->model('mArtigos');
        $this->load->model('mGestaoStock');
        $idMoeda = $this->mMoeda->id_moeda_em_uso();
        //   $dta=$this->InventarioM->consultDataInv($dataInvntario); //verifica o inventario
        $idFatura = 0;
        $ultimaDta = $this->mFatura->retornaUltimaDataHora();
        if (strtotime($dataComputador) >= strtotime($ultimaDta)) {
//
//
            $idFatura = $this->mFatura->registarVenda($idUsuario, $idCliente, $totalgeral, $tatus, $idTipoPagamento, $idTipoDocumento, $idcaixa, $idMoeda, $descontoGlobal, $valorRecebido, $idLoja);
            $this->registaSaidaSaldoCliente($idTipoPagamento, $totalgeral, $idCliente);
//
//            if (!empty($idDocManual)) {
//                $this->mfaturaM2->associarVendaFaturaManual($idDocManual, $fatura); // ASSOCIAR VENDA FATURA MANUAL
//            }
            $idDocumentoEmitido = $this->mFatura->registar_documentos_emitidos($idTipoDocumento, $idVenda);
            $this->mFatura->registar_docs_ft_fr($idFatura, $idDocumentoEmitido);
//            if (!empty($idVendaOrigemGR)) {
//                $this->load->model('mGuiaRemessa');
//                $this->mGuiaRemessa->alterarEstadoGuia($idGuiaReme);
//                $this->mGuiaRemessa->registarGuiaRemessaFaturaConsignadas($idGuiaReme, $fatura);
//            }
//
            $this->pagamentosParcelados2($idFatura, $idTipoPagamento, $dinheiro, $vrtpa, 0, $tbancaria);
            $this->registarFormasPagamento($idFatura, $idTipoPagamento, $dinheiro, $vrtpa, 0, $tbancaria);
            $this->dadosCliente($idCliente, $idFatura);
            $erie = $this->abre_serie_fatura();
            $this->mFatura->grava_serie($idFatura, $erie);
            if ($idTipoDocumento == 1) {
                $this->numeroFaturaFt($idFatura);
            } else {
                $this->numeroFaturaFr($idFatura);
            }
            $this->registarProdutosItemCarrinho($idCliente, $idFatura, $idVenda, $dataInvntario, $tipo, $idGuia, $idLoja, $idTipoDocumento, $idTipoPagamento, $totalgeral, $idUsuario, $datapagamento);
//
//            if (!empty($idMesa)) {
//                $this->mfaturaM2->atualizarEstadoCarrinhoMesas($idVenda);
//            }
//
            $saida = array(
                "idFatura" => $idFatura,
                "msg" => 'OK',
            );
            echo json_encode($saida);
        } else {
            $saida = array(
                "idFatura" => 0,
                "msg" => 'INV',
            );
            echo json_encode($saida);
        }
    }

    public function registarProdutosItemCarrinho($idCliente, $fatura, $idVenda, $dataInvntario, $tipo, $idGuia, $idLoja, $tipoVenda, $fpagamento, $totalgeral, $idusuario, $datapagamento) {
        foreach ($this->mFatura->itemCarrinho($idVenda)as $value) {
            $idProduto = $value->idpr;
            $valor = $value->custo;
            $iditem = $value->iditem;
            $qtd = $value->qtd;
            $idGrupoPreco = $value->idGrupoPreco;
            $idUnidade = $value->idUnidade;
            $desconto = $this->mFatura->pegaDescontoItemCarrinho($idVenda, $iditem);
            $this->regitarImeiProdutoFatura($fatura, $idVenda, $idProduto);
            $this->regitarSimProdutoFatura($fatura, $idVenda, $idProduto);
            $irt = $this->irt($idProduto, $idCliente);
            $ivaVenda = $this->ivaVenda($idProduto);
            $total = $this->acharTotal($desconto, $qtd, $valor);
            $this->mFatura->itemfatura($fatura, $idProduto, $valor, $desconto, $qtd, $total, $ivaVenda, $irt, $idUnidade);
            $this->atualiza_stock3($idProduto, $qtd, $idGuia, $dataInvntario, $idLoja, $idGrupoPreco);
            $this->mhistorico->registarHistorico($tipo, $idProduto, $qtd);
        }
        $this->registarEntrada($tipoVenda, $fpagamento, $totalgeral, $idusuario, $idCliente); // chama a função para registar o movimento de entrada
        $this->registarSaldoConta($tipoVenda, $fpagamento, $totalgeral); // chama a função para registar o saldo na respectiva conta
        $this->registarVendasCredito($tipoVenda, $idCliente, $datapagamento, $totalgeral, $fatura);
        $this->gerarHash($fatura, $tipoVenda);
        $this->mFatura->atualizarEstadoCarrinho($idVenda);
    }

    public function regitarImeiProdutoFatura($idFatura, $idVenda, $idProduto) {

        if ($this->mFatura->consulta_emei_produto($idVenda, $idProduto)) {
            foreach ($this->mFatura->listaImeii($idVenda, $idProduto) as $value) {
                $idpr = $value->idpr;
                $imei = $value->imei;
                $this->mFatura->mRegistaImeil($idFatura, $idpr, $imei);
            }
        }
    }

    public function regitarSimProdutoFatura($idFatura, $idVenda, $idProduto) {
        if ($this->mFatura->consulta_sim_produto($idVenda, $idProduto)) {
            foreach ($this->mFatura->listaSim($idVenda, $idProduto) as $value) {
                $idpr = $value->idpr;
                $sim_numero = $value->sim_numero;
                $this->mFatura->mRegistaSim($idFatura, $idpr, $sim_numero);
            }
        }
    }

    public function cancelarDocumento() {
        $idVenda = $this->input->post('idVenda');
        $this->load->model('mFatura');
        if ($this->mFatura->cancelarVendam($idVenda)) {
            echo json_encode('OK');
        }
    }

    public function consultaContaBalcao() {
        $idVenda = $this->input->post('idVenda');
        $this->load->model('mConsultaContaBalcao');
        $this->mConsultaContaBalcao->imprimirConsultaContaPDF2($idVenda);
        $this->json->success('OK');
    }

    public function listaUsuarioCaixa() {
        $cont = 0;
        $data = array();
        $data1 = array();
        $this->load->model('mfaturaM2');
        foreach ($this->mfaturaM2->mListaUsuarioCaixa()as $value) {
            $usuario = $value->usuario;
            $idUsuario = $value->id_usiario;
            $data[] = array(
                'usuario' => $usuario,
                'idUsuario' => $idUsuario,
            );
            $total = 1;
        }
        $data1[] = array('usuario' => "Todos Usuarios", 'idUsuario' => 0);
        $arr = array_merge($data1, $data);
        $ados = json_encode($arr);
        $resposta = '{success: true, total:' . $total . ',results:' . $ados . '}';
        echo $resposta;
    }

    public function listaLojas() {
        $cont = 0;
        $this->load->model('mfaturaM2');
        $data = array();
        $data1 = array();
        foreach ($this->mfaturaM2->mListaLojas()as $value) {
            $narmanze = $value->narmanze;
            $idLoja = $value->idLoja;

            $cont++;
            $data[] = array(
                'narmanze' => $narmanze,
                'idLoja' => $idLoja,
            );
            $total = 1;
        }
        $data1[] = array('narmanze' => "Todos os Armanzes", 'idLoja' => 0);
        $arr = array_merge($data1, $data);
        $ados = json_encode($arr);
        $resposta = '{success: true, total:' . $total . ',results:' . $ados . '}';
        echo $resposta;
    }

    public function imprimeResumoVendas() {
        $dataminima = $this->input->post('dataminima');
        $datamaxima = $this->input->post('datamaxima');
        $idLoja = $this->input->post('idLoja');
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mResumoVendas');
        $this->mResumoVendas->imprimirResumoVendasPDF($dataminima, $datamaxima, $idLoja, $idUsuario);
        $this->json->success('OK');
    }

    public function imprimeResumoVendasPorFuncionario() {
        ini_set('memory_limit', '256M');
        ini_set('upload_max_filesize', '20M');
        ini_set('download_max_filesize', '20M');
        ini_set('post_max_size', '20M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);
        $dataminima = $this->input->post('dataminima');
        $datamaxima = $this->input->post('datamaxima');
        $idResumo = $this->input->post('idResumo');
        $idUsuario = $this->input->post('idUsuario');
        if ($idResumo == 1) {
            $this->load->model('mResumoVendasOperadorDocumentos');
            $this->mResumoVendasOperadorDocumentos->imprimirResumoVendasPDF($dataminima, $datamaxima, $idUsuario);
        } else {
            $this->load->model('mResumoVendasOperadorDivisoes');
            $this->mResumoVendasOperadorDivisoes->imprimirResumoVendasDivisoesPDF($dataminima, $datamaxima, $idUsuario);
        }
        $this->json->success('OK');
    }

    public function pegaIdVenda() {
        $idFatura = $this->input->get('idFatura');
        $this->load->model('mfaturaM2');
        $idDocumentoEmitido = $this->mfaturaM2->pega_idDocumentoEmitido($idFatura);
        $data = array('idVenda' => $this->mfaturaM2->p_idVenda($idDocumentoEmitido));
        $response['results'][] = $data;
        echo json_encode($response);
    }

    public function cImprimirResuVendaArtigo() {
        $dataminima = $this->input->post('dataminima');
        $datamaxima = $this->input->post('datamaxima');
        $idCategoria = $this->input->post('idCategoria');
        $this->load->model('mResumoVendasArtigo');
        $this->mResumoVendasArtigo->imprimirResumoVendasArtigoPDF($dataminima, $datamaxima, $idCategoria);
        $this->json->success('OK');
    }

    public function transfereContaMesas() {// tota de credito parcial
        $idVenda = $this->input->post('idVenda');
        $idMesa = $this->input->post('idMesa');
        $itemsTransferir = $this->input->post('itemsanular');
        $array = explode(',', $itemsTransferir);
        $this->load->model('mfaturaM2');
        $this->load->model('mMesas');
        $idVendaDestino = $this->mMesas->idVendaDestino($idMesa);
        foreach ($array as $idItem) {
            $idItem;
            $idProduto = $this->mfaturaM2->idProdutoByItem($idItem);
            $qtd = $this->mfaturaM2->qtdByItem($idItem);
            $custo = $this->mfaturaM2->custoByItem($idItem);
            $iva = $this->mfaturaM2->ivaByItem($idItem);
            $total = $this->mfaturaM2->tota_por_linha2($idItem);
            $idVendaDestino = $this->mMesas->idVendaDestino($idMesa);
            $this->mfaturaM2->mremoveItemCarrinha2($idItem);
            $this->mfaturaM2->subtrairTotalGeral2($idVenda, $total);
            if ($this->mfaturaM2->contaIdProduto($idVenda, $idProduto) > 0) {
                $this->mfaturaM2->atualizarTotalQtd2($idVendaDestino, $total, $idProduto, $qtd, 2);
                $this->mfaturaM2->atualizarTotalGeralCarrinha($idVendaDestino, $total);
                $this->json->success('OK');
            } else {
                $this->mfaturaM2->atualizarTotalGeralCarrinha($idVendaDestino, $total);
                $this->mfaturaM2->registaItemCarrinho2($idVendaDestino, $idProduto, $qtd, 0, $custo, $total, $iva, 1);
                $this->json->success('OK');
            }
        }
    }

    public function grafico_tota_mes_por_fatura() {
        $this->load->model('mDashBoardCompras');
        $this->load->model('mfaturaM2');
        $totalFr = 0;
        $totalFt = 0;
        if ($this->mDashBoardCompras->pegaMeses()) {
            foreach ($this->mDashBoardCompras->pegaMeses() as $linha) {
                $idMes = $linha->idMes;
                $mes = $linha->mes;
                $totalFr = $this->mfaturaM2->grafico_tota_mes_por_fatura_fr($idMes);
                $totalFt = $this->mfaturaM2->grafico_tota_mes_por_fatura_ft($idMes);

                $dados[] = array(
                    'mes' => $mes,
                    'totalFr' => $totalFr,
                    'totalFt' => $totalFt,
                );

                $total = 12;

                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function grafico_tota_mes() {
        $this->load->model('mDashBoardCompras');
        $this->load->model('mfaturaM2');
        $totaFaturas = 0;
        $totalFt = 0;
        if ($this->mDashBoardCompras->pegaMeses()) {
            foreach ($this->mDashBoardCompras->pegaMeses() as $linha) {
                $idMes = $linha->idMes;
                $mes = $linha->mes;
                $totaFaturas = $this->mfaturaM2->mgrafico_tota_mes($idMes);

                $dados[] = array(
                    'mes' => $mes,
                    'totaFaturas' => $totaFaturas,
                );

                $total = 12;

                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function calcularIva($idFatura) {
        $totalIva = 0;
//         $taxa= $this->ProdutosM->pegaIvaVenda($idproduto);
//              $iva=$custo*$taxa/100;
        foreach ($this->mFatura->mlista_item_por_fatura($idFatura)as $linha) {
            $custo = $linha->custo;
            $qtd = $linha->qtd;
            $idproduto = $linha->idpr;
            $total = $this->acharTotal($linha->desconto, $qtd, $custo);
            $ivaInt = $this->MIva->calculo_iva_int($total, $idproduto);
            $totalIva = $totalIva + $ivaInt;
        }
        return $totalIva;
    }

    public function listarDocsFatura() {
        ini_set('memory_limit', '256M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);
        $searchValue = ('pesquisa');
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start'); // Offset para paginação
        $dataInicial = $this->input->post('startDate'); // Offset para paginação
        $dataFinal = $this->input->post('endDate'); // Offset para paginação
        $anuladas = $this->input->post('ativo'); // Offset para paginação
        $this->load->model('mFatura');
        $this->load->model('MIva');
        $this->load->model('MEmpresa');
        
        $subtotal = 0;
        $totalGeral = 0;
        $credito = 0;
        $debito = 0;
        $data = array();
        $totalFiltrafo=$this->mFatura->obter_total_registos_filtrados_faturas($dataInicial, $dataFinal, $searchValue, $anuladas);
        foreach ($this->mFatura->mlista_documentos_faturas($limit, $offset, $dataInicial, $dataFinal, $searchValue, $anuladas)as $row) {
            $idFatura = $row->idFatura;
            $dataFatura = $row->data;
            $idTipoDocumento = $this->mFatura->tipoDocumento($idFatura);
            $serie = $this->mFatura->serie($idFatura);
            $subtotal = $this->mFatura->somaTotalVendas($idFatura);
            $descontos = $this->mFatura->somaTotalDesconto($idFatura);
            $totalGeral = $subtotal - $descontos;
            $iva = $this->calcularIva($idFatura);
            if ($this->MEmpresa->pegaRegime() != 1) {
                $iva = 0;
            }
            if ($idTipoDocumento == 1) {
                $abrDoc = 'FT';
                $credito = $totalGeral;
                $debito = 0;
            } else {
                $abrDoc = 'FR';
                $debito = $totalGeral;
                $credito = 0;
            }
            if ($row->idtipo == 1) {
                $numero = $this->mFatura->pegaNumeroFtPorIdFatura($idFatura);
            } else {
                $numero = $this->mFatura->pegaNumeroFrPorIdFatura($idFatura);
            }
            $data[] = array(
                'idFatura' => $idFatura,
                'entidade'=>$row->nome,
                'numeroFatura' => $abrDoc . ' ' . $serie . '/' . $numero,
                'dataFatura' => $dataFatura,
                'subtotal' => $subtotal,
                'totalDescontos' => $descontos,
                'totalgeral' => $totalGeral,
                'credito' => $credito,
                'debito' => $debito,
                'totalIva' => $iva,
            );
        }

        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" =>$this->mFatura->mTotalRegistosDockFaturas(),
            "recordsFiltered" =>$totalFiltrafo,
            "data" => $data
        ));
    }

}
