<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of FaturaProformaC
 *
 * @author VINEVALA
 */
class cOrcamento extends CI_Controller {

    var $fatura = '';

    public function irt($idProduto, $idCliente) {
        if ($this->mClientes->tipoCliete($idCliente) == 'Empresa' && $this->ProdutosM->classe_produto($idProduto) == 2) {
            return $this->mClientes->pegaIrt(4);
        } elseif ($this->mClientes->tipoCliete($idCliente) == 'Individual' && $this->ProdutosM->classe_produto($idProduto) == 2) {
            return $this->mClientes->pegaIrt(3);
        } else {
            return 0;
        }
    }

    public function ivaVenda($idproduto) {
        $this->load->model('ProdutosM');
        if ($this->ProdutosM->produto_isencao($idproduto) == 1) {// SE O TIPO DE ISENÇÃO FOR IGUA A 1 QUER DIZER Q O PRODUTO TEM IVA
            return $this->ProdutosM->pegaIvaVenda($idproduto);
        } else {
            return 0;
        }
    }

    public function ivaCompra($idproduto) {
        $this->load->model('ProdutosM');
        if ($this->ProdutosM->produto_isencao($idproduto) == 1) {// SE O TIPO DE ISENÇÃO FOR IGUA A 1 QUER DIZER Q O PRODUTO TEM IVA
            return $this->ProdutosM->pegaIvaCompra($idproduto);
        } else {
            return 0;
        }
    }

    public function acharTotal($desconto, $qtd, $valor) {
        if ($desconto > 0) {
            $desconto1 = ($valor * $desconto) / 100;
            $preco = $valor - $desconto1;
            return $total = $preco * $qtd;
        } else {
            return $total = $valor * $qtd;
        }
    }

    public function registar_orcamento() {
        ini_set('memory_limit', '256M');
        ini_set('upload_max_filesize', '20M');
        ini_set('download_max_filesize', '20M');
        ini_set('post_max_size', '20M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);
        ini_set('max_input_time', '2000');

        $idCliente = $this->input->post('idCliente');
        if (empty($idCliente)) {
            $idCliente = 60;
        }
        if (!is_numeric($idCliente) && !empty($idCliente)) {
            $this->load->model('mClientes');
            $idCliente = $this->mClientes->registarclM2($idCliente);
        }
        $idusuario = $this->input->post('idUsuario');
        $totalgeral = $this->input->post('totalgeral');
        $idVenda = $this->input->post('idVenda');
        $idMesa = $this->input->post('idMesa');

        $dataValidade = date('Y-m-d');
        $this->load->model('mFatura');
        $this->load->model('mClientes');
        $this->load->model('mOrcaento');
        $this->load->model('mMoeda');
        $this->load->model('ProdutosM');
        $this->load->model('mIva');
        $idMoeda = $this->mMoeda->id_moeda_em_uso();
        $idFatura = $this->mOrcaento->registar($idusuario, $dataValidade, $idCliente, $totalgeral, $idMoeda);
        $idDocumentoEmitido = $this->mFatura->registar_documentos_emitidos(4, $idVenda);
        $this->mOrcaento->registar_docs_or($idFatura, $idDocumentoEmitido);
        if (isset($idMesa)) {
            $this->registarProdutosItemRestaurante($idCliente, $idFatura, $idVenda);
        } else {
            $this->registarProdutosItemCarrinho($idCliente, $idFatura, $idVenda);
        }

        $this->gerarHash($idFatura);
        $saida = array(
            "idFatura" => $idFatura,
            "msg" => 'OK',
        );
        echo json_encode($saida);
    }

    public function registarProdutosItemCarrinho($idCliente, $idFatura, $idVenda) {
        foreach ($this->mFatura->itemCarrinho($idVenda)as $value) {
            $idProduto = $value->idpr;
            $valor = $value->custo;
            $qtd = $value->qtd;
            $desconto = $value->desconto;
            $irt = $this->irt($idProduto, $idCliente);
            $ivaVenda = $this->ivaVenda($idProduto);
            $total = $this->acharTotal($desconto, $qtd, $valor);
            $this->mOrcaento->itemFaturaforma($idFatura, $idProduto, $valor, $qtd, $total, $ivaVenda, 0, $irt);
        }
        $this->mFatura->atualizarEstadoCarrinho($idVenda);
    }

    public function gerarHash($idFatura) { // gera a assinatura digital para as faturas
        $stipoVenda = 'OR';
        $inVoiveDate = $this->mOrcaento->inVoiceDate($idFatura);
        $systemEntryate = $this->mOrcaento->systemEntryate($idFatura); // data e hora da fatura
        $grossTotal = $this->mOrcaento->grossTotal($idFatura);
        $serie = $this->mOrcaento->serie($idFatura);
        $inVoiceNo = $stipoVenda . ' ' . $serie . '/' . $idFatura;
        if ($this->mOrcaento->contarRegistosFaturasProforma() > 1) {// se ja existe notas de creditos  assinadas
            $hasUltimo = $this->mOrcaento->hash_da_ultima_fatura($idFatura);
            $registo = $inVoiveDate . ';' . $systemEntryate . ';' . $inVoiceNo . ';' . $grossTotal . ';' . $hasUltimo;
        } else {// caso nao caso 
            $registo = $inVoiveDate . ';' . $systemEntryate . ';' . $inVoiceNo . ';' . $grossTotal . ';';
        }


        $priv_key = file_get_contents('./ChavePrivada/ChavePrivada.pem');
        $key = openssl_get_privatekey($priv_key);
        $ignature = '';
        openssl_sign($registo, $ignature, $key, OPENSSL_ALGO_SHA1);
        $registoHash = base64_encode($ignature);
        $control1 = $registoHash[0];
        $control2 = $registoHash[10];
        $control3 = $registoHash[20];
        $control4 = $registoHash[30];

        $hasControl = $control1 . '' . $control2 . '' . $control3 . '' . $control4;
        $this->mOrcaento->matualizar_hash($idFatura, $registoHash, $hasControl);
    }

    //metodo cotrolador responsavel listar vendas diarias por utilizador
    public function listarFaturasProforma() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $this->load->model('mOrcaento');
        if ($this->mOrcaento->listarvendasFaturasProformas($start, $limit)) {
            foreach ($this->mOrcaento->listarvendasFaturasProformas($start, $limit)as $row) {
                $imprimir[] = array(
                    'idFatura' => $row->idFatura,
                    'data' => $row->data,
                    'total' => $row->total_venda,
                    'cliente' => $row->nome,
                    'usuario' => $row->usuario,
                    'idcliente' => $row->idcliente,
                    'hora' => $row->hora
                );

                $total = $this->mOrcaento->contarFaturasProformas();
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function imprimirOrcamento() {
        $idFatura = $this->input->post('idFatura');
        $this->load->model('mOrcamentoPDF');
        $this->mOrcamentoPDF->imprimirPdfOrcamento($idFatura);
        $this->json->success('Ipmrimir');
    }

    public function lista_orcamento() {
        $this->load->model('mOrcaento');
        foreach ($this->mOrcaento->mlista_orcamento() as $linha) {
            $data = $linha->data;
            $sd = new DateTime($data);
            $ano = utf8_encode(strftime(" %Y", strtotime($sd->format("d. M. Y "))));
            $data = array(
                'fatura' => 'OR' . ' ' . $ano . '/' . $linha->idFatura,
                'idFatura' => $linha->idFatura,
            );
            $response['results'][] = $data;
        }
        echo json_encode($response);
    }

    public function pegaIdVenda() {
        $idFatura = $this->input->get('idFatura');
        $this->load->model('mOrcaento');
        $idDocumentoEmitido = $this->mOrcaento->pega_idDocumentoEmitido($idFatura);
        $data = array('idVenda' => $this->mOrcaento->p_idVenda($idDocumentoEmitido));
        $response['results'][] = $data;
        echo json_encode($response);
    }

}

?>
