<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of CProvincias
 *
 * @author VINEVALA
 */
class CProvincias extends CI_Controller {

   
    public function listarProvincia() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $this->load->model('ProvinciaM');
        $ord = 1;
        $lista = $this->ProvinciaM->mlistaProvincia($start, $limit);
        if ($lista) {
            foreach ($lista as $linha) {

                $imprimir[] = array(
                    'idpais' => $linha->idpais,
                    'pais' => $linha->pais,
                    'provincia' => $linha->provincia,
                    'ord' => $ord,
                );
                $ord++;
                $total = $this->ProvinciaM->contarProvincia();
                $ados = json_encode($imprimir);
                $resposta = '{success: true, total:' . $total . ',data:' . $ados . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function guardarC() {
        $provincia = $this->input->post('provincia');
        $idpais = $this->input->post('idpais');
        $this->load->model('ProvinciaM');
        $existe = $this->ProvinciaM->consultarProvincia($provincia);
        if ($existe) {
            $this->json->GerarMessagemJSONText('Ja existe uma provincia registada com o nome de ' . $provincia);
        } else {
            $this->load->model('PaisM');
            $resultado = $this->PaisM->consultarPais($idpais);
            if ($resultado) {
                $this->ProvinciaM->gravarProvinciaM($provincia, $idpais);
                $this->json->success('Provincia registada');
            } else {
                $this->json->GerarMessagemJSONText('Pais nao encontrado');
            }
        }
    }

    public function listarProvinciasC() {
        $id = $this->input->get('idpais');
        $this->load->model('ProvinciaM');
        $consulta = $this->ProvinciaM->listarProvincia($id);
        if ($consulta) {
            foreach ($consulta as $linha) {
                $dados[] = array(
                    'idprovincia' => $linha->idprovincia,
                    'provincia' => $linha->provincia,
                );
                $total = 1;
                $json = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $json . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

  

    public function getAllProvincias() {
        $this->load->model('MProvincias');
        $listar = $this->MProvincias->mgetAllProvincias();
        $dados=array();
        foreach ($listar as $linha) {
            $dados[] = array(
                'idProvincia' => $linha->idprovincia,
                'provincia' => $linha->provincia,
            );
        }
        echo json_encode($dados);
    }

}
