<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cStock
 *
 * @author VINEVALA
 */
class cStock extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->library('migration');
    }

    public function registarPedidosCompras() {
        $idfornecedor = $this->input->post('idfornecedor');
        $dados = $this->input->post('dados');
        $idusuario = $this->input->post('idusuario');
        $motivo = 'Necessidade de reposição de produtos para revenda';
        $item = json_decode($dados);
        $this->load->model('StockM');
        $idCompra = $this->StockM->registarPedidos($idfornecedor, $motivo, $idusuario);
        foreach ($item as $value) {
            $idProduto = $value->idProduto;
            $qtd = $value->qtd;
            $idUnidade = $value->idUnidade;
            $this->StockM->registarPedidosItem($idCompra, $idProduto, $qtd, $idUnidade);
        }
        $this->json->success('Stock realizado');
    }

    public function atualizarPedidosCompras() {
        $idPedido = $this->input->post('idPedido');
        $dataEntrega = $this->input->post('dataEntrega');
        $valor = $this->input->post('valor');

        $this->load->model('StockM');
        $this->StockM->atualizaPedidosm($idPedido, $dataEntrega, $valor);

        $this->json->success('ok');
    }

    public function atualizarPedidosCompras2($idPedido, $dataEntrega, $valor) {
        $this->StockM->atualizaPedidosm($idPedido, $dataEntrega, $valor);
    }

    public function regitarcompras($idProduto, $qtd, $custo, $idUnidade, $totalcompras, $iva, $idusuario, $idCompra, $prazo, $totalUnidade, $desconto) {

        $this->StockM->registarItemCompras($idProduto, $qtd, $custo, $idUnidade, $totalcompras, $iva, $idusuario, $idCompra, $prazo, $totalUnidade, $desconto);
    }

    public function verificaTotalProdutos($item) {
        $cont = 0;
        foreach ($item as $value) {
            $value->idProduto;
            $cont++;
        }
        return$cont;
    }

    public function verificaUnidade($item) {
        $cont = 0;
        foreach ($item as $value) {
            $unidade = $value->unidade;
            if ($unidade == '') {
                $cont++;
            }
        }
        return$cont;
    }

    public function qtd($item) {
        $cont = 0;
        foreach ($item as $value) {
            if ($value->qtd == 0) {
                $cont++;
            }
        }
        return$cont;
    }

    public function custo($item) {
        $cont = 0;
        foreach ($item as $value) {
            if ($value->custo == 0) {
                $cont++;
            }
        }
        return$cont;
    }

    public function iva($item) {
        $cont = 0;
        foreach ($item as $value) {
            if ($value->iva == '') {
                $cont++;
            }
        }
        return$cont;
    }

    public function totalUnidade($item) {
        $cont = 0;
        foreach ($item as $value) {
            if ($value->totalUnidade == 0) {
                $cont++;
            }
        }
        return$cont;
    }

    public function atualizarQtdPontoVenda($idProduto, $qtd, $custo, $operacao, $operacao1, $idusuario, $idArmanzeOrigem, $idArmanzeDestino) {

        $venda = $this->mGestaoStock->pega_custo_venda($idProduto);
        $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idProduto);
        $qtd1 = $qtd * $total_por_unidade;
        if ($total_por_unidade > 1) { // se a loja selecionada vende produtos a  retalho
            $totalcompras = $venda * $qtd;
            $cutoCopra = ($custo / $total_por_unidade);
            $this->StockM->somaQuantidedePrecoCompra($idProduto, $qtd, $totalcompras, $idArmanzeDestino);
            $this->historicoSaida($idProduto, $qtd1, $operacao1, $idusuario, $idArmanzeOrigem, $cutoCopra);
            $this->historicoEntrada($idProduto, $qtd1, $operacao, $idusuario, $idArmanzeDestino, $cutoCopra);
        } else { // caso seja a grosso
            $venda = $custo * $qtd1;
            $totalcompras = $venda * $qtd;
            $this->StockM->somaQuantidedePrecoCompra($idProduto, $qtd1, $totalcompras, $idArmanzeDestino);
            $this->historicoSaida($idProduto, $qtd1, $operacao1, $idusuario, $idArmanzeOrigem, $custo);
            $this->historicoEntrada($idProduto, $qtd1, $operacao, $idusuario, $idArmanzeDestino, $custo);
        }
    }

    private function disponibliza_Produto_pv($idProduto, $qtd, $custo, $idusuario, $idArmanzeOrigem, $idArmanzeDestino) {
        $operacao1 = ' Transferência de Stock';
        $operacao = 'Receção de Stock';

        $this->atualizarQtdPontoVenda($idProduto, $qtd, $custo, $operacao, $operacao1, $idusuario, $idArmanzeOrigem, $idArmanzeDestino);
        $idMovimento = $this->mGestaoStock->registarMovimentoProduto($idusuario);
        $this->mGestaoStock->registar_armanzes_destino_produto($idMovimento, $idArmanzeDestino);
        $this->mGestaoStock->registar_armanzes_origem_produto($idMovimento, $idArmanzeOrigem);

        $this->mGestaoStock->registarMovimentoProdutoItem($qtd, $idProduto, $idMovimento, $custo);
    }

    public function registarFaturaFornecedor() {
        $idfornecedor = $this->input->post('idfornecedor');
        $nfatura = $this->input->post('nfatura');
        $idusuario = $this->input->post('idusuario');
        $valorFatura = $this->input->post('valorFatura');
        $dtaCompra = $this->input->post('dataFatura');
        $dataVencimento = $this->input->post('dataVencimento');
        $produtospv = $this->input->post('produtospv');
        $idArmanzeDestino = $this->input->post('idArmanzeDestino');
        $hashDoc = $this->input->post('hashDoc');
        $dados = $this->input->post('dados');
        $item = json_decode($dados);
        $this->load->model('StockM');
        if ($this->verificaTotalProdutos($item) < 1) {
            $this->json->success('semprodutos');
        } elseif ($this->verificaUnidade($item) >= 1) {
            $this->json->success('n');
        } elseif ($this->qtd($item) >= 1) {
            $this->json->success('n');
        } elseif ($this->custo($item) >= 1) {
            $this->json->success('n');
        } elseif ($this->iva($item) >= 1) {
            $this->json->success('n');
        } elseif ($this->totalUnidade($item) >= 1) {
            $this->json->success('n');
        } elseif ($produtospv == 'true' && empty($idArmanzeDestino)) {
            $this->json->success('ar');
        } else {
            $this->load->model('StockM');
            $this->load->model('mUnidade');
            $this->load->model('mfluxoCaixa');
            $this->load->model('mGestaoStock');
            $idCompra = $this->StockM->registarFaturaFornecedor($idfornecedor, $nfatura, $dtaCompra, $idusuario, $valorFatura, $dataVencimento, $hashDoc);
            foreach ($item as $value) {
////               
                $idProduto = $value->idProduto;
                $custo = $value->custo;
                $prazo = $value->prazo;
                $totalUnidade = $value->totalUnidade;
                $iva = $this->mUnidade->pegaImpostoIva($value->iva);
                $qtd = $value->qtd;
                $desconto = $value->desconto;
                $total = $value->total;
                $idUnidade = $this->mUnidade->pegarIdUnidade($value->unidade);
                $this->regitarcompras($idProduto, $qtd, $custo, $idUnidade, $total, $iva, $idusuario, $idCompra, $prazo, $totalUnidade, $desconto);
                if ($produtospv == 'true') {
                    $idArmanzeOrigem = 1;
                    $this->disponibliza_Produto_pv($idProduto, $qtd, $custo, $idusuario, $idArmanzeOrigem, $idArmanzeDestino);
                }
            }
            $referencia = 'Factura nº' . ' ' . $nfatura;
            $data = @date('Y-m-d');
            $statu = 'ACTIVA';
            $this->mfluxoCaixa->registarContasPagar($idfornecedor, $data, $dataVencimento, $idusuario, $valorFatura, $referencia, $statu, $idCompra); // verifica se a quantidade disponivel é menor que a solicitada 
            $this->json->success('ok');
        }
    }

    public function salva_ateracoes_stockVarios($idProduto, $qtd, $operacao, $idUsuario, $idArmanze, $tipo, $preco_compra) {

        $this->mStock->somaQtd($idProduto, $qtd, $idArmanze);
        $this->mStock->registarHistoricoStock($idProduto, $qtd, $operacao, $idUsuario, $idArmanze, $tipo, $preco_compra);
        if ($preco_compra > 0) {
            $this->mArtigos->atualizarProcoCompra($idProduto, $preco_compra);
        }
    }

    function isValidDate($date) {
        // Verifica se a data está no formato YYYY-MM-DD
        $d = DateTime::createFromFormat('Y-m-d', $date);
        return $d && $d->format('Y-m-d') === $date;
    }

    // Função para verificar se a data de caducidade e o lote estão corretamente preenchidos.
    function verificarDataCaducidade($dt_caducidade, $lote) {
        // Verifica se o campo 'tatuDt' é igual a 's' e se os campos de data de caducidade e lote não estão preenchidos corretamente.
        if (empty($dt_caducidade) || !$this->isValidDate($dt_caducidade) || empty($lote)) {
            // Se a data de caducidade estiver vazia, não for uma data válida, ou o lote estiver vazio, retorna um erro.
            echo json_encode('NerroDt');
            exit; // Interrompe a execução do código e retorna a resposta de erro imediatamente.
        } else {
            // Se a verificação passou sem erros, retorna 'true', indicando que os dados estão válidos.
            return true;
        }
    }

    function salvar_stock_dt_caducidade($idProduto, $id_stock, $dt_caducidade, $lote) {
        $this->mStock->mstock_dt_caducidade($idProduto, $id_stock, $dt_caducidade, $lote);
    }

    public function rececao_stock_varios() {
        // Recebe os dados JSON da requisição POST
        $dadosPost = json_decode($this->input->raw_input_stream, true); // Converte o JSON para um array associativo
        $idUsuario = $dadosPost['idUsuario'];
        $alterations = $dadosPost['alterations'];
        $this->load->model('mStock');
        $this->load->model('mArtigos');
        $tipo = 'ENTRADA2';
        $operacao = 'Receção de Stock';
        $temDados = false;
        $verificado = false;
        foreach ($alterations as $value) {
            // Verifica se id_stock não está vazio, qtd é maior ou igual a 0 e não é null

            if (!empty($value['id_stock']) && isset($value['qtd']) && $value['qtd'] !== null && $value['qtd'] > 0) {
                $temDados = true;
                // Acessar os campos do array associativo
                $id_stock = $value['id_stock'];
                $idProduto = $this->mStock->pegaIdProduto($id_stock);
                $tatuDt = $this->mArtigos->statu_dt_caducidade($idProduto);
                $idArmanze = $this->mStock->pegaIdArmanzen($id_stock);
                $qtd = $value['qtd'];
                $preco_compra = $value['custo'];
                $dt_caducidade = isset($value['dt_caducidade']) ? $value['dt_caducidade'] : null;
                $lote = isset($value['lote']) ? $value['lote'] : null;

                /// Verificar se o produto exige data de caducidade e ela não foi fornecida
                $tatuDt === 's' ? $verificado = $this->verificarDataCaducidade($dt_caducidade, $lote) : null;

                // Salva as alterações no estoque
                $this->salva_ateracoes_stockVarios($idProduto, $qtd, $operacao, $idUsuario, $idArmanze, $tipo, $preco_compra);
                // Se $verificado for verdadeiro, executa a função salvar_stock_dt_caducidade
                $verificado && $this->salvar_stock_dt_caducidade($idProduto, $id_stock, $dt_caducidade, $lote);

                // Realizar outras operações com os dados aqui, se necessário
            }
        }

        if (!$temDados) {
            echo json_encode('N');
        } else {
            echo json_encode('OK');
        }
    }

    public function transferirStock() { /// transfere stok para outra loja física
        $idUsuario = $this->input->post('idusuario');
        $destino = $this->input->post('destino');
        $dados = $this->input->post('dados');
        $this->load->model('Musuarios');
        $idLoja = $this->Musuarios->idLoja($idUsuario);
        $item = json_decode($dados);

        if ($this->verificaTotalProdutos($item) < 1) {
            $this->json->success('semprodutos');
        } elseif ($this->qtd($item) >= 1) {
            $this->json->success('n');
        } else {
            $this->load->model('StockM');
            $idTrans = $this->StockM->transferirStockm($destino, $idLoja, $idUsuario);
            foreach ($item as $value) {
                $idProduto = $value->idProduto;
                $qtd = $value->qtd;
                $this->StockM->subtraiQtd($idProduto, $qtd, $idLoja);
                $this->StockM->itemTrasfereStock($idProduto, $qtd, $idTrans);
            }
            $this->json->success('ok');
        }
    }

    public function alterarQuantidade() { // altera a quantidade diretamente da view produto
        $idProduto = $this->input->post('idProduto');
        $qtd = $this->input->post('qtd');
        //  $data=  $this->input->post('data');
        $this->load->model('StockM');
        $custo = $this->StockM->pegaCusto($idProduto);
        $totalcompras = $qtd * $custo;
        if ($this->StockM->verificaProdutoStock($idProduto)) {

            // $qtdAntiga=  $this->StockM->qtdAntiga($idstock);

            $this->StockM->somaQuantidedePrecoCompra($idProduto, $qtd, $totalcompras);
            $this->json->success('quantidade alterada');
        } else {
            $this->registarQtd($idProduto, $qtd, $custo, $totalcompras);
            $this->json->success('quantidade alterada');
        }
    }

    public function registarQtd($idProduto, $qtd, $custo, $totalcompras) {
        $this->StockM->registarQtd($idProduto, $qtd, $custo, $totalcompras);
    }

    public function atualizar_estado_compra($idProduto, $idPedido, $comprado) {
        $this->StockM->atualizaEstadoCompra($idProduto, $idPedido, $comprado);
    }

    public function alterarQtd() {
        $idstock = $this->input->post('idstock');
        $qtd = $this->input->post('qtd');
        $data = $this->input->post('data');
        $this->load->model('StockM');
        $this->load->model('InventarioM');
        $qtdAntiga = $this->StockM->qtdAntiga($idstock);
        $idProduto = $this->StockM->pegaIdProduto($idstock);
        $custo = $this->StockM->pegaCusto($idstock);
        $this->StockM->resetarQtd($idstock, $qtdAntiga);
        $this->StockM->subtrairQuantidede($idProduto, $qtdAntiga);
        $idStockQtd = $this->StockM->pegaIdStockQauntidade($idProduto); // pega id Stock quantidade
        $ultimaData = $this->StockM->pegaUltimaDataCompra($idProduto); // pega a ultima data
        $idHistorico = $this->StockM->pegaIdHistorico($idProduto);
        $this->StockM->resetaHistorico($idHistorico, $qtd);
        $valorfinal = $qtd * $custo;
        if ($this->StockM->verificar_se_existe_inventario($idStockQtd, $data)) {
            $idInventario = $this->StockM->pegaIdInventario($idStockQtd, $data);
            $this->InventarioM->subtrairQuantides($idInventario, $qtdAntiga);
            $this->InventarioM->atualizarQtdValorFinal($idInventario, $qtd, $valorfinal);
        }
        $this->StockM->somaQtdCompra($idstock, $qtd, $valorfinal);
        $this->StockM->somaQuantidedePrecoCompra($idProduto, $qtd, $valorfinal);
        $this->StockM->atualizaHistorico($idHistorico, $qtd);
        $this->json->success('quantidade alterada');
    }

    public function subtrairSaldoConta($fpagamento, $preco, $idBanco) {
        $this->load->model('mfluxoCaixa');
        if ($fpagamento == 2) {
            $idtipoConta = 1;
            $this->mfluxoCaixa->atualizarSadoNasContasBanco($idBanco, $preco); // chama modelo que contem a função para o saldo nas contas 
            $this->mfluxoCaixa->atualizarSadoNasContasDebito($idtipoConta, $preco); // chama modelo que contem a função para o saldo nas contas
        } else {
            $idtipoConta = 3;
            $this->mfluxoCaixa->atualizarSadoNasContasDebito($idtipoConta, $preco); // chama modelo que contem a função para o saldo nas contas
        }
    }

    public function chavesArray($dpr, $dadosBd) {
        $this->load->model('StockM');
        foreach ($this->StockM->stockLojaArmanze($dpr) as $qtdLojas) {
            array_push($dadosBd, $qtdLojas->qtd);
            //  echo  $qtdLojas->qtd;
        }
//         $key = array('codigo', 'red');
//         return array_push($key, 'amarelo');
    }

    public function mpega_qtd($idproduto) {
        $this->db->select_sum('qtd');
        $this->db->from('stock_quantidade');
        $this->db->where("idproduto", $idproduto);
        $consulta = $this->db->get();
        // Pega o primeiro resultado da consulta
        $value = $consulta->row();
        // Retorna a quantidade, se houver, ou 0 caso contrário
        return $value && $value->qtd ? $value->qtd : 0;
    }

    public function consulta_idproduto_compra($idproduto) {
        $this->db->select('idproduto');
        $this->db->from('compras');
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where("idproduto", $idproduto);
        return $this->db->count_all_results();
    }

    public function mpega_custo($idproduto) {
        $this->db->select('custo');
        $this->db->from('item_compras');
        $this->db->where("idproduto", $idproduto);
        $this->db->order_by("idstock", 'DESC');
        $this->db->limit(1);
        $consulta = $this->db->get();
        // Pega o primeiro resultado da consulta
        $value = $consulta->row();
        // Retorna o custo, se houver, ou 0 caso contrário
        return $value && $value->custo ? $value->custo : 0;
    }

    public function pega_custo_produto($idproduto) {
        if ($this->consulta_idproduto_compra($idproduto) > 0) {
            $custo_grosso = $this->mpega_custo($idproduto);
            $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idproduto);
            $custo = number_format($custo_grosso / $total_por_unidade, 2);
            return $custo;
        } else {
            return $this->mLucro->mpega_custo_produto($idproduto);
        }
    }

    public function clistaArtigosQtdStock() {

        $this->load->model('mIva');
        $this->load->model('mStock');
        $this->load->model('mGestaoStock');
        $this->load->model('mLucro');
        $this->load->model('mLojas');
        $this->load->library('fucoes');

        $searchValue = ($_POST["search"] ["value"]);
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start'); // Offset para paginação
        // Obter os dados com limite e offset para paginação
        $totaGralVenda2 = 0;
        foreach ($this->mStock->mListaProdutosParaTotalGeralVenda() as $linha) {
            $qtd = $this->mpega_qtd($linha->idproduto);
            $custo = $this->pega_custo_produto($linha->idproduto);
            $venda = $this->mStock->pega_preco_venda($linha->idproduto);
            $ivaInt = $this->mIva->calculo_iva_int($venda, $linha->idproduto);
            $vendaIva = $venda + $ivaInt;
            $totalv = $qtd * $vendaIva;
            $totaGralVenda2 = $totaGralVenda2 + $totalv;
        }
        $data = array();

        $totalGeral = 0;
        // Obter nomes de armazéns
        $armazens = $this->mLojas->mlistaLojas(); // Função retorna uma lista de nomes de armazéns
        $totalGeralCompra = $this->mStock->totalGeralCompras();
        $totalQtd = $this->mStock->totalQtd();
        foreach ($this->mStock->mlistaArtigosQtdStock($searchValue, $limit, $offset) as $linha) {
            $quantidadesArmazens = array();
            foreach ($armazens as $armazem) {

                $quantidadesArmazens[$armazem->narmanze] = $this->mStock->getQuantidadeArmazem($linha->idproduto, $armazem->id);
            }
            $qtd = $this->mpega_qtd($linha->idproduto);
            $custo = $this->pega_custo_produto($linha->idproduto);
            $venda = $this->mStock->pega_preco_venda($linha->idproduto);
            $ivaInt = $this->mIva->calculo_iva_int($venda, $linha->idproduto);
            $vendaIva = $venda + $ivaInt;
            $totalv = $qtd * $vendaIva;
            $totalGeral = $totalGeral + $totalv;
            if ($custo > 0) {
                $lucroProduto = $vendaIva - $custo;
                $totalLucro = $lucroProduto * $qtd;
            } else {
                $totalLucro = 'Informe o Custo do Produto';
            }
            $data[] = array(
                'idProduto' => $linha->idpr,
                'produto' => $linha->produto,
                'codigodebara' => $linha->codigodebara,
                'qtd' => $qtd,
                'custo' => $custo,
                'totalcusto' => $qtd * $custo,
                'ultimadata' => $linha->ultimadata,
                'venda' => $venda + $ivaInt,
                'totalLucro' => $totalLucro,
                'idstock' => $linha->idstock,
                'totalv' => $totalv,
                'totalLucro' => $totalLucro,
                'totalGeral' => $totalGeral,
                'totalGeralCompra' => $totalGeralCompra,
                'armazens' => $quantidadesArmazens, // Adiciona os armazéns e suas quantidades
            );
        }
        $totalItens = array(
            "totalGeralCompra" => $totalGeralCompra,
            "totaGralVenda" => $totaGralVenda2,
            "totalQtd" => $totalQtd
        );
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $this->mStock->mTotalContaRegistosStock(),
            "recordsFiltered" => $this->mStock->obter_total_registos_filtrados($searchValue),
            "columns" => $armazens, // Envia os nomes dos armazéns
            "data" => $data,
            "totalItens" => $totalItens,
           
        ));
    }

    public function clistaArtigosDtCaducidade() {

        $this->load->model('mIva');
        $this->load->model('mStock');
        $this->load->model('mGestaoStock');
        $this->load->model('mLucro');
        $this->load->model('mLojas');
        $this->load->library('fucoes');

        $searchValue = ($_POST["search"] ["value"]);
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start'); // Offset para paginação
        // Obter os dados com limite e offset para paginação
        $data = array();
        foreach ($this->mStock->mlistaArtigosDtCaducidade($searchValue, $limit, $offset) as $linha) {
            $data[] = array(
                'idProduto' => $linha->idpr,
                'produto' => $linha->produto,
                'lote' => $linha->lote,
                'qtd' => $linha->qdt,
                'dataValidade' => $linha->data_validade,
            );
        }
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $this->mStock->mTotalContaRegistosStock(),
            "recordsFiltered" => $this->mStock->obter_total_registos_dt_val_filtrados($searchValue),
            "data" => $data
        ));
    }

    public function clistaArtigosAddStock() {// Listas os artigos para a tela de stock
        $this->load->model('mIva');
        $this->load->model('mStock');
        $this->load->model('mGestaoStock');
        $searchValue = ($_POST["search"] ["value"]);
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start'); // Offset para paginação
        // Obter os dados com limite e offset para paginação
        $data = array();
        foreach ($this->mStock->mlistaArtigosAddStock($searchValue, $limit, $offset) as $linha) {
            $data[] = array(
                'idProduto' => $linha->idpr,
                'produto' => $linha->produto,
                'qtd' => $linha->qtd,
                'narmanze' => $linha->narmanze,
                'idstock' => $linha->idstock,
            );
        }
        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $this->mStock->mTotalContaRegistosStock(),
            "recordsFiltered" => $this->mStock->obter_total_registos_filtrados($searchValue),
            "data" => $data
        ));
    }

    public function calcula_qtd($total_por_unidade, $td) {
        if ($total_por_unidade > $td) {
            return 0;
        } else {
            return $td / $total_por_unidade;
        }
    }

    public function pega_qtd($td, $idGrupoPreco, $idProduto) {
        if ($this->mGestaoStock->tipo_grupo($idGrupoPreco) == 'gr') {
            if ($this->mGestaoStock->mconsulta_idproduto_compra($idProduto)) {
                $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idProduto);
                return intval($this->calcula_qtd($total_por_unidade, $td));
            } else {
                return $td;
            }
        } else {
            return $td;
        }
    }

    public function precoComIVa($preco, $idpr) {
        if ($this->mempresa->pegaRegime() == 2 || $this->mempresa->pegaRegime() == 3) {
            return '0.00';
        } else {
            $iva = $this->mIva->calculo_iva_int($preco, $idpr);
//            $iva = $this->mIva->calculo_iva($preco, $idpr);
            return $this->fucoes->formatarDinheiro($iva + $preco, true);
        }
    }

    public function listaProdutosServicosPontoVenda() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $produto = $this->input->get('produto');
        $idCategoriaPontoVenda = $this->input->get('idCategoriaPontoVenda');
        $idLoja = $this->input->get('idLoja');
        $idGrupoPreco = $this->input->get('idGrupoPreco');
        $referencia = $this->input->get('referencia');
        $this->load->model('StockM');
        $this->load->model('mGestaoStock');
        $this->load->model('mempresa');
        $this->load->model('mIva');
        $this->load->library('fucoes');
        if ($idCategoriaPontoVenda == 2 || $idCategoriaPontoVenda == '') {
            if ($this->StockM->listarProdutosPOS($start, $limit, $produto, $idLoja, $idGrupoPreco, $referencia)) {
                foreach ($this->StockM->listarProdutosPOS($start, $limit, $produto, $idLoja, $idGrupoPreco, $referencia) as $linha) {

                    $qtd = $this->pega_qtd($linha->qtd, $idGrupoPreco, $linha->idpr);
                    $venda = $this->StockM->pegaPrecoPorGrupo($idGrupoPreco, $linha->idproduto);
                    $dados[] = array(
                        'codigo' => $linha->idpr,
                        'idProduto' => $linha->idpr,
                        'produto' => $linha->produto,
                        'codigodebara' => $linha->codigodebara,
                        'qtd' => $qtd,
                        'venda' => $venda,
                        'precoIVA' => $this->precoComIVa($venda, $linha->idpr),
                    );
                    $total = count($this->StockM->contarProdutosPOS($idLoja));
                    $codificar = json_encode($dados);
                    $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
                }
            } else {
                $resposta = "{success:false, total: 0, data:''}";
            }
            echo $resposta;
        } else {
            if ($this->StockM->listarServicosView($start, $limit, $produto)) {
                foreach ($this->StockM->listarServicosView($start, $limit, $produto) as $linha) {

                    $dados[] = array(
                        'codigo' => $linha->idpr,
                        'idProduto' => $linha->idpr,
                        'produto' => $linha->produto,
                        'venda' => $linha->preco,
                        'qtd' => 0,
                    );
                    $total = $this->StockM->contarlistarServicosView();
                    $codificar = json_encode($dados);
                    $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
                }
            } else {
                $resposta = "{success:false, total: 0, data:''}";
            }
            echo $resposta;
        }
    }

    //metodo que lista as compras feitas
    public function calculaPercentagemProdutosRecebido($qtdRecebido, $totalQtdComprado) {

        return ($qtdRecebido * 100) / $totalQtdComprado;
    }

    public function listarComprasFornecedor() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $dataminima = $this->input->get('dataminima');
        $datamaxima = $this->input->get('datamaxima');

        $this->load->model('StockM');
        $this->load->model('mfluxoCaixa');
        if ($this->StockM->listarComprasM($start, $limit, $dataminima, $datamaxima)) {
            foreach ($this->StockM->listarComprasM($start, $limit, $dataminima, $datamaxima) as $linha) {
                $qtd = $this->StockM->total_qtd_compra_por_fatura_fornecedor($linha->idCompra);
                $custo = $this->StockM->total_custo_compra_por_fatura_fornecedor($linha->idCompra);

                $idCompra = $linha->idCompra;
                $qtdRecebido = $this->mfluxoCaixa->totalProdutosComprados($idCompra);
                $idcontaPagar = $linha->idcontaPagar;
                $totalQtdComprado = $this->mfluxoCaixa->totalProdutosComprados($idCompra);
                //  $totalRecebido= $this->calculaPercentagemProdutosRecebido($qtdRecebido,$totalQtdComprado);
                $debito = $this->mfluxoCaixa->totalDividaPgagoFornecedores($idcontaPagar);

                $dados[] = array(
                    'idCompra' => $linha->idCompra,
                    'nfatura' => $linha->nfatura,
                    'fornecedor' => $linha->fornecedor,
                    'dataCompra' => $linha->dataCompra,
                    'dataentrada' => $linha->dataentrada,
                    'dataVencimento' => $linha->dataVencimento,
                    'valorFatura' => $linha->valorFatura,
                    'unome' => $linha->unome,
                    'qtd' => $qtd,
                    'custo' => $custo,
                    'debito' => $this->fucoes->formatarDinheiro($debito, true),
                    'valor' => $this->fucoes->formatarDinheiro($linha->valor, true),
                        //'percentagem'=>$this->fucoes->formatarDinheiro($linha->valor,true),
                );
                $total = $this->StockM->contarlinhasStok();
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarComprasFornecedorPorFatura() {
        $idCompra = $this->input->get('idCompra');

        $this->load->model('StockM');
        if ($this->StockM->listatotal_compra_por_fatura_fornecedor($idCompra)) {
            foreach ($this->StockM->listatotal_compra_por_fatura_fornecedor($idCompra)as $linha) {

                $dados[] = array(
                    'idCompra' => $linha->idCompra,
                    'produto' => $linha->produto,
                    'unidade' => $linha->nunidade,
                    'custo' => $linha->custo,
                    'qtd' => $linha->qtd,
                    'total' => $linha->totalcompra,
                );
                $total = 50;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function ImprimirQtd() {
        $this->load->model('mstockdisponivel');
        $limite = $this->input->post('limite');
        $this->mstockdisponivel->imprimirStockDisponivel($limite);
        $this->json->success('OK');
    }

    public function inventario() {
        ini_set('memory_limit', '256M');
        ini_set('upload_max_filesize', '20M');
        ini_set('download_max_filesize', '20M');
        ini_set('post_max_size', '20M');
        ini_set('max_execution_time', 0);
        set_time_limit(3600);
        $this->load->model('StockDisponivel');
        $this->StockDisponivel->invetarioPDF();
        $this->json->success('OK');
    }

    public function rececaoStock() {
        $datarececcao = $this->input->post('datarececcao');
        $this->load->model('StockM');
        if ($this->StockM->consulta_rececao_stock($datarececcao)) {
            $this->load->model('mRececcaoStock');
            $this->mRececcaoStock->rececaoStockPDF($datarececcao);
            $this->json->success('OK');
        } else {
            $this->json->success('N');
        }
    }

    public function ImprimirCompras() {
        $this->load->model('mrelatoriocompras');
        $dataminima = $this->input->post('dataminima');
        $datamaxima = $this->input->post('datamaxima');
        $this->mrelatoriocompras->comprasDiarias($dataminima, $datamaxima);
        $this->json->success('OK');
    }

    public function alterarPreco() {
        $idProduto = $this->input->post('idProduto');
        $idstock = $this->input->post('idstock');
        $data = $this->input->post('data');
        $custo = $this->input->post('custo');
        $venda = $this->input->post('valor');
        $qtd = $this->input->post('qtd');
        $this->load->model('StockM');
        $this->StockM->atualizaPrecoStQtd($idstock, $custo, $venda, $data, $idProduto);
        $this->json->success('Stock atualizado');
    }

    public function ImprimirPrecosProdutos() {
        $this->load->model('mCatalogarProdutos');
        $produto = $this->input->post('produto');
        $venda = $this->input->post('venda');
        $this->mCatalogarProdutos->imprimirPrecosPDF($produto, $venda);
        $this->json->success('OK');
    }

    public function listaDePedido() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $produto = $this->input->get('produto');
        $this->load->model('StockM');
        $this->load->library('fucoes');

        if ($this->StockM->listarPedido($start, $limit)) {
            foreach ($this->StockM->listarPedido($start, $limit) as $linha) {

                $dados[] = array(
                    'idPedido' => $linha->idPedido,
                    'fornecedor' => $linha->fornecedor,
                    'requisitante' => $linha->unome,
                    'motivo' => $linha->motivo,
                    'dataPedido' => $linha->dataPedido,
                    'dataEntrega' => $linha->dataEntrega,
                    'valor' => $linha->valor,
                );
                $total = $this->StockM->contarPedidos();
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:true, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function ImprimirPedidoCompras() {
        $this->load->model('mPedidosComprasPdf');
        $idPedido = $this->input->post('idPedido');
        $this->mPedidosComprasPdf->imprimirComprasPDF($idPedido);
        $this->json->success('OK');
    }

    public function listaDePedidoNumero() {
        $this->load->model('StockM');
        if ($this->StockM->listarNumeroPedidos()) {
            foreach ($this->StockM->listarNumeroPedidos() as $linha) {
                $dados[] = array(
                    'idPedido' => $linha->idPedido,
                );
                $total = count($this->StockM->listarNumeroPedidos());
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function lista_por_numero_de_pedido() {
        $idPedido = $this->input->get('idPedido');

        $this->load->model('StockM');
        $this->load->library('fucoes');

        if ($this->StockM->lista_pedido_compra($idPedido)) {
            foreach ($this->StockM->lista_pedido_compra($idPedido) as $linha) {
                $dados[] = array(
                    'idProduto' => $linha->idproduto,
                    'produto' => $linha->produto,
                    'idUnidade' => $linha->idUnidade,
                    'unidade' => $this->StockM->lista_unidade($linha->idUnidade),
                    'qtd' => $linha->qtd,
                    'estado' => $linha->comprado,
                    'total' => $this->StockM->lista_total_por_unidade($linha->idproduto),
                );
                $total = count($this->StockM->lista_pedido_compra($idPedido));
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function alterar($qtdArray, $idProduto) {

        foreach ($qtdArray as $linha) {
            if ($linha->value == 's' && $linha->qtAlterar !== null) {
                $this->load->model('StockM');
                $this->StockM->alteraStock($idProduto, $linha->idArmanze, $linha->qtAlterar);
                $this->StockM->acertos_inventario($idProduto, $linha->idArmanze, $linha->qtAlterar, $linha->qtd);
            }
        }
    }

    public function resetQtd() {

        $qtdArrayjson = $this->input->post('qtdArray');
        $idProduto = $this->input->post('idProduto');
        ;
        $qtdArray = json_decode($qtdArrayjson);
        $this->load->model('StockM');
        $this->alterar($qtdArray, $idProduto);
        $this->json->success('OK');
    }

    public function transferir($idProduto, $idArmaze, $qtd, $idArmanzeDestino) {
        if ($this->mArtigos->consultaProdutoStock($idProduto, $idArmanzeDestino)) {
            $this->mStock->somaQtd($idProduto, $qtd, $idArmanzeDestino);
            $this->mStock->subtraiQtd($idProduto, $qtd, $idArmaze);
        } else {
            $custo = $this->mArtigos->custo2($idProduto);
            $this->mArtigos->registarQtdLoja($idProduto, $qtd, $custo, 0, $idArmanzeDestino);
            $this->mStock->subtraiQtd($idProduto, $qtd, $idArmaze);
        }
    }

    public function transferir_produto_variacao($idProduto, $idArmaze, $qtd, $idArmanzeDestino, $idCor, $idTamanho) {

        if ($this->ProdutosM->consultaProdutoStock($idProduto, $idArmanzeDestino)) {
            $this->StockM->somaQtd($idProduto, $qtd, $idArmanzeDestino);
            $this->StockM->somaQtdVariacoes($idProduto, $qtd, $idArmanzeDestino, $idCor, $idTamanho);
            $this->StockM->subtraiQtd($idProduto, $qtd, $idArmaze);
            $this->StockM->subtraiQtdVariacoes($idProduto, $qtd, $idArmaze, $idCor, $idTamanho);
        }
    }

    public function rececao_stock() {

        $idArmanze = $this->input->post('idArmanze');
        $qtd = $this->input->post('qtd');
        $operacao = 'Receção de Stock';
        $idProduto = $this->input->post('idProduto');
        $preco_compra = $this->input->post('preco_compra');
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mStock');
        $this->load->model('mArtigos');
        $tipo = 'ENTRADA2';
        $this->mStock->somaQtd($idProduto, $qtd, $idArmanze);
        if ($preco_compra > 1) {
            $this->mArtigos->atualizarProcoCompra($idProduto, $preco_compra);
        }
        $this->mStock->registarHistoricoStock($idProduto, $qtd, $operacao, $idUsuario, $idArmanze, $tipo, $preco_compra);
        echo json_encode('OK');
    }

    public function historicoSaida($idProduto, $qtd, $operacao1, $idUsuario, $idArmanzeOrigem, $custo) {
        $tipo = 'SAIDA';
        $idHistoricoStock = $this->mStock->registarHistoricoStock($idProduto, $qtd, $operacao1, $idUsuario, $idArmanzeOrigem, $tipo, $custo);
        $this->mStock->registarHistoricoStockLojaOrigem($idHistoricoStock, $idArmanzeOrigem);
    }

    public function historicoSaidaVariacoes($idProduto, $qtd, $operacao1, $idUsuario, $idArmaze, $idCor, $idTamanho) {
        $tipo = 'SAIDA';
        $idHistoricoStock = $this->mStock->registarHistoricoStockVariacooes($idProduto, $qtd, $operacao1, $idUsuario, $idArmaze, $tipo, $idCor, $idTamanho);
        $this->mStock->registarHistoricoStockLojaOrigemVariacao($idHistoricoStock, $idArmaze);
    }

    public function historicoEntrada($idProduto, $qtd, $operacao, $idUsuario, $idArmanzeDestino, $custo) {
        $tipo = 'ENTRADA';
        $idHistoricoStock = $this->mStock->registarHistoricoStock($idProduto, $qtd, $operacao, $idUsuario, $idArmanzeDestino, $tipo, $custo);
        $this->mStock->registarHistoricoStockLojaDesdino($idHistoricoStock, $idArmanzeDestino);
    }

    public function historicoEntradaVariacoes($idProduto, $qtd, $operacao1, $idUsuario, $idArmaze, $idCor, $idTamanho) {
        $tipo = 'ENTRADA';
        $idHistoricoStock = $this->StockM->registarHistoricoStockVariacooes($idProduto, $qtd, $operacao1, $idUsuario, $idArmaze, $tipo, $idCor, $idTamanho);
        $this->StockM->registarHistoricoStockLojaDesdinoVariacoes($idHistoricoStock, $idArmaze);
    }

    public function transferirProdutos() {

        $idArmanzeOrigem = $this->input->post('idArmanzeOrigem');
        $idArmanzeDestino = $this->input->post('idArmanzeDestino');
        $qtd = $this->input->post('qtd');
        $operacao1 = 'Transferência de Stock'; // vai no armanzem de origem
        $operacao = 'Receção de Stock';
        $idProduto = $this->input->post('idProduto');
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('mStock');
        $this->load->model('mArtigos');
        $custo = $this->mArtigos->custo2($idProduto);
        $this->transferir($idProduto, $idArmanzeOrigem, $qtd, $idArmanzeDestino);
        $this->historicoSaida($idProduto, $qtd, $operacao1, $idUsuario, $idArmanzeOrigem, $custo);

        $this->historicoEntrada($idProduto, $qtd, $operacao, $idUsuario, $idArmanzeDestino, $custo);
        echo json_encode('OK');
    }

    public function adicionarStockProdutosComVariacoes() {
        $idArmaze = $this->input->post('idArmaze');
        $idArmanzeDestino = $this->input->post('idArmanzeDestino');
        $qtd = $this->input->post('qtd');
        $idCor = $this->input->post('idCor');
        $idTamanho = $this->input->post('idTamanho');
        $operacao1 = $this->input->post('operacao1'); // vai no armanzem de origem
        $operacao = $this->input->post('operacao');
        $idProduto = $this->input->post('idProduto');
        $idUsuario = $this->input->post('idUsuario');
        $this->load->model('StockM');
        $this->load->model('ProdutosM');
        if (empty($idArmanzeDestino)) {
            $this->StockM->somaQtd($idProduto, $qtd, $idArmaze);
            $this->StockM->somaQtdVariacoes($idProduto, $qtd, $idArmaze, $idCor, $idTamanho);
            $this->StockM->registarHistoricoStockVariacooes($idProduto, $qtd, $operacao, $idUsuario, $idArmaze, 'ENTRADA2', $idCor, $idTamanho);
            $this->json->success('OK');
        } else {
            $this->transferir_produto_variacao($idProduto, $idArmaze, $qtd, $idArmanzeDestino, $idCor, $idTamanho);
            $this->historicoSaidaVariacoes($idProduto, $qtd, $operacao1, $idUsuario, $idArmaze, $idCor, $idTamanho);
            $this->historicoEntradaVariacoes($idProduto, $qtd, $operacao1, $idUsuario, $idArmanzeDestino, $idCor, $idTamanho);
            $this->json->success('OK');
        }
    }

    public function listarHistoricoPorLojas() {
        $idArmaze = $this->input->get('idArmanze');
        $idProduto = $this->input->get('idProduto');
        $this->load->model('mStock');
        $this->load->model('mArtigos');
        $observacao = '';
        $dados = array();
        foreach ($this->mStock->mlistarHistoricoPorLojas($idArmaze, $idProduto) as $linha) {
            $tipo = $linha->tipo;
            $operacao = $linha->operacao;
            $idHistoricoStock = $linha->idHistoricoStock;
            $data = $linha->data;
            $qtd = $linha->qtd;
            $hora = $linha->hora;
            $usuario = $linha->usuario;
            $idArmanzeDestino = $this->mStock->idArmanzeDestino($idHistoricoStock);
            $idArmanzeOrigem = $this->mStock->idArmanzeOrigem2($idHistoricoStock);
            $armanzeDestino = $this->mArtigos->armanze($idArmanzeDestino);
            $armanzeOrigem = $this->mArtigos->armanze($idArmanzeOrigem);
            $dados[] = array(
                'data' => $data,
                'hora' => $hora,
                'qtd' => $qtd,
                'tipo' => $tipo,
                'operacao' => $operacao,
                'usuario' => $usuario,
                'observacao' => $observacao,
                'armanzeDestino' => $armanzeDestino,
                'armanzeOrigem' => $armanzeOrigem,
            );
        }
        echo json_encode(array(
            "data" => $dados,
        ));
    }

    public function listarHistoricoPorLojasVariacoes() {
        $idArmaze = $this->input->get('idArmanze');
        $idProduto = $this->input->get('idProduto');
        $idCor = $this->input->get('idCor');
        $idTamanho = $this->input->get('idTamanho');
        $this->load->model('StockM');
        $this->load->model('ProdutosM');
        $observacao = '';
        $sIcon = '';
        if ($this->StockM->mlistarHistoricoPorLojasVariacoes($idArmaze, $idProduto, $idCor, $idTamanho)) {
            foreach ($this->StockM->mlistarHistoricoPorLojasVariacoes($idArmaze, $idProduto, $idCor, $idTamanho) as $linha) {
                $tipo = $linha->tipo;
                $operacao = $linha->operacao;
                $idHistoricoStock = $linha->idHistoricoStock;
                $data = $linha->data;
                $qtd = $linha->qtd;
                $hora = $linha->hora;
                $usuario = $linha->usuario;
                if ($tipo == 'SAIDA') {
                    $idArmanzeDestino = $this->StockM->idArmanzeDestino2VariacoesProdutos($idHistoricoStock);
                    $idArmanzeOrigem = $this->StockM->idArmanzeOrigem($idHistoricoStock);
                    $armanzeDestino = $this->ProdutosM->armanze($idArmanzeDestino);
                    $armanzeOrigem = $this->ProdutosM->armanze($idArmanzeOrigem);
                    $observacao = $armanzeOrigem . '<div class="fa fa-long-arrow-right"></div>' . '<span style="color:blue">' . $armanzeDestino . '</span>';
                    $qtd2 = '-' . $qtd;
                    $sIcon = '<div class="fa fa-long-arrow-right"></div>';
                }
                if ($tipo == 'ENTRADA') {
                    $idArmanzeDestino = $this->StockM->idArmanzeDestinoVariacoes($idHistoricoStock);
                    $idArmanzeOrigem = $this->StockM->idArmanzeOrigem2Variacoes($idHistoricoStock);
                    $armanzeDestino = $this->ProdutosM->armanze($idArmanzeDestino);
                    $armanzeOrigem = $this->ProdutosM->armanze($idArmanzeOrigem);
                    $observacao = $armanzeDestino . '<div class="fa fa-long-arrow-left"></div>' . '<span style="color:blue">' . $armanzeOrigem . '</span>';
                    $qtd2 = '<span style="color:green;">' . $qtd . '</span>';
                    $sIcon = '<div class="fa fa-plus-square"></div>';
                }
                if ($tipo == 'ENTRADA2') {
                    $observacao = '';
                    $qtd2 = '<span style="color:green;">' . $qtd . '</span>';
                    $sIcon = '<div class="fa fa-plus-square"></div>';
                }
                $data1 = '<span style="color:black ;font-weight:bold">' . $data . '</span>' . '<br><i>' . $hora . '</i>';
                $operacao1 = '<span style="color:black ;font-weight:bold">' . $operacao . '</span>' . '<br><i>' . $usuario . '</i>';
                $dados[] = array(
                    'narmanze' => $data1,
                    'icon' => $sIcon,
                    'qtd' => $qtd2,
                    'operacao' => $operacao1,
                    'observacao' => $observacao,
                );
                $total = count($this->StockM->mlistarHistoricoPorLojasVariacoes($idArmaze, $idProduto, $idCor, $idTamanho));
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listarArmanzeGridDinamuca() {
        $this->load->model('StockM');
        if ($this->StockM->pegaLojasProduto()) {
            foreach ($this->StockM->pegaLojasProduto() as $linha) {
                $dados[] = array(
                    'idArmaze' => $linha->idArmaze,
                    'narmanze' => $linha->narmanze,
                    'totalArmanze' => count($this->StockM->pegaLojasProduto()),
                );
                $total = count($this->StockM->pegaLojasProduto());
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function listaVariacaoTamanhoProduto() {
        //     $idCor = $this->input->get('idCor');  
        $idProduto = $this->input->get('idProduto');

        $this->load->model('StockM');
        $this->load->model('ProdutosM');
        $cont = 0;
        $key = array(
            'idCor',
            'idTamanho',
            'idLoja',
            'idProduto',
            'nomeCorWin',
            'cor',
            'codigobarras',
        );
        foreach ($this->StockM->pegaLojasProduto() as $linhaLoj) {
            $cont++;
            $armanze = 'armanze' . $linhaLoj->idArmaze;
            array_push($key, $armanze);
        }
        if ($this->StockM->mListaVariacaoTamanhoProduto($idProduto)) {
            foreach ($this->StockM->mListaVariacaoTamanhoProduto($idProduto) as $linha) {
                $idProduto = $linha->idProduto;
                $idTamanho = $linha->idTamanho;
                $idCor = $linha->idCor;
                $dadosBd = array(
                    $idCor,
                    $idTamanho,
                    $linha->idLoja,
                    $idProduto,
                    '<span style="color:blue ;font-weight:bold">' . $linha->cor . ' / ' . $linha->tamanho . '</span>',
                    '<span style="color:blue ;font-weight:bold">' . $linha->cor . ' / ' . $linha->tamanho . '</span>' . '<br><i>VCMA9-1292828.blues</i>',
                    $linha->codigobarras,
                );
                foreach ($this->StockM->pegaLojasProduto() as $linhaLoj) {
                    $idArmaze = $linhaLoj->idArmaze;
                    $arrayQtd = $this->StockM->stockLojaArmanzeTamanhoProduto($idProduto, $idArmaze, $idTamanho, $idCor);
                    if ($arrayQtd) {
                        foreach ($arrayQtd as $qtdLojas) {
                            if ($qtdLojas->qtd > 0) {
                                $qtd = '<span style="color:black ;font-weight:bold">' . $qtdLojas->narmanze . ' </span>' . '<span style="color:green ;font-weight:bold">' . $qtdLojas->qtd . ' </span>';
                            } else {
                                $qtd = '<span style="color:black ;font-weight:bold">' . $qtdLojas->narmanze . ' </span>' . '<span style="color:red ;font-weight:bold">' . $qtdLojas->qtd . ' </span>';
                            }

                            array_push($dadosBd, $qtd);
                        }
                    } else {
                        array_push($dadosBd, 0);
                    }
                }

                $dados[] = array_combine($key, $dadosBd);
                $total = 20;
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function relatorioAcerto() {

        $dataAcerto = $this->input->post('dataAcerto');
        $this->load->model('StockM');
        if ($this->StockM->consulta_acerto_inventario($dataAcerto) > 0) {
            $this->load->model('mAcertosInventario');
            $this->mAcertosInventario->acertosPDF($dataAcerto);
            $this->json->success('OK');
        } else {
            $this->json->success('N');
        }
    }

    public function listaTrasferenciaProdutos() {
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');

        setlocale(LC_ALL, "pt_BR", "pt_BR.iso-8859-1", "pt_BR.utf-8", "portuguese");
        $this->load->model('StockM');
        if ($this->StockM->listarProdutosTransferencia($start, $limit)) {
            foreach ($this->StockM->listarProdutosTransferencia($start, $limit) as $linha) {
                $dataBd = $linha->data;
                $sd2 = new DateTime($dataBd);
                $ano = $sd2->format('Y');
                $data = utf8_encode(strftime("%a %d  %b  %Y", strtotime($sd2->format("d. M. Y "))));
                $dados[] = array(
                    'idTrans' => $linha->idTrans,
                    'n' => 'TRANS' . ' ' . $ano . '/' . $linha->idTrans,
                    'data' => $data . ' ' . $linha->hora,
                    'destino' => $linha->destino,
                );
                $total = $this->StockM->totalTrasferencia();
                $codificar = json_encode($dados);
                $resposta = '{success: true, total:' . $total . ',data:' . $codificar . '}';
            }
        } else {
            $resposta = "{success:false, total: 0, data:''}";
        }
        echo $resposta;
    }

    public function imprimirListaProductosTransferidos() {
        $this->load->model('mListaProdutosTransgeridos');
        $idTrans = $this->input->post('idTrans');
        $this->mListaProdutosTransgeridos->imprimirProdutosTransferidos($idTrans);
        $this->json->success('OK');
    }

}

?>
