<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of StockM
 *
 * @author VINEVALA
 */
class mGestaoStock extends CI_Model {
    public function registarQtd($idProduto, $qtd,$custo,$totalcompras){
        $dados=array(
            'idproduto'=> $idProduto,
            'qtd'=>$qtd,
            'custo'=>$custo,
            'totalcompras' =>$totalcompras,
            'ultimadata'=>@date('Y-m-d') 
        );
        $this->db->insert('stock_quantidade',$dados) ; 
    }
    public function registarPedidos($idfornecedor,$motivo,$idusuario){
        $dados=array(
           'motivo'=>$motivo,
          'idFornecedor'=>$idfornecedor, 
          'dataPedido' =>@date('Y-m-d'), 
          'idUsuario'=>$idusuario
        );
        $this->db->insert('pedidoCompras',$dados) ;
       return $this->db->insert_id();
    }
    public function registarPedidosItem($idCompra,$idProduto,$qtd,$idUnidade){
        $dados=array(
           'idPedido'=>$idCompra,
           'idProduto'=>$idProduto, 
           'qtd'=>$qtd,
           'idUnidade'=>$idUnidade
        );
        $this->db->insert('itemPedido',$dados) ;
  
    }
    public function registarStockM($idProduto,$qtd,$custo,$venda,$totalcompras,$iva,$idusuario,$idCompra){
        $dados=array(
            'idproduto'=> $idProduto,
            'qtd'=>$qtd,
            'custo'=>$custo,
            'venda'=>$venda,
            'iva'=>$iva,
            'totalcompra'=>$totalcompras,
            'data' =>@date('Y-m-d'),
            'id_usiario'=>$idusuario,
            'idCompra'=>$idCompra,
        );
        $this->db->insert('item_compras',$dados) ; 
    }
     public function registarItemCompras($idProduto,$qtd,$custo,$idUnidade,$totalcompras,$iva,$idusuario,$idCompra,$prazo,$totalUnidade){
        $dados=array(
            'idproduto'=> $idProduto,
            'qtd'=>$qtd,
            'custo'=>$custo,
            'idUnidade'=>$idUnidade,
            'totalcompra'=>$totalcompras,
            'id_usiario'=>$idusuario,
            'idCompra'=>$idCompra,
            'iva'=>$iva,
            'prazo_validade'=>$prazo,
            'total_por_unidade'=>$totalUnidade,
        );
        $this->db->insert('item_compras',$dados) ; 
    }
    // metodo para atualizar stock somando
    public function atualiarQtd($idProduto, $qtd,$custo,$venda,$totalcompras){
        $data=@date('Y-m-d');
        $this->db->where('idproduto',$idProduto);
        $this->db->set('qtd','qtd+'.$qtd,FALSE);
        $this->db->set('custo',$custo);
        $this->db->set('venda',$venda);
        $this->db->set('totalcompras',$totalcompras);
        $this->db->set('ultimadata',$data);
         $this->db->update('stock_quantidade');
    }
    public function pegarQtd($idProduto)
    {  
       $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto',$idProduto);
        $query = $this->db->get();
        return $query->result();
    }
    public function atualizarSubtrairQtd($idProduto, $qtd){
     $this->db->where('idproduto',$idProduto);
     $this->db->set('qtd','qtd-'.$qtd, FALSE);
     $this->db->update('stock_quantidade');
    }
     public function atualizaEstadoCompra($idProduto,$idPedido,$comprado){
     $this->db->where('idPedido',$idPedido);
     $this->db->where('idProduto',$idProduto);
     $this->db->set('comprado',$comprado);
     $this->db->update('itempedido');
    }
    // metodo para verificar se o produto ja existe em stock
    public function consulta($idProduto) {
        $this->db->where('idproduto', $idProduto); 
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
          return false;
        
    }
//    metodo para vrificar a quantidade
     public function consultaQtd($idProduto, $qtd)
    {
       
        $this->db->where('idproduto', $idProduto);
        $this->db->where('qtd <', $qtd); 
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
            return false;
        
   
    }
    
    
//    metodo para listar a quantidade  disponivel
    public function listarQtdM($start,$limit,$produto) {  
       $this->db->select('*');
       $this->db->from('stock_quantidade');
       $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
       if($produto!=''){
            $this->db->like('produto',$produto);
        }
            $this->db->limit($limit, $start);
            $this->db->order_by('produto');
            $query = $this->db->get();
            return $query->result();
    }
    public function totalProdutos(){ // pega o total pago de uma divida
        $this->db->select_sum('qtd');//
        $this->db->from('stock_quantidade');
      //  $this->db->where('idCredito', $idCredito); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
        
    }
    //metodo para listar stock realizados
    public function listarComprasM($start, $limit,$dataminima,$datamaxima)
    {  
         $this->db->select('*');
         $this->db->from('compras');
         $this->db->join('usuarios', 'compras.id_usiario = usuarios.id_usiario');
         $this->db->join('fonecedores', 'compras.idfornecedor = fonecedores.idfornecedor');
         if($datamaxima!=''){
            $this->db->where('dataentrada >=',$dataminima);
            $this->db->where('dataentrada<=',$datamaxima);
        }
   
         $this->db->limit($limit,$start);
          $this->db->order_by('dataentrada', 'DESC');
        $query = $this->db->get();
        return $query->result();  
    }
    
    //metodo que conta as linhas exitente na tabela quantidade_stock
     public function contarlinhasM(){
         $this->db->select('*');
         $this->db->from('stock_quantidade');
         $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        return $this->db->count_all_results();
    }
    //metodo que conta as linhas exitente na tabela stock
    public function contarlinhasStok(){
         $this->db->select('*');
         $this->db->from('compras');
        return $this->db->count_all_results();
    }
    //verifica se a quantidade desejada e menor ue a existente no bd
    public function consultaQuantidade($idpr,$qtd)
    { 
        $this->db->where('idproduto', $idpr);
        $this->db->where('qtd <', $qtd); 
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
            return false;
    }
    
    public function selecionarIdStock($idpr)
    {   $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idpr);
        $query = $this->db->get();
        return $query->result();
    }//
    public function CopiarStock(){
      
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('prodt.idTipo', 3);
        $query = $this->db->get();
        return $query->result();
    }
    // metodo para atualizar o novo valor no  stock subtraindo
    public function atualizarValor($idstock, $novovalofinal){

        $this->db->where('idstock',$idstock);
        $this->db->set('totalcompras','totalcompras-'.$novovalofinal,FALSE);
         $this->db->update('stock_quantidade');
    }
    
    
    // Imprimir vendas
    public function listarCompras($dataminima,$datamaxima){
        $this->db->select('*');
        $this->db->from('stock');
        $this->db->join('prodt', 'stock.idproduto = prodt.idpr');
        $this->db->join('usuarios', 'stock.id_usiario = usuarios.id_usiario');
         if($datamaxima!=''){
            $this->db->where('data >=',$dataminima);
            $this->db->where('data<=',$datamaxima);
        }
          $this->db->order_by('data', 'DESC');
          $query = $this->db->get();
          return $query->result(); 
    }
    public function preco_produto($idProduto,$preco){
         $this->db->where('idpr',$idProduto);
         $this->db->set('preco',$preco);
         $this->db->update('prodt');     
    }
    public function atualizaPrecoStQtd($idstock,$custo,$venda,$data,$idProduto){
        $dados=array(
            'custo'=>$custo,
            'venda'=>$venda,
        );
         $this->db->where('idstock',$idstock);
         $this->db->set($dados);
         $this->db->update('stock_quantidade');
         $qtd= $this->pegaQtdPorData($data);
         $totalcompra=$qtd*$custo;
         $dadosStock=array(
            'custo'=>$custo,
            'venda'=>$venda,
            'totalcompra'=>$totalcompra,
        );
         $this->db->where('idproduto',$idProduto);
         $this->db->where('data',$data);
         $this->db->set($dadosStock);
         $this->db->update('stock'); 
         
         $dadosProduto=array(
         'preco'=>$venda,
        );
         $this->db->where('idpr',$idProduto);
         $this->db->set($dadosProduto);
         $this->db->update('prodt'); 
    }
    
     public function pegaQtdPorData($data){  
       $this->db->select('qtd');
        $this->db->from('stock');
        $this->db->where('data',$data);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->qtd;
        }
      
    }
    public function pegarPrecoIva($idProduto){
        $this->db->select('*');
        $this->db->from('stock');
        $this->db->where('idproduto',$idProduto);
        $this->db->order_by('idstock', 'DESC');
        $this->db->limit(1);
        $query = $this->db->get();
        return $query->result(); 
    }
     public function registarCompra($idfornecedor, $nfatura,$dtaCompra,$idusuario,$idPedido){
        $dados=array(
          'idfornecedor'=> $idfornecedor,
          'nfatura'=>$nfatura,
          'hora'=>@date('H:i:s'),
          'dataCompra'=>$dtaCompra,
          'dataentrada'=>@date('Y-m-d'), 
          'id_usiario'=>$idusuario,
          'idPedido'=>$idPedido,
        );
        $this->db->insert('compras',$dados) ; 
        return $this->db->insert_id();
    }
    public function qtdAntiga($idstock){ // pega  a quandidade 
        $this->db->select('qtd');//
        $this->db->from('stock');
        $this->db->where('idstock', $idstock); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
        
    }
    public function pegaIdProduto($idstock){ // pega o a id do dproduto atraves do id stock 
        $this->db->select('idproduto');//
        $this->db->from('stock');
        $this->db->where('idstock', $idstock); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idproduto;
        }
        
    }
    public function pegaCusto($idProduto){ // pega o custo da compra do produto
        $this->db->select('custopr');//
        $this->db->from('prodt');
        $this->db->where('idpr', $idProduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custopr;
        }
        
    }
     // meto que reseta a quantidade  comprada
    public function resetarQtd($idProduto, $qtd){

        $this->db->where('idstock',$idProduto);
         $this->db->set('totalcompra',0);
        $this->db->set('qtd','qtd-'.$qtd,FALSE);
         $this->db->update('stock');
    }
    // meto que soma a quantidade em comprada
    public function somaQtdCompra($idstock, $qtd,$totalcompras){
        $this->db->where('idstock',$idstock);
          $this->db->set('totalcompra','totalcompra+'.$totalcompras,FALSE);
        $this->db->set('qtd','qtd+'.$qtd,FALSE);
         $this->db->update('stock');
    }
     // subtrair a quanidade
    public function subtrairQuantidede($idproduto, $qtd){

        $this->db->where('idproduto',$idproduto);
      
         $this->db->set('qtd','qtd-'.$qtd,FALSE);
         $this->db->update('stock_quantidade');
    }
    public function somaQuantidedePrecoCompra($idproduto, $qtd,$totalcompras){

        $this->db->where('idproduto',$idproduto);
        $this->db->set('totalcompras','totalcompras+'.$totalcompras,FALSE);
         $this->db->set('qtd','qtd+'.$qtd,FALSE);
         $this->db->update('stock_quantidade');
    }
     public function pegaIdStockQauntidade($idproduto){ // pega id Stock quantidade
        $this->db->select('idstock');//
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idproduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idstock;
        }
        
    }
    public function pegaUltimaDataCompra($idproduto){ // pega a ultima data da compra
        $this->db->select('ultimadata');//
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idproduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->ultimadata;
        }
        
    }
    public function verificar_se_existe_inventario($idstock,$data){// 
       $this->db->select('idstock');
       $this->db->from('inventario');
       $this->db->where('datainventario>=',$data); 
       $this->db->where('idstock',$idstock); 
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
          return false;  
   }
   public function pegaIdInventario($idstock,$data){// 
       $this->db->select('idinventario');
       $this->db->from('inventario');
       $this->db->where('datainventario >=',$data); 
       $this->db->where('idstock',$idstock); 
       $this->db->limit(1); 
       $this->db->order_by('idinventario','DESC');
       $consulta=  $this->db->get();
       foreach ($consulta->result() as $value) {
            return $value->idinventario;
        }  
   }
   public function pegaIdHistorico($idproduto){// 
       $this->db->select('idhistorico');
       $this->db->from('historicoprodutos');
       $this->db->where('idproduto',$idproduto); 
       $this->db->where('tipomovimento','ENTRADA'); 
       $this->db->limit(1); 
       $this->db->order_by('idhistorico','DESC'); 
       $consulta=  $this->db->get();
       foreach ($consulta->result() as $value) {
            return $value->idhistorico;
       } 
   }
       public function resetaHistorico($idhistorico, $qtd){
        $this->db->where('idhistorico',$idhistorico);
         $this->db->set('qtd','qtd-'.$qtd,FALSE);
         $this->db->update('historicoprodutos');
      }
       public function atualizaHistorico($idhistorico, $qtd){
        $this->db->where('idhistorico',$idhistorico);
         $this->db->set('qtd','qtd+'.$qtd,FALSE);
         $this->db->update('historicoprodutos');
      }
      public function pega_preco_venda($idproduto){// 
       $this->db->select('preco');
       $this->db->from('prodt');
       $this->db->where('idpr',$idproduto); 
   
       $consulta=  $this->db->get();
       foreach ($consulta->result() as $value) {
            return $value->preco;
       } 
   }
      public function totalGeralVendas() { // soma o valor total de vendas 
       $this->db->select('qtd,idproduto');
       $this->db->from('stock_quantidade');
       $query = $this->db->get();
       $totalGeral=0;
       foreach ($query->result() as $linha) {
         $qtd=$linha->qtd;
         $venda= $this->pega_preco_venda($linha->idproduto);
         $totalv=$qtd*$venda;
         $totalGeral=$totalv+$totalGeral; 
       }
       return $totalGeral;
    }
     
    // Imprimir 
    public function listarPedido(){
        $this->db->select('*');
        $this->db->from('pedidoCompras');
        $this->db->join('fonecedores', 'pedidoCompras.idFornecedor = fonecedores.idfornecedor');
        $this->db->join('usuarios', 'pedidoCompras.idUsuario = usuarios.id_usiario');

        $this->db->order_by('idPedido', 'DESC');
        $query = $this->db->get();
        return $query->result(); 
    }
    public function contarPedidos(){// 
       $this->db->select('*');
        $this->db->from('pedidoCompras');
        $this->db->join('fonecedores', 'pedidoCompras.idFornecedor = fonecedores.idfornecedor');
        $this->db->join('usuarios', 'pedidoCompras.idUsuario = usuarios.id_usiario');
        return $this->db->count_all_results();
        
   }
    public function atualizaPedidosm($idPedido,$dataEntrega,$valor){

        $this->db->where('idPedido',$idPedido);
        $this->db->set('dataEntrega',$dataEntrega);
         $this->db->set('valor',$valor);
         $this->db->update('pedidoCompras');
    }
    public function listarPedidoPdf($idPedido){
        $this->db->select('*');
        $this->db->from('pedidoCompras');
        $this->db->join('itemPedido', 'pedidoCompras.idPedido = itemPedido.idPedido');
         $this->db->join('prodt', 'itemPedido.idProduto = prodt.idpr');
        $this->db->join('fonecedores', 'pedidoCompras.idFornecedor = fonecedores.idfornecedor');
         $this->db->join('contatofornecedor', 'fonecedores.idfornecedor = contatofornecedor.idfornecedor');
        $this->db->join('usuarios', 'pedidoCompras.idUsuario = usuarios.id_usiario');

        $this->db->where('pedidoCompras.idPedido',$idPedido);
        $query = $this->db->get();
        return $query->result(); 
    }
    
    //verifica se o produto ja existe na tabela stok
    public function verificaProdutoStock($idpr){ 
        $this->db->where('idproduto', $idpr);
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
            return false;
    }
     public function total_qtd_compra_por_fatura_fornecedor($idCompra){ // 
        $this->db->select_sum('qtd');//
        $this->db->from('compras');
         $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where('compras.idCompra', $idCompra); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
        
    }
    public function total_custo_compra_por_fatura_fornecedor($idCompra){ // 
        $this->db->select_sum('custo');//
        $this->db->from('compras');
         $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where('compras.idCompra', $idCompra); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custo;
        }
        
    }
    public function listatotal_compra_por_fatura_fornecedor($idCompra){ // 
        $this->db->select('*');//
        $this->db->from('compras');
         $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
         $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
         $this->db->join('unidade_medida', 'item_compras.idUnidade = unidade_medida.idUnidade');
        $this->db->where('compras.idCompra', $idCompra); 
        $consulta=  $this->db->get();
         return $consulta->result();
        
    }
     public function listarNumeroPedidos(){
        $this->db->select('idPedido');
        $this->db->from('pedidoCompras');
        $this->db->order_by('idPedido', 'DESC'); 
        $query = $this->db->get();
        return $query->result(); 
    }
    public function listar_compras($start,$limit){ 
        $this->db->select('item_compras.idstock,compras.dataCompra,item_compras.prazo_validade,item_compras.custo ,item_compras.qtd, prodt.produto,
                fonecedores.fornecedor,armanzes.narmanze,item_compras.total_por_unidade');//
        $this->db->from('item_compras'); 
        $this->db->join('compras', 'item_compras.idCompra = compras.idCompra');
        $this->db->join('fonecedores', 'compras.idfornecedor = fonecedores.idfornecedor');
         $this->db->join('armanzes', 'compras.idArmanze = armanzes.id');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
         $this->db->limit($limit,$start);
        $consulta=  $this->db->get();
         return $consulta->result();
        
    }
    public function contar_compras(){ 
        $this->db->select('item_compras.idstock,compras.dataCompra,item_compras.prazo_validade,item_compras.custo ,item_compras.qtd, prodt.produto,
                fonecedores.fornecedor,armanzes.narmanze,item_compras.total_por_unidade');//
        $this->db->from('item_compras'); 
        $this->db->join('compras', 'item_compras.idCompra = compras.idCompra');
        $this->db->join('fonecedores', 'compras.idfornecedor = fonecedores.idfornecedor');
         $this->db->join('armanzes', 'compras.idArmanze = armanzes.id');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
       
         return $this->db->count_all_results();
        
    }
    
     public function armanze(){ 
        $this->db->select('*');//
        $this->db->from('armanzes'); 
        $this->db->where('id !=', 1); 
        $this->db->where('id !=', 3); 
        $consulta=  $this->db->get();
        return $consulta->result();   
    }
     public function registarMovimentoProduto($idusuario){
        $dados=array(
           'idusuario'=>$idusuario, 
           'data' =>@date('Y-m-d'), 
        );
        $this->db->insert('movimentacoes_produtos',$dados) ;
       return $this->db->insert_id();
    }
    public function registar_armanzes_destino_produto($idMovimento,$idArmanzeDestino){
        $dados=array(
           'idMovimento'=>$idMovimento, 
           'idArmanze' =>$idArmanzeDestino, 
        );
        $this->db->insert('armanzes_destino_produto',$dados) ;    
    }
    public function registar_armanzes_origem_produto($idMovimento,$idArmanzeOrigem){
        $dados=array(
           'idMovimento'=>$idMovimento, 
           'idArmanze' =>$idArmanzeOrigem, 
        );
        $this->db->insert('armanzes_origem_produto',$dados) ;    
    }
     public function registarMovimentoProdutoItem($qtd,$idProduto,$idMovimento,$custo){
        $dados=array(
             'qtd'=>$qtd,  
             'idProduto'=>$idProduto, 
             'idMovimento'=>$idMovimento,
             'custo'=>$custo,
          
        );
        $this->db->insert('item_movimentacoes_produtos',$dados) ;
      
    }
    public function pegaUnidadeVenda($idProduto){ // 
        $this->db->select('idUnidade');//
        $this->db->from('prodt');
        $this->db->where('idpr', $idProduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->idUnidade;
        }
      
    }
    public function pegaUnidadeCompra($idProduto){ // 
        $this->db->select('idUnidade');//
        $this->db->from('item_compras');
        $this->db->where('idproduto', $idProduto); 
        $this->db->limit(1); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->idUnidade;
        }
      
    } 
    public function pega_total_por_unidade($idProduto){ // 
        $this->db->select('total_por_unidade');//
        $this->db->from('item_compras');
        $this->db->where('idproduto', $idProduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->total_por_unidade;
        }
      
    }
     public function pega_total_preco_grosso($idProduto){ // 
        $this->db->select('custo');//
        $this->db->from('item_compras');
        $this->db->where('idproduto', $idProduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->custo;
        }
      
    }
     public function pega_total_preco_retalho($idProduto){ // 
        $this->db->select('custopr');//
        $this->db->from('prodt');
        $this->db->where('idpr', $idProduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->custopr;
        }
      
    }
    public function pega_custo_compra($idProduto){ // 
        $this->db->select('custo');//
        $this->db->from('item_compras');
        $this->db->where('idproduto', $idProduto); 
        $this->db->order_by('idstock', 'DESC'); 
         $this->db->limit(1); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->custo;
        }
      
    }
    public function pega_custo_venda($idProduto){ // 
        $this->db->select('custo as venda');//
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idProduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->venda;
        }
      
    }
     public function listar_movimento_produtos($start,$limit){   
        $this->db->select('movimentacoes_produtos.data,movimentacoes_produtos.hora,prodt.idpr,prodt.produto,item_movimentacoes_produtos.qtd,
                 item_movimentacoes_produtos.custo,usuarios.unome,armanzes_destino_produto.idArmanze');//
        $this->db->from('movimentacoes_produtos'); 
        $this->db->join('item_movimentacoes_produtos', 'movimentacoes_produtos.idMovimento = item_movimentacoes_produtos.idMovimento');
        $this->db->join('prodt', 'item_movimentacoes_produtos.idProduto = prodt.idpr');
        $this->db->join('usuarios', 'movimentacoes_produtos.idusuario = usuarios.id_usiario');

         $this->db->join('armanzes_destino_produto', 'movimentacoes_produtos.idMovimento = armanzes_destino_produto.idMovimento');
        $this->db->order_by('movimentacoes_produtos.idMovimento', 'DESC');
         $this->db->limit($limit,$start);
        $consulta=  $this->db->get();
         return $consulta->result();
        
    }
    public function conta_movimento_produtos(){   
        $this->db->select('movimentacoes_produtos.data,prodt.idpr,prodt.produto,item_movimentacoes_produtos.qtd,
                 item_movimentacoes_produtos.custo,usuarios.unome,armanzes_destino_produto.idArmanze');//
        $this->db->from('movimentacoes_produtos'); 
        $this->db->join('item_movimentacoes_produtos', 'movimentacoes_produtos.idMovimento = item_movimentacoes_produtos.idMovimento');
        $this->db->join('prodt', 'item_movimentacoes_produtos.idProduto = prodt.idpr');
        $this->db->join('usuarios', 'movimentacoes_produtos.idusuario = usuarios.id_usiario');
         $this->db->join('armanzes_destino_produto', 'movimentacoes_produtos.idMovimento = armanzes_destino_produto.idMovimento');
        $consulta=  $this->db->get();
         return $consulta->result(); 
    }
     public function pega_narmanze_nome($idArmanze){  
        $this->db->select('narmanze');//
        $this->db->from('armanzes');
        $this->db->where('id', $idArmanze); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->narmanze;
        }
      
    }
     public function pegaUnidadeMedida($idProduto){ // 
        $this->db->select('nunidade');//
        $this->db->from('unidade_medida');
        $this->db->where('idUnidade', $idProduto); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->nunidade;
        }
      
    }
     public function listar_iventario_geral($start,$limit){   
        $this->db->select('item_compras.idproduto,item_compras.custo,item_compras.qtd,prodt.produto,compras.idArmanze,prodt.stockMinimo,prodt.stockMaximo');//
        $this->db->from('compras');  
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
        $this->db->group_by('item_compras.idproduto');
        $this->db->order_by('produto');
        $this->db->limit($limit,$start);
        $consulta=  $this->db->get();
         return $consulta->result();
        
    }
     public function contar_iventario_geral(){   
        $this->db->select('item_compras.idproduto,item_compras.custo,item_compras.qtd,prodt.produto,compras.idArmanze');//
        $this->db->from('compras');  
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
        $this->db->group_by('item_compras.idproduto');
         return $this->db->count_all_results();
        
    }
     public function soma_qtd_entradas($idproduto){ // soma a quantidade de entradas por cada produto  
        $this->db->select_sum('qtd');//
        $this->db->from('item_compras'); 
        $this->db->where('idproduto', $idproduto);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->qtd;
        }
  
    }
    public function soma_qtd_entradas_por_prazo($idproduto,$prazo_validade){   
        $this->db->select_sum('qtd');//
        $this->db->from('item_compras'); 
        $this->db->where('idproduto', $idproduto);
         $this->db->where('prazo_validade', $prazo_validade);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->qtd;
        }
  
    }
     public function soma_total_gastos($idproduto){   
        $this->db->select_sum('totalcompra');//
        $this->db->from('item_compras'); 
        $this->db->where('idproduto', $idproduto);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->totalcompra;
        } 
    }
    
    public function soma_qtd_saidas($idArmanze,$idProduto){   
        $this->db->select_sum('qtd');//
        $this->db->from('movimentacoes_produtos'); 
        $this->db->join('item_movimentacoes_produtos', 'movimentacoes_produtos.idMovimento = item_movimentacoes_produtos.idMovimento');
        $this->db->join('armanzes_origem_produto', 'movimentacoes_produtos.idMovimento = armanzes_origem_produto.idMovimento');
         $this->db->where('armanzes_origem_produto.idArmanze', $idArmanze);
        $this->db->where('item_movimentacoes_produtos.idProduto', $idProduto);
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->qtd;
        }
       
        
    }  
    public function contar_iventario_prazo(){   
        $this->db->select('item_compras.idproduto,item_compras.custo,item_compras.qtd,prodt.produto,compras.idArmanze,item_compras.prazo_validade');//
        $this->db->from('compras');  
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
        $this->db->where('prazo_validade !=',NULL);
        $this->db->group_by('prazo_validade');
        $this->db->order_by('produto');  
         return $this->db->count_all_results();
        
    }
    public function listar_iventario_prazo_validade($start,$limit){   
        $this->db->select('item_compras.idproduto,item_compras.custo,item_compras.qtd,prodt.produto,compras.idArmanze,item_compras.prazo_validade');//
        $this->db->from('compras');  
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
        $this->db->where('prazo_validade !=',NULL);
        $this->db->group_by('prazo_validade');
        $this->db->order_by('produto,prazo_validade');
        $this->db->limit($limit,$start);
        $consulta=  $this->db->get();
         return $consulta->result();
        
    }
     public function soma_qtd_entradas_total(){   
        $this->db->select_sum('qtd');//
        $this->db->from('item_compras'); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->qtd;
        }
     }
   public function soma_qtd_saidas_total($idArmanze){   
        $this->db->select_sum('qtd');//
        $this->db->from('movimentacoes_produtos'); 
        $this->db->join('item_movimentacoes_produtos', 'movimentacoes_produtos.idMovimento = item_movimentacoes_produtos.idMovimento');
        $this->db->join('armanzes_origem_produto', 'movimentacoes_produtos.idMovimento = armanzes_origem_produto.idMovimento');
         $this->db->where('armanzes_origem_produto.idArmanze', $idArmanze);
       
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
             return $value->qtd;
        }  
    }  
    public function total_por_produto_armazem($idProduto){   
        $this->db->select('item_compras.idproduto,item_compras.custo,item_compras.qtd,prodt.produto,compras.idArmanze,prodt.stockMinimo,prodt.stockMaximo');//
        $this->db->from('compras');  
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
        $this->db->where('item_compras.idproduto', $idProduto);
        $this->db->group_by('item_compras.idproduto');
        $consulta=  $this->db->get();
         return $consulta->result();
        
    }
     public function mpegaqtd_unidade($idProduto){ // 
        $this->db->select('total_por_unidade');//
        $this->db->from('compras');
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where("idproduto",$idProduto); 
        $this->db->limit(1); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
               if($value->total_por_unidade){
                     return $value->total_por_unidade; 
                }else{
                   return 0;   
                }
            }
      
    }
    public function tipo_grupo($idGrupoPreco){ // 
        $this->db->select('tipo_grupo');//
        $this->db->from('grupo_preco');
        $this->db->where("idGrupoPreco",$idGrupoPreco);  
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
                 return $value->tipo_grupo; 
            }
      
      }

     public function mconsulta_idproduto_compra($idproduto){ 
     $this->db->select('idproduto');
     $this->db->from('compras');
     $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
     $this->db->where("idproduto",$idproduto);
     if($this->db->count_all_results()>0){
        return true;   
     }else{
       return false;      
     }
   
     }
      public function mpega_unidade_medida($idProduto){ // 
        $this->db->select('idUnidade');//
        $this->db->from('compras');
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where("idproduto",$idProduto); 
        $this->db->limit(1); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
               return $value->idUnidade; 
            }
      
    }
    
}


?>
