<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mInventario
 *
 * @author VINEVALA
 */
class mInventario extends CI_Model {
    public function regirtarInventarioM($idStock,$qtdinicial,$qtd,$totalcompras,$qtd_saidas,$punitario,$valorsaidas,$valorfinal){
        $dados=array(
         'idstock'=>$idStock,
         'datainventario'=>date('Y/m/d'),
         'qtd_saidas'=>$qtd_saidas,   
         'qtdinicial'=>$qtdinicial, 
         'valorinicial'=>$totalcompras,   
         'valorsaidas'=>$valorsaidas,
         'qtdfinal'=>$qtd,// Na primeira venda a quantidade sera igual a qtd do bd - qtd do form , este sera o qtd inicial e o qtd final se não se realizar mas vendas
         'valorfinal'=>$valorfinal,
         'punitario'=>$punitario   
        );
        $this->db->insert('inventario',$dados);
    }
    
    public function atualizaInventario($idStock,$quantidade,$novovalorsaidas,$novovalofinal,$dta){
        $this->db->where('idstock', $idStock);
        $this->db->where('datainventario', $dta);
        $this->db->set('qtd_saidas','qtd_saidas+'.$quantidade, FALSE);
        $this->db->set('valorsaidas','valorsaidas+'.$novovalorsaidas,FALSE);
        $this->db->set('qtdfinal','qtdfinal-'.$quantidade, FALSE);
        $this->db->set('valorfinal','valorfinal-'.$novovalofinal,FALSE);
        $this->db->update('inventario');
    }
    public function atualisaSaldoFinal($idStock,$quantidade,$punitario,$valorfinal){// atualiza o saldo final por data
        $data=@date('Y/m/d');
        $this->db->where('idstock', $idStock);
        $this->db->where('datainventario', $data);
        $this->db->set('qtdfinal','qtdfinal+'.$quantidade, FALSE);
        $this->db->set('punitario',$punitario);
        $this->db->set('valorfinal','valorfinal+'.$valorfinal,FALSE);
        $this->db->update('inventario');
    }
     public function atualisaSaldoFinalPorIdInventario($idinventario,$quantidade,$punitario,$valorfinal){// atualiza o saldo final por data
        $this->db->where('idinventario', $idinventario);
        $this->db->set('qtdfinal','qtdfinal+'.$quantidade, FALSE);
        $this->db->set('punitario',$punitario);
        $this->db->set('valorfinal','valorfinal+'.$valorfinal,FALSE);
        $this->db->update('inventario');
    }

public function inventarioGeralM($data){
       $this->db->select('*');
       $this->db->from('inventario');
       $this->db->join('stock_quantidade', 'inventario.idstock = stock_quantidade.idstock');
       $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
            $this->db->where('datainventario >=',$data);
            $this->db->where('datainventario <=',$data);
       $this->db->order_by('produto');
       $this->db->order_by('produto');
       $query = $this->db->get();
       return $query->result();

}

     public function inventarioRelatorio($data,$limite){
       $this->db->select('*');
       $this->db->from('inventario');
       $this->db->join('stock_quantidade', 'inventario.idstock = stock_quantidade.idstock');
       $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
       $this->db->where('datainventario',$data);
       if(!empty($limite)){
         $this->db->where('qtd_saidas >=',$limite);
       }
        $this->db->order_by('produto');
        $query = $this->db->get();
        return $query->result();
    }
    
    public function contarlinhasregistoInventario($data){
        $this->db->where('datainventario',$data);
        $this->db->from('inventario');
        return $this->db->count_all_results();
    }
    // verifica se o produto ja extiste na tabela inventario com a data de hoje
     public function consultar_Idstock_NoInventario($idstock){
        $data=@date('Y/m/d') ;
       $this->db->select('idstock');
        $this->db->where('idstock',$idstock);
       $this->db->where('datainventario',$data);
       $this->db->from('inventario');  
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
          return false;
    }
    
    // verifica se o produto ja extiste na tabela inventario com a data de hoje
     public function consultar_Idstock($idstock){
        $data=@date('Y/m/d') ;
       $this->db->select('idstock');
        $this->db->where('idstock',$idstock);
       $this->db->where('datainventario',$data);
       $this->db->from('inventario');  
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
          return false;
    }
    
    public function consultDataInv($data){
        $this->db->where( 'datainventario',$data);
        $this->db->from('inventario');
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
            return false;             
    }
     public function subtrairQuantides($idInventario,$qtdAntiga){
        $this->db->where('idinventario', $idInventario);
        $this->db->set('qtdinicial','qtdinicial-'.$qtdAntiga, FALSE);
        $this->db->set('qtdfinal','qtdfinal-'.$qtdAntiga,FALSE);
        $this->db->update('inventario');
    }
     public function atualizarQtdValorFinal($idInventario,$quantidade,$valorfinal){
       
        $this->db->where('idinventario', $idInventario);
        $this->db->set('qtdinicial','qtdinicial+'.$quantidade, FALSE);
         $this->db->set('qtdfinal','qtdfinal+'.$quantidade, FALSE);
        $this->db->set('valorfinal','valorfinal+'.$valorfinal,FALSE);
        $this->db->update('inventario');
    }
    public function verificar_data_inventario($data){// verifica se o saldo inicial do caixa ja foi aberto
       $this->db->select('datainventario');
       $this->db->from('inventario');
       $this->db->where('datainventario',$data);  
        if ($this->db->count_all_results() > 0) { 
            return true;
        }else
          return false;  
   }
}

?>
