<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of CategoriaM
 *
 * @author VINEVALA
 */
class MLojas extends CI_Model {
    public function mregistaLoja($loja,$descricao,$morada,$email,$telefone){ 
       $dados= array (
           'narmanze'=>$loja,
           'descricao'=>$descricao,
           'morada'=>$morada,
           'email'=>$email,
           'telefone'=>$telefone,
            );
       $this->db->insert('armanzes', $dados);
        
    }
    public function mlistaLojas(){
        $this->db->select('');
        $this->db->from('armanzes');
        $this->db->where('id !=',1);
        $this->db->where('id !=',3);
       $consulta= $this->db->get();
       return $consulta->result();
    }
   
     public function consultaArmanzeProduto($idArmaze){
        $this->db->select('idArmaze');
        $this->db->where('idArmaze',$idArmaze);
        $this->db->from('stock_quantidade');
        if($this->db->count_all_results() >0){
            return true;
        }else{
          return false;  
        }
    }
     function mdeleteLoja($idLoja) {
        if($this->db->delete('armanzes', array('id' => $idLoja)))  
            return true;
        else
            return false;
        
     }  
     public function matualizarLoja($idLoja,$narmanze,$descricao,$morada,$email,$telefone){
       
          $this->db->where('id',$idLoja);
          $this->db->set('narmanze',$narmanze);
          $this->db->set('descricao',$descricao);
          $this->db->set('morada',$morada);
          $this->db->set('email',$email);
          $this->db->set('telefone',$telefone);
          $this->db->update('armanzes');
     
    }
    public function mcaixaLoja($idArmanze){
        $this->db->select('');
        $this->db->from('caixa_loja');
        $this->db->join('tipo_caixa', 'caixa_loja.idTipoCaixa = tipo_caixa.idTipoCaixa');
        $this->db->join('grupo_preco','caixa_loja.idGrupoPreco=grupo_preco.idGrupoPreco');
        $this->db->where('idArmanze',$idArmanze);
        $consulta= $this->db->get();
        return $consulta->result();
    }
    public function mtipoCaixa(){
       $this->db->select('*');
       $this->db->from('tipo_caixa');
       $consulta= $this->db->get();
       return $consulta->result();
    }
    public function mregistaLojaCaixa($idLoja,$caixa,$idTipoCaixa, $idGrupoPreco){ 
       $dados= array (
           'idTipoCaixa'=>$idTipoCaixa,
           'idGrupoPreco'=>$idGrupoPreco,
           'nomeCaixa'=>$caixa,
           'idArmanze'=>$idLoja,
            );
       $this->db->insert('caixa_loja', $dados);
        
    }
    public function matualizarCaixaLoja($idCaixa,$caixa,$idTipoCaixa, $idGrupoPreco){
          $this->db->where('idCaixa',$idCaixa);
          $this->db->set('idTipoCaixa',$idTipoCaixa);
          $this->db->set('idGrupoPreco',$idGrupoPreco);
          $this->db->set('nomeCaixa',$caixa);
          $this->db->update('caixa_loja');
     
    }
    public function mcaixaLojaPorUtilizador($idUsuario){
        $this->db->select('');
        $this->db->from('caixa_loja');
        $this->db->join('armanzes', 'caixa_loja.idArmanze = armanzes.id');
        $this->db->join('usuarioLojas','armanzes.id=usuarioLojas.idLoja');
        $this->db->where('idUsuario',$idUsuario);
        $consulta= $this->db->get();
        return $consulta->result();
    }
     public function constutarLojaUtilizadorCaixa($idUsuario){
        $this->db->select('idUsuario');
        $this->db->from('usuariosCaixaLoja');
        $this->db->where('idUsuario',$idUsuario);
        if($this->db->count_all_results() >0){
            return true;
        }else{
          return false;  
        }
    }
     public function matualizarLojaUtilizadorCaixa($idUsuario,$idCaixa){
          $this->db->where('idUsuario',$idUsuario);
          $this->db->set('idCaixa',$idCaixa);
          $this->db->update('usuariosCaixaLoja');
    }
    public function mregistaLojaUtilizadorCaixa($idUsuario,$idCaixa){ 
       $dados= array (
           'idUsuario'=>$idUsuario,
           'idCaixa'=>$idCaixa,
            );
       $this->db->insert('usuariosCaixaLoja', $dados);
        
    }
    public function idCaixaLoja($idUsuario){ 
        $this->db->select('idCaixa');//
        $this->db->from('usuarioscaixaloja');
        $this->db->where('idUsuario', $idUsuario); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idCaixa;
        }
        
    }
     public function nomeCaixa($idCaixa){ 
        $this->db->select('nomeCaixa');//
        $this->db->from('caixa_loja');
        $this->db->where('idCaixa', $idCaixa); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->nomeCaixa;
        }
        
    }
    public function idGrupoPreco($idCaixa){ 
        $this->db->select('idGrupoPreco');//
        $this->db->from('caixa_loja');
        $this->db->where('idCaixa', $idCaixa); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idGrupoPreco;
        }
        
    }
     public function idLoja($idCaixa){ 
        $this->db->select('idArmanze');//
        $this->db->from('caixa_loja');
        $this->db->where('idCaixa', $idCaixa); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
        
    }
     public function nomeLoja($idLoja){ 
        $this->db->select('narmanze');//
        $this->db->from('armanzes');
        $this->db->where('id', $idLoja); 
        $consulta=  $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->narmanze;
        }
        
    }
}

?>
