<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mNotaCredito
 *
 * @author VINEVALA
 */
class mNotaCredito extends CI_Model {

    public function registarNota($idFatura, $idUsuario) {

        $dados = array(
            'data' => date('Y-m-d'),
            'idFatura' => $idFatura,
            'idUsuario' => $idUsuario,
            'hora' => date('H:i:s'),
        );
        $this->db->insert('nota_credito', $dados);

        return $this->db->insert_id();
    }

    public function alteraestado($idFatura, $idpr) {
        $dados = array(
            'estado' => 'A',
        );
        $this->db->where('fatura', $idFatura);
        $this->db->where('idpr', $idpr);
        $this->db->set($dados);
        $this->db->update('item_fatura');
    }

    public function alteraestadoP($idFatura, $idpr) {
        $dados = array(
            'estado' => 'P',
        );
        $this->db->where('fatura', $idFatura);
        $this->db->where('idpr', $idpr);
        $this->db->set($dados);
        $this->db->update('item_fatura');
    }

    public function registarNotaParcial($idFatura, $idUsuario) {

        $dados = array(
            'data' => @date('Y-m-d'),
            'idFatura' => $idFatura,
            'idUsuario' => $idUsuario,
            'hora' => @date('H:i:s'),
        );
        $this->db->insert('nota_credito', $dados);
        return $this->db->insert_id();
    }

    public function consultar_nota_credito($idNota) {
        $this->db->select('item_nota_credito.idNota');
        $this->db->from('item_nota_credito');
        $this->db->where('item_nota_credito.idNota', $idNota);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function imprimirNotaCredito($idNota) {
        $this->db->select('nota_credito.idNota,nota_credito.hora,nota_credito.data,faturas.fatura,faturas.total_venda,usuarios.unome,prodt.idpr,prodt.produto,
                clientes.nome,item_fatura.qtd,item_fatura.desconto,faturas.idTipopagamento,faturas.idtipo,faturas.idMoeda,faturas.hashcontrol,item_fatura.custo,item_fatura.total,
                cliente_contacto.fone,cliente_contacto.nif,cliente_contacto.localizacao,usuarios.unome, unidade_medida.nunidade');
        $this->db->from('nota_credito');
        $this->db->join('faturas', 'nota_credito.idFatura=faturas.fatura');

        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'nota_credito.idUsuario=usuarios.id_usiario');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->where('idNota', $idNota);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function imprimirNotaCreditoParcial($idNota) {
        $this->db->select('nota_credito.idNota,nota_credito.hora,nota_credito.data,faturas.fatura,faturas.total_venda,usuarios.unome,prodt.idpr,prodt.produto,
                clientes.nome,faturas.idTipopagamento,faturas.idtipo,faturas.idMoeda,nota_credito.hashcontrol,unidade_medida.nunidade,
                cliente_contacto.fone,cliente_contacto.nif,cliente_contacto.localizacao,usuarios.unome');
        $this->db->from('nota_credito');

        $this->db->join('faturas', 'nota_credito.idFatura=faturas.fatura');
        $this->db->join('item_nota_credito', 'nota_credito.idNota=item_nota_credito.idNota');
        $this->db->join('prodt', 'item_nota_credito.idProduto=prodt.idpr');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'nota_credito.idUsuario=usuarios.id_usiario');
        //  $this->db->join('item_fatura','faturas.fatura=item_fatura.fatura');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where('item_nota_credito.idNota', $idNota);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaNotaCredito($start, $limit) {
        $this->db->select('*');
        $this->db->from('nota_credito');
        $this->db->join('faturas', 'nota_credito.idFatura=faturas.fatura');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'nota_credito.idUsuario=usuarios.id_usiario');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->group_by('faturas.fatura');
        $this->db->order_by('idNota', 'DESC');
        $this->db->limit($limit, $start);
        $consulta = $this->db->get();
        return $consulta->result();
    }
     public function obter_total_registos_filtrados_notas_credito() {
        $this->db->select('COUNT(*) as total'); // Apenas conta o número de registros
         $this->db->from('nota_credito');
        $this->db->join('faturas', 'nota_credito.idFatura=faturas.fatura');
//        if (!empty($dataInicial) && !empty($dataFinal)) {
//            $this->db->where('faturas.data >=', $dataInicial);
//            $this->db->where('faturas.data <=', $dataFinal);
//        }
        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }

    public function contarNotaCredito() {
        $this->db->select('*');
        $this->db->from('nota_credito');
        $this->db->join('faturas', 'nota_credito.idFatura=faturas.fatura');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'nota_credito.idUsuario=usuarios.id_usiario');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->group_by('faturas.fatura');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // atualizar total somando
    public function atualizarTotal($fatura, $total) {
        $this->db->where('fatura', $fatura);
        $this->db->set('total_venda', 'total_venda+' . $total, FALSE);
        $this->db->update('faturas');
    }

    // atualizar totam subtraido
    public function atualizarTotalS($fatura, $total) {
        $this->db->where('fatura', $fatura);
        $this->db->set('total_venda', 'total_venda-' . $total, FALSE);
        $this->db->update('faturas');
    }

    public function itemfatura($fatura, $idpr, $preco, $desconto, $quantidade, $total) {
        $dados = array(
            'fatura' => $fatura,
            'idpr' => $idpr,
            'qtd' => $quantidade,
            'desconto' => $desconto,
            'custo' => $preco,
            'total' => $total,
            'datavenda' => $data = @date('Y/m/d'),
        );
        $this->db->insert('item_fatura', $dados);
    }

    public function auxiliarM($fatura, $idfunc) {
        $dados = array(
            'fatura' => $fatura,
            'iduser' => $idfunc
        );
        $this->db->insert('auxiliarfaturas', $dados);
    }

    public function pegarNumeroFatura($idusuario) {
//        echo'modelo   '. $fatura.'   ';
        $this->db->select('fatura');
        $this->db->from('auxiliarfaturas');
        $this->db->where('iduser', $idusuario);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    //metodo auxiliar para pegra o numero da fatura 
    public function apagrUxiliarfaturaM($idusuario) {
        $this->db->where('iduser', $idusuario);
        $this->db->delete('auxiliarfaturas');
    }

    //Metodo para carregar item na carrinha de vendas
    public function listaritemM($fatura) {
        $this->db->select('*');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('fatura', $fatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo para remover Item da carrinha
    public function removerItem($id) {
        $this->db->where('iditem', $id);
        $this->db->delete('item_fatura');
    }

    // metodo que lista as vendas diarias por cada utilizador
    public function listarvendasDiarias($start, $limit, $usuario) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->where('iduser', $usuario);
        $this->db->where('faturas.data', @date('Y-m-d'));
        $this->db->limit($limit, $start);
        $this->db->order_by('hora', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    //metodo para contar o numero de registo existente na bd
    public function contarRegistosDeVendas($dataminima, $datamaxima, $id) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        if ($id != '')
            $this->db->where('iduser', $id);
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        } else {
            $this->db->where('data', $data);
        }
        return $this->db->count_all_results();
    }

    // Consultar produto ligado a uma fatura
    public function ConsultarItem($idpr, $fatura) {
        $this->db->where('fatura', $fatura);
        $this->db->where('idpr', $idpr);
        $this->db->from('item_fatura');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    // atualizara quantidade de produto vendido por fatura
    public function atualizarItem($idpr, $fatura, $qtd, $total) {
        $this->db->where('fatura', $fatura);
        $this->db->where('idpr', $idpr);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->set('total', 'total+' . $total, FALSE);
        $this->db->update('item_fatura');
    }

    // metodo pra imprimir fatura
    public function imprimir_vendas($fatura) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('faturas.fatura', $fatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function finalizarVendasM($fatura, $tatus) {
        $this->db->where('fatura', $fatura);
        $this->db->set('status', $tatus);
        $this->db->update('faturas');
    }

    public function consultarStatusM($fatura, $tatus) {
        $this->db->where('fatura', $fatura);
        $this->db->where('status', $tatus);
        $this->db->from('faturas');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    // metodo para listar as vendas 
    public function listaDeVendas($start, $limit, $dataminima, $datamaxima, $id) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        if ($id != '')
            $this->db->where('iduser', $id);
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        } else {
            $this->db->where('data', $data);
        }
        $this->db->limit($limit, $start);
        $this->db->order_by('data', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo venda relatorio
    public function listarVendasRelatorio($dataminima, $datamaxima, $id) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        if ($id != '')
            $this->db->where('iduser', $id);
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        } else {
            $this->db->where('data', $data);
        }
        $this->db->order_by('data', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // soma a as vendas  no Bd
    public function somarvendasRelatorio($dataminima, $datamaxima, $id) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->select_sum('total_venda');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        if ($id != '')
            $this->db->where('iduser', $id);
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        } else {
            $this->db->where('data', $data);
        }
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo para listar os produtos vendidos 
    public function listarProdutosVendidos($start, $limit, $dataminima, $datamaxima, $idproduto) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->select_sum('qtd');
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        if ($datamaxima != '') {
            $this->db->where('datavenda >=', $dataminima);
            $this->db->where('datavenda <=', $datamaxima);
        } else {
            $this->db->where('datavenda', $data);
        }
        if ($idproduto) {
            $this->db->where('prodt.idpr', $idproduto);
        }
        $this->db->limit($limit, $start);
        $this->db->group_by('prodt.idpr');
        $this->db->order_by('datavenda', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // listar produtos vendidos
    public function listarProdutosVendidosRelatorio($dataminima, $datamaxima, $idproduto) {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->select_sum('qtd');
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        if ($datamaxima != '') {
            $this->db->where('datavenda >=', $dataminima);
            $this->db->where('datavenda <=', $datamaxima);
        } else {
            $this->db->where('datavenda', $data);
        }
        if ($idproduto) {
            $this->db->where('prodt.idpr', $idproduto);
        }
        $this->db->group_by('prodt.idpr');
        $this->db->order_by('datavenda', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contarProdutosVendidos() {
        $data = @date('Y/m/d');
        $this->db->select('*');
        $this->db->from('item_fatura');
        return $this->db->count_all_results();
    }

    public function listarStokDiponivel() {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto=prodt.idpr');
        $this->db->order_by('produto', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // metodo para listar os produtos mas vndidos 
    public function listarProdutosPorQauatidade($dataminima, $Qtdminimo, $Qtdmaximo, $datamaxima) {

        $this->db->select('*');
        $this->db->select_sum('qtd');
        $this->db->select_sum('total');
        $this->db->from('item_fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('datavenda >=', $dataminima);
        $this->db->where('datavenda <=', $datamaxima);
        $this->db->where('qtd >=', $Qtdminimo);
        $this->db->where('qtd <=', $Qtdmaximo);
        $this->db->group_by('prodt.idpr');
        $this->db->order_by('qtd', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function consultar_fatura($fatura) {
        $this->db->where('fatura', $fatura);

        $this->db->from('faturas');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function listarTipo($fatura) {
        $this->db->where('fatura', $fatura);
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto=prodt.idpr');
        $this->db->order_by('produto', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
        $this->db->from('faturas');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function mListaFaturas() {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->order_by('fatura', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mListaProdutosFaturas($idFatura, $idProduto) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->join('prodt', 'item_fatura.idpr=prodt.idpr');
        $this->db->where('faturas.fatura', $idFatura);
        if ($idProduto != '') {
            $this->db->where('prodt.idpr', $idProduto);
        }
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function liastaDataNotaCredito($idFatura) {// pega a data da criacao da nota de credito
        $this->db->select('*');
        $this->db->from('nota_credito');
        $this->db->where('idFatura', $idFatura);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $data = $value->data . 'T' . $value->hora;
        }
    }

    public function notaCreditoSaft($dataminima, $datamaxima) {
        $this->db->select('nota_credito.idNota,nota_credito.hora,nota_credito.data,faturas.fatura,faturas.total_venda,usuarios.unome,
                clientes.nome,clientes.idcliente,faturas.idTipopagamento,faturas.idtipo,faturas.idMoeda,faturas.hash,faturas.hashcontrol,
                cliente_contacto.fone,cliente_contacto.nif,cliente_contacto.localizacao');
        $this->db->from('nota_credito');
        $this->db->join('faturas', 'nota_credito.idFatura=faturas.fatura');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'nota_credito.idUsuario=usuarios.id_usiario');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where('nota_credito.data >=', $dataminima);
        $this->db->where('nota_credito.data <=', $datamaxima);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listaProduto($idFatura) {
        $this->db->select('*');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function atualizarSubtrairQtd($idProduto, $qtd) {
        $this->db->where('idproduto', $idProduto);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->update('stock_quantidade');
    }

    public function pegaQtd($idFatura, $idProduto) {
        $this->db->select('qtd');
        $this->db->from('item_fatura');
        $this->db->where('item_fatura.fatura', $idFatura);
        $this->db->where('item_fatura.idpr', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function registarNotaCreditoItem($idNota, $idProduto) {

        $dados = array(
            'idNota' => $idNota,
            'idProduto' => $idProduto,
        );
        $this->db->insert('item_nota_credito', $dados);
    }

    public function qtd($idFatura, $idpr) {
        $this->db->select('qtd');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->where('idpr', $idpr);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function custo($idFatura, $idpr) {
        $this->db->select('custo');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->where('idpr', $idpr);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custo;
        }
    }

    public function desconto($idFatura, $idpr) {
        $this->db->select('desconto');
        $this->db->from('item_fatura');
        $this->db->where('fatura', $idFatura);
        $this->db->where('idpr', $idpr);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->desconto;
        }
    }

    public function estado($idNota) {
        $this->db->select('estado');
        $this->db->from('nota_credito');
        $this->db->where('idNota', $idNota);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->estado;
        }
    }

    public function atualizarEstado($idNota, $estado) {
        $this->db->where('idNota', $idNota);
        $this->db->set('estado', $estado);
        $this->db->update('nota_credito');
    }

    public function serie($idNota) {// serie da nota de credito
        $this->db->select('data');
        $this->db->from('nota_credito');
        $this->db->where('nota_credito.idNota', $idNota);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $dt->format('Y');
        }
    }

    public function systemEntryate($idNota) { // data e hora da fatura
        $this->db->select('data,hora');
        $this->db->from('nota_credito');
        $this->db->where('nota_credito.idNota', $idNota);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->data . 'T' . $value->hora;
        }
    }

    public function inVoiceDate($idNota) {
        $this->db->select('data');
        $this->db->from('nota_credito');
        $this->db->where('nota_credito.idNota', $idNota);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            $dt = new DateTime($value->data);
            return $dt->format('Y-m-d');
        }
    }

    public function grossTotal($idNota, $idFatura) {
        if ($this->mNotaCredito->consultar_nota_credito($idNota)) {// se existe nota de credito parcial
            $this->db->select_sum('total');
            $this->db->from('nota_credito');
            $this->db->join('item_nota_credito', 'nota_credito.idNota=item_nota_credito.idNota');
            $this->db->join('faturas', 'nota_credito.idFatura=faturas.fatura');
            $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
            $this->db->where('nota_credito.idNota', $idNota);
            $consulta = $this->db->get();
            foreach ($consulta->result() as $value) {
                return $value->total;
            }
        } else {
            $this->db->select('total_venda');
            $this->db->from('faturas');
            $this->db->where('faturas.fatura', $idFatura);
            $consulta = $this->db->get();
            foreach ($consulta->result() as $value) {
                return $value->total_venda;
            }
        }
    }

    public function contarRegistosNotas() {// verifica se ja existe registo no bd
        $this->db->select('idNota');
        $this->db->from('nota_credito');
        return $this->db->count_all_results();
    }

    public function hash_da_ultima_fatura($idNota) {
        $this->db->select('hash');
        $this->db->from('nota_credito');
        $this->db->where('nota_credito.idNota', $idNota - 1);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->hash;
        }
    }

    public function matualizar_hash($idNota, $registoHash, $hasControl) {
        $dados = array(
            'hash' => $registoHash,
            'hashcontrol' => $hasControl,
        );
        $this->db->where('idNota', $idNota);
        $this->db->set($dados);
        $this->db->update('nota_credito');
    }

    public function pegaIdNotaCredito($idFatura) {
        $this->db->select('idNota');
        $this->db->from('nota_credito');
        $this->db->where('nota_credito.idFatura', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {

            return $value->idNota;
        }
    }

    public function consultar_fatura_nota_credito($fatura) {
        $this->db->select('idFatura');
        $this->db->from('nota_credito');
        $this->db->where('idFatura', $fatura);

        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function hash_nota_credito($idNota) {
        $this->db->select('hash');
        $this->db->from('nota_credito');
        $this->db->where('nota_credito.idNota', $idNota);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->hash;
        }
    }
    public function idFatura($idFatura) {
        $this->db->select('idFatura');
        $this->db->from('nota_credito');
        $this->db->where('nota_credito.idNota', $idFatura);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {

            return $value->idFatura;
        }
    }

}

?>
