<script src="<?php echo base_url(); ?>src/pos/dashBoard.js"></script>



<style>
    /* Ajustes gerais para os cards */
    .card {
        transition: transform 0.3s ease, box-shadow 0.3s ease;
    }
    
    .card:hover {
        transform: translateY(-5px);
        box-shadow: 0px 5px 15px rgba(0, 0, 0, 0.2);
    }

    /* Animação suave nos textos */
    .valor-destaque,
    .valor-label {
        transition: color 0.3s ease, transform 0.3s ease;
    }

    /* Efeito ao passar o mouse sobre os valores */
    .valor-destaque:hover,
    .valor-label:hover {
        transform: scale(1.1);
    }

    /* Efeito de fade-in ao carregar a página */
    .card-body p {
        opacity: 0;
        animation: fadeIn 0.8s ease-in-out forwards;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
            transform: translateY(10px);
        }
        to {
            opacity: 1;
            transform: translateY(0);
        }
    }

    /* Ajustes de margem e centralização do header */
    .card-header {
        padding: 0.5rem;
        text-align: center;
        font-weight: bold;
        color: #fff;
    }

    /* Estilização da card-body */
    .card-body {
        min-height: 150px;
        font-size: 0.8rem;
        line-height: 1.0 !important;
        padding-top: 0.3rem !important;
    }

    .card-body p {
        line-height: 1.0 !important;
        margin: 0;
    }

    .valor-destaque {
        font-size: 0.9rem;
        color: #dc3545;
        margin: 0;
        line-height: 1.0 !important;
    }

    .valor-label {
        font-size: 0.9rem;
        margin: 0;
        color: #555;
        line-height: 1.0 !important;
    }

    /* Classe para os valores "A Receber" em azul */
    .valor-receber {
        color: #007bff;
        line-height: 1.0 !important;
    }

    /* Cores customizadas para os headers */
    .header-hoje {
        background-color: #17a2b8;
    }

    .header-mes {
        background-color: #28a745;
    }

    .header-ano {
        background-color: #ffc107;
        color: #000;
    }

    /* Headers alternativos */
    .header-hoje-alt {
        background-color: #6f42c1;
        color: #fff;
    }

    .header-mes-alt {
        background-color: #fd7e14;
        color: #fff;
    }

    .header-ano-alt {
        background-color: #20c997;
        color: #fff;
    }

    /* Regra para o elemento de resultado */
    .valor-destaque.valor-resultado {
        font-size: 0.8rem !important;
        color: #20c997 !important;
    }
</style>




<main>
    <div class="container-fluid my-4">
        <div class="row g-3">
            <!-- Coluna 1 -->
            <div class="col-md-2">
                <div class="card shadow-sm">
                    <div class="card-header header-hoje">
                        Hoje
                    </div>
                    <div class="card-body bg-light">
                        <p class="valor-label valor-receber"> Entradas</p>
                        <p class="valor-destaque" id="recebeHoje">0,00</p>
                        <hr>
                        <p class="valor-label">Saidas</p>
                        <p class="valor-destaque" id="pagoHoje">0,00</p>
                        <hr>
                        <p class="valor-label">Resultado </p>
                        <p class="valor-destaque valor-resultado" id="resultadoHoje">0,00</p>
                        <hr>
                        <!-- Espaço para gráfico ou outro conteúdo -->
                    </div>
                </div>
            </div>

            <!-- Coluna 2 -->
            <div class="col-md-2">
                <div class="card shadow-sm">
                    <div class="card-header header-mes">
                        Mês Atual
                    </div>
                    <div class="card-body bg-light">
                        <p class="valor-label valor-receber">Entradas</p>
                        <p class="valor-destaque" id="recebeMes">0,00</p>
                        <hr>
                        <p class="valor-label">Saidas</p>
                        <p class="valor-destaque" id="pagobeMes"> 0,00</p>
                        <hr>
                        <p class="valor-label">Resultado </p>
                        <p class="valor-destaque valor-resultado" id="resultadoMes">0,00</p>
                        <hr>
                        <!-- Espaço para gráfico -->
                    </div>
                </div>
            </div>

            <!-- Coluna 3 -->
            <div class="col-md-2">
                <div class="card shadow-sm">
                    <div class="card-header header-ano">
                        Ano Atual
                    </div>
                    <div class="card-body bg-light">
                        <p class="valor-label valor-receber">Entradas</p>
                        <p class="valor-destaque" id="recebeAno">0,00</p>
                        <hr>
                        <p class="valor-label">Saidas</p>
                        <p class="valor-destaque" id="pagobeAno">0,00</p>
                        <hr>
                        <p class="valor-label">Resultado </p>
                        <p class="valor-destaque valor-resultado" id="resultadoAno">0,00</p>
                        <hr>
                        <!-- Espaço para gráfico -->
                    </div>
                </div>
            </div>

            <!-- Coluna 4 (Header com cor diferente) -->
            <div class="col-md-2">
                <div class="card shadow-sm">
                    <div class="card-header header-hoje-alt">
                        Hoje (2)
                    </div>
                    <div class="card-body bg-light">
                        <canvas id="donutChartPagamentos" style="min-height: 180px; height: 180px; max-height: 250px; max-width: 100%;"></canvas>
                    </div>
                </div>
            </div>

            <!-- Coluna 5 (Header com cor diferente) -->
            <div class="col-md-2">
                <div class="card shadow-sm">
                    <div class="card-header header-mes-alt">
                        Mês Atual (2)
                    </div>
                    <div class="card-body bg-light">
                       <canvas id="donutChartPagamentosMes" style="min-height: 180px; height: 180px; max-height: 250px; max-width: 100%;"></canvas>
                    </div>
                </div>
            </div>

            <!-- Coluna 6 (Header com cor diferente) -->
            <div class="col-md-2">
                <div class="card shadow-sm">
                    <div class="card-header header-ano-alt">
                        Ano Atual (2)
                    </div>
                    <div class="card-body bg-light">
                        <canvas id="donutChartPagamentosAno" style="min-height: 180px; height: 180px; max-height: 250px; max-width: 100%;"></canvas>
                    </div>
                </div>
            </div>
        </div>
    </div>
</main>
