<script src="<?php echo base_url(); ?>src/pos/resumo_caixa.js"></script>
<script src="<?php echo base_url(); ?>src/pos/resumoCaixaPdf.js"></script>
<style>


    .icon-action {
        margin-right: 10px;
        color: #333;
        text-decoration: none;
    }

    .icon-action i {
        font-size: 18px;
    }
    .icon-action2 {
        margin-right: 10px;
        text-decoration: none;
    }

    .icon-action2 i {
        font-size: 20px;
    }

    dataTable tbody td,
    .dataTable thead th {
        padding:2px 4px; /* Diminui o padding (espaçamento) das células */
        line-height: 0.5; /* Diminui a altura da linha */
        height: 5px;     /* Define uma altura fixa para as linhas */
    }




</style>

<main>
    <div class="container-fluid">
        <div class="row">
            <!-- Coluna maior (8/12 da tela) -->
            <div class="col-12 col-md-12">
                <div class="card mb-3">
                    <div class="card-header  d-flex justify-content-between align-items-center bg-primary text-white" >
                        <div class="d-flex align-items-center">
                            <h4>Informações do caixa</h4>
                        </div>

                    </div>
                    <div class="card-body pt-0">
                        <table class="data-table data-table-scrollable responsive nowrap " id="tabelaListaInformacaoCaixa" width="100%">
                            <thead>
                                <tr class="p-1">
                                    <th  width="15%">Dt.Abertura</th>
                                    <th  width="10%">Entradas</th>
                                    <th  width="10%">Saidas</th>
                                    <th  width="10%">Vendas Cash</th>
                                    <th  width="10%">Vendas Tpa</th>
                                    <th  width="10%">Total</th>
                                    <th  width="10%">Informado</th>
                                    <th  width="10%">Em falta</th>
                                    <th  width="6%">Acções</th>
                                </tr>
                            </thead>
                            <tbody>
                                <!-- Dados da tabela serão preenchidos aqui -->
                            </tbody>
                        </table>
                    </div>
                </div>
                <div class="card mb-3" >
                    <div class="card-header  d-flex justify-content-between align-items-center bg-primary text-white" >
                        <div class="d-flex align-items-center">
                            <h4>Entrada e saida de dinheiro</h4>
                        </div>

                    </div>
                    <div class="card-body pt-0" > 
                        <table class="data-table data-table-scrollable responsive nowrap " id="tabelaListaSangriaSuprimentos" width="100%">
                            <thead>
                                <tr class="p-1">
                                    <th  width="20%">Data</th>
                                    <th  width="12%">Tipo</th>
                                    <th  width="40%">Descrição</th>
                                    <th  width="15%">Usuário</th>
                                    <th  width="12%">Forma</th>
                                    <th  width="10%">Valor</th>
                                </tr>
                            </thead>
                            <tbody>
                                <!-- Dados da tabela serão preenchidos aqui -->
                            </tbody>
                        </table>
                    </div>
                </div>

            </div>
            <!-- Coluna menor (4/12 da tela), alinhado na mesma linha -->


        </div>
    </div>
</main>
<!--Modal para aplicar a qtd  e desconto de produto-->
<div class="modal fade modal-left" id="exampleFecharCaixa" tabindex="-1" role="dialog"
     aria-labelledby="exampleModalLeft" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">

            <div class="modal-body">

                <form id="formFechoCaixa" novalidate >
                    <input type="hidden"  name="idCaixaAberto"  id="idCaixaAberto">
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="qtd">Saldo inicial</label> 
                        </div>
                        <div class="form-group col-md-6 text-right" >
                            <label id="saldo" for="preco">0</label>
                        </div>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="qtd">Vendas em Cash</label> 
                        </div>
                        <div class="form-group col-md-6 text-right" >
                            <label id="cash" for="preco">0</label>
                        </div>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="qtd">Vendas em tpa</label> 
                        </div>
                        <div class="form-group col-md-6 text-right" >
                            <label id="tpa" for="preco">0</label>
                        </div>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="qtd">Total</label> 
                        </div>
                        <div class="form-group col-md-6 text-right" >
                            <label id="total" for="preco">0</label>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <input type="number" class="form-control" name="valor" id="valor" required />
                            <span>Informe o valor</span>
                        </label>
                    </div>
                    <div class="d-flex justify-content-end top-right-button">
                        <button class="btn btn-primary btn-lg btn-shadow" type="submit">Fechar</button>
                    </div>
                </form>
            </div>
            
        </div>
    </div>
</div>
<!--Fim-->
